IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtDecimal6_2' )
   CREATE TYPE dbo.udtDecimal6_2 FROM DECIMAL(6,2)
go


IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtDecimal10_2' )
   CREATE TYPE dbo.udtDecimal10_2 FROM DECIMAL(10,2)
go

IF not EXISTS(select syscolumns.name  from syscolumns
  left join sysobjects on syscolumns.id=sysobjects.id
  where UPPER(syscolumns.name) = 'OTROSPAGOS' and sysobjects.name='acum_emps')
 Alter table acum_emps add otrospagos numeric(12,2) DEFAULT 0

GO


IF not EXISTS(select syscolumns.name  from syscolumns
  left join sysobjects on syscolumns.id=sysobjects.id
  where UPPER(syscolumns.name) = 'FechaInicial' and sysobjects.name='subcontratacionEmpleado')
 Alter table dbo.subcontratacionEmpleado add FechaInicial DATETIME

GO

IF not EXISTS(select syscolumns.name  from syscolumns
  left join sysobjects on syscolumns.id=sysobjects.id
  where UPPER(syscolumns.name) = 'FechaFinal' and sysobjects.name='subcontratacionEmpleado')
 Alter table dbo.subcontratacionEmpleado add FechaFinal DATETIME

GO


-- Agregar campo el ISR que se dejo de retener...pero que no se debe acumular para el ajuste anual
IF NOT EXISTS (SELECT SysColumns.Name
               FROM SysColumns
               LEFT JOIN SysObjects ON SysColumns.id = SysObjects.id
               WHERE UPPER(SysColumns.Name) = 'ISRDEJORETENER' AND UPPER(SysObjects.Name) = 'ACUM_EMPS')
  ALTER TABLE Acum_Emps ADD ISRDejoRetener NUMERIC(12,2) DEFAULT 0

GO




IF OBJECT_ID('dbo.sp_infoacumemp') IS NOT NULL
  DROP PROCEDURE dbo.sp_infoacumemp
GO

/*
 * PROCEDURE: sp_infoacumemp
 */
CREATE PROCEDURE dbo.sp_infoacumemp
        @Codigo Numeric = 0,
        @Empresa Int = 0,
        @Ejercicio Int = 0,
		@Consolida CHAR(1) = 'N'

AS
IF @Consolida ='N'
   SELECT empleados.codigo,
          Rtrim(empleados.ap_paterno) + ' ' + Rtrim(empleados.ap_materno) + ' ' + rtrim(empleados.nombre) AS 'Nombre',
          empleados.fchalta,
          empleados.ultfchmov,
          empleados.ultmov,
          ISNULL(acum_emps.acu_percep,0) AS 'acu_percep',
          ISNULL(acum_emps.gravable,0) AS 'gravable',
          ISNULL(acum_emps.exento,0) AS 'exento',
          ISNULL(acum_emps.acu_percep,0) - (ISNULL(acum_emps.gravable,0) + ISNULL(acum_emps.exento,0)) AS 'Diferencia',
          ISNULL(acum_emps.Ptu,0) AS 'Ptu',
          ISNULL(forma30.gravable,0) + ISNULL(forma30.exento,0) AS 'OtrosPat',
          ISNULL(acum_emps.ispt,0) AS 'Ispt',
          ISNULL(acum_emps.Cr_sal,0) AS 'Cr_Sal',
          ISNULL(acum_emps.isrdejoretener,0) AS 'isrdejoretener',
          ISNULL(acum_emps.credtotal,0) AS 'credtotal',
          ISNULL(acum_emps.prevsocial,0) AS 'prevsocial',
          ISNULL(acum_emps.prevgrava,0) AS 'prevgrava',
          ISNULL(acum_emps.prevexenta,0) AS 'prevexenta',
          ISNULL(acum_emps.dias_labor,0) AS 'dias_labor',
          ISNULL(acum_emps.faltas,0) AS 'faltas',
          ISNULL(acum_emps.permisos,0) AS 'permisos',
          ISNULL(acum_emps.suspende,0) AS 'suspende',
          ISNULL(acum_emps.paro,0) AS 'paro',
          ISNULL(acum_emps.incap_rt,0) AS 'incap_rt',
          ISNULL(acum_emps.incap_eg,0) AS 'incap_eg',
          ISNULL(acum_emps.incap_mat,0) AS 'incap_mat',
          ISNULL(acum_emps.otrospagos,0) AS 'otrospagos'
   FROM dbo.empleados
   LEFT JOIN dbo.acum_emps On (empleados.codigo = acum_emps.codigo AND empleados.empresa = acum_emps.empresa AND acum_emps.ejercicio = @Ejercicio)
   LEFT JOIN dbo.Forma30   On (forma30.codigo = acum_emps.codigo AND forma30.empresa = acum_emps.empresa AND forma30.ejercicio = acum_emps.ejercicio)
   WHERE empleados.codigo = @Codigo AND
         empleados.empresa = @Empresa --And acum_emps.ejercicio = @Ejercicio
ELSE
   SELECT empleados.codigo,
          MAX(Rtrim(empleados.ap_paterno) + ' ' + Rtrim(empleados.ap_materno) + ' ' + rtrim(empleados.nombre)) AS 'Nombre',
          MIN(empleados.fchalta) AS 'fchalta',
          MAX(empleados.ultfchmov) AS 'ultfchmov',
          MAX(empleados.ultmov) AS 'ultmov',
          SUM(ISNULL(acum_emps.acu_percep,0)) AS 'acu_percep',
          SUM(ISNULL(acum_emps.gravable,0)) AS 'gravable',
          SUM(ISNULL(acum_emps.exento,0)) AS 'exento',
          SUM(ISNULL(acum_emps.acu_percep,0) - (ISNULL(acum_emps.gravable,0) + ISNULL(acum_emps.exento,0))) AS 'Diferencia',
          SUM(ISNULL(acum_emps.Ptu,0)) AS 'Ptu',
          SUM(ISNULL(forma30.gravable,0) + ISNULL(forma30.exento,0)) AS 'OtrosPat',
          SUM(ISNULL(acum_emps.ispt,0)) AS 'Ispt',
          SUM(ISNULL(acum_emps.Cr_sal,0)) AS 'Cr_Sal',
          SUM(ISNULL(acum_emps.isrdejoretener,0)) AS 'isrdejoretener',
          SUM(ISNULL(acum_emps.credtotal,0)) AS 'credtotal',
          SUM(ISNULL(acum_emps.prevsocial,0)) AS 'prevsocial',
          SUM(ISNULL(acum_emps.prevgrava,0)) AS 'prevgrava',
          SUM(ISNULL(acum_emps.prevexenta,0)) AS 'prevexenta',
          SUM(ISNULL(acum_emps.dias_labor,0)) AS 'dias_labor',
          SUM(ISNULL(acum_emps.faltas,0)) AS 'faltas',
          SUM(ISNULL(acum_emps.permisos,0)) AS 'permisos',
          SUM(ISNULL(acum_emps.suspende,0)) AS 'suspende',
          SUM(ISNULL(acum_emps.paro,0)) AS 'paro',
          SUM(ISNULL(acum_emps.incap_rt,0)) AS 'incap_rt',
          SUM(ISNULL(acum_emps.incap_eg,0)) AS 'incap_eg',
          SUM(ISNULL(acum_emps.incap_mat,0)) AS 'incap_mat',
          SUM(ISNULL(acum_emps.otrospagos,0)) AS 'otrospagos'
   FROM dbo.empleados
   LEFT JOIN dbo.acum_emps On (empleados.codigo = acum_emps.codigo AND empleados.empresa = acum_emps.empresa AND acum_emps.ejercicio = @Ejercicio)
   LEFT JOIN dbo.Forma30   On (forma30.codigo = acum_emps.codigo AND forma30.empresa = acum_emps.empresa AND forma30.ejercicio = acum_emps.ejercicio)
   LEFT JOIN dbo.consolidacion ON (empleados.empresa = consolidacion.empresas AND consolidacion.ejercicio = @Ejercicio )
   WHERE empleados.codigo = @Codigo
         --consolidacion.empresa = @Empresa --And acum_emps.ejercicio = @Ejercicio
   GROUP BY empleados.codigo
   ORDER BY empleados.codigo

GO



/**************************************************************************************************
 * Name          : 01.UserDefinedDataTypes.sql
 * Project       : Joaquinh's Framework
 * Description   : Creates the user-defined data types.
 * Copyright     : (c) joaquinh 2009 - 2014. All rights reserved
 * Company       : joaquinh. (http://www.joaquinh.com/)
 * Author        : Joaquin Hdz. G. (joaquinhdzg@hotmail.com)
 **************************************************************************************************/
/*==============================================================*/
/* Domain: udtBoolean                                           */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtBoolean' )
   CREATE TYPE dbo.udtBoolean FROM BIT
go

/*==============================================================*/
/* Domain: udtByte                                              */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtByte' )
   CREATE TYPE dbo.udtByte FROM TINYINT
GO

/*==============================================================*/
/* Domain: udtDateTime                                          */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtDateTime' )
   CREATE TYPE dbo.udtDateTime FROM DATETIME
go

/*==============================================================*/
/* Domain: udtFloat                                             */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtFloat' )
   CREATE TYPE dbo.udtFloat FROM FLOAT
go

/*==============================================================*/
/* Domain: udtId                                                */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtId' )
   CREATE TYPE dbo.udtId FROM BIGINT NOT NULL
go

/*==============================================================*/
/* Domain: udtInteger                                           */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtInteger' )
   CREATE TYPE dbo.udtInteger FROM INT
go

/*==============================================================*/
/* Domain: udtLong                                              */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtLong' )
   CREATE TYPE dbo.udtLong FROM BIGINT
go

/*==============================================================*/
/* Domain: udtName                                              */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtName' )
   CREATE TYPE dbo.udtName FROM VARCHAR(50)
go

/*==============================================================*/
/* Domain: udtNameId                                            */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtNameId' )
   CREATE TYPE dbo.udtNameId FROM VARCHAR(50) NOT NULL
go

/*==============================================================*/
/* Domain: udtStringSize1024                                    */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize1024' )
   CREATE TYPE dbo.udtStringSize1024 FROM VARCHAR(1024)
go

/*==============================================================*/
/* Domain: udtStringSize128                                     */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize128' )
   CREATE TYPE dbo.udtStringSize128 FROM VARCHAR(128)
go

/*==============================================================*/
/* Domain: udtStringSize2048                                    */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize2048' )
   CREATE TYPE dbo.udtStringSize2048 FROM VARCHAR(2048)
go

/*==============================================================*/
/* Domain: udtStringSize255                                     */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize255' )
   CREATE TYPE dbo.udtStringSize255 FROM VARCHAR(255)
go

/*==============================================================*/
/* Domain: udtStringSize4096                                    */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize4096' )
   CREATE TYPE dbo.udtStringSize4096 FROM VARCHAR(4096)
go

/*==============================================================*/
/* Domain: udtStringSize512                                     */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize512' )
   CREATE TYPE dbo.udtStringSize512 FROM VARCHAR(512)
go

/*==============================================================*/
/* Domain: udtStringSize8000                                    */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtStringSize8000' )
   CREATE TYPE dbo.udtStringSize8000 FROM VARCHAR(8000)
go

/*==============================================================*/
/* Domain: udtText                                              */
/*==============================================================*/
IF NOT EXISTS ( SELECT  1
            FROM    dbo.systypes
            WHERE   name = 'udtText' )
   CREATE TYPE dbo.udtText FROM TEXT
GO

/***********************************************************************************************
* Reporteador (funcion K)
************************************************************************************************/

/************************************************************************************************
* Descripcion  :Actualiza la tabla gr_catalogo, para agregar la nueva agrupacion
*               Para el reporteador de la nueva version 2011
* Creado por  : Mario Garcia
* Creado      : 07/09/2010
*************************************************************************************************/
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'gr_formas')
                    AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
    BEGIN
        ALTER TABLE dbo.gr_formas ALTER COLUMN  mascara VARCHAR(1024)
    END

IF NOT EXISTS ( SELECT  *
                FROM    dbo.gr_catalogo
                WHERE   orden = '01.-Generales' )
    BEGIN
        UPDATE  gr_catalogo
        SET     orden = '01.-Generales'
        WHERE   numero IN ( 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 16,
                            17, 18, 19, 20, 21, 31, 33, 42, 43, 44, 45, 52, 88,
                            89, 90, 93 )

        UPDATE  gr_catalogo
        SET     orden = '02.-Acumulados'
        WHERE   numero IN ( 36, 37, 53, 54, 55, 56, 57, 58, 75, 76, 77, 78, 79,
                            80, 81, 82, 83, 84, 85, 86, 91 )

        UPDATE  gr_catalogo
        SET     orden = '03.-De Nominas Calculadas'
        WHERE   numero IN ( 15, 30, 46, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68,
                            69, 70, 74, 92 )

        UPDATE  gr_catalogo
        SET     orden = '04.-Personales'
        WHERE   numero IN ( 22, 23, 24, 25, 26, 27, 32, 47, 48, 49, 50, 51, 71,
                            72, 73, 87 )

        UPDATE  gr_catalogo
        SET     orden = '05.-Otros'
        WHERE   numero IN ( 94, 95, 96, 97 )
    END

GO


/*
Se agrego nuevo campo, para saber como se van a dividir los dias de variables :
DiasNaturales .- Igual como siempre se ha hecho sobre los dias de avisos_imss
Diasnomina    .- De la tabla nomina1_anual, se consideraran los dias, ausentismos e incapacidades,
                 De los periodos que esten dentro del bimestre
                 24/08/2012
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'DivisorPercepcionesVariables'
                        AND sysobjects.name = 'empresas' )
    ALTER TABLE dbo.empresas ADD DivisorPercepcionesVariables VARCHAR(30) NULL

GO

UPDATE  dbo.empresas
SET     DivisorPercepcionesVariables = 'DIASNATURALES'
WHERE   DivisorPercepcionesVariables IS NULL

Go

IF NOT EXISTS ( SELECT  *
                FROM    dbo.opciones
                WHERE   opcion = 'S'
                        AND sistema = 'NO'
                        AND funcion = 'I' )
    INSERT  INTO opciones
            ( opcion ,
              sistema ,
              funcion ,
              descripcion
            )
    VALUES  ( 'S' ,
              'NO' ,
              'I' ,
              'Dias base para dividir los salarios variables'
            )

GO


IF NOT EXISTS ( SELECT  *
                FROM    dbo.perfil_funcion
                WHERE   idperfil = 1
                        AND funcion = 'I'
                        AND opcion = 'S' )
    BEGIN
        IF EXISTS ( SELECT  *
                    FROM    dbo.perfiles
                    WHERE   idperfil = 1 )
            INSERT  INTO dbo.perfil_funcion
                    ( funcion, opcion, idperfil )
            VALUES  ( 'I', 'S', 1 )
    END

GO



/*
Se agrego nuevo campo, para la conexion de la nomina con Infofin
S .- Ejecutar en la nomina el llenado de las tablas de infofin
N .- Ignorar este proceso
     02/05/2012
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'ConexionERP'
                        AND sysobjects.name = 'empresas' )
    ALTER TABLE dbo.empresas ADD ConexionERP CHAR(2) NULL

GO

UPDATE  dbo.empresas
SET     ConexionERP = 'N'
WHERE   ConexionERP IS NULL

Go


IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'UnidadReferencia_A'
                        AND sysobjects.name = 'salarios_minimos' )
    ALTER TABLE dbo.salarios_minimos ADD UnidadReferencia_A FLOAT NULL

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'UnidadReferencia_B'
                        AND sysobjects.name = 'salarios_minimos' )
    ALTER TABLE dbo.salarios_minimos ADD UnidadReferencia_B FLOAT NULL

GO


UPDATE  dbo.salarios_minimos
SET     UnidadReferencia_A = zona_a ,
        UnidadReferencia_B = zona_b
WHERE   UnidadReferencia_A IS NULL

GO

/*
Campos para la tabla de solicitud de Prestamos y permisos 30/06/2017
Adan Sanchez.
*/
IF NOT EXISTS ( SELECT  *
                 FROM    dbo.sysobjects
                 WHERE   id = OBJECT_ID(N'[dbo].[Solicitud_VPA]')
                         AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
BEGIN
  CREATE TABLE dbo.Solicitud_VPA
  (
    Empresa         numeric(3, 0) NOT NULL,
    Codigo          numeric(8, 0) NOT NULL,
    Disfrute        datetime      NOT NULL,
    Fin_Disfrute    datetime      NOT NULL,
    Dias_Disfrute   int               NULL,
    Dias_Autoriza   int               NULL,
    Estatus         varchar(2)        NULL,
    Motivo          varchar(50)       NULL,
    Fecha_Real      datetime          NULL,
    Cerrada         varchar(2)        NULL,
    CausaVacaciones varchar(100)      NULL,
    Importe         numeric(10, 2)    NULL,
    Tipo            varchar(3)    NOT NULL,
    Nomina          varchar(3)        NULL,
    idSolicitud     bigint            NULL,
    CONSTRAINT [PKSolicitud_VPA] PRIMARY KEY NONCLUSTERED
    (
      Tipo ASC,
      Disfrute ASC,
      Empresa ASC,
      Codigo ASC
    ) WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
  ) ON [PRIMARY]

  ALTER TABLE dbo.Solicitud_VPA  WITH CHECK ADD  CONSTRAINT RefempleadosSolicitud_VPA FOREIGN KEY(Empresa, Codigo)
  REFERENCES dbo.empleados (empresa, codigo)

  ALTER TABLE dbo.Solicitud_VPA CHECK CONSTRAINT RefempleadosSolicitud_VPA

  --INSERT INTO Solicitud_VPA
  --SELECT * ,0,'V'
  --FROM Solicitud_Vacaciones

END

GO


IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Nomina'
                        AND sysobjects.name = 'Solicitud_VPA' )
    ALTER TABLE dbo.Solicitud_VPA ADD Nomina VARCHAR(3) NULL
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'idSolicitud'
                        AND sysobjects.name = 'Solicitud_VPA' )
    ALTER TABLE dbo.Solicitud_VPA ADD idSolicitud bigint NULL
GO

/* Nuevo campo para identificar el tipo del concepto 133 Adan 14/10/2020 */
IF NOT EXISTS ( SELECT syscolumns.name
                FROM syscolumns
                     LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE syscolumns.name = 'Marca'
                      AND sysobjects.name = 'solicitud_VPA' )
   ALTER TABLE dbo.solicitud_VPA ADD Marca varchar(3) NULL
GO

/* Nuevos campos para identificar el tipo de plazo,plazo, fecha de autorizacion y usuarios, para los prestamos Adan 10/09/2021 */
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
				LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'FechaAprobacion'
				AND sysobjects.name = 'solicitud_VPA' ) 
				ALTER TABLE dbo.solicitud_VPA ADD FechaAprobacion Datetime null
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
				LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Usuario'
				AND sysobjects.name = 'solicitud_VPA' ) 
				ALTER TABLE dbo.solicitud_VPA ADD Usuario Varchar(100) null
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
				LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Plazo'
				AND sysobjects.name = 'Solicitud_VPA' ) 
				ALTER TABLE dbo.Solicitud_VPA ADD Plazo int NULL 
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
				LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'TipoPlazo'
				AND sysobjects.name = 'Solicitud_VPA' ) 
				ALTER TABLE dbo.Solicitud_VPA ADD TipoPlazo int NULL 
GO

/*
Tabla para los registros cancelados de CFDI
*/
IF OBJECT_ID('dbo.CancelaCFDIs') IS NULL
  CREATE TABLE dbo.CancelaCFDIs
  (
    Empresa          INTEGER,
    Codigo           INTEGER,
    Periodo          INTEGER,
    Ayo              INTEGER,
    TipoNom          INTEGER,
    Nomina           CHAR(3),
    ArchivoXML       VARCHAR(200),
    CorreoEnviado    CHAR(1),
    SelloSAT         VARCHAR(500),
    NoCertificadoSAT VARCHAR(50),
    SelloCFD         VARCHAR(500),
    FechaTimbrado    VARCHAR(20),
    UUID             VARCHAR(50),
    CadenaOriginal   VARCHAR(500),
    CertificadoCSD   VARCHAR(50),
    FechaCancela     DATETIME,
    FolioCancela     VARCHAR(200),
    Usuario          VARCHAR(50)

  )
GO

iF NOT EXISTS ( SELECT  *
                FROM    dbo.sysobjects
                WHERE   id = OBJECT_ID(N'[dbo].[PE_Incapacidades]')
                        AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
    BEGIN

		CREATE TABLE [dbo].[PE_Incapacidades](
			[idIncapacidad] [bigint] NOT NULL,
			[empresa] [int] NOT NULL,
			[codigo] [int] NOT NULL,
			[Inicio] [datetime] NULL,
			[Termino] [datetime] NULL,
			[Folio] [varchar](15) NULL,
			[Tipo] [varchar](3) NULL,
			[Riesgo] [int] NULL,
			[Secuela] [int] NULL,
			[control] [int] NULL,
			[Importado][int] NULL,
			[Comentarios][varchar](500),
		 CONSTRAINT [PK_PE_Incapacidades] PRIMARY KEY CLUSTERED
		(
			[idIncapacidad] ASC
		)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
		) ON [PRIMARY]

    END

GO

/*Se agregaron campos para registrar la fecha y usuario de quien actualiza */
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
				LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Usuario'
				    AND sysobjects.name = 'PE_Incapacidades' ) 
	ALTER TABLE dbo.PE_Incapacidades ADD Usuario Varchar(100) null
GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'FechaAprobacion'
                AND sysobjects.name = 'PE_Incapacidades' )
   ALTER TABLE dbo.PE_Incapacidades ADD FechaAprobacion datetime null
GO


/************************************************************************************************
* Descripcion  :Actualiza la tabla infonavit_cambios, para actualizar los motivos de cambios
*               y homologarlos con los del SUA
* Creado por  : Mario Garcia
* Creado      : 12/09/2012
*************************************************************************************************/

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'infonavit_cambios')
                    AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
    BEGIN
        ALTER TABLE dbo.infonavit_cambios ALTER COLUMN  cambio VARCHAR(3)
    END

GO


UPDATE  dbo.infonavit_cambios
SET     cambio = CASE WHEN cambio = 'A' THEN 'ICV'
                      WHEN cambio = 'B' THEN 'FSD'
                      WHEN cambio = 'C' THEN 'RD'
                      WHEN cambio = 'D' THEN 'MTD'
                      WHEN cambio = 'E' THEN 'MVD'
                      WHEN cambio = 'F' THEN 'MNC'
                      WHEN cambio = 'G' THEN 'MFO'
                      WHEN cambio = 'H' THEN 'MFI'
                      WHEN cambio = 'I' THEN 'MFL'
                      WHEN cambio = 'J' THEN 'MSV'
                 END
WHERE   cambio IN ( 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J' )

GO

/************************************************************************************************
* Descripcion  :Funcion para convertir una cadena separada por comas, a una tabla con los valores
*               dicha cadena
* Parametros  : @pString = Cadena de valores
*             : @pDelimiter = delimitador entre los valores, por ejemplo la coma
* Regresa     : una tabla con los valores de la cadena.
* Creado por  : Mario Garcia
* Creado      : 20/03/2013
*************************************************************************************************/

IF OBJECT_ID('dbo.CadenaATabla') IS NOT NULL
    DROP FUNCTION dbo.CadenaATabla

Go


CREATE FUNCTION [dbo].[CadenaATabla]
--===== Define I/O parameters
    (
      @pString VARCHAR(8000) ,
      @pDelimiter CHAR(1)
    )
RETURNS TABLE
    WITH SCHEMABINDING
AS

 RETURN
  WITH  E1 ( N )
          AS ( SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
               UNION ALL
               SELECT   1
             ),                          --10E+1 or 10 rows
        E2 ( N )
          AS ( SELECT   1
               FROM     E1 a ,
                        E1 b
             ), --10E+2 or 100 rows
        E4 ( N )
          AS ( SELECT   1
               FROM     E2 a ,
                        E2 b
             ), --10E+4 or 10,000 rows max
        cteTally ( N )
          AS (
               SELECT TOP ( ISNULL(DATALENGTH(@pString), 0) )
                        ROW_NUMBER() OVER ( ORDER BY ( SELECT NULL
                                                     ) )
               FROM     E4
             ),
        cteStart ( N1 )
          AS (
               SELECT   1
               UNION ALL
               SELECT   t.N + 1
               FROM     cteTally t
               WHERE    SUBSTRING(@pString, t.N, 1) = @pDelimiter
             ),
        cteLen ( N1, L1 )
          AS (
               SELECT   s.N1 ,
                        ISNULL(NULLIF(CHARINDEX(@pDelimiter, @pString, s.N1),
                                      0) - s.N1, 8000)
               FROM     cteStart s
             )

 SELECT registro = ROW_NUMBER() OVER ( ORDER BY l.N1 ) ,
        valor = SUBSTRING(@pString, l.N1, l.L1)
 FROM   cteLen l


GO




/***********************************************************************************************
* Reportes de deducciones funcion E
************************************************************************************************/

/**************************************************************************************************
 * Name          : GetDeductiosListAbsenteeism
 * Project       : APSI Nomina
 * Description   : July 06, 2010
 *                 List deductios concepts from period
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : July 06 2010
 * Parameters    : companyId
 *               : operationMonth1 = Begin Month
 *               : operationMonth2 = End Month
 *               : operationYear   = Operation Year
 *               : order           = 1 Codigo, 2, Nombre, 3 Centro y codigo, 4 Centro y nombre
 *               : conceptList     = Id concepts to list
 *               : detailLis       = 0 Details conceptos, 1 Resumen concepts
 **************************************************************************************************/

IF OBJECT_ID('dbo.GetDeductiosListAbsenteeism') IS NOT NULL
    DROP PROCEDURE dbo.GetDeductiosListAbsenteeism
Go


CREATE PROCEDURE dbo.GetDeductiosListAbsenteeism
    (
      @companyId AS INT ,
      @operationMonth1 AS INT ,
      @operationMonth2 AS INT ,
      @operationYear AS INT ,
      @order AS INT ,
      @conceptList AS VARCHAR(4000) ,
      @detailList AS INT,
      @showSBC AS CHAR(1)
    )
AS

    SET NOCOUNT ON

    DECLARE @selectClausule AS VARCHAR(4000)
    DECLARE @whereClausule AS VARCHAR(4000)
    DECLARE @orderClausule AS VARCHAR(4000)
    DECLARE @groupByClausule AS VARCHAR(4000)
    DECLARE @dateInitial AS CHAR(8)
    DECLARE @dateFinal AS CHAR(8)
    DECLARE @amount AS FLOAT
    DECLARE @showSBCClausule AS VARCHAR(100)
    DECLARE @showDeductionClausule AS VARCHAR(100)
    DECLARE @nameFalta AS VARCHAR(100)
    DECLARE @namePermiso AS VARCHAR(100)
    DECLARE @nameSuspension AS VARCHAR(100)
    DECLARE @nameParo AS VARCHAR(100)
    DECLARE @nameLic140bis AS VARCHAR(100)
    DECLARE @namePermisoCovid AS VARCHAR(100)


    SET @selectClausule = ''
    SET @whereClausule = ''
    SET @orderClausule = ''
    SET @groupByClausule = ''

    SET @nameFalta = 'FALTA INJUSTIFICADA'
    SET @namePermiso = 'PERMISO SIN SUELDO'
    SET @nameSuspension = 'SUSPENSION/DISCIPLINA'
    SET @nameParo = 'PARO TECNICO'

    SET @nameLic140bis = 'LICENCIA ART. 140 BIS LSS'
    SET @namePermisoCovid = 'PERMISO COVID ENF. GRAL.'

    SELECT  @nameFalta = CASE WHEN LEN(RTRIM(ISNULL(variable1, ''))) > 0
                              THEN  RTRIM(variable1)
                              ELSE  @nameFalta
                         END ,
            @namePermiso = CASE WHEN LEN(RTRIM(ISNULL(variable2, ''))) > 0
                                THEN RTRIM(variable2)
                                ELSE @namePermiso
                           END ,
            @nameSuspension = CASE WHEN LEN(RTRIM(ISNULL(variable3, ''))) > 0
                                   THEN RTRIM(variable3)
                                   ELSE @nameSuspension
                              END ,
            @nameParo = CASE WHEN LEN(RTRIM(ISNULL(variable4, ''))) > 0
                             THEN RTRIM(variable4)
                             ELSE @nameParo
                        END
    FROM    dbo.conceptos
    WHERE   empresa = @companyid
            AND num_conc = 108
            AND clase = ''


    SET @dateInitial = dbo.DateToChar(dbo.NvaFecha(1,@operationMonth1,@operationYear),'YYYYMMDD','')
    SET @dateFinal = dbo.DateToChar(dbo.fin_mes(@operationMonth2,@operationYear),'YYYYMMDD','')

    IF @showSBC <> 'S'
        BEGIN
            SET @showSBCClausule = '0.00 as saldiaint,'
            SET @showDeductionClausule = '0.00 as descuento,'
        END
    ELSE
       BEGIN
            SET @showSBCClausule = 'e.saldiaint,'
            SET @showDeductionClausule = 'd.descuento,'
       END


    IF @detailList = 0
        SET @selectClausule = 'SELECT  e.codigo ,
                               e.afiliacion + ''-'' + e.digvera AS Afiliacion,
                               RTRIM(e.ap_paterno) + '' '' + RTRIM(e.ap_materno) + '' '' + RTRIM(e.nombre) AS ''Nombre'' ,' +
                               @showSBCClausule + '
                               CASE WHEN d.num_conc = 108 THEN d.justificar ELSE d.tipoinc END AS ''TipoInc'',
                               d.inicsubs,
                               CASE WHEN (d.fchinicio >=''' + @dateInitial + ''' AND d.fchtermino <= ''' + @dateFinal + ''') THEN d.dias
                               WHEN (d.fchinicio < ''' + @dateInitial + ''' AND (d.fchtermino >= ''' + @dateInitial + ''' AND d.fchtermino <= ''' + @dateFinal + ''')) THEN DATEDIFF(DAY,''' + @dateInitial + ''',d.fchtermino) + 1
                               WHEN (d.fchinicio >= ''' + @dateInitial + ''' AND d.fchInicio <= ''' + @dateFinal + ''') THEN DATEDIFF(DAY,d.fchInicio,''' + @dateFinal+ ''') + 1
                               WHEN (d.fchinicio < ''' + @dateInitial + ''' AND d.fchtermino > ''' + @dateFinal + ''') THEN DATEDIFF(DAY,''' + @dateInitial + ''',''' + @dateFinal+ ''') + 1 END AS dias,
                               d.numeroinc,
                               CASE WHEN d.fchinicio < ''' + @dateInitial + ''' THEN ''' + @dateInitial + ''' ELSE d.fchinicio END AS fchinicio,'+
                               @showDeductionClausule + '
                               ll.tiponom ,
                               ll.centro ,
                               d.Num_Conc ,
                               cc.nomdepto
                               FROM    deducciones AS d
                               INNER JOIN empleados AS e ON ( d.Codigo = e.codigo AND d.empresa = e.empresa )
                               INNER JOIN llaves AS ll ON ( d.codigo = ll.codigo AND d.empresa = ll.empresa )
                               INNER JOIN centros AS cc ON (ll.empresa = cc.empresa AND ll.centro = cc.centro) '
    ELSE
        SET @selectClausule = 'SELECT d.num_conc ,
                               CASE WHEN d.num_conc = 107 AND d.justificar = ''F'' THEN ''AJTE POR FALTA INJUST''
                                    WHEN d.num_conc = 107 AND d.justificar = ''I'' THEN ''AJTE POR INCAPACIDAD''
                                    WHEN d.num_conc = 107 AND d.justificar = ''P'' THEN ''AJTE POR PERMISO S/SDO''
                                    WHEN d.num_conc = 108 AND d.justificar = ''F'' THEN ''' + @nameFalta + '''
                                    WHEN d.num_conc = 108 AND d.justificar = ''P'' THEN ''' + @namePermiso + '''
                                    WHEN d.num_conc = 108 AND d.justificar = ''S'' THEN ''' + @nameSuspension + '''
                                    WHEN d.num_conc = 108 AND d.justificar = ''T'' THEN ''' + @nameParo + '''
                                    WHEN d.num_conc = 109 AND d.inicsubs = ''4'' THEN ''' + @nameLic140bis + '''
                                    WHEN d.num_conc = 109 AND d.num_cr = 1 THEN ''' + @namePermisoCovid + '''
                                    ELSE c.concepto END AS ''concepto'',
                               SUM(d.descuento) AS ''descuento'' ,
                               SUM(CASE WHEN (d.fchinicio >=''' + @dateInitial + ''' AND d.fchtermino <= ''' + @dateFinal + ''') THEN d.dias
                                        WHEN (d.fchinicio < ''' + @dateInitial + ''' AND (d.fchtermino >= ''' + @dateInitial + ''' AND d.fchtermino <= ''' + @dateFinal + ''')) THEN DATEDIFF(DAY,''' + @dateInitial + ''',d.fchtermino) + 1
                                        WHEN (d.fchinicio >= ''' + @dateInitial + ''' AND d.fchInicio <= ''' + @dateFinal + ''') THEN DATEDIFF(DAY,d.fchInicio,''' + @dateFinal+ ''') + 1
                                        WHEN (d.fchinicio < ''' + @dateInitial + ''' AND d.fchtermino > ''' + @dateFinal + ''') THEN DATEDIFF(DAY,''' + @dateInitial + ''',''' + @dateFinal+ ''') + 1 END) AS dias
                               FROM deducciones AS d
                               INNER JOIN conceptos AS c ON (d.num_conc = c.num_conc AND d.empresa = c.empresa AND d.clase = c.clase AND d.centro = c.centro) '



    SET @whereClausule = 'WHERE d.empresa = ' + CONVERT(CHAR(3), @companyId)
        + ' AND ( (d.fchinicio >=''' + @dateInitial + ''' AND d.fchtermino <= ''' + @dateFinal + ''')'
        + '  OR (d.fchinicio < ''' + @dateInitial + ''' AND (d.fchtermino >= ''' + @dateInitial + ''' AND d.fchtermino <= ''' + @dateFinal + ''')) '
        + '  OR (d.fchinicio >= ''' + @dateInitial + ''' AND d.fchInicio <= ''' + @dateFinal + ''' AND d.fchtermino >= ''' + @dateFinal + ''') '
        + '  OR (d.fchinicio < ''' + @dateInitial + ''' AND d.fchtermino > ''' + @dateFinal + ''') ) '

/*
        + ' AND (d.mes_operacion >=  ' + CONVERT(CHAR(3), @operationMonth1)
        + ' AND d.mes_operacion <=  ' + CONVERT(CHAR(3), @operationMonth2) + ') '
        + ' AND d.ayo_operacion = ' + CONVERT(CHAR(4), @operationYear)
*/

    IF LEN(RTRIM(@conceptList)) > 0
        SET @whereClausule = @whereClausule + ' AND d.num_conc IN ('
            + @conceptList + ') '

    IF @detailList = 0
        SET @orderClausule = ' ORDER BY '
            + CASE WHEN @order = 1 THEN 'd.codigo,d.fchinicio'
                   WHEN @order = 2 THEN 'e.ap_paterno,e.ap_materno,e.Nombre,d.fchinicio'
                   WHEN @order = 3 THEN 'll.centro,e.Codigo,d.fchinicio'
                   WHEN @order = 4 THEN 'e.afiliacion,e.digvera,d.fchinicio'
                   ELSE 'd.codigo,d.fchinicio'
              END
    ELSE
        BEGIN
            SET @groupByClausule = ' GROUP BY d.num_conc,d.justificar,c.concepto,d.inicsubs,d.num_cr '
            SET @orderClausule = ' ORDER BY d.num_conc '
        END

    EXECUTE ( @selectClausule + @whereClausule + @groupByClausule + @orderClausule )
    --SELECT @selectClausule , @whereClausule , @orderClausule

GO


/**************************************************************************************************
 * Name          : GetDeductiosCapturedListPeriod
 * Project       : APSI Nomina
 * Description   : July 06, 2010
 *                 List deductios concepts from period
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : July 06 2010
 **************************************************************************************************/

IF OBJECT_ID('dbo.GetDeductiosCapturedListPeriod') IS NOT NULL
    DROP PROCEDURE dbo.GetDeductiosCapturedListPeriod
Go



CREATE PROCEDURE dbo.GetDeductiosCapturedListPeriod
    (
      @companyid AS INT ,
      @periodid AS INT ,
      @payrolltype AS INT ,
      @operationyear AS INT ,
      @order AS INT ,
      @conceptlist AS VARCHAR(4000) ,
      @detaillist AS INT
    )
AS

    SET NOCOUNT ON

    DECLARE @selectclausule AS VARCHAR(4000)
    DECLARE @whereclausule AS VARCHAR(4000)
    DECLARE @orderclausule AS VARCHAR(4000)
    DECLARE @groupbyclausule AS VARCHAR(4000)
    DECLARE @nameFalta AS VARCHAR(100)
    DECLARE @namePermiso AS VARCHAR(100)
    DECLARE @nameSuspension AS VARCHAR(100)
    DECLARE @nameParo AS VARCHAR(100)
    DECLARE @stringPayDate AS CHAR(08)
    DECLARE @nameLic140bis AS VARCHAR(100)
    DECLARE @namePermisoCovid AS VARCHAR(100)


    SET @selectclausule = ''
    SET @whereclausule = ''
    SET @orderclausule = ''
    SET @groupbyclausule = ''
    SET @nameFalta = 'FALTA INJUSTIFICADA'
    SET @namePermiso = 'PERMISO SIN SUELDO'
    SET @nameSuspension = 'SUSPENSION/DISCIPLINA'
    SET @nameParo = 'PARO TECNICO'

    SET @nameLic140bis = 'LICENCIA ART. 140 BIS LSS'
    SET @namePermisoCovid = 'PERMISO COVID ENF. GRAL.'

    SELECT  @stringPayDate = dbo.DateToChar(periodos.pago,'','')
    FROM    dbo.Periodos
    WHERE   empresa = @companyid
            AND periodo = @periodid
            AND ayo_operacion = @operationyear
            AND tiponom = @payrolltype


    SELECT  @nameFalta = CASE WHEN LEN(RTRIM(ISNULL(variable1, ''))) > 0
                              THEN  RTRIM(variable1)
                              ELSE  @nameFalta
                         END ,
            @namePermiso = CASE WHEN LEN(RTRIM(ISNULL(variable2, ''))) > 0
                                THEN RTRIM(variable2)
                                ELSE @namePermiso
                           END ,
            @nameSuspension = CASE WHEN LEN(RTRIM(ISNULL(variable3, ''))) > 0
                                   THEN RTRIM(variable3)
                                   ELSE @nameSuspension
                              END ,
            @nameParo = CASE WHEN LEN(RTRIM(ISNULL(variable4, ''))) > 0
                             THEN RTRIM(variable4)
                             ELSE @nameParo
                        END
    FROM    dbo.conceptos
    WHERE   empresa = @companyid
            AND num_conc = 108
            AND clase = ''


    IF @detaillist = 0
        SET @selectclausule = 'SELECT  e.codigo ,
                       RTRIM(e.ap_paterno) + '' '' + RTRIM(e.ap_materno) + '' '' + RTRIM(e.nombre) AS ''Nombre'' ,
                       ll.tiponom ,
                       ll.centro ,
                       d.Num_Conc ,
                       CASE WHEN d.num_conc = 107 AND d.justificar = ''F'' THEN ''AJTE POR FALTA INJUST''
                            WHEN d.num_conc = 107 AND d.justificar = ''I'' THEN ''AJTE POR INCAPACIDAD''
                            WHEN d.num_conc = 107 AND d.justificar = ''P'' THEN ''AJTE POR PERMISO S/SDO''
                            WHEN d.num_conc = 108 AND d.justificar = ''F'' THEN ''' + @nameFalta + '''
                            WHEN d.num_conc = 108 AND d.justificar = ''P'' THEN ''' + @namePermiso + '''
                            WHEN d.num_conc = 108 AND d.justificar = ''S'' THEN ''' + @nameSuspension + '''
                            WHEN d.num_conc = 108 AND d.justificar = ''T'' THEN ''' + @nameParo + '''
                            WHEN d.num_conc = 109 AND d.inicsubs = ''4'' THEN ''' + @nameLic140bis + '''
                            WHEN d.num_conc = 109 AND d.num_cr = 1 THEN ''' + @namePermisoCovid + '''
                            ELSE c.concepto END AS ''concepto'',
                       CASE WHEN d.num_conc IN (108,109,110,111) THEN d.fchinicio ELSE d.Fch_Pago END AS Fch_Pago,
                       d.Plazo ,
                       d.Descuento ,
                       d.Dias,
                       d.Dias ,
                       CASE WHEN d.Num_conc = 108 THEN CONVERT(CHAR(10),d.dias)
                            WHEN d.num_conc >= 109 AND d.num_conc <= 111 THEN d.NumeroInc
                            WHEN d.num_conc = 120 THEN CONVERT(CHAR(10),d.varia2)
                            ELSE d.NumeroInc END AS NumeroInc,
                       d.FchInicio ,
                       d.Varia1 ,
                       d.Varia2 ,
                       d.Varia3 ,
                       d.Varia4 ,
                       d.Justificar ,
                       cc.nomdepto
                       FROM dbo.deducciones AS d
                       INNER JOIN empleados AS e ON ( d.Codigo = e.codigo AND d.empresa = e.empresa )
                       INNER JOIN llaves AS ll ON ( d.codigo = ll.codigo AND d.empresa = ll.empresa )
                       INNER JOIN conceptos AS c ON (d.num_conc = c.num_conc AND d.empresa = c.empresa AND d.clase = c.clase AND d.centro = c.centro)
                       INNER JOIN centros AS cc ON (ll.empresa = cc.empresa AND ll.centro = cc.centro) '
    ELSE
        SET @selectclausule = 'SELECT d.num_conc ,
                          CASE WHEN d.num_conc = 107 AND d.justificar = ''F'' THEN ''AJTE POR FALTA INJUST''
                               WHEN d.num_conc = 107 AND d.justificar = ''I'' THEN ''AJTE POR INCAPACIDAD''
                               WHEN d.num_conc = 107 AND d.justificar = ''P'' THEN ''AJTE POR PERMISO S/SDO''
                               WHEN d.num_conc = 108 AND d.justificar = ''F'' THEN ''' + @nameFalta + '''
                               WHEN d.num_conc = 108 AND d.justificar = ''P'' THEN ''' + @namePermiso + '''
                               WHEN d.num_conc = 108 AND d.justificar = ''S'' THEN ''' + @nameSuspension + '''
                               WHEN d.num_conc = 108 AND d.justificar = ''T'' THEN ''' + @nameParo + '''
                               WHEN d.num_conc = 109 AND d.inicsubs = ''4'' THEN ''' + @nameLic140bis + '''
                               WHEN d.num_conc = 109 AND d.num_cr = 1 THEN ''' + @namePermisoCovid + '''
                               ELSE c.concepto END AS ''concepto'',
                          SUM(d.Descuento) AS ''descuento'' ,
                          SUM(d.Varia1) AS ''varia1'' ,
                          SUM(d.Varia2) AS ''varia2'' ,
                          SUM(d.Varia3) AS ''varia3'' ,
                          SUM(d.Varia4) AS ''varia4''
                          FROM dbo.deducciones AS d
                          INNER JOIN conceptos AS c ON (d.num_conc = c.num_conc AND d.empresa = c.empresa AND d.clase = c.clase AND d.centro = c.centro) '


    IF @periodid <> 1
       SET @whereclausule = 'WHERE d.empresa = ' + CONVERT(CHAR(3), @companyid)
           + ' AND d.periodo =  ' + CONVERT(CHAR(3), @periodid)
           + ' AND d.ayo_operacion = ' + CONVERT(CHAR(4), @operationyear)
           + ' AND d.tiponom = ' + CONVERT(CHAR(3), @payrolltype)
    ELSE
       SET @whereclausule = 'WHERE d.empresa = ' + CONVERT(CHAR(3), @companyid)
           + ' AND d.fch_pago =  ''' + @stringPayDate + ''''
           + ' AND d.tiponom = ' + CONVERT(CHAR(3), @payrolltype)


    IF LEN(RTRIM(@conceptlist)) > 0
        SET @whereclausule = @whereclausule + ' AND d.num_conc IN ('
            + @conceptlist + ') '

    IF @detaillist = 0
        SET @orderclausule = ' ORDER BY '
            + CASE WHEN @order = 1 THEN 'd.codigo,d.fchinicio,d.folio'
                   WHEN @order = 2
                   THEN 'e.ap_paterno,e.ap_materno,e.Nombre,d.fchinicio,d.Folio'
                   WHEN @order = 3 THEN 'll.centro,e.Codigo,d.fchinicio,d.Folio'
                   ELSE 'd.codigo,d.fchinicio,d.folio'
              END
    ELSE
        BEGIN
            SET @groupbyclausule = ' GROUP BY d.num_conc,d.justificar,c.concepto,inicsubs,num_cr '
            SET @orderclausule = ' ORDER BY d.num_conc '
        END

    EXECUTE ( @selectclausule + @whereclausule + @groupbyclausule + @orderclausule )


GO


/***********************************************************************************************
* Reportes percepciones funcion F
************************************************************************************************/

/**************************************************************************************************
 * Name          : GetPerceptionsCapturedListPeriod
 * Project       : APSI Nomina
 * Description   : September 02, 2010
 *                 List perceptions concepts from period
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : September 02 2010
 **************************************************************************************************/

IF OBJECT_ID('dbo.GetPerceptionsCapturedListPeriod') IS NOT NULL
    DROP PROCEDURE dbo.GetPerceptionsCapturedListPeriod
Go


CREATE PROCEDURE dbo.GetPerceptionsCapturedListPeriod
    (
      @companyId AS INT ,
      @periodId AS INT ,
      @payrollType AS INT ,
      @operationYear AS INT ,
      @order AS INT ,
      @conceptList AS VARCHAR(4000) ,
      @detailList AS INT
    )
AS
    DECLARE @selectClausule AS VARCHAR(4000)
    DECLARE @whereClausule AS VARCHAR(4000)
    DECLARE @orderClausule AS VARCHAR(4000)
    DECLARE @groupByClausule AS VARCHAR(4000)

    SET @selectClausule = ''
    SET @whereClausule = ''
    SET @orderClausule = ''
    SET @groupByClausule = ''

    IF @detailList = 0
        SET @selectClausule = 'SELECT  e.codigo ,
                       RTRIM(e.ap_paterno) + '' '' + RTRIM(e.ap_materno) + '' '' + RTRIM(e.nombre) AS ''Nombre'' ,
                       ll.tiponom ,
                       ll.centro ,
                       p.Num_Conc ,
                       c.concepto ,
                       e.FchAntigua,
                       p.Fch_Pago,
                       p.Fch_Real,
                       p.Nomina,
                       p.Horas_Ex,
                       p.Varia1,
                       p.Varia2,
                       p.Varia3,
                       p.Varia4,
                       p.Siempre,
                       p.motivo,
                       cc.nomdepto
                       FROM    dbo.percepciones AS p
                       INNER JOIN empleados AS e ON ( p.Codigo = e.codigo AND p.empresa = e.empresa )
                       INNER JOIN llaves AS ll ON ( p.codigo = ll.codigo AND p.empresa = ll.empresa )
                       INNER JOIN conceptos AS c ON (p.num_conc = c.num_conc AND p.empresa = c.empresa AND p.clase = c.clase AND p.centro = c.centro)
                       INNER JOIN centros AS cc ON (ll.empresa = cc.empresa AND ll.centro = cc.centro) '

    IF @detailList = 1
        SET @selectClausule = 'SELECT p.num_conc ,
                          c.concepto,
                          SUM(p.nomina) AS ''Nomina'' ,
                          SUM(p.Varia1) AS ''varia1'' ,
                          SUM(p.Varia2) AS ''varia2'' ,
                          SUM(p.Varia3) AS ''varia3'' ,
                          SUM(p.Varia4) AS ''varia4'' ,
                          SUM(p.Horas_ex) AS ''Horas''
                          FROM dbo.percepciones AS p
                          INNER JOIN conceptos AS c ON (p.num_conc = c.num_conc AND p.empresa = c.empresa AND p.clase = c.clase AND p.centro = c.centro) '

    IF @detailList = 2
        SET @selectClausule = 'SELECT p.motivo ,
                          SUM(p.horas_ex) AS ''Horas'' ,
                          SUM(p.nomina) AS ''Nomina''  ,
                          MAX(m.descripcion) AS ''Descripcion''
                          FROM dbo.percepciones AS p
                          INNER JOIN motivo_cambio AS m ON (p.motivo = m.num_motivo AND m.dato = ''TEX'') '


    SET @whereClausule = 'WHERE p.empresa = ' + CONVERT(CHAR(3), @companyId)
        + ' AND p.periodo =  ' + CONVERT(CHAR(3), @periodId)
        + ' AND p.ayo_operacion = ' + CONVERT(CHAR(4), @operationYear)
        + ' AND p.tiponom = ' + CONVERT(CHAR(3), @payrollType)

    IF @detailList < 2
       BEGIN
       IF LEN(RTRIM(@conceptList)) > 0
             SET @whereClausule = @whereClausule + ' AND p.num_conc IN ('
            + @conceptList + ') '
       END
    ELSE
        SET @whereClausule = @whereClausule + ' AND (p.num_conc >= 10 AND p.num_conc <= 13) '

    IF @detailList = 0
        SET @orderClausule = ' ORDER BY '
            + CASE WHEN @order = 1 THEN 'p.codigo,p.folio'
                   WHEN @order = 2
                   THEN 'e.ap_paterno,e.ap_materno,e.Nombre,p.Folio'
                   WHEN @order = 3 THEN 'll.centro,e.Codigo,p.Folio'
                   ELSE 'p.codigo,p.folio'
              END
    IF @detailList = 1
        BEGIN
            SET @groupByClausule = ' GROUP BY p.num_conc,c.concepto '
            SET @orderClausule = ' ORDER BY p.num_conc '
        END
    IF @detailList = 2
        BEGIN
            SET @groupByClausule = ' GROUP BY p.motivo '
            SET @orderClausule = ' ORDER BY p.motivo '
        END

    EXECUTE ( @selectClausule + @whereClausule + @groupByClausule + @orderClausule )
    --SELECT @selectClausule , @whereClausule ,@groupByClausule ,@orderClausule

GO


/***********************************************************************************************
* Reportes de motivos Funcion K
************************************************************************************************/

/**************************************************************************************************
 * Name          : Fun_K_GetMotivesIncidences
 * Project       : APSI Nomina
 * Description   : September 02, 2010
 *                 Genera datos para graficas por motivos de baja, tiempo extra y cambios a
                   los datos de empleados
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : September 02 2010
 **************************************************************************************************/

IF OBJECT_ID('dbo.Fun_K_GetMotivesIncidences') IS NOT NULL
    DROP PROCEDURE dbo.Fun_K_GetMotivesIncidences
GO


CREATE PROCEDURE dbo.Fun_K_GetMotivesIncidences
    (
      @empresa AS INT ,
      @fechaInicio AS DATETIME ,
      @fechaCierre AS DATETIME ,
      @tipoReporte AS INT
    )
AS
    SET NOCOUNT OFF


    /*
    *  Reporte por cambios en campos de captura de los datos de empleado
    */
    IF @tipoReporte = 1
        OR @tipoReporte = 0
        SELECT  h.campo AS 'valor' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
        WHERE   h.campo IN ( 'CLASE', 'TIPONOM', 'CENTRO', 'TABULADOR',
                             'HORARIO', 'SINDICATO', 'SUELDO', 'DOMICILIO' )
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
        GROUP BY h.campo
        ORDER BY h.campo


    /*
    * Reporte por motivos del tiempo extra
    */

    IF @tipoReporte = 2
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(p.horas_ex) AS 'Casos'
        FROM    dbo.percepciones AS p
                INNER JOIN dbo.conceptos AS c ON ( p.empresa = c.empresa
                                                   AND p.num_conc = c.num_conc
                                                   AND p.clase = c.clase
                                                   AND p.centro = c.centro
                                                 )
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( p.motivo = mtv.num_motivo )
        WHERE   p.num_conc >= 10
                AND p.num_conc <= 13
                AND p.motivo IS NOT NULL
                AND p.fch_pago >= @fechaInicio
                AND p.fch_pago <= @fechaCierre
                AND p.empresa = @empresa
                AND p.motivo > 0
                AND mtv.dato = 'TEX'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos de avisos afiliatorios (bajas)
    */

    IF @tipoReporte = 3
        OR @tipoReporte = 0
        SELECT  mot_baja AS 'motivo' ,
                COUNT(codigo) AS 'Casos'
        FROM    dbo.avisos_imss
        WHERE   mov = 'B'
                AND clave_baja IS NOT NULL
                AND fch_mov >= @fechaInicio
                AND fch_mov <= @fechaCierre
                AND empresa = @empresa
                AND clave_baja > 0
        GROUP BY mot_baja

    /*
    * Reporte por motivos cambio en el campo tiponom
    */
    IF @tipoReporte = 4
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'TIPONOM'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'TPNO'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos cambio en el campo Centro
    */
    IF @tipoReporte = 5
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'CENTRO'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'CECO'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos cambio en el campo Horario
    */
    IF @tipoReporte = 6
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'HORARIO'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'HORA'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos cambio en el campo Tabulador
    */
    IF @tipoReporte = 7
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'TABULADOR'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'TAB'
        GROUP BY mtv.descripcion


    /*
    * Reporte por motivos cambio en el campo Sindicato
    */
    IF @tipoReporte = 8
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'SINDICATO'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'SIND'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos cambio en el campo Sueldo
    */
    IF @tipoReporte = 9
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'SUELDO'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'SDO'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos cambio en el campo Sueldo
    */
    IF @tipoReporte = 10
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'MANOOBRA'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'MANO'
        GROUP BY mtv.descripcion


    /*
    * Reporte por motivos cambio en el campo Domicilio
    */
    IF @tipoReporte = 11
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'DOMICILIO'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'DOM'
        GROUP BY mtv.descripcion

    /*
    * Reporte por motivos cambio en el campo Clase
    */
    IF @tipoReporte = 12
        OR @tipoReporte = 0
        SELECT  mtv.descripcion AS 'motivo' ,
                COUNT(h.codigo) AS 'Casos'
        FROM    dbo.Historico AS h
                LEFT JOIN dbo.motivo_cambio AS mtv ON ( h.num_motivo = mtv.num_motivo )
        WHERE   h.campo = 'CLASE'
                AND h.num_motivo IS NOT NULL
                AND h.fecha_captura >= @fechaInicio
                AND h.fecha_captura <= @fechaCierre
                AND h.empresa = @empresa
                AND h.num_motivo > 0
                AND mtv.dato = 'CLA'
        GROUP BY mtv.descripcion

GO


----------------------------------------------------------------------------------------------------------------------------------------
--
--   Vacations PROCEDURES
--
----------------------------------------------------------------------------------------------------------------------------------------

/**************************************************************************************************
 * Name          : GetVacationsForAbsentimsForYear
 * Project       : APSI Nomina
 * Description   : Browse Savings to Employee
 * Table name    :
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx)
 * Creation date : Wednesday, 16-10-2013
 **************************************************************************************************/

/**************************************************************************************************
 * Name          : GetVacationsForAbsentimsForYear
 * Project       : APSI Nomina
 * Description   : Browse Savings to Employee
 * Table name    :
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx)
 * Creation date : Wednesday, 16-10-2013
 **************************************************************************************************/

IF OBJECT_ID('dbo.GetVacationsForAbsentimsForYear') IS NOT NULL
    DROP PROCEDURE dbo.GetVacationsForAbsentimsForYear

Go


CREATE PROCEDURE dbo.GetVacationsForAbsentimsForYear
    (
      @companyId INTEGER ,
      @employeeId INTEGER ,
      @year INTEGER
    )
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    DECLARE @detailVacationsEnd AS TABLE
        (
          empresa INTEGER  ,
          codigo INTEGER ,
          disfrute dbo.udtDateTime ,
          dias_disfr INTEGER ,
          disf_ant INTEGER ,
          descansos INTEGER ,
          festivos INTEGER ,
          fin_disfru dbo.udtDateTime ,
          periodo INTEGER ,
          ayo_operacion INTEGER,
          num_conc INTEGER
        )

    DECLARE @detailVacations AS TABLE
        (
          disfrute dbo.udtDateTime ,
          dias_disfr INTEGER ,
          disf_ant INTEGER ,
          descansos INTEGER ,
          festivos INTEGER ,
          fin_disfru dbo.udtDateTime ,
          periodo INTEGER ,
          ayo_operacion INTEGER ,
          num_conc INTEGER,
          serial dbo.udtLong
        )

    DECLARE @maxSerial INTEGER
    DECLARE @minSerial INTEGER
    DECLARE @serialMet INTEGER
    DECLARE @beginDate dbo.udtDateTime
    DECLARE @endDate dbo.udtDateTime
    DECLARE @fechaMeter dbo.udtDateTime
    DECLARE @periodo INTEGER
    DECLARE @ayo_oper INTEGER
    DECLARE @numeroDia INTEGER
    DECLARE @horario INTEGER

    SET @serialMet = 1


    INSERT  INTO @detailVacations
            SELECT  disfrute ,
                    dias_disfr ,
                    disf_ant ,
                    descansos ,
                    festivos ,
                    fin_disfru ,
                    periodo ,
                    ayo_operacion ,
                    30,
                    dense_rank() OVER ( PARTITION  BY codigo ORDER BY disfrute ) AS serial
            FROM    dbo.hist_vac
            WHERE   ayo_operacion = @year
                    AND codigo = @employeeId
                    AND empresa = @companyId

            SELECT  @maxSerial = ISNULL(MAX(serial),0) ,
                    @minSerial = ISNULL(MIN(serial),0)
            FROM    @detailVacations

            INSERT  INTO @detailVacations
            SELECT  a.fch_inicio ,
                    a.dias ,
                    0 ,
                    0 ,
                    0 ,
                    a.fch_inicio + (a.dias-1) ,
                    c.periodo ,
                    c.ayo_operacion ,
                    8,
                    @maxSerial + dense_rank() OVER ( PARTITION  BY a.codigo ORDER BY a.fch_inicio ) AS serial
            FROM    dbo.kardex AS a
            INNER JOIN dbo.Llaves AS b ON a.empresa = b.empresa AND a.codigo = b.codigo
            INNER JOIN dbo.Periodos AS c ON b.empresa = c.empresa AND b.tiponom = c.tiponom AND estatus='A'
            WHERE   a.codigo = @employeeId
                    AND a.empresa = @companyId
                    AND a.num_conc=8

            SELECT  @maxSerial = ISNULL(MAX(serial),0) ,
                    @minSerial = ISNULL(MIN(serial),0)
            FROM    @detailVacations

            INSERT  INTO @detailVacations
            SELECT  fch_inicio ,
                    dias ,
                    0 ,
                    0 ,
                    0 ,
                    fch_inicio + (dias-1) ,
                    periodo ,
                    ayo_operacion ,
                    8,
                    @maxSerial + dense_rank() OVER ( PARTITION  BY codigo ORDER BY fch_inicio ) AS serial
            FROM    dbo.kardex_anual
            WHERE   ayo_operacion = @year
                    AND codigo = @employeeId
                    AND empresa = @companyId
                    AND num_conc=8

    SELECT  @maxSerial = MAX(serial) ,
            @minSerial = MIN(serial)
    FROM    @detailVacations

--SELECT  *
--FROM    @detailVacations

    WHILE @serialMet <= @maxSerial
        BEGIN
            IF ( SELECT 1
                 FROM   @detailVacations
                 WHERE  serial = @serialMet
                        AND ( descansos > 0
                              OR festivos > 0
                            )
               ) IS NOT NULL
                BEGIN
                    SELECT  @beginDate = disfrute ,
                            @endDate = fin_disfru ,
                            @periodo = periodo ,
                            @ayo_oper = ayo_operacion
                    FROM    @detailVacations
                    WHERE   serial = @serialMet

                    SET @fechaMeter = @beginDate

                    SELECT  @horario = ISNULL(b.horario, a.horario)
                    FROM    dbo.Llaves AS a
                            LEFT JOIN dbo.nomina1_anual AS b ON a.empresa = b.empresa
                                                              AND a.codigo = b.codigo
                                                              AND b.periodo = @periodo
                                                              AND b.ayo_operacion = @ayo_oper
                    WHERE   a.empresa = @companyId
                            AND a.codigo = @employeeId


                    WHILE @fechaMeter <= @endDate
                        BEGIN
                            SET @numeroDia = CASE WHEN DATENAME(weekday,
@fechaMeter) = 'Lunes'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Monday'
                                                  THEN 1
                                                  WHEN DATENAME(weekday,
@fechaMeter) = 'Martes'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Tuesday'
                                                  THEN 2
                                                  WHEN DATENAME(weekday,
@fechaMeter) = 'Miercoles'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Wednesday'
                                                  THEN 3
                                                  WHEN DATENAME(weekday,
@fechaMeter) = 'Jueves'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Thursday'
                                                  THEN 4
                                                  WHEN DATENAME(weekday,
@fechaMeter) = 'Viernes'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Friday'
                                                  THEN 5
                                                  WHEN DATENAME(weekday,
@fechaMeter) = 'Sabado'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Saturday'
                                                  THEN 6
                                                  WHEN DATENAME(weekday,
@fechaMeter) = 'Domingo'
                                                       OR DATENAME(weekday,
@fechaMeter) = 'Sunday'
                                                  THEN 7
                                             END

                            IF ( SELECT 'Festivo'
                                 FROM   dbo.festivos
                                 WHERE  empresa = @companyId
                                        AND ( fecha >= @fechaMeter
                                              AND fecha <= @fechaMeter
                                            )
                               ) = 'Festivo'
                                OR ( SELECT 'Descanso'
                                     FROM   dbo.detalle_horarios
                                     WHERE  empresa = @companyId
                                            AND horario = @horario
                                            AND dia_Semana = @numeroDia
                                            AND descanso = 'T'
                                   ) = 'Descanso'
                                BEGIN
                                    PRINT 'No Pasa'
                                END
                            ELSE
                                BEGIN
                                    INSERT  INTO @detailVacationsEnd
                                            SELECT  @companyId ,
                                                    @employeeId ,
                                                    @fechaMeter ,
                                                    1 ,
                                                    1 ,
                                                    0 ,
                                                    0 ,
                                                    @fechaMeter ,
                                                    @periodo ,
                                                    @ayo_oper,
                                                    num_conc
                                                    FROM @detailVacations
                            WHERE   serial = @serialMet
                                END

                            SET @fechaMeter = @fechaMeter + 1
                        END
                END
            ELSE
                BEGIN
                    INSERT  INTO @detailVacationsEnd
                            SELECT  @companyId ,
                                    @employeeId ,
                                    disfrute ,
                                    dias_disfr ,
                                    disf_ant ,
                                    descansos ,
                                    festivos ,
                                    fin_disfru ,
                                    periodo ,
                                    ayo_operacion,
                                    num_conc
                            FROM    @detailVacations
                            WHERE   serial = @serialMet
                END
            SET @serialMet = @serialMet + 1
        END
    SELECT  *
    FROM    @detailVacationsEnd

GO


/**************************************************************************************************
 * Name          : GetAbsentimsForYear
 * Project       : APSI Nomina
 * Description   : Browse Savings to Employee
 * Table name    :
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx)
 * Creation date : Wednesday, 03-03-2010
 **************************************************************************************************/
IF OBJECT_ID('dbo.GetAbsentimsForYear') IS NOT NULL
    DROP PROCEDURE dbo.GetAbsentimsForYear

Go


CREATE PROCEDURE dbo.GetAbsentimsForYear
(
@companyId as udtInteger,
@employeeId as udtInteger,
@year as udtInteger
)

AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

DECLARE @detailVacations AS TABLE
    (
      empresa udtInteger,
      codigo udtInteger,
      disfrute udtDateTime ,
      dias_disfr udtInteger ,
      disf_ant udtInteger ,
      descansos udtInteger ,
      festivos udtInteger ,
      fin_disfru udtDateTime ,
      periodo udtInteger ,
      ayo_operacion udtInteger,
      num_conc udtInteger
    )

INSERT INTO @detailVacations
EXEC dbo.GetVacationsForAbsentimsForYear @companyId,@employeeId,@year

--SELECT * FROM @detailVacations

DECLARE @Meter as udtInteger,@beginDate as udtDateTime,@endDate as udtDateTime,@Type as udtname,@oSQL as udtStringSize2048,@monthopetation as udtInteger,@year_operation as udtInteger,@month_number as udtInteger,@HiringDate as udtDateTime
DECLARE @obs as udtName,@aus as udtInteger,@vac as udtInteger,@vach as udtInteger,@typeabsences as udtName,@payrollEndDate as udtDatetime,@vacConc udtInteger
Set @Meter = 1
select @monthopetation=a.mes_operacion,
       @year_operation=a.ayo_operacion,
       @HiringDate=e.fchalta,
       @payrollEndDate=p.cierre
from dbo.empresas as a
inner join dbo.empleados as e on a.empresa=e.empresa
inner join dbo.llaves as l on l.empresa=e.empresa and l.codigo=e.codigo
inner join dbo.Periodos as p on p.empresa=l.empresa and p.tiponom=l.tiponom and p.estatus='A'
where a.empresa=@companyId and e.codigo=@employeeId


If OBJECT_ID('dbo.tmp_Monts') IS NOT NULL
  Drop Table dbo.tmp_Monts
If OBJECT_ID('dbo.tmp_AbsT') IS NOT NULL
  Drop Table dbo.tmp_AbsT

Create Table dbo.tmp_Monts(
    empresa int not null,
    codigo int not null,
    monthLeter varchar(15) not null,
    monthNumber varchar(2) not null,
    ayo_operation int not null,
    nombre varchar(200) null,
    centro varchar(50) null,
    puesto varchar(150) null,
    --HiringDate datetime not null,
    [01] varchar(10) null,
    [02] varchar(10) null,
    [03] varchar(10) null,
    [04] varchar(10) null,
    [05] varchar(10) null,
    [06] varchar(10) null,
    [07] varchar(10) null,
    [08] varchar(10) null,
    [09] varchar(10) null,
    [10] varchar(10) null,
    [11] varchar(10) null,
    [12] varchar(10) null,
    [13] varchar(10) null,
    [14] varchar(10) null,
    [15] varchar(10) null,
    [16] varchar(10) null,
    [17] varchar(10) null,
    [18] varchar(10) null,
    [19] varchar(10) null,
    [20] varchar(10) null,
    [21] varchar(10) null,
    [22] varchar(10) null,
    [23] varchar(10) null,
    [24] varchar(10) null,
    [25] varchar(10) null,
    [26] varchar(10) null,
    [27] varchar(10) null,
    [28] varchar(10) null,
    [29] varchar(10) null,
    [30] varchar(10) null,
    [31] varchar(10) null,
    saldo numeric(10,2) null,
    disfrutados numeric(10,2) null,
    dias_ant numeric(10,2) null,
    ejercicio integer,
    ejercicioant INTEGER,
    pagadas INTEGER
    )

WHILE @Meter <= 12
BEGIN
    insert into tmp_Monts
    select @companyId,@employeeId,
    case    when @Meter = 01 then 'ENE'
            when @Meter = 02 then 'FEB'
            when @Meter = 03 then 'MAR'
            when @Meter = 04 then 'ABR'
            when @Meter = 05 then 'MAY'
            when @Meter = 06 then 'JUN'
            when @Meter = 07 then 'JUL'
            when @Meter = 08 then 'AGO'
            when @Meter = 09 then 'SEP'
            when @Meter = 10 then 'OCT'
            when @Meter = 11 then 'NOV'
            when @Meter = 12 then 'DIC'
    END as monthleter,
    case    when @Meter = 01 then '01'
            when @Meter = 02 then '02'
            when @Meter = 03 then '03'
            when @Meter = 04 then '04'
            when @Meter = 05 then '05'
            when @Meter = 06 then '06'
            when @Meter = 07 then '07'
            when @Meter = 08 then '08'
            when @Meter = 09 then '09'
            when @Meter = 10 then '10'
            when @Meter = 11 then '11'
            when @Meter = 12 then '12'
    end,
    @year,'','','',
    --@HiringDate,
'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',0,0,0,0,0,0


    Set @Meter = @Meter + 1
END

    Set @Meter = 1

Set @month_number = CASE WHEN @year = @year_operation then @monthopetation else 12 end

WHILE @Meter <= @month_number
BEGIN
    Set @beginDate = CAST(
    str(@year) +
    case    when @Meter = 01 then '01'
            when @Meter = 02 then '02'
            when @Meter = 03 then '03'
            when @Meter = 04 then '04'
            when @Meter = 05 then '05'
            when @Meter = 06 then '06'
            when @Meter = 07 then '07'
            when @Meter = 08 then '08'
            when @Meter = 09 then '09'
            when @Meter = 10 then '10'
            when @Meter = 11 then '11'
            when @Meter = 12 then '12'
    END + '01' as datetime)
    Set @endDate = case when month(@payrollEndDate)=@meter and @year_operation=@meter then @payrollEndDate else dateadd( month,1,@beginDate) - 1 end

        while @beginDate <= @endDate

        Begin
            --Print @beginDate
            if @HiringDate<=@beginDate
            Begin
                select
                @vac=isnull((SELECT
                isnull(0,1)
                FROM dbo.kardex as a
                WHERE a.empresa=@companyId AND a.codigo=@employeeId AND a.num_conc=30 AND nomina='VAC' AND ( ( a.fch_inicio >= @beginDate AND a.fch_cierre <= @beginDate
                          )
                          OR ( a.fch_inicio <= @beginDate
                               AND ( a.fch_cierre >= @beginDate
                                     AND a.fch_cierre <= @beginDate
                                   )
                             )
                          OR ( a.fch_inicio <= @beginDate
                               AND ( a.fch_cierre >= @beginDate
                                     AND a.fch_cierre >= @beginDate
                                   )
                             )
                          OR ( a.fch_inicio >= @beginDate
                               AND a.fch_cierre <= @beginDate
                             )
                        )
                ),1),
                @vach=isnull((SELECT
                isnull(0,1)
                FROM @detailVacations as a
                WHERE a.empresa=@companyId AND a.codigo=@employeeId AND ( ( a.disfrute >= @beginDate AND a.fin_disfru <= @beginDate

                          )
                          OR ( a.disfrute <= @beginDate
                               AND ( a.fin_disfru >= @beginDate
                                     AND a.fin_disfru <= @beginDate
                                   )
                             )
                          OR ( a.disfrute <= @beginDate
                               AND ( a.fin_disfru >= @beginDate
                                     AND a.fin_disfru >= @beginDate
                                   )
                             )
                          OR ( a.disfrute >= @beginDate
                               AND a.fin_disfru <= @beginDate
                             )
                        )GROUP BY a.disfrute
                ),1),
                @vacConc=(SELECT
                MAX(a.num_conc)
                FROM @detailVacations as a
                WHERE a.empresa=@companyId AND a.codigo=@employeeId AND ( ( a.disfrute >= @beginDate AND a.fin_disfru <= @beginDate
                          )
                          OR ( a.disfrute <= @beginDate
                               AND ( a.fin_disfru >= @beginDate
                                     AND a.fin_disfru <= @beginDate
                                   )
                             )
                          OR ( a.disfrute <= @beginDate
                               AND ( a.fin_disfru >= @beginDate
                                     AND a.fin_disfru >= @beginDate
                                   )
                             )
                          OR ( a.disfrute >= @beginDate
                               AND a.fin_disfru <= @beginDate
                             )
                        )
                ),
                @aus=isnull((
                SELECT isnull(0,1)
                FROM dbo.deducciones as a
                WHERE a.empresa=@companyId AND a.codigo=@employeeId AND    (a.num_conc>=108 AND a.num_conc<=111) AND ( ( a.fchinicio >= @beginDate AND a.fchtermino <= @beginDate
                          )
                          OR ( a.fchinicio < @beginDate
                               AND ( a.fchtermino >= @beginDate
                                     AND a.fchtermino <= @beginDate
                                   )
                             )
                          OR ( a.fchinicio <= @beginDate
                               AND ( a.fchtermino >= @beginDate
                                     AND a.fchtermino >= @beginDate
                                   )
                             )
                          OR ( a.fchinicio >= @beginDate
                               AND a.fchInicio <= @beginDate
                             )
                        )
                GROUP BY a.codigo
                ),1),
                @typeabsences=isnull((
                SELECT case when a.num_conc=108 then 'AUS' else 'INC' end
                FROM dbo.deducciones as a
                WHERE a.empresa=@companyId AND a.codigo=@employeeId AND    (a.num_conc>=108 AND a.num_conc<=111)
                AND ( ( a.fchinicio >= @beginDate AND a.fchtermino <= @beginDate
                          )
                          OR ( a.fchinicio < @beginDate
                               AND ( a.fchtermino >= @beginDate
                                     AND a.fchtermino <= @beginDate
                                   )
                             )
                          OR ( a.fchinicio < @beginDate
                               AND ( a.fchtermino >= @beginDate
                                     AND a.fchtermino >= @beginDate
                                   )
                             )
                          OR ( a.fchinicio >= @beginDate
                               AND a.fchInicio <= @beginDate
                             )
                        )
                GROUP BY a.codigo,a.num_conc
                ),'')

                Set @obs = case when @vac = 1 and @aus=1 and @vach=1  then  '*' when @vac = 0 then 'VAC' when @aus=0 then @typeabsences when @vach=0 AND @vacConc = 30 then 'VAC' when @vach=0 AND @vacConc = 8 then 'VP' else '*' end

                Set @oSQL = ('update a set [' + ltrim(rtrim(case when day(@beginDate)<= 9 then '0' else '' end)) + ltrim(rtrim(str(day(@beginDate)))) + ']='+ ''''+ @obs + '''' +
                            Case When @obs = 'VAC' then ', disfrutados = disfrutados+1 ' else '' end +
                            ' from tmp_Monts as a '+
                            'where a.empresa='+ltrim(rtrim(STR(@companyId))) + ' and a.codigo=' + ltrim(rtrim(STR(@employeeId))) + ' and a.monthNumber='+ ltrim(rtrim(STR(@Meter))) +' and a.ayo_operation=' + ltrim(rtrim(str(@year))))
                exec(@oSQL)

            End
            Set @beginDate = @beginDate + 1
    End
    Set @Meter = @Meter + 1
END

update a set saldo=b.dias_saldo, --disfrutados=b.disfruto,
             nombre=RTRIM(LTRIM(e.ap_paterno)) + ' ' + RTRIM(LTRIM(e.ap_materno)) + ' ' + RTRIM(LTRIM(e.nombre)),
             puesto=t.actividad,centro=RTRIM(LTRIM(c.centro)) + ' ' + RTRIM(LTRIM(c.nomdepto)),
             dias_ant = b.dias_ant,
             ejercicio = year(b.vence),
             ejercicioant = year(b.vence_ant),
             pagadas = (SELECT SUM(dias_disfr) FROM @detailVacations WHERE empresa=@companyId AND codigo=@employeeId AND num_conc=8)
from dbo.tmp_Monts as a
inner join dbo.empleados as e on a.empresa=e.empresa and a.codigo=e.codigo
inner join dbo.llaves as l on l.empresa=e.empresa and l.codigo=e.codigo
inner join dbo.tabulador as t on t.empresa=l.empresa and t.ocupacion=l.ocupacion
inner join dbo.centros as c on c.empresa=l.empresa and c.centro=l.centro
inner join dbo.vacaciones as b on e.empresa=b.empresa and e.codigo=b.codigo

select * from tmp_Monts

If OBJECT_ID('dbo.tmp_Monts') IS NOT NULL
  Drop Table dbo.tmp_Monts

GO


/**************************************************************************************************
 * Name          : GetConceptList
 * Project       : APSISISTEMAS
 * Description   : Finds existing records
 * Table name    : GetAbsentism
 * Copyright     : APSI SA, de CV 2010 - 2015. All rights reserved
 * Company       : APSI SA, de CV
 * Author        : adan.sanchez@apsi.com.mx
 * Creation date : martes, 12 de octubre de 2010
 **************************************************************************************************/
IF OBJECT_ID('dbo.GetConceptList') IS NOT NULL
    DROP PROCEDURE dbo.GetConceptList

Go


CREATE PROCEDURE dbo.GetConceptList(
    @companyId AS udtInteger,
    @startPosition AS udtInteger,
    @elementsToRetrieve AS udtInteger
)
WITH ENCRYPTION
AS
SET NOCOUNT ON
SET DATEFORMAT MDY
DECLARE @selectClause AS NVARCHAR(4000)
DECLARE @whereClause AS udtStringSize1024
DECLARE @orderByClause AS udtStringSize512
DECLARE @totalRecords AS udtInteger
DECLARE @startPositionPlusOneElement AS udtInteger
DECLARE @whereClauseUsed AS udtBoolean
DECLARE @debugFlag AS udtBoolean
SET XACT_ABORT ON
BEGIN TRANSACTION
    BEGIN TRY

        -- Set the debug flag
        SET @debugFlag = 0

        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''

        -- Count all the existing records
        SET @selectClause = 'SELECT COUNT(*) FROM conceptos as a '

        -- Search criteria: empresa
        IF @companyId > 0 BEGIN

            IF @whereClauseUsed = 0 BEGIN

                SET @whereClause = @whereClause + 'WHERE '
                SET @whereClauseUsed = 1

            END ELSE

                SET @whereClause = @whereClause + ' AND '

            SET @whereClause = @whereClause + 'a.empresa = ' + LTRIM(RTRIM(STR(@companyId)))

        END


            IF @whereClauseUsed = 0 BEGIN

                SET @whereClause = @whereClause + 'WHERE '
                SET @whereClauseUsed = 1

            END ELSE

                SET @whereClause = @whereClause + ' AND '

            --SET @whereClause = @whereClause + '(a.num_conc>=39 and a.num_conc<126 OR a.num_conc>126 and a.num_conc<=299) AND a.uso=''S'' AND a.captura<>'''' '
            SET @whereClause = @whereClause + ' a.num_conc<=299 AND a.uso=''S'' AND a.captura<>'''' '


        CREATE TABLE #GetemployessCounter (
            TotalRecords Integer
        )

        IF @debugFlag = 1
            SELECT @selectClause + @whereClause
        ELSE
            INSERT INTO #GetemployessCounter EXECUTE (@selectClause + @whereClause)

        -- Set the total records indicador
        SELECT TOP 1 @totalRecords = TotalRecords FROM #GetemployessCounter
        SET @totalRecords = ISNULL(@totalRecords, 0)
        SET @whereClauseUsed = 0

        DROP TABLE #GetemployessCounter

        -- Check the element per page indicator
        IF @elementsToRetrieve < 1
            SET @elementsToRetrieve = @totalRecords

        -- Check the initial position
        IF @startPosition < 1
            SET @startPosition = 0

        SET @whereClauseUsed = 0

        IF @startPosition > 1 BEGIN

            SET @startPositionPlusOneElement = @startPosition + @elementsToRetrieve - 1

            IF @startPositionPlusOneElement < 1
                SET @startPositionPlusOneElement = 1

            IF @startPositionPlusOneElement > @totalRecords BEGIN
                SET @startPositionPlusOneElement = @totalRecords
                SET @elementsToRetrieve = @totalRecords - @startPosition + 1
            END

            IF @startPosition = @totalRecords
                SET @elementsToRetrieve = 1

            IF @startPosition > @totalRecords
                SET @startPosition = @totalRecords

            IF @elementsToRetrieve >= @totalRecords AND @startPosition > 1
                SET @elementsToRetrieve = @totalRecords - @startPosition + 1

            SET @selectClause = 'SELECT num_conc,concepto,captura,des_pag_prov,Totales,clase,centro,Sexo,Tipo_Emp,ISR,IMSS_INFO,PTU,Aguinaldo,Despensa,Fdo_Aho,Cuenta,NatCuenta,Contabilizacion,condicion,mascara,mascara2,isptmask,imssmask, ' + RTRIM(LTRIM(STR(@totalRecords))) + ' AS TotalRecords FROM (SELECT TOP ' + LTRIM(RTRIM(STR(@elementsToRetrieve))) + ' num_conc,concepto,captura,des_pag_prov,Totales,clase,centro,Sexo,Tipo_Emp,ISR,IMSS_INFO,PTU,Aguinaldo,Despensa,Fdo_Aho,Cuenta,NatCuenta,Contabilizacion,condicion,mascara,mascara2,isptmask,imssmask FROM (SELECT TOP ' + LTRIM(RTRIM(STR(@startPositionPlusOneElement))) + ' a.num_conc,a.concepto,CASE WHEN a.captura=''A'' THEN ''Automtica'' WHEN a.captura=''M'' THEN ''Manual'' END as captura,CASE WHEN (a.num_conc>=1 AND a.num_conc<=99) THEN ''Pago'' WHEN (a.num_conc>=101 AND a.num_conc<=199) THEN ''Desc'' WHEN (a.num_conc>=201 AND a.num_conc<=299) THEN ''Prov'' END as des_pag_prov,CASE WHEN CHARINDEX(''ntotpercep'',a.formula)>0 THEN a.totales ELSE '''' END as Totales,a.clase,a.centro,CASE WHEN a.condicion2=''M'' THEN ''Hombre'' WHEN a.condicion2=''F'' THEN ''Mujer'' WHEN a.condicion2=''A'' THEN ''General'' ELSE '''' END AS Sexo,CASE WHEN a.condicion1=''C'' THEN ''Conf'' WHEN a.condicion1=''T'' THEN ''General'' WHEN a.condicion1=''S'' THEN ''Sind'' ELSE '''' END AS Tipo_Emp,CASE WHEN a.ispt=''S'' THEN ''Si'' WHEN a.ispt=''N'' THEN ''No'' ELSE '''' END AS ISR,CASE WHEN a.imss=''S'' THEN ''Si'' WHEN a.imss=''N'' THEN ''No'' ELSE '''' END AS IMSS_INFO,CASE WHEN a.ptu=''S'' THEN ''Si'' WHEN a.ptu=''N'' THEN ''No'' ELSE '''' END AS PTU,CASE WHEN a.mca_agui=''S'' THEN ''Si'' WHEN a.mca_agui=''N'' THEN ''No'' ELSE '''' END AS Aguinaldo,CASE WHEN a.despensa=''S'' THEN ''Si'' WHEN a.despensa=''N'' THEN ''No'' ELSE '''' END AS Despensa,CASE WHEN a.fdoahorro=''S'' THEN ''Si'' WHEN a.fdoahorro=''N'' THEN ''No'' ELSE '''' END AS Fdo_Aho,isnull(b.cuenta1,'''') as Cuenta,CASE WHEN b.tipo=''D'' THEN ''Debe'' WHEN b.tipo=''H'' THEN ''Haber'' ELSE '''' END AS NatCuenta,CASE WHEN b.clasifica=''D'' THEN ''Depto'' WHEN b.clasifica=''G'' THEN ''Gral'' ELSE '''' END AS Contabilizacion,a.condition AS condicion,a.mascara,a.mascara2,a.isptmask,a.imssmask FROM conceptos AS a LEFT JOIN cuentas AS b ON a.empresa = b.empresa AND a.num_conc = b.num_conc AND a.clase = b.clase AND a.centro = b.centro '

            SET @orderByClause = ' ORDER BY num_conc,clase DESC) AS GetAbsentismTemporalOne ORDER BY num_conc,clase DESC) AS GetAbsentismTemporalTwo ORDER BY V'

        END ELSE BEGIN

            IF @startPosition = 0

                SET @selectClause = 'SELECT TOP 100 PERCENT'

            ELSE

                SET @selectClause = 'SELECT TOP ' + RTRIM(LTRIM(STR(@elementsToRetrieve)))

            SET @selectClause = @selectClause + ' a.num_conc,a.concepto,CASE WHEN a.captura=''A'' THEN ''Automtica'' WHEN a.captura=''M'' THEN ''Manual'' END as captura,CASE WHEN (a.num_conc>=1 AND a.num_conc<=99) THEN ''Pago'' WHEN (a.num_conc>=101 AND a.num_conc<=199) THEN ''Desc'' WHEN (a.num_conc>=201 AND a.num_conc<=299) THEN ''Prov'' END as des_pag_prov,CASE WHEN CHARINDEX(''ntotpercep'',a.formula)>0 THEN a.totales ELSE '''' END as Totales,a.clase,a.centro,CASE WHEN a.condicion2=''M'' THEN ''Hombre'' WHEN a.condicion2=''F'' THEN ''Mujer'' WHEN a.condicion2=''A'' THEN ''General'' ELSE '''' END AS Sexo,CASE WHEN a.condicion1=''C'' THEN ''Conf'' WHEN a.condicion1=''T'' THEN ''General'' WHEN a.condicion1=''S'' THEN ''Sind'' ELSE '''' END AS Tipo_Emp,CASE WHEN a.ispt=''S'' THEN ''Si'' WHEN a.ispt=''N'' THEN ''No'' ELSE '''' END AS ISR,CASE WHEN a.imss=''S'' THEN ''Si'' WHEN a.imss=''N'' THEN ''No'' ELSE '''' END AS IMSS_INFO,CASE WHEN a.ptu=''S'' THEN ''Si'' WHEN a.ptu=''N'' THEN ''No'' ELSE '''' END AS PTU,CASE WHEN a.mca_agui=''S'' THEN ''Si'' WHEN a.mca_agui=''N'' THEN ''No'' ELSE '''' END AS Aguinaldo,CASE WHEN a.despensa=''S'' THEN ''Si'' WHEN a.despensa=''N'' THEN ''No'' ELSE '''' END AS Despensa,CASE WHEN a.fdoahorro=''S'' THEN ''Si'' WHEN a.fdoahorro=''N'' THEN ''No'' ELSE '''' END AS Fdo_Aho,isnull(b.cuenta1,'''') as Cuenta,CASE WHEN b.tipo=''D'' THEN ''Debe'' WHEN b.tipo=''H'' THEN ''Haber'' ELSE '''' END AS NatCuenta,CASE WHEN b.clasifica=''D'' THEN ''Depto'' WHEN b.clasifica=''G'' THEN ''Gral'' ELSE '''' END AS Contabilizacion,a.condition AS condicion,a.mascara,a.mascara2,a.isptmask,a.imssmask, ' + RTRIM(LTRIM(STR(@totalRecords))) + ' AS TotalRecords FROM conceptos AS a LEFT JOIN cuentas AS b ON a.empresa = b.empresa AND a.num_conc = b.num_conc AND a.clase = b.clase AND a.centro = b.centro '

            SET @orderByClause = ' ORDER BY a.empresa DESC '
        END

        IF @debugFlag = 1
            SELECT @selectClause + @whereClause + @orderByClause
        ELSE
            EXECUTE (@selectClause + @whereClause + @orderByClause)

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState))) + CHAR(13) + CHAR(10) + 'Severity: ' + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10) + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13) + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10) + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1 OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION
GO


/**************************************************************************************************
 * Name          : GetDetailedSchedule
 * Project       : APSISISTEMAS
 * Description   : Detail Schedule recibos
 * Table name    :
 * Copyright     : APSI SA, de CV 2010 - 2015. All rights reserved
 * Company       : APSI SA, de CV
 * Author        : adan.sanchez@apsi.com.mx
 * Creation date : martes, 12 de octubre de 2010
 **************************************************************************************************/
IF OBJECT_ID('dbo.GetDetailedSchedule') IS NOT NULL
    DROP PROCEDURE dbo.GetDetailedSchedule
go

CREATE PROCEDURE dbo.GetDetailedSchedule
    @companyId udtInteger ,
    @payrollType udtInteger ,
    @periodId udtInteger ,
    @yearId udtInteger,
	@BaseACIO Varchar(150),
	@linkServer varchar(150)

    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

	set @linkServer = ''
	Declare @tabla varchar(50)

	DECLARE @inicio datetime 
    DECLARE	@Termino datetime 
	DECLARE	@Error int 
	DECLARE @sqlACIO varchar(max)

	SET @Error = 0

	if len(@BaseACIO)>0
	begin
		set @tabla = '@detalle'
		
		select @inicio=inicio,@termino=cierre
		from dbo.Periodos
		where	empresa=@companyId
				and tiponom=@payrollType
				and periodo=@periodId
				and ayo_operacion=@yearId

		set @sqlACIO = 	' '+
				' Declare @Detalle as table (codigo int, empresa int,periodo int, ayo_operacion int, fecha datetime,Entra1 varchar(5),Sale1 varchar(5),Entra2 varchar(5),Sale2 varchar(5),HorasEx int,HorasRet int,Descanso varchar(5),Observa varchar(20),Tiponom int)' +
				' insert into @Detalle '+
				' select	a.codigo,a.empresa,'+convert(varchar,@periodId)+' as periodo,'+convert(varchar,@yearId)+' as ayo_operacion,r.Fecha,
							isnull(max(case when r.serial=1 then substring(convert(varchar,r.hora),1,2)+substring(convert(varchar,r.hora),4,2) else null end),'''') as Entra1,
							isnull(max(case when r.serial=2 then substring(convert(varchar,r.hora),1,2)+substring(convert(varchar,r.hora),4,2) else null end),'''') as Sale1,
							isnull(max(case when r.serial=3 then substring(convert(varchar,r.hora),1,2)+substring(convert(varchar,r.hora),4,2) else null end),'''') as Entra2,
							isnull(max(case when r.serial=4 then substring(convert(varchar,r.hora),1,2)+substring(convert(varchar,r.hora),4,2) else null end),'''') as Sale2,
							0 as HorasEx,
							0 as HorasRet,
							isnull(max(case when r.Descanso=''D'' then ''T'' else ''F'' end),'''') as Descanso,
							isnull(max(r.Obs),'''') as Observa,
							'+convert(varchar,@payrollType)+' as Tiponom '+
				' from dbo.SeleccionElementos as a '+
				' outer apply( '+
								' select	a1.codigo,c1.clave as empresa,a1.IdEmpleado '+
								' from '+case when len(@linkServer)>0 then '['+@linkServer +'].' else '' end +'['+@BaseACIO+'].dbo.empleado as a1 '+
								' inner join '+case when len(@linkServer)>0 then '['+@linkServer +'].' else '' end +'['+@BaseACIO+'].dbo.llaves as b1 on b1.idEmpleado=a1.idEmpleado '+
								' inner join '+case when len(@linkServer)>0 then '['+@linkServer +'].' else '' end +'['+@BaseACIO+'].dbo.empresasnomina as c1 on c1.idEmpresaNom=b1.idEmpresaNom '+
								' where c1.clave=a.empresa and a1.codigo=a.codigo '+
							' ) as b '+
				' outer apply( '+
								' select * '+
								' from ( '+
										' ( '+
											' select	a1.idEmpleado,a1.fecha,case when a1.retardos>0 then ''RET '' + convert(varchar,a1.Retardos) + '' min.'' '+
																				' when a1.TiempoExtra>0 then ''TE '' + convert(varchar,a1.TiempoExtra) + '' min.'' '+
																				' when a1.DescansoLaborado>0 then ''DL '' + convert(varchar,a1.DescansoLaborado) + '' min.'' '+
																				' when a1.Descanso=''D'' then ''DESC'' '+
																				' when a1.esfalta=1 then ''AUS'' '+
																				' when a1.esVac=1 then ''V'' '+
																				' when a1.esInc=1 then ''INC'' '+
																				' when a1.Festivo=''F'' then ''FES'' '+
																				' when a1.HrsFestivo>0 then ''FL '' + convert(varchar,a1.HrsFestivo) + '' min.'' '+
																			' end as Obs,'+
											' a1.descanso ' +
											' from '+case when len(@linkServer)>0 then '['+@linkServer +'].' else '' end +'['+@BaseACIO+'].dbo.analisisperiodo as a1 '+
											' where	a1.idEmpleado=b.idEmpleado '+
											' and a1.Fecha between '''+convert(varchar,@inicio,112)+''' and '''+convert(varchar,@termino,112)+''' '+
										' ) '+
										' union '+
										' ( '+
											' select	a1.idEmpleado,a1.fecha,case when a1.retardos>0 then ''RET '' + convert(varchar,a1.Retardos) + '' min.'' '+
																				' when a1.TiempoExtra>0 then ''TE '' + convert(varchar,a1.TiempoExtra) + '' min.'' '+
																				' when a1.DescansoLaborado>0 then ''DL '' + convert(varchar,a1.DescansoLaborado) + '' min.'' '+
																				' when a1.Descanso=''D'' then ''DESC'' '+
																				' when a1.esfalta=1 then ''AUS'' '+
																				' when a1.esVac=1 then ''V'' '+
																				' when a1.esInc=1 then ''INC'' '+
																				' when a1.Festivo=''F'' then ''FES'' '+
																				' when a1.HrsFestivo>0 then ''FL '' + convert(varchar,a1.HrsFestivo) + '' min.'' '+
																			' end as Obs,'+
											' a1.descanso ' +
											' from '+case when len(@linkServer)>0 then '['+@linkServer +'].' else '' end +'['+@BaseACIO+'].dbo.analisisperiodoh as a1 '+
											' where	a1.idEmpleado=b.idEmpleado '+
											' and a1.Fecha between '''+convert(varchar,@inicio,112)+''' and '''+convert(varchar,@termino,112)+''' '+
										' ) '+
									' ) as tbl1 '+
									' outer apply (	select	Aplicara,hora,fecha+hora as FechaHora,Obs as ObsReg,Tiempo, '+
															' DENSE_RANK() OVER (PARTITION BY idEmpleado,Aplicara ORDER BY Fecha+hora ASC) as serial '+
													' from '+case when len(@linkServer)>0 then '['+@linkServer +'].' else '' end +'['+@BaseACIO+'].dbo.registro  '+
													' where idEmpleado=tbl1.idEmpleado and Aplicara=tbl1.Fecha and Aplicara=tbl1.Fecha and isnull(eliminada,''N'')=''N''  '+
												' ) as r1 '+
							' ) as r '+
				' where a.empresa='+ convert(varchar,@companyId) +
				' group by a.empresa,a.codigo,r.fecha '+
				' order by a.empresa,a.codigo,r.fecha '		
	end
	else begin
		set @sqlACIO = ''
		set @tabla = 'dbo.Detalle_Rec'
	end


    DECLARE @endDate udtDateTime
    DECLARE @date udtDateTime
    DECLARE @stringEntrada1 udtStringSize1024
    DECLARE @stringSalida1 udtStringSize1024
    DECLARE @stringEntrada2 udtStringSize1024
    DECLARE @stringSalida2 udtStringSize1024
    DECLARE @stringObs udtStringSize1024
    DECLARE @string udtStringSize1024
    DECLARE @whereClause udtStringSize1024

    SET @stringEntrada1 = '''En'' as Tipo,'
    SET @stringSalida1 = '''Sa'' as Tipo,'
    SET @stringEntrada2 = '''En'' as Tipo,'
    SET @stringSalida2 = '''Sa'' as Tipo,'
    SET @stringObs = '''Ob'' as Tipo,'
    SET @string = ''
    SET @whereClause = ''

    SELECT  @date = inicio ,
            @endDate = cierre
    FROM    periodos
    WHERE   empresa = @companyId
            AND tiponom = @payrollType
            AND periodo = @periodid
            AND ayo_operacion = @yearId

    WHILE @date <= @endDate
        BEGIN
            SET @stringEntrada1 = @stringEntrada1 + '['
                + CONVERT(VARCHAR(30), @date, 103) + '],'
            SET @stringEntrada2 = @stringEntrada2 + '['
                + CONVERT(VARCHAR(30), @date, 103) + '],'
            SET @stringSalida1 = @stringSalida1 + '['
                + CONVERT(VARCHAR(30), @date, 103) + '],'
            SET @stringSalida2 = @stringSalida2 + '['
                + CONVERT(VARCHAR(30), @date, 103) + '],'
            SET @stringObs = @stringObs + '[' + CONVERT(VARCHAR(30), @date, 103)
                + '],'
            SET @string = @string + '[' + CONVERT(VARCHAR(30), @date, 103)
                + '],'--convert(varchar(30),@date,103)
            SET @date = @date + 1
        END

    SET @stringEntrada1 = @stringEntrada1 + 'codigo,1 as serial'
    SET @stringSalida1 = @stringSalida1 + 'codigo,2 as serial'
    SET @stringEntrada2 = @stringEntrada2 + 'codigo,3 as serial'
    SET @stringSalida2 = @stringSalida2 + 'codigo,4 as serial'
    SET @stringObs = @stringObs + 'codigo,5 as serial'
    SET @string = SUBSTRING(@string, 1, LEN(@string) - 1)
    SET @whereClause = ' where a.empresa=' + STR(@companyId)
        + ' and a.TipoNom=' + RTRIM(LTRIM(STR(@payrollType)))
        + ' and a.Periodo=' + RTRIM(LTRIM(STR(@periodId)))
        + ' and a.Ayo_Operacion=' + RTRIM(LTRIM(STR(@yearId))) + ' '

    --exec(@sqlACIO )
	exec(
			@sqlACIO +
			--'select * from ' + @tabla + ' as a ' + @whereClause +
			'
			Select * from(
			(SELECT '+@stringEntrada1+'
			FROM
			(SELECT a.codigo,convert(varchar(30),a.fecha,103) as fecha,CASE WHEN len(ltrim(rtrim(entra1)))>0 THEN  SUBSTRING(a.entra1,1,2) + '':'' + SUBSTRING(a.entra1,3,2) ELSE entra1 END as entra1
			FROM '+@tabla+' as a
			inner join SeleccionElementos as b on a.empresa=b.empresa and a.Codigo=b.codigo '+
			@whereClause +'
			) AS Detalle_Rec
			PIVOT
			(
			max(entra1)
			FOR fecha IN ('+@string+')
			) AS PivotTable)

			Union
			(SELECT '+@stringSalida1+'
			FROM
			(SELECT a.codigo,convert(varchar(30),a.fecha,103) as fecha,CASE WHEN len(ltrim(rtrim(sale1)))>0 THEN  SUBSTRING(a.sale1,1,2) + '':'' + SUBSTRING(a.sale1,3,2) ELSE sale1 END as sale1
			FROM '+@tabla+' as a
			inner join SeleccionElementos as b on a.empresa=b.empresa and a.Codigo=b.codigo '+
			@whereClause +'
			) AS Detalle_Rec
			PIVOT
			(
			max(sale1)
			FOR fecha IN ('+@string+')
			) AS PivotTable)

			Union
			(SELECT '+@stringEntrada2+'
			FROM
			(SELECT a.codigo,convert(varchar(30),a.fecha,103) as fecha,CASE WHEN len(ltrim(rtrim(entra2)))>0 THEN  SUBSTRING(a.entra2,1,2) + '':'' + SUBSTRING(a.entra2,3,2) ELSE entra2 END as entra2
			FROM '+@tabla+' as a
			inner join SeleccionElementos as b on a.empresa=b.empresa and a.Codigo=b.codigo '+
			@whereClause +'
			) AS Detalle_Rec
			PIVOT
			(
			max(entra2)
			FOR fecha IN ('+@string+')
			) AS PivotTable)

			Union
			(SELECT '+@stringSalida2+'
			FROM
			(SELECT a.codigo,convert(varchar(30),a.fecha,103) as fecha,CASE WHEN len(ltrim(rtrim(sale2)))>0 THEN  SUBSTRING(a.sale2,1,2) + '':'' + SUBSTRING(a.sale2,3,2) ELSE sale2 END as sale2
			FROM '+@tabla+' as a
			inner join SeleccionElementos as b on a.empresa=b.empresa and a.Codigo=b.codigo '+
			@whereClause +'
			) AS Detalle_Rec
			PIVOT
			(
			max(sale2)
			FOR fecha IN ('+@string+')
			) AS PivotTable)

			Union
			(SELECT '+@stringObs+'
			FROM
			(SELECT a.codigo,convert(varchar(30),a.fecha,103) as fecha,a.observa
			FROM '+@tabla+' as a
			inner join SeleccionElementos as b on a.empresa=b.empresa and a.Codigo=b.codigo '+
			@whereClause +'
			) AS Detalle_Rec
			PIVOT
			(
			max(observa)
			FOR fecha IN ('+@string+')
			) AS PivotTable)
			) as Tbl
			Order By codigo,serial'
    )


GO

/*
Actualiza las tablas de Isr de SCHP, porque tenia el campo mca_ultimo = U y debe ser X
Mario Garcia 05/01/2011
*/
UPDATE dbo.apsiispt SET mca_ultimo = 'A' WHERE trimestre = 20090 AND mca_ultimo = 'X'
UPDATE dbo.apsiispt SET mca_ultimo = 'X' WHERE trimestre = 20109 AND mca_ultimo = 'U'

GO

/**************************************************************************************************
 * Name          : GetReportAcumulateGeneral
 * Project       : APSI Nomina
 * Description   : Octuber 13, 2010
 *                 Reporte de acumulados generales por ejercicio
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octuber 13, 2010
 **************************************************************************************************/

IF OBJECT_ID('dbo.GetReportAcumulateGeneral') IS NOT NULL
    DROP PROCEDURE dbo.GetReportAcumulateGeneral
Go


CREATE PROCEDURE dbo.GetReportAcumulateGeneral
    (
      @companyId AS VARCHAR(100) ,
      @operationYear AS INT ,
      @consolidateInformation AS CHAR(1)
    )
AS
    DECLARE @selectClausule AS VARCHAR(4000)
    DECLARE @whereClausule AS VARCHAR(4000)
    DECLARE @orderClausule AS VARCHAR(4000)

    IF @consolidateInformation = 'N'
        BEGIN
            SET @selectClausule = 'SELECT  ace.codigo ,'
                + 'RTRIM(e.ap_paterno) + '' '' + RTRIM(e.ap_materno) + '' '' + RTRIM(e.nombre) AS ''Nombre'' ,'
                + 'e.rfcalfa + ''-'' + CONVERT(CHAR(6),e.rfcnum) + ''-'' + e.rfchomo AS ''Rfc'','
                + 'ace.acu_percep ,' + 'ace.gravable ,' + 'ace.exento ,'
                + 'ace.ispt ,' + 'ace.cr_sal AS subsidiof ,' + 'ace.credtotal ,'
                + 'ace.dias_labor ,' + 'ace.faltas ,' + 'ace.permisos ,'
                + 'ace.suspende ,' + 'ace.paro ,' + 'ace.incap_eg ,'
                + 'ace.incap_mat ,' + 'ace.incap_rt, '
                + 'ace.empresa '
                + ' FROM dbo.acum_emps AS ace '
                + ' INNER JOIN dbo.empleados AS e ON ( ace.empresa = e.empresa AND ace.codigo = e.codigo ) '


            SET @orderClausule = ' ORDER BY ace.codigo'
        END
    ELSE
        BEGIN
            SET @selectClausule = 'SELECT  ace.codigo ,'
                + 'RTRIM(e.ap_paterno) + '' '' + RTRIM(e.ap_materno) + '' '' + RTRIM(e.nombre) AS ''Nombre'' ,'
                + 'e.rfcalfa + ''-'' + CONVERT(CHAR(6),e.rfcnum) + ''-'' + e.rfchomo AS ''Rfc'','
                + 'ace.acu_percep ,' + 'ace.gravable ,' + 'ace.exento ,'
                + 'ace.ispt ,' + 'ace.cr_sal AS subsidiof ,' + 'ace.credtotal ,'
                + 'ace.dias_labor ,' + 'ace.faltas ,' + 'ace.permisos ,'
                + 'ace.suspende ,' + 'ace.paro ,' + 'ace.incap_eg ,'
                + 'ace.incap_mat ,' + 'ace.incap_rt, '
                + 'ace.empresa '
                + ' FROM dbo.acum_emps AS ace '
                + ' INNER JOIN dbo.empleados AS e ON ( ace.empresa = e.empresa AND ace.codigo = e.codigo ) '


            SET @orderClausule = ' ORDER BY ace.empresa,ace.codigo'

        END
    SET @whereClausule = ' WHERE ace.ejercicio = '
        + CONVERT(CHAR(4), @operationYear) + ' AND ace.empresa IN '
        + @companyId
        + ' AND ace.acu_percep > 0 '

    --SELECT @selectClausule + @whereClausule + @orderClausule
    EXECUTE ( @selectClausule + @whereClausule + @orderClausule )


GO


/**************************************************************************************************
 * Name          : ObtenDetalleConceptosEmpleadosAnual
 * Project       : APSI Nomina
 * Description   : Enero 24, 2011
 *                 Reporte de conceptos por mes anual
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Adan Sanchez (adan.sanchez@apsi.com.mx)
 * Creation date : Enero 24, 2011
 **************************************************************************************************/
IF OBJECT_ID('dbo.ObtenDetalleConceptosEmpleadosAnual') IS NOT NULL
    DROP PROCEDURE dbo.ObtenDetalleConceptosEmpleadosAnual
go


CREATE PROCEDURE dbo.ObtenDetalleConceptosEmpleadosAnual
    (
      @companyId udtInteger ,
      @yearId udtInteger ,
      @type udtInteger,
      @concepts udtStringSize4096,
      @nominas udtStringSize1024,
      @tiponomina udtInteger
    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    DECLARE @fromClause udtStringSize4096
    DECLARE @selectClause udtStringSize4096
    DECLARE @whereClause udtStringSize4096
    DECLARE @groupByClause udtStringSize4096
    DECLARE @orderByClause udtStringSize4096
    DECLARE @title udtStringSize4096
    DECLARE @debug udtInteger
    DECLARE @kardex udtName
    DECLARE @detailClause udtStringSize4096

    select    empresa,
            codigo + ' ' + Nombre as nombre,
            letra + ' ' + num_conc + ' ' + concepto AS concepto,
            Importe,
            mes
            --,MesNum,Tipo
    From
            (    Select    a.empresa,
                        REPLICATE('0',8 - LEN(LTRIM(RTRIM(STR(a.codigo))))) + rtrim(ltrim(str(a.codigo))) as Codigo,
                        rtrim(ltrim(b.ap_paterno)) + ' ' + rtrim(ltrim(b.ap_materno)) + ' ' + rtrim(ltrim(b.nombre)) as Nombre,
                        REPLICATE('0',4 - LEN(LTRIM(RTRIM(STR(a.num_conc))))) + rtrim(ltrim(str(a.num_conc))) as num_conc,
                        a.concepto,
                        sum(a.importe) as Importe,
                        case    when substring(a.mes,1,3)='ENE' then '01 ENE'
                                when substring(a.mes,1,3)='FEB' then '02 FEB'
                                when substring(a.mes,1,3)='MAR' then '03 MAR'
                                when substring(a.mes,1,3)='ABR' then '04 ABR'
                                when substring(a.mes,1,3)='MAY' then '05 MAY'
                                when substring(a.mes,1,3)='JUN' then '06 JUN'
                                when substring(a.mes,1,3)='JUL' then '07 JUL'
                                when substring(a.mes,1,3)='AGO' then '08 AGO'
                                when substring(a.mes,1,3)='SEP' then '09 SEP'
                                when substring(a.mes,1,3)='OCT' then '10 OCT'
                                when substring(a.mes,1,3)='NOV' then '11 NOV'
                                when substring(a.mes,1,3)='DIC' then '12 DIC'
                        end as Mes,
                        case    when substring(a.mes,1,3)='ENE' then 1
                                when substring(a.mes,1,3)='FEB' then 2
                                when substring(a.mes,1,3)='MAR' then 3
                                when substring(a.mes,1,3)='ABR' then 4
                                when substring(a.mes,1,3)='MAY' then 5
                                when substring(a.mes,1,3)='JUN' then 6
                                when substring(a.mes,1,3)='JUL' then 7
                                when substring(a.mes,1,3)='AGO' then 8
                                when substring(a.mes,1,3)='SEP' then 9
                                when substring(a.mes,1,3)='OCT' then 10
                                when substring(a.mes,1,3)='NOV' then 11
                                when substring(a.mes,1,3)='DIC' then 12
                        end as MesNum,
                        case when ( (a.num_conc >=1 and a.num_conc<=99) or ( a.num_conc >= 501 AND a.num_conc <= 599)OR ( a.num_conc >= 1101 AND a.num_conc <= 1199) ) then 'A'  when ( ( a.num_conc >= 101 AND a.num_conc <= 199) OR ( a.num_conc >= 601 AND a.num_conc <= 699) OR ( a.num_conc >= 1001 AND a.num_conc <= 1099) )then 'B' else 'C' end as Letra,
                        max(case when @type =1 then convert(varchar,a.empresa) else c.centro end) as Tipo
                From dbo.kardex_anual as a
                inner join dbo.empleados as b on b.empresa=a.empresa and a.codigo=b.codigo
                inner join dbo.Llaves as c on c.empresa=b.empresa and c.codigo=b.codigo
                where    CHARINDEX(a.nomina,@nominas)>0
                        and a.empresa=@companyId
                        and a.ayo_operacion=@yearId

                        and (@concepts = '' or charindex(dbo.padl(a.num_conc,null,4,'0'),@concepts) > 0 )
                        and (@tiponomina = 0 or a.tiponom = @tiponomina)

                group by    a.codigo,
                            rtrim(ltrim(b.ap_paterno)) + ' ' + rtrim(ltrim(b.ap_materno)) + ' ' + rtrim(ltrim(b.nombre)),
                            a.num_conc,
                            a.concepto,
                            a.mes,
                            a.empresa
    ) as Tbl
    order by    Tipo,
                codigo,
                MesNum asc,
                Letra,
                num_conc

GO

/**************************************************************************************************
 * Name          : asp_calcular_salario_variables
 * Project       : APSI Nomina
 * Description   : Marzo 03, 2011
 *                 Listado de validacion de variables
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia, Actualizado Jesus Frias
 * Creation date : Marzo 03, 2011
 **************************************************************************************************/
IF OBJECT_ID('dbo.asp_calcular_salario_variables') IS NOT NULL
    DROP PROCEDURE dbo.asp_calcular_salario_variables

GO



CREATE PROCEDURE dbo.asp_calcular_salario_variables
    @nEmpresa INT ,
    @nAyo INT ,
    @nMes1 INT ,
    @nMes2 INT ,
    @dFFMes1 DATETIME ,
    @dFFMes2 DATETIME ,
    @nSalDF DECIMAL(10, 2) ,
    @EsRadial AS CHAR(1) ,
    @EsCecytec AS CHAR(1)
AS
    PRINT @nMes1
    PRINT @nMes2
    PRINT @dFFmes1
    PRINT @dFfmes2


    SET NOCOUNT ON

    /*
    DECLARE @nEmpresa INT
    DECLARE @nAyo INT
    DECLARE @nMes1 INT
    DECLARE @nMes2 INT
    DECLARE @dFFMes1 DATETIME
    DECLARE @dFFMes2 DATETIME
    DECLARE @nSalDF DECIMAL(10, 2)
    DECLARE @EsRadial AS CHAR(1)
    DECLARE @EsCecytec AS CHAR(1)

    SET @nEmpresa = 14
    SET @nAyo = 2011
    SET @nMes1 = 1
    SET @nMes2 = 2
    SET @dFFMes1 = '20110131'
    SET @dFFMes2 = '20110228'
    SET @nSalDF = 50
    SET @EsRadial = 'S'
    SET @EsCecytec = 'N'
    */

    DECLARE @dFF AS DATETIME
    DECLARE @dFFSigMes AS DATETIME
    DECLARE @nExedeDesp AS DECIMAL(10, 2)
    DECLARE @nDias1 AS DECIMAL(5, 2)
    DECLARE @nDias2 AS DECIMAL(5, 2)
    DECLARE @nError AS INT
    DECLARE @cConTope AS VARCHAR(30)
    DECLARE @nSalMin AS DECIMAL(10, 2)
    DECLARE @cRegPat AS CHAR(10)
    DECLARE @fechaFinBimAnt AS DATETIME
    DECLARE @mesBimAnt AS INT
    DECLARE @ayoBimAnt AS INT
    DECLARE @mesInicialNomina AS CHAR(5)
    DECLARE @mesFinalNomina AS CHAR(5)
    DECLARE @diasBaseDivisor AS VARCHAR(30)
    DECLARE @fechaVariables AS DATETIME

    SET @nDias1 = DAY(@dFFMes1)
    SET @nDias2 = DAY(@dFFMes2)
    SET @nError = 0

    SET @fechaFinBimAnt = dbo.NvaFecha(01, MONTH(@dFFmes1), YEAR(@dFfMes1))
        - 1
    SET @mesBimAnt = MONTH(@fechaFinBimAnt)
    SET @ayoBimAnt = YEAR(@fechaFinBimAnt)

    SET @cRegPat = ( SELECT Registro_Patronal
                     FROM   Empresas
                     WHERE  Empresa = @nEmpresa
                   )

    SET @diasBaseDivisor = ( SELECT DivisorPercepcionesVariables
                             FROM   Empresas
                             WHERE  Empresa = @nEmpresa
                           )

    SET @mesInicialNomina = CASE WHEN @nMes1 = 01 THEN 'ENE'
                                 WHEN @nMes1 = 02 THEN 'FEB'
                                 WHEN @nMes1 = 03 THEN 'MAR'
                                 WHEN @nMes1 = 04 THEN 'ABR'
                                 WHEN @nMes1 = 05 THEN 'MAY'
                                 WHEN @nMes1 = 06 THEN 'JUN'
                                 WHEN @nMes1 = 07 THEN 'JUL'
                                 WHEN @nMes1 = 08 THEN 'AGO'
                                 WHEN @nMes1 = 09 THEN 'SEP'
                                 WHEN @nMes1 = 10 THEN 'OCT'
                                 WHEN @nMes1 = 11 THEN 'NOV'
                                 ELSE 'DIC'
                            END + RIGHT(CONVERT(CHAR(4), @nAyo), 2)

    SET @mesFinalNomina = CASE WHEN @nMes2 = 01 THEN 'ENE'
                               WHEN @nMes2 = 02 THEN 'FEB'
                               WHEN @nMes2 = 03 THEN 'MAR'
                               WHEN @nMes2 = 04 THEN 'ABR'
                               WHEN @nMes2 = 05 THEN 'MAY'
                               WHEN @nMes2 = 06 THEN 'JUN'
                               WHEN @nMes2 = 07 THEN 'JUL'
                               WHEN @nMes2 = 08 THEN 'AGO'
                               WHEN @nMes2 = 09 THEN 'SEP'
                               WHEN @nMes2 = 10 THEN 'OCT'
                               WHEN @nMes2 = 11 THEN 'NOV'
                               ELSE 'DIC'
                          END + RIGHT(CONVERT(CHAR(4), @nAyo), 2)

    PRINT @mesInicialNomina
    PRINT @mesFinalNomina
    PRINT @diasBaseDivisor


--Actualiza los dias del primer mes del bimestre
    EXEC dbo.asp_ds @nEmpresa, 0, @nAyo, @nMes1, @dFFMes1
    EXEC dbo.asp_ds_aus @nEmpresa, 0, @nAyo, @nMes1, @nDias1
    EXEC dbo.asp_ds_inc @nEmpresa, 0, @nAyo, @nMes1

--Actualiza los dias del segundo mes del bimestre
    EXEC dbo.asp_ds @nEmpresa, 0, @nAyo, @nMes2, @dFFMes2
    EXEC dbo.asp_ds_aus @nEmpresa, 0, @nAyo, @nMes2, @nDias2
    EXEC dbo.asp_ds_inc @nEmpresa, 0, @nAyo, @nMes2


--Variables de calculo para los exedentes y la fecha de antiguedad
    SET @dFF = @dFFMes2
    SET @nExedeDesp = ROUND(@nSalDf * 0.40, 2)

    SET @fechaVariables = @dFF + 1

-- Obtiene la fecha final del siguiente mes de la fecha final del bimestre para calcular la antiguedad, para integracion
    EXEC ASP_UltimoDiaMesProximo @dFF, @dFFSigMes OUTPUT
    SET @dFfSigMes = CONVERT(VARCHAR(8), @dFFsigMes, 112)
--Print @dFFSigMes

--select @dFfSigMes

--Buscar la marca para ver si se topa la despensa (03/07/2009 Mario)
    SELECT  @cConTope = variable2
    FROM    conceptos
    WHERE   num_conc = 31
            AND empresa = @nEmpresa

    SELECT  @nSalMin = CASE WHEN e.zona_geografica = 'A' THEN s.zona_a
                            WHEN e.zona_geografica = 'B' THEN s.zona_b
                            ELSE s.zona_c
                       END
    FROM    dbo.salarios_minimos AS s
            INNER JOIN empresas AS e ON ( e.empresa = @nEmpresa )
    WHERE   YEAR(s.fecha_ini) = @nAyo

	/*
	* Para los variables del 6to bimestre de 2022, por el cambio de los dias de vacaciones, considerar las tablas de integracion 
	* de Enero 2023, a peticion de Arturo Espinoza.
	*/
	DECLARE @mesEmpresa AS INTEGER
	DECLARE @ayoEmpresa AS INTEGER

	SELECT @mesEmpresa = mes_operacion,
	       @ayoEmpresa = ayo_operacion
    FROM dbo.empresas 
	WHERE empresa = @nEmpresa

    -- Buscar las fechas de antiguedad reales de acuerdo al mes del listado
    -- sobre todo para meses anteriores y empleados que tienen B y RI
    --DECLARE @tAntigua TABLE (Codigo INTEGER, FchAntigua DATETIME)

    IF OBJECT_ID('#Tmp_Antigua') IS NOT NULL
        DROP TABLE #Tmp_Antigua

    --INSERT INTO @tAntigua
    SELECT  Codigo ,
            FchAntigua,
            0 AS ayos
    INTO    #Tmp_Antigua
    FROM    dbo.Empleados
    WHERE   Empresa = @nEmpresa

    IF NOT EXISTS ( SELECT  Empresa
                    FROM    dbo.Empresas
                    WHERE   Empresa = @nEmpresa
                            AND Mes_Operacion = @nMes2
                            AND Ayo_Operacion = @nAyo )
        UPDATE  tAntigua
        SET     FchAntigua = ISNULL(( SELECT TOP 1
                                                Campo_07
                                      FROM      dbo.Avisos_Imss
                                      WHERE     Codigo = tAntigua.Codigo
                                                AND Mov = 'B'
                                                AND Fch_Mov >= dbo.NvaFecha(1,
                                                              @nMes1, @nAyo)
                                                AND Empresa = @nEmpresa
                                      ORDER BY  fch_mov
                                    ), Empleados.FchAntigua)
        FROM    #Tmp_Antigua AS tAntigua
                INNER JOIN dbo.Empleados ON Empleados.Codigo = tAntigua.Codigo
                                        AND Empleados.Empresa = @nEmpresa
    --

--Borra la tabla tmp_vars, para llenarla con el calculo de los variables
    DELETE  dbo.tmp_vars
    WHERE   empresa = @nEmpresa

    IF @@ERROR = 0
        BEGIN
	--Insert en tmp_vars, los dias del bimestre, el ultimo sueldo y los ausentismos

            INSERT  INTO dbo.tmp_vars
                    ( empresa ,
                      codigo ,
                      diastrba ,
                      incapba ,
                      ausenba ,
                      cuotadia ,
                      saldiaint ,
                      baja ,
                      fecha ,
                      dia ,
                      mes ,
                      ano ,
                      variable ,
                      varia_imss ,
                      nomina
                    )
                    SELECT  a.empresa ,
                            a.codigo ,
                            SUM(a.diastr) AS Diastr ,
                            SUM(a.incap) AS incap ,
                            SUM(a.ausen) AS ausen ,
--	       max(b.sueldo) AS sueldo,
--	       max(b.saldiaint) AS saldiaint,
                            ( SELECT TOP 1
                                        sueldo
                              FROM      dbo.avisos_imss
                              WHERE     avisos_imss.empresa = @nempresa
                                        AND avisos_imss.codigo = a.codigo
                                        AND ( ( SUBSTRING(LTRIM(avisos_imss.ayo_operacion
                                                              + 10000), 2, 4)
                                                + SUBSTRING(LTRIM(avisos_imss.mes_operacion
                                                              + 100), 2, 2) BETWEEN SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes1
                                                              + 100), 2, 2)
                                                              AND
                                                              SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes2
                                                              + 100), 2, 2) )
                                              OR ( @dFF + 1 = dbo.NvaFecha(1,
                                                              1,
                                                              YEAR(@dFF) + 1)
                                                   AND fch_mov = @dFF + 1
                                                 )
                                            )
                                        AND avisos_imss.mov <> 'B'
                              ORDER BY  fch_mov DESC ,
                                        serial DESC
                            ) AS 'sueldo' ,
                            ( SELECT TOP 1
                                        saldiaint
                              FROM      dbo.avisos_imss
                              WHERE     avisos_imss.empresa = @nempresa
                                        AND avisos_imss.codigo = a.codigo
                                        AND ( ( SUBSTRING(LTRIM(avisos_imss.ayo_operacion
                                                              + 10000), 2, 4)
                                                + SUBSTRING(LTRIM(avisos_imss.mes_operacion
                                                              + 100), 2, 2) BETWEEN SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes1
                                                              + 100), 2, 2)
                                                              AND
                                                              SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes2
                                                              + 100), 2, 2) )
                                              OR ( @dFF + 1 = dbo.NvaFecha(1,
                                                              1,
                                                              YEAR(@dFF) + 1)
                                                   AND fch_mov = @dFF + 1
                                                 )
                                            )
                                        AND avisos_imss.mov <> 'B'
                              ORDER BY  fch_mov DESC ,
                                        serial DESC
                            ) AS 'saldiaint' ,
                            CASE WHEN ( SELECT TOP 1
                                                Mov
                                        FROM    dbo.Avisos_Imss
                                        WHERE   Avisos_Imss.Codigo = a.Codigo
                                                AND Avisos_Imss.Mes_Operacion IN (
                                                @nMes1, @nMes2 )
                                                AND Avisos_Imss.Ayo_Operacion = @nAyo
                                                AND Avisos_Imss.Empresa = @nEmpresa
                                        ORDER BY fch_mov DESC ,
                                                Serial DESC
                                      ) = 'B' THEN 'B'
                                 ELSE ''
                            END AS ultmov ,

                            /*
                            CASE MAX(b.ultmov)
                              WHEN 'B' THEN MAX(b.ultmov)
                              ELSE ''
                            END AS ultmov ,
                            */
                            @dFF + 1 AS fecha ,
                            RIGHT('00' + RTRIM(CONVERT(CHAR(2), DATEPART(day,
                                                              @dFF + 1))), 2) AS dia ,
                            RIGHT('00' + RTRIM(CONVERT(CHAR(2), DATEPART(month,
                                                              @dFF + 1))), 2) AS mes ,
                            RIGHT(DATEPART(yy, @dFF + 1), 2) AS ano ,
                            0 AS variable ,
                            0 AS varia_imss ,
                            0 AS nomina
                    FROM    dbo.avisos_imss AS a
                            INNER JOIN dbo.empleados AS b ON ( a.codigo = b.Codigo
                                                           AND a.empresa = b.empresa
                                                         )
                    WHERE   ( ( a.mes_operacion = @nMes1
                                OR a.mes_operacion = @nMes2
                              )
                              AND a.ayo_operacion = @nAyo
                            )
                            AND a.empresa = @nEmpresa

                            -- Si se envia un listado de validacion de meses anteriores, no salen
                            -- los empleados que tienen BAJA y REINGRESO...porque empleados guarda solo
                            -- la fecha del ultimo reingreso y no se cumple la condicion
                            -- P.E. Listado de validacion de Mayo y Junio del 2009
                            --      Un empleado viene del 2008 pero tuvo B y RI en Febrero del 2010
                            --AND b.fchalta <= @dFFMes2
                            AND EXISTS ( SELECT TOP 1
                                                Codigo
                                         FROM   dbo.Avisos_Imss
                                         WHERE  Codigo = b.codigo
                                                AND Mes_Operacion IN ( @nMes1,
                                                              @nMes2 )
                                                AND Ayo_Operacion = @nAyo
                                                AND Empresa = @nEmpresa )
                            AND
              --b.activo = 'S' AND
                            b.borrado = 'N'  --AND
             -- (b.ultmov <> 'B' OR b.ultfchmov > @dFF)
                    GROUP BY a.empresa ,
                            a.codigo

            IF @@ERROR = 0
                BEGIN
		-- Suma los importes variables, del bimestre para actualizar la tabla TMP_VARS
                    SELECT  a.empresa ,
                            a.codigo ,
                            SUM(b.variable) AS variable ,
                            SUM(b.varia_imss) AS varia_imss ,
                            SUM(b.nomina) AS nomina ,
                            CONVERT(NUMERIC(12, 2), 0) AS contras
                    INTO    #tmp_sum_variable
                    FROM    tmp_vars AS a
                            INNER JOIN percepciones AS b ON ( a.codigo = b.codigo
                                                              AND a.empresa = b.empresa
                                                            )
                    WHERE   ( ( b.mes_operacion = @nMes1
                                OR b.mes_operacion = @nMes2
                              )
                              AND b.ayo_operacion = @nAyo
                            )
                            AND a.empresa = @nEmpresa
                    GROUP BY a.empresa ,
                            a.codigo

        --Actualiza la tabla temporal con las contras para Radial y Cecytec
                    IF @EsRadial = 'S'
                        UPDATE  tsm
                        SET     tsm.contras = ISNULL(d.descuento, 0)
                        FROM    #tmp_sum_variable AS tsm
                                INNER JOIN ( SELECT dbo.deducciones.codigo ,
                                                    SUM(dbo.deducciones.descuento) AS descuento
                                             FROM   dbo.deducciones
                                             WHERE  dbo.deducciones.mes_operacion IN ( @nMes1, @nMes2 )
                                                    AND dbo.deducciones.ayo_operacion = @nAyo
                                                    AND dbo.deducciones.num_conc > 1000
                                                    AND EXISTS ( SELECT TOP 1
                                                              Imss
                                                              FROM
                                                              dbo.conceptos
                                                              WHERE
                                                              dbo.conceptos.num_conc = dbo.deducciones.num_conc
                                                              - 1000
                                                              AND dbo.conceptos.imss = 'S'
                                                              AND dbo.conceptos.empresa = @nEmpresa )
                                                    AND dbo.deducciones.empresa = @nEmpresa
                                             GROUP BY dbo.deducciones.Codigo
                                           ) AS d ON d.codigo = tsm.Codigo

                    IF @EsCecytec = 'S'
					   begin
                        UPDATE  tsm
                        SET     tsm.contras = ISNULL(d.descuento, 0)
                        FROM    #tmp_sum_variable AS tsm
                                INNER JOIN ( SELECT dbo.deducciones.codigo ,
                                                    SUM(dbo.deducciones.descuento) AS descuento
                                             FROM   dbo.deducciones
                                             WHERE  dbo.deducciones.mes_operacion IN ( @nMes1, @nMes2 )
                                                    AND dbo.deducciones.ayo_operacion = @nAyo
                                                    AND (dbo.deducciones.num_conc > 1000 OR dbo.deducciones.num_conc = 145 )
                                                    AND EXISTS ( SELECT TOP 1 Imss
                                                                 FROM dbo.conceptos
                                                                 WHERE dbo.conceptos.num_conc = dbo.deducciones.num_conc- CASE WHEN dbo.deducciones.num_conc > 1000 THEN 1000 ELSE 0 END
                                                                       AND dbo.conceptos.imss = 'S'
                                                                       AND dbo.conceptos.empresa = @nEmpresa )
                                                    AND dbo.deducciones.empresa = @nEmpresa
                                             GROUP BY dbo.deducciones.Codigo
                                           ) AS d ON d.codigo = tsm.Codigo

                      end


		--Actualiza la tabla TMP_VARS, con la sumatoria de los importes variables del bimestre
                    UPDATE  tmp_vars
                    SET     variable = ISNULL(b.variable, 0)
                            - ISNULL(b.contras, 0) ,
                            varia_imss = ISNULL(b.varia_imss, 0)
                            - ISNULL(b.contras, 0) ,
                            nomina = ISNULL(b.nomina, 0) - ISNULL(b.contras, 0)
                    FROM    tmp_vars AS a
                            INNER JOIN #tmp_sum_variable AS b ON ( a.codigo = b.codigo
                                                              AND a.empresa = b.empresa
                                                              )

                    DROP TABLE #tmp_sum_variable

       --Actualiza los dias laborados, en funcion de la marca si, se consideran los periodos cerrados de nomina.
                    IF @diasBaseDivisor = 'DIASNOMINA'
                        BEGIN

                            DECLARE @tDiasNomina TABLE
                                (
                                  empresa INT ,
                                  codigo NUMERIC(8, 0) ,
                                  diastr_nom FLOAT
                                )


                            INSERT  INTO @tDiasNomina
                                    SELECT  na.empresa ,
                                            na.codigo ,
                                            SUM(na.diastr_nom) AS 'diastr_nom'
                                    FROM    dbo.nomina1_anual AS na
									        INNER JOIN dbo.empleados AS e ON na.empresa = e.empresa AND na.codigo = e.codigo
                                    WHERE   --e.tiposal <> 1 AND
									        na.empresa = @nEmpresa AND
                                            ( na.mes = @mesInicialNomina
                                             OR na.mes = @mesFinalNomina
                                            )
                                    GROUP BY na.empresa ,
                                            na.codigo
                                    --ORDER BY na.empresa ,
                                    --        na.codigo
							/*
							INSERT  INTO @tDiasNomina
									-- Calculo de das para empleados con Tipo de Salario 1
                                    SELECT  diasAvisos.empresa ,
                                            diasAvisos.codigo ,
                                            SUM(CASE WHEN na.fchinicio < diasAvisos.fch_mov AND
	                                                      na.fchcierre > diasAvisos.fch_mov AND
				                                          na.fchcierre <= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                     THEN DATEDIFF(dd, diasAvisos.fch_mov, na.fchcierre) + 1
                                                     ELSE CASE WHEN na.fchinicio >= diasAvisos.fch_mov AND
                                                                    na.fchcierre <= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                               THEN DATEDIFF(dd, na.fchinicio, na.fchcierre) + 1
                                                               ELSE CASE WHEN na.fchinicio >= diasAvisos.fch_mov AND
                                                                              na.fchinicio <= diasAvisos.fch_mov + diasAvisos.diastr - 1 AND
                                                                              na.fchcierre >= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                                         THEN datediff(dd, na.fchinicio, diasAvisos.fch_mov + diasAvisos.diastr)
                                                                         ELSE CASE WHEN na.fchinicio < diasAvisos.fch_mov AND
                                                                                        na.fchcierre > diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                                                   THEN diasAvisos.diastr
                                                                                   ELSE 0
                                                                              END
                                                                    END
                                                          END
                                                END) AS 'diastr_nom'
                                    FROM    dbo.nomina1_anual AS na
									        INNER JOIN dbo.empleados AS e ON na.empresa = e.empresa AND na.codigo = e.codigo
                                            INNER JOIN (SELECT diasAvisos.empresa
                                                               , diasAvisos.codigo
                                                               , diasAvisos.fch_mov
                                                               , diasAvisos.diastr
                                                        FROM dbo.avisos_imss AS diasAvisos) diasAvisos ON diasAvisos.empresa = na.empresa AND
                                                                                                          diasAvisos.codigo = na.codigo AND
                                                                                                          ( ( na.fchinicio <= diasAvisos.fch_mov AND
                                                                                                              na.fchcierre >= diasAvisos.fch_mov AND
                                                                                                              na.fchinicio <= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                                                                            )
                                                                                                           OR ( na.fchinicio >= diasAvisos.fch_mov AND
                                                                                                                na.fchcierre <= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                                                                              )
                                                                                                           OR ( na.fchinicio >= diasAvisos.fch_mov AND
                                                                                                                na.fchinicio <= diasAvisos.fch_mov + diasAvisos.diastr - 1 AND
                                                                                                                na.fchcierre >= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                                                                              )
                                                                                                           OR ( na.fchinicio <= diasAvisos.fch_mov AND
                                                                                                                na.fchcierre >= diasAvisos.fch_mov + diasAvisos.diastr - 1
                                                                                                              )
                                                                                                          )
                                    WHERE   e.tiposal = 1 AND
									        na.empresa = @nEmpresa AND
                                            ( na.mes = @mesInicialNomina
                                             OR na.mes = @mesFinalNomina
                                            )
                                    GROUP BY diasAvisos.empresa ,
                                            diasAvisos.codigo
							*/


                            UPDATE  tv
                            SET     tv.diastrba = ISNULL(na.diastr_nom, 1) ,
                                    tv.ausenba = 0 ,
                                    tv.incapba = 0
                            FROM    tmp_vars AS tv
                                    LEFT JOIN @tDiasNomina AS na ON ( tv.codigo = na.codigo
                                                              AND tv.empresa = na.empresa
                                                              )
                            WHERE   tv.empresa = @nEmpresa


                            UPDATE  tmp_vars
                            SET     diastrba = 1
                            WHERE   diastrba <= 0
                                    AND empresa = @nEmpresa

                        END

            --Se agrego el calculo de los aos en empresa de SistemaTiss-Sar, cuando son altas del 31/01/2017 y se genera el listado de validacion
            --no estaba calculando los aos, se valido para que si es cero lo iguale a 1, para la relacion con las tablas de integracion. (Mario 03/03/2017)
                    UPDATE  tAntigua SET tAntigua.ayos =  ISNULL(CASE WHEN DATEDIFF(yy, tAntigua.fchantigua,
                                               @dffsigmes)
                                      + CASE WHEN YEAR(tAntigua.fchantigua) <= YEAR(@dffsigmes)
                                                  AND MONTH(tAntigua.fchantigua) <= MONTH(@dffsigmes)
                                                  --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                  AND ( DAY(tAntigua.fchantigua) <= DAY(@dffsigmes)
                                                        OR ( DAY(tAntigua.fchantigua) = 31
                                                             AND DAY(@dffsigmes) = 30
                                                           )
                                                      ) THEN 1
                                             ELSE 0
                                        END > 45 THEN 45
                                 ELSE DATEDIFF(yy, tAntigua.fchantigua,
                                               @dffsigmes)
                                      + CASE WHEN YEAR(tAntigua.fchantigua) <= YEAR(@dffsigmes)
                                                  AND MONTH(tAntigua.fchantigua) <= MONTH(@dffsigmes)
                                                  --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                  AND ( DAY(tAntigua.fchantigua) <= DAY(@dffsigmes)
                                                        OR ( DAY(tAntigua.fchantigua) = 31
                                                             AND DAY(@dffsigmes) = 30
                                                           )
                                                      ) THEN 1
                                             ELSE 0
                                        END
                            END,0)
                    FROM    #Tmp_Antigua AS tAntigua

                    UPDATE tAntigua SET tAntigua.ayos = 1
                    FROM  #Tmp_Antigua AS tAntigua
                    WHERE tAntigua.ayos = 0

		--Comienza el calculo de salario diario integrado, para actualizar tmp_vars
		--Extrae los campos de las tablas de integracion para determinar el salario variable
		--Apartir del 01/01/2017, se considera el valor de la UMA,para determinar los excedentes de Despensa Mario.
                    SELECT  a.empresa ,
                            a.codigo ,
                            a.cuotadia ,
                            b.fchantigua ,
                            c.clase ,
                            tAntigua.ayos,
		       --d.factor,
                            ROUND(1 + ( d.aguinaldo / 365 ) + -- aguinaldo
                          ( ( d.dias_vac / 365 ) * ( d.prima_vac / 100 ) )
                                  + -- prima vacacional
                          ( d.pmavacdias / 365 ) + -- dias de prima vac.
                          ( d.dias_ayo / 365 ) + -- dias x ao
                          ( d.porc_ayo / 100 ) + -- % x ao
                          ( d.porc_mes / 100 ) + -- % x mes
                          ( d.porc_dia / 100 ) + -- % x dia
                          ( d.pmo1ayopor / 100 ) + -- % premio anual 1
                          ( d.pmo2ayopor / 100 ) + -- % premio anual 2
                          ( d.dias_mes / 030.4167 )
                                  + -- dias x mes

                          -- si el fdo. de ahorro del Patron, es mayor al del Trabajador
                          -- integrarlo todo...sumar el % al factor y si tiene $ fijo ponerlo aparte
                          CASE WHEN @cRegPat <> 'C121910510'
                               THEN CASE WHEN ISNULL(ROUND(a.cuotadia
                                                           * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                     + d.fdoahopati, 0) > ISNULL(ROUND(a.cuotadia
                                                              * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                              + d.fdoahotrai,
                                                              0)
                                         THEN d.fdoahopatp / 100
                                         ELSE 0
                                    END
                               ELSE CASE WHEN d.fdoahopatp > d.fdoahotrap
                                              AND d.fdoahopati = 0
                                              AND d.fdoahotrai = 0
                                         THEN ( d.fdoahopatp / 100 )
                                              - ( d.fdoahotrap / 100 )
                                         ELSE 0
                                    END
                          END, 4) AS factor ,

                            CASE WHEN ROUND(( ( a.cuotadia * ( d.despensa
                                                              / 100 ) )
                                              + d.despensaim ), 2) > ISNULL(( uma.umaDiario
                                                              * 0.40 ),
                                                              @nExedeDesp)
                                 THEN ROUND(( ( a.cuotadia * ( d.despensa
                                                              / 100 ) )
                                              + d.despensaim ), 2)
                                      - ISNULL(( uma.umaDiario * 0.40 ),
                                               @nExedeDesp)
                                 ELSE 0
                            END AS exedente_desp ,
                            ISNULL(( ROUND(d.imp_ayo / 365, 2)
                                     + ROUND(d.pmo1ayoimp / 365, 2)
                                     + ROUND(d.pmo2ayoimp / 365, 2)
                                     + ROUND(d.Imp_mes / 30.4167, 2)
                                     + d.imp_dia ), 0) AS importes_fijos ,

               -- Si el fdo. de ahorro del Patron es mayor al del Trabajador
               -- si tiene $ fijo ponerlo aparte porque no va en el factor
                            CASE WHEN @cRegPat <> 'C121910510'
                                 THEN CASE WHEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                       + d.fdoahopati, 0) > ISNULL(ROUND(a.cuotadia
                                                              * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                              + d.fdoahotrai,
                                                              0)
                                           THEN d.fdoahopati
                                           ELSE 0
                                      END
                                 ELSE CASE WHEN d.fdoahopatp = d.fdoahotrap
                                                OR d.fdoahopati > 0
                                                OR d.fdoahotrai > 0
                                           THEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                       + d.fdoahopati, 0)
                                           ELSE 0
                                      END
                            END AS FdoAhoPat ,
                            CASE WHEN @cRegPat <> 'C121910510'
                                 THEN CASE WHEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                       + d.fdoahopati, 0) > ISNULL(ROUND(a.cuotadia
                                                              * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                              + d.fdoahotrai,
                                                              0)
                                           THEN d.fdoahotrai
                                           ELSE 0
                                      END
                                 ELSE CASE WHEN d.fdoahopatp = d.fdoahotrap
                                                OR d.fdoahopati > 0
                                                OR d.fdoahotrai > 0
                                           THEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                       + d.fdoahotrai, 0)
                                           ELSE 0
                                      END
                            END AS FdoAhoTra ,
                            CASE WHEN a.varia_Imss > 0
                                 THEN ROUND(a.varia_imss
                                            / CASE WHEN ( a.diastrba
                                                          - ( a.incapba
                                                              + a.ausenba ) ) = 0
                                                   THEN 1
                                                   ELSE ( a.diastrba
                                                          - ( a.incapba
                                                              + a.ausenba ) )
                                              END, 2)
                                 ELSE 0
                            END AS ParteVar ,

                            --b.varia_imss AS varia_ant
                            ISNULL(pv.parte_variable, 0) AS 'varia_ant'
                    INTO    #tmp_calc_variable
                    FROM    dbo.tmp_vars AS a
                            INNER JOIN dbo.empleados AS b ON ( a.codigo = b.codigo
                                                           AND a.empresa = b.empresa
                                                         )
                            INNER JOIN dbo.llaves AS c ON ( a.codigo = c.codigo
                                                        AND a.empresa = c.empresa
                                                      )
                            INNER JOIN #Tmp_Antigua AS tAntigua ON tAntigua.Codigo = a.codigo
                            INNER JOIN dbo.tablas_int AS d ON ( a.empresa = d.empresa
                                                            AND c.clase = d.clase
                                                            AND tAntigua.ayos = CAST(d.ayos AS INT))
                            LEFT JOIN dbo.partes_variables AS pv ON ( a.codigo = pv.codigo
                                                              AND a.empresa = pv.empresa
                                                              AND pv.mes_operacion = @mesBimAnt
                                                              AND pv.ayo_operacion = @ayoBimAnt
                                                              )
                            LEFT JOIN ( SELECT TOP 1
                                                uma.umaDiario
                                        FROM    dbo.TblUMA AS uma
                                        WHERE   uma.fecha <= @fechaVariables
                                        ORDER BY uma.fecha DESC
                                      ) AS uma ON 1 = 1
                    WHERE   d.mes_operacion = CASE WHEN @mesEmpresa =1 AND @ayoEmpresa = 2023 AND @nAyo = 2022 AND @nMes2 = 12 THEN @mesEmpresa ELSE @nMes2 END AND  --Esto se utilizo por incremento en los dias de vacaciones LFT 2023 y el cambio de los factores en tablas de integracion 
                            d.ayo_operacion = CASE WHEN @mesEmpresa =1 AND @ayoEmpresa = 2023 AND @nAyo = 2022 AND @nMes2 = 12 THEN @ayoEmpresa ELSE @nAyo END       --cuando se ejecutaron los variables de diciembre 2022, considerara en la reimpresion del listado de validacion estando en Enero 2023.
                    ORDER BY a.codigo



                -- Asi estaba, pero las tablas de integracion del @nmes2 aun no existen
                -- por ejemplo: estoy en Junio, para calcular las variables del 1o. de Julio...pero las tablas de Julio no existen
		--WHERE d.mes_operacion = @nMes2 AND d.ayo_operacion = @nAyo

        --Si la despensa esta topada ajustar el monto, del excedente, apartir del 31/07/2009
        --01/02/2017, se agrego que los ajustes de topes se consideren con la UMA
                    IF @cConTope = 'CONTOPE'
                        AND @dFfMes1 >= '20090731'
                        UPDATE  tmpv
                        SET     tmpv.exedente_desp = CASE WHEN tmpv.exedente_desp > ( ISNULL(uma.UmaDiario,
                                                              @nSalmin)
                                                              - ( ISNULL(uma.UmaDiario,
                                                              @nSalDf) * 0.40 ) )
                                                          THEN ( ISNULL(uma.UmaDiario,
                                                              @nSalmin)
                                                              - ( ISNULL(uma.UmaDiario,
                                                              @nSalDf) * 0.40 ) )
                                                          ELSE tmpv.exedente_desp
                                                     END
                        FROM    #tmp_calc_variable AS tmpv
                                LEFT JOIN ( SELECT TOP 1
                                                    uma.umaDiario
                                            FROM    dbo.TblUMA AS uma
                                            WHERE   uma.fecha <= @fechaVariables
                                            ORDER BY uma.fecha DESC
                                          ) AS uma ON 1 = 1



		--Select * from #tmp_calc_variable
		--Actualiza el salario base de cotizacion del siguiente bimestre, con el calculo de variables.
                    UPDATE  tmp_vars
                    SET     sdi_nvo = ROUND(( a.cuotadia * a.factor )
                                            + ISNULL(a.exedente_desp, 0)
                                            + ISNULL(a.importes_fijos, 0)
                                            + ( CASE WHEN ISNULL(a.FdoAhoPat,
                                                              0) > ISNULL(a.FdoAhoTra,
                                                              0)
                                                     THEN ISNULL(a.FdoAhoPat,
                                                              0)
                                                          - CASE
                                                              WHEN @cRegPat = 'C121910510'
                                                              THEN a.FdoAhoTra
                                                              ELSE 0
                                                            END
                                                     ELSE 0
                                                END ) + ISNULL(a.ParteVar, 0),
                                            2) , -- EL REGISTRO PATRONAL ES DEL ITESO, QUE SOLO INTEGRA LA DIFERENCIA
                            factor = a.factor ,
                            excedentes = a.exedente_desp ,
                            otrosfijos = a.importes_fijos
                            + ( CASE WHEN a.FdoAhoPat > a.FdoAhoTra
                                     THEN a.FdoAhoPat
                                          - CASE WHEN @cRegPat = 'C121910510'
                                                 THEN a.FdoAhoTra
                                                 ELSE 0
                                            END
                                     ELSE 0
                                END ) ,
                            observa = ( CASE WHEN ( baja <> 'B'
                                                    AND varia_imss > 0
                                                  ) THEN '1' --Cuando tienen percepciones variables y no son baja
                                             WHEN ( baja = 'B'
                                                    AND Varia_imss > 0
                                                  ) THEN '2' --Cuando tienen percepciones variables y es baja
                                             WHEN ( baja <> 'B'
                                                    AND varia_imss = 0
                                                    AND a.varia_ant > 0
                                                  ) THEN '3' --Cuando no tienen percepciones variables en el bimestre, pero tuvo el bimestre anterior  y no es baja
                                             WHEN ( variable > 0
                                                    AND varia_imss = 0
                                                  ) THEN '4' --Cuando tienen percepciones que NO integran, solo informativo
                                             ELSE '5' --Cualquier otro caso que no este contemplado para analizarlo
                                        END )
                    FROM    dbo.tmp_vars AS b
                            INNER JOIN #tmp_calc_variable AS a ON ( a.empresa = b.empresa
                                                              AND a.codigo = b.codigo
                                                              )

                          --select * from tmp_vars

                -- Si el salario variable es menor al minimo o cero registrar el minimo integrado por el factor del empleado
                -- 07/11/2013 Mario, reportado por Luz Maria en nomina no Fiscal
                    UPDATE  tv
                    SET     tv.sdi_nvo = @nSalMin * tv.factor
                    FROM    dbo.tmp_vars AS tv
                            INNER JOIN dbo.empleados AS e ON tv.empresa = e.empresa
                                                             AND tv.codigo = e.codigo
                    WHERE   tv.empresa = @nEmpresa
                            AND tv.sdi_nvo <= @nSalMin
                            AND e.jornada < 6


                    DROP TABLE #tmp_calc_variable

                --Borra los registros que no tiene variable, ni modificacion en salario diario integrado o
                --los que la nueva MS es igual al SBC anterior
                    DELETE  dbo.tmp_vars
                    WHERE   empresa = @nEmpresa
                            AND nomina = 0
                            AND variable = 0
                            AND ABS(saldiaint - sdi_nvo) <= 0.03

                --Inserta los empleados que son bajas en meses anteriores pero que se les pago en el bimestre en proceso
                    INSERT  INTO dbo.tmp_vars
                            SELECT  p.empresa ,
                                    p.codigo ,
                                    MAX(e.saldiaint) AS 'Saldiant' ,
                                    RIGHT('00'
                                          + RTRIM(CONVERT(CHAR(2), DATEPART(day,
                                                              @dFF + 1))), 2) AS dia ,
                                    RIGHT('00'
                                          + RTRIM(CONVERT(CHAR(2), DATEPART(month,
                                                              @dFF + 1))), 2) AS mes ,
                                    RIGHT(DATEPART(yy, @dFF + 1), 2) AS ano ,
                                    @dFF + 1 AS fecha ,
                                    MAX(e.sueldo) AS 'CuotaDia' ,
                                    SUM(p.variable) AS 'Variable' ,
                                    SUM(p.varia_imss) AS 'Varia_imss' ,
                                    0 AS 'Diastrba' ,
                                    0 AS 'ausenba' ,
                                    0 AS 'incapba' ,
                                    CASE WHEN MAX(e.ultmov) = 'B' THEN 'B'
                                         ELSE ''
                                    END AS 'Baja' ,
                                    NULL AS 'conc18' ,
                                    SUM(p.nomina) AS 'nomina' ,
                                    NULL AS 'sdi_act' ,
                                    MAX(e.saldiaint) AS 'Sdi_nvo' ,
                                    NULL AS 'dif_sdi' ,
                                    0 AS 'factor' ,
                                    0 AS 'Excedentes' ,
                                    0 AS 'otrosFijos' ,
                                    6 AS 'Observa'
                            FROM    dbo.percepciones AS p
                                    INNER JOIN dbo.empleados AS e ON p.empresa = e.empresa
                                                              AND p.codigo = e.codigo
                            WHERE   p.empresa = @nEmpresa
                                    AND NOT EXISTS ( SELECT tv.codigo
                                                     FROM   dbo.tmp_vars AS tv
                                                     WHERE  tv.empresa = p.empresa
                                                            AND tv.codigo = p.codigo )
                                    AND p.mes_operacion >= @nMes1
                                    AND p.mes_operacion <= @nMes2
                                    AND p.ayo_operacion = @nAyo
                            GROUP BY p.empresa ,
                                    p.codigo


                END
            ELSE
                BEGIN
             --Existe un error en la insercion de TMP_VARS
                    RETURN(2)
                END
        END
    ELSE
        BEGIN
       --Existe un error en el borrado de la tabla tmp_vars
            RETURN(1)
        END
--Select * from tmp_vars


    SET NOCOUNT OFF
GO

IF OBJECT_ID('dbo.tmp_hijos_centros') IS NOT NULL
   DROP TABLE dbo.tmp_hijos_centros

GO

IF OBJECT_ID('dbo.tmp_llaves_codigos') IS NOT NULL
   DROP TABLE dbo.tmp_llaves_codigos

GO

IF OBJECT_ID('dbo.tmp_conceptos_centros') IS NOT NULL
   DROP TABLE dbo.tmp_conceptos_centros

GO


/**************************************************************************************************
 * Name          : asp_update_estructura_centros
 * Project       : APSI Nomina
 * Description   : Marzo 03, 2011
 *                 Actualiza los centros de costos
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia, Actualizado Jesus Frias
 * Creation date : Marzo 03, 2011
 **************************************************************************************************/
If OBJECT_ID('dbo.asp_update_estructura_centros') Is NOT NULL
  Drop Procedure dbo.asp_update_estructura_centros
Go


CREATE PROCEDURE dbo.asp_update_estructura_centros
    @cCentro CHAR(14) ,
    @nEmpresa INT ,
    @cNivel CHAR(02) ,
    @cNombre CHAR(30) ,
    @cOldCen CHAR(14) ,
    @cUsuario VARCHAR(20) ,
    @dFecha DATETIME ,
    @nMotivo INT
AS
    DECLARE @cQuery_upd VARCHAR(300)
    DECLARE @nCodigo NUMERIC(8, 0)
    DECLARE @nTiponom INT
    DECLARE @nMes INT
    DECLARE @nAyo INT
    DECLARE @cMes CHAR(2)
    DECLARE @cAyo CHAR(4)
    DECLARE @cPeriodo VARCHAR(6)
    DECLARE @Origen CHAR(2)
    DECLARE @ErrorSeverity udtInteger
    DECLARE @ErrorState udtInteger
    DECLARE @ErrorMessage udtStringSize2048

    /*Clave de origen para el historico*/
    SET @Origen = 'CE'

    BEGIN
        BEGIN TRANSACTION
        BEGIN TRY

            --Borrar la tabla temporal de dependencias de centros
            IF OBJECT_ID('dbo.tmp_hijos_centros') IS NOT NULL
                DROP TABLE dbo.tmp_hijos_centros

            IF OBJECT_ID('dbo.tmp_llaves_codigos') IS NOT NULL
                DROP TABLE dbo.tmp_llaves_codigos

            IF OBJECT_ID('dbo.tmp_conceptos_centros') IS NOT NULL
                DROP TABLE dbo.tmp_conceptos_centros


            --Insertar el centro de costos
            PRINT 'Actualizando tabla centros con el nuevo centro'
            IF NOT EXISTS ( SELECT  centro
                            FROM    dbo.centros
                            WHERE   centro = @cCentro
                                    AND empresa = @nEmpresa )
                INSERT  INTO dbo.centros
                        ( centro ,
                          empresa ,
                          nomdepto ,
                          defindpto2
                        )
                VALUES  ( @cCentro ,
                          @nEmpresa ,
                          @cNombre ,
                          @cNivel
                        )

            --Para actualizar la tabla de conceptos y percepciones/deducciones
            PRINT 'Actualizando tabla conceptos'
            SELECT  *
            INTO    dbo.tmp_conceptos_centros
            FROM    dbo.conceptos
            WHERE   centro = @coldcen
                    AND empresa = @nempresa

            UPDATE  dbo.tmp_conceptos_centros
            SET     centro = @ccentro
            WHERE   centro = @coldcen

            INSERT  INTO dbo.conceptos
                    SELECT  *
                    FROM    dbo.tmp_conceptos_centros


            --Si el centro de costos anterior tiene valor actualizar los historicos
            IF LEN(RTRIM(@cOldCen)) > 0
                BEGIN
                    --Tablas que estan relacionadas a centros
                    SELECT  OBJECT_NAME(constid) FKey_Name ,
                            OBJECT_NAME(fkeyid) hija ,
                            c1.name FKey_Col ,
                            OBJECT_NAME(rkeyid) padre ,
                            c2.name Ref_KeyCol ,
                            'UPDATE ' + OBJECT_NAME(fkeyid) + ' SET centro = '
                            + CHAR(39) + RTRIM(@cCentro) + CHAR(39)
                            + ' WHERE centro = ' + CHAR(39) + RTRIM(@cOldCen)
                            + CHAR(39) + ' AND empresa = '
                            + CONVERT(CHAR(5), @nEmpresa) AS query_upd
                    INTO    dbo.tmp_hijos_centros
                    FROM    sysforeignkeys s
                            INNER JOIN syscolumns c1 ON ( s.fkeyid = c1.id
                                                          AND s.fkey = c1.colid
                                                        )
                            INNER JOIN syscolumns c2 ON ( s.rkeyid = c2.id
                                                          AND s.rkey = c2.colid
                                                        )
                    WHERE   OBJECT_NAME(rkeyid) = 'centros'
                            AND c2.name = 'centro'


                    --Empleados que tiene el centro de costos anterior, para guardar
                    --El cambio en el historico de movimientos
                    SELECT  ll.codigo ,
                            ll.tiponom ,
                            e.mes_operacion ,
                            e.ayo_operacion,
                            p.periodo,
                            ll.empresa
                    INTO    dbo.tmp_llaves_codigos
                    FROM    dbo.llaves AS ll
                            INNER JOIN empresas AS e ON ( ll.empresa = e.empresa )
                            LEFT JOIN periodos AS p ON (ll.tiponom = p.tiponom AND ll.empresa = p.empresa AND p.estatus = 'A')
                    WHERE   ll.empresa = @nEmpresa
                            AND ll.centro = @cOldCen



                    --Estas tablas no tienen relacion con centros, pero tambien tienen ese campo y son
                    --para reportes historicos
                    PRINT 'Actualizando tablas sin relacion'
                    UPDATE  dbo.nomina1_anual
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    UPDATE  dbo.horas_laboradas
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    UPDATE  dbo.cuentas
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    UPDATE  dbo.recibos
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    UPDATE  dbo.kardex
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    UPDATE  dbo.finiquitos
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    UPDATE  dbo.finiquitos_anual
                    SET     centro = @cCentro
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                    --Borrar la tabla de conceptos, porque se actualiza mas abajo, junto con la tabla percepciones y deducciones
                    DELETE  dbo.tmp_hijos_centros
                    WHERE   hija = 'conceptos'

                    --Cursor para hacer los cambios en todas las tablas historicas, que tiene
                    --Relacion con centros
                    IF EXISTS ( SELECT  NAME
                                FROM    sys.dm_exec_cursors(0)
                                WHERE   NAME = 'mod_str_cc' )
                        DEALLOCATE mod_str_cc

                    DECLARE mod_str_cc CURSOR
                    FOR
                    SELECT  query_upd
                    FROM    dbo.tmp_hijos_centros

                    OPEN mod_str_cc

                    FETCH NEXT FROM mod_str_cc INTO @cQuery_upd

                    WHILE ( @@fetch_status <> -1 )
                        BEGIN
                            --BEGIN TRY

                                PRINT @cQuery_upd
                                EXEC( @cQuery_upd )

                                FETCH NEXT FROM mod_str_cc INTO @cQuery_upd
/*
                            END TRY
                            BEGIN CATCH


                                SET @ErrorSeverity = ERROR_SEVERITY()
                                SET @ErrorState = ERROR_STATE()
                                SET @ErrorMessage = 'State: '
                                    + LTRIM(RTRIM(STR(@ErrorState))) + CHAR(13)
                                    + CHAR(10) + 'Severity: '
                                    + LTRIM(RTRIM(STR(@ErrorSeverity)))
                                    + CHAR(13) + CHAR(10) + 'Error number:  '
                                    + LTRIM(RTRIM(STR(ERROR_NUMBER())))
                                    + CHAR(13) + CHAR(10) + 'Message: '
                                    + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
                                    + 'Procedure: ' + ERROR_PROCEDURE()
                                    + CHAR(13) + CHAR(10) + 'Line: '
                                    + LTRIM(RTRIM(STR(ERROR_LINE())))


                                RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

                            END CATCH
*/

                        END

                    CLOSE mod_str_cc
                    DEALLOCATE mod_str_cc


                    --Cursor para guardar los cambios en el historico de cambios
                   INSERT  INTO dbo.historico
                   SELECT codigo ,
                          empresa ,
                          'CENTRO',
                          @cCentro,
                          @cOldCen,
                          periodo ,
                          mes_operacion ,
                          ayo_operacion ,
                          @nMotivo ,
                          @cUsuario ,
                          @cUsuario ,
                          @dFecha ,
                          @dFecha ,
                          'NUEVO CAT.',
                          @nMotivo ,
                          @Origen
                   FROM dbo.tmp_llaves_codigos



/*
                    IF EXISTS ( SELECT  NAME
                                FROM    sys.dm_exec_cursors(0)
                                WHERE   NAME = 'mod_llaves_cc' )
                        DEALLOCATE mod_llaves_cc

                    DECLARE mod_llaves_cc CURSOR
                    FOR
                    SELECT  codigo ,
                    tiponom ,
                    mes_operacion ,
                    ayo_operacion
                    FROM    dbo.tmp_llaves_codigos

                    PRINT 'Actualizando historico'

                    OPEN mod_llaves_cc

                    FETCH NEXT FROM mod_llaves_cc INTO @nCodigo, @nTiponom, @nMes, @nAyo

                    WHILE ( @@fetch_status <> -1 )
                        BEGIN

                            PRINT @nCodigo
                            PRINT @nTiponom
                            PRINT @nMes
                            PRINT @nAyo

                            SET @cMes = CONVERT(CHAR(2), @nMes)
                            SET @cAYO = CONVERT(CHAR(4), @nAyo)
                            SET @cPeriodo = @cMes + @cAyo

                            EXEC dbo.sp_agrega_registro_historico @nEmpresa,
                                @nCodigo, 'CENTRO', @cCentro, @cOldCen,
                                @cPeriodo, @nMes, @nAyo, @cUsuario, @dFecha,
                                @dFecha, 'NUEVO CAT.', @nMotivo, @ntiponom,
                                @Origen

                            FETCH NEXT FROM mod_llaves_cc INTO @nCodigo, @nTiponom, @nMes,@nAyo

                        END

                    CLOSE mod_llaves_cc
                    DEALLOCATE mod_llaves_cc
*/

                    --Para actualizar la tabla de conceptos y percepciones/deducciones
/*
                    PRINT 'Actualizando tabla conceptos'
                    SELECT  *
                    INTO    dbo.tmp_conceptos_centros
                    FROM    dbo.conceptos
                    WHERE   centro = @coldcen
                            AND empresa = @nempresa

                    UPDATE  dbo.tmp_conceptos_centros
                    SET     centro = @ccentro
                    WHERE   centro = @coldcen

                    INSERT  INTO dbo.conceptos
                            SELECT  *
                            FROM    dbo.tmp_conceptos_centros
*/

                    PRINT 'Actualizando tabla percepciones'
                    UPDATE  dbo.percepciones
                    SET     centro = @ccentro
                    WHERE   centro = @coldcen
                            AND empresa = @nempresa

                    PRINT 'Actualizando tabla deducciones'
                    UPDATE  dbo.deducciones
                    SET     centro = @ccentro
                    WHERE   centro = @coldcen
                            AND empresa = @nempresa

                    PRINT 'Borrando tabla conceptos'
                    DELETE  dbo.conceptos
                    WHERE   centro = @coldcen
                            AND empresa = @nempresa


                    --Borrar el centro de costos anterior
                    PRINT 'Borrando tabla centros'
                    DELETE  dbo.centros
                    WHERE   centro = @cOldCen
                            AND empresa = @nEmpresa

                END

        END TRY
        BEGIN CATCH


            SET @ErrorSeverity = ERROR_SEVERITY()
            SET @ErrorState = ERROR_STATE()
            SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
                + CHAR(13) + CHAR(10) + 'Severity: '
                + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
                + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER())))
                + CHAR(13) + CHAR(10) + 'Message: ' + ERROR_MESSAGE()
                + CHAR(13) + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                + CHAR(13) + CHAR(10) + 'Line: '
                + LTRIM(RTRIM(STR(ERROR_LINE())))

            IF ( XACT_STATE() ) = -1
                OR @@TRANCOUNT > 0
                ROLLBACK TRANSACTION

            RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

        END CATCH

        IF @@TRANCOUNT > 0
            COMMIT TRANSACTION


    END

GO



/**************************************************************************************************
 * Name          : Fun_I_ActualizarPrimaRt
 * Project       : APSI Nomina
 * Description   : Mayo 25, 2011
 *                 Actualiza la prima de riesgo de trabajo
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Mayo 25 2010
 * Parameters    : empresa
 *               : fecha1            = Fecha de la prima anterior
 *               : primaRtAnterior   = Prima de riesgo anterior
 *               : fechaNuevaPrimaRt = Fecha en que se va registrar la nueva prima
 *               : primaRtNueva      = Nueva prima de riesgo de trabajo a registrar
 *               : cUser             = Usuario de la nomina, para registrar en la bitacora
 **************************************************************************************************/


IF OBJECT_ID('dbo.Fun_I_ActualizarPrimaRt') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_ActualizarPrimaRt
GO


CREATE PROCEDURE dbo.Fun_I_ActualizarPrimaRt
    @empresa INTEGER ,
    @fecha1 DATETIME ,
    @primaRtAnterior FLOAT ,
    @fechaNuevaPrimaRt DATETIME ,
    @primaRtNueva FLOAT ,
    @cUser VARCHAR(20)
AS
    DECLARE @fechaFinalPrimaRtAnterior AS DATETIME
    DECLARE @fechaInicialPrimaRtAnterior AS DATETIME
    DECLARE @fechaFinalPrimaRtNueva AS DATETIME


    BEGIN TRANSACTION
    BEGIN TRY

    /*Prima Rt anterior o actual*/
        SELECT  @fechaFinalPrimaRtAnterior = Fecha_Final ,
                @fechaInicialPrimaRtAnterior = fecha_inicial
        FROM    Primas_Rt
        WHERE   ( @fecha1 >= Fecha_Inicial
                  AND @fecha1 <= fecha_final
                )
                AND Empresa = @empresa
                AND prima_rt = @primaRtAnterior

      /*Si no encuentra la prima del ejercicio anterior por la fecha, buscarla por el ao por si se registro con otra fecha */
      IF @fechaFinalPrimaRtAnterior IS NULL
        SELECT  @fechaFinalPrimaRtAnterior = Fecha_Final ,
                @fechaInicialPrimaRtAnterior = fecha_inicial
        FROM    Primas_Rt
        WHERE   ( YEAR(@fecha1) = YEAR(Fecha_Inicial)
                  AND @fecha1 <= fecha_final
                )
                AND Empresa = @empresa
                AND prima_rt = @primaRtAnterior


    /*Prima Rt nueva*/
        SELECT  @fechaFinalPrimaRtNueva = Fecha_Final
        FROM    Primas_Rt
        WHERE   ( @fechaNuevaPrimaRt >= Fecha_Inicial
                  AND @fechaNuevaPrimaRt <= fecha_final
                )
                AND Empresa = @empresa
                AND prima_rt = @primaRtNueva

    /*Si las fechas de las 2 primas son iguales, esta mal, corregir la fecha final de la prima anterio*/
        IF @fechaFinalPrimaRtAnterior = @fechaFinalPrimaRtNueva
            BEGIN

                UPDATE  dbo.primas_rt
                SET     fecha_final = @fechaNuevaPrimaRt - 1
                WHERE   empresa = @empresa
                        AND fecha_inicial = @fechaInicialPrimaRtAnterior
                        AND fecha_final = @fechaFinalPrimaRtAnterior

                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema
                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'I' ,
                                0 ,
                                'Actualizar prima de riesgo de trabajo' ,
                                'Fecha final :' + dbo.DateToChar(@fechaFinalPrimaRtAnterior,'DD/MM/YYYY', '/') + ' nueva fecha : ' + dbo.DateToChar((@fechaNuevaPrimaRt - 1),'DD/MM/YYYY', '/'),
                                'Fecha final erronea de aos anteriores' ,
                                @cUser ,
                                '' ,
                                LEFT(Empresas.Registro_Patronal, 10) ,
                                'NO'
                        FROM    Empresas
                        WHERE   Empresa = @empresa


            END


    /*Si la prima nueva no existe, a la anterior ponerle como fecha final con la fecha de la nueva,
     un dia antes y agregar la nueva prima de rt
    */

        IF @fechaFinalPrimaRtAnterior IS NOT NULL
            AND @fechaFinalPrimaRtNueva IS NULL
            BEGIN

            /*Si la fecha final es la ultima registrada actualizar y agregar*/
                IF @fechaFinalPrimaRtAnterior = '29991231'
                    BEGIN

                        SELECT  '1'

                        UPDATE  dbo.primas_rt
                        SET     fecha_final = @fechaNuevaPrimaRt - 1
                        WHERE   empresa = @empresa
                                AND fecha_inicial = @fechaInicialPrimaRtAnterior
                                AND fecha_final = @fechaFinalPrimaRtAnterior

                        SELECT  '1.1'


                        -- Actualizar la bitacora
                        INSERT  INTO Bitacora
                                ( Empresa ,
                                  Fecha ,
                                  Hora ,
                                  Funcion ,
                                  Codigo ,
                                  Opcion ,
                                  Opcion2 ,
                                  Opcion3 ,
                                  Usuario ,
                                  Clave ,
                                  RegPat ,
                                  Sistema
                                )
                                SELECT  @empresa ,
                                        GETDATE() ,
                                        SUBSTRING(CONVERT(CHAR(20), GETDATE()),12, 8) ,
                                        'I' ,
                                        0 ,
                                        'Actualizar prima de riesgo de trabajo' ,
                                        'Fecha anterior :' + dbo.DateToChar(@fechaFinalPrimaRtAnterior,'DD/MM/YYYY', '/') + ' nueva fecha :' + dbo.DateToChar((@fechaNuevaPrimaRt - 1), 'DD/MM/YYYY','/'),
                                        'Agregar nueva prima de riesgo de trabajo' ,
                                        @cUser ,
                                        '' ,
                                        LEFT(Empresas.Registro_Patronal, 10) ,
                                        'NO'
                                FROM    Empresas
                                WHERE   Empresa = @empresa

                        SELECT  '1.2'

                        INSERT  INTO dbo.primas_rt
                                ( empresa ,
                                  fecha_inicial ,
                                  fecha_final ,
                                  prima_rt ,
                                  prima_omitida ,
                                  sw_omitida
                                )
                        VALUES  ( @empresa , -- empresa - numeric
                                  @fechaNuevaPrimaRt , -- fecha_inicial - datetime
                                  '29991231' , -- fecha_final - datetime
                                  @primaRtNueva , -- prima_rt - decimal
                                  0.00 , -- prima_omitida - decimal
                                  ''  -- sw_omitida - char(1)
                                )

                        SELECT  '1.3'

                        -- Actualizar la bitacora
                        INSERT  INTO Bitacora
                                ( Empresa ,
                                  Fecha ,
                                  Hora ,
                                  Funcion ,
                                  Codigo ,
                                  Opcion ,
                                  Opcion2 ,
                                  Opcion3 ,
                                  Usuario ,
                                  Clave ,
                                  RegPat ,
                                  Sistema
                                )
                                SELECT  @empresa ,
                                        GETDATE() ,
                                        SUBSTRING(CONVERT(CHAR(20), GETDATE()),12, 8) ,
                                        'I' ,
                                        0 ,
                                        'Actualizar prima de riesgo de trabajo' ,
                                        'Prima anterior : ' + Convert(CHAR(10),@primaRtAnterior) + ' Nueva prima : ' + Convert(CHAR(10),@primaRtNueva),
                                        'Agregar nueva prima de riesgo',
                                        @cUser ,
                                        '' ,
                                        LEFT(Empresas.Registro_Patronal, 10) ,
                                        'NO'
                                FROM    Empresas
                                WHERE   Empresa = @empresa

                        SELECT  '1.4'


                    END
                ELSE
                    BEGIN
                    /*Este proceso es para actualizar la prima del ao en curso, si la modifican */

                        SELECT  '2'

                        SELECT  @fechaFinalPrimaRtAnterior = Fecha_Final ,
                                @fechaInicialPrimaRtAnterior = fecha_inicial
                        FROM    Primas_Rt
                        WHERE   ( @fechaNuevaPrimaRt >= Fecha_Inicial
                                  AND @fechaNuevaPrimaRt <= fecha_final
                                )
                                AND Empresa = @empresa


                        UPDATE  dbo.primas_rt
                        SET     prima_rt = @primaRtNueva
                        WHERE   empresa = @empresa
                                AND fecha_inicial = @fechaInicialPrimaRtAnterior
                                AND fecha_final = @fechaFinalPrimaRtAnterior

                        SELECT  '2.1'

                        -- Actualizar la bitacora
                        INSERT  INTO Bitacora
                                ( Empresa ,
                                  Fecha ,
                                  Hora ,
                                  Funcion ,
                                  Codigo ,
                                  Opcion ,
                                  Opcion2 ,
                                  Opcion3 ,
                                  Usuario ,
                                  Clave ,
                                  RegPat ,
                                  Sistema
                                )
                                SELECT  @empresa ,
                                        GETDATE() ,
                                        SUBSTRING(CONVERT(CHAR(20), GETDATE()),12, 8) ,
                                        'I' ,
                                        0 ,
                                        'Actualizar prima de riesgo de trabajo' ,
                                        'Prima anterior : ' + Convert(CHAR(10),@primaRtAnterior) + ' Nueva prima : ' + Convert(CHAR(10),@primaRtNueva),
                                        'Modificar prima de riesgo de trabajo',
                                        @cUser ,
                                        '' ,
                                        LEFT(Empresas.Registro_Patronal, 10) ,
                                        'NO'
                                FROM    Empresas
                                WHERE   Empresa = @empresa

                        SELECT  '2.2'


                    END
            END
        ELSE
           IF @primaRtAnterior <> @primaRtNueva AND @primartanterior > 0
              BEGIN
                /*Este proceso es para actualizar la prima del ao en curso, si la modifican */

                 SELECT  '3'


                 SELECT  @fechaFinalPrimaRtAnterior = Fecha_Final ,
                         @fechaInicialPrimaRtAnterior = fecha_inicial
                 FROM    Primas_Rt
                 WHERE   ( @fechaNuevaPrimaRt >= Fecha_Inicial
                          AND @fechaNuevaPrimaRt <= fecha_final
                           )
                         AND Empresa = @empresa


                 /*Si las fechas de la prima son nulas buscar por el ao, porque puede ser que sea empresa nueva y se haya
                   registrado posterior a Marzo */
                 IF @fechaFinalPrimaRtAnterior IS NULL
                    AND @fechaInicialPrimaRtAnterior IS NULL
                    SELECT  @fechaFinalPrimaRtAnterior = Fecha_Final ,
                            @fechaInicialPrimaRtAnterior = fecha_inicial
                    FROM    Primas_Rt
                    WHERE   ( YEAR(@fechaNuevaPrimaRt) = YEAR(Fecha_Inicial)
                              AND @fechaNuevaPrimaRt <= fecha_final
                            )
                            AND Empresa = @empresa


                  UPDATE  dbo.primas_rt
                  SET     prima_rt = @primaRtNueva
                  WHERE   empresa = @empresa
                          AND fecha_inicial = @fechaInicialPrimaRtAnterior
                          AND fecha_final = @fechaFinalPrimaRtAnterior

                  SELECT  '3.1'

                  -- Actualizar la bitacora
                  INSERT  INTO Bitacora
                               ( Empresa ,
                                 Fecha ,
                                 Hora ,
                                 Funcion ,
                                 Codigo ,
                                 Opcion ,
                                 Opcion2 ,
                                 Opcion3 ,
                                 Usuario ,
                                 Clave ,
                                 RegPat ,
                                 Sistema
                               )
                               SELECT  @empresa ,
                                        GETDATE() ,
                                        SUBSTRING(CONVERT(CHAR(20), GETDATE()),12, 8) ,
                                        'I' ,
                                        0 ,
                                        'Actualizar prima de riesgo de trabajo' ,
                                        'Prima anterior : ' + Convert(CHAR(10),@primaRtAnterior) + ' Nueva prima : ' + Convert(CHAR(10),@primaRtNueva),
                                        'Modificar prima de riesgo de trabajo',
                                        @cUser ,
                                        '' ,
                                        LEFT(Empresas.Registro_Patronal, 10) ,
                                        'NO'
                                FROM    Empresas
                                WHERE   Empresa = @empresa

                        SELECT  '3.2'

              END
          ELSE
           IF @primartanterior <> @primartnueva AND @primartanterior = 0
              BEGIN
                /*Este proceso es agregar la prima RT, cuando no existe una registro anterior */
                        SELECT  '4'

                        INSERT  INTO dbo.primas_rt
                                ( empresa ,
                                  fecha_inicial ,
                                  fecha_final ,
                                  prima_rt ,
                                  prima_omitida ,
                                  sw_omitida
                                )
                        VALUES  ( @empresa , -- empresa - numeric
                                  @fechanuevaprimart , -- fecha_inicial - datetime
                                  '29991231' , -- fecha_final - datetime
                                  @primartnueva , -- prima_rt - decimal
                                  0.00 , -- prima_omitida - decimal
                                  ''  -- sw_omitida - char(1)
                                )

                        SELECT  '4.1'

                        -- Actualizar la bitacora
                        INSERT  INTO Bitacora
                                ( Empresa ,
                                  Fecha ,
                                  Hora ,
                                  Funcion ,
                                  Codigo ,
                                  Opcion ,
                                  Opcion2 ,
                                  Opcion3 ,
                                  Usuario ,
                                  Clave ,
                                  RegPat ,
                                  Sistema
                                )
                                SELECT  @empresa ,
                                        GETDATE() ,
                                        SUBSTRING(CONVERT(CHAR(20), GETDATE()),12, 8) ,
                                        'I' ,
                                        0 ,
                                        'Actualizar prima de riesgo de trabajo' ,
                                        'Prima anterior : ' + Convert(CHAR(10),@primartanterior) + ' Nueva prima : ' + Convert(CHAR(10),@primartnueva),
                                        'Agregar nueva prima de riesgo',
                                        @cuser ,
                                        '' ,
                                        LEFT(Empresas.Registro_Patronal, 10) ,
                                        'NO'
                                FROM    Empresas
                                WHERE   Empresa = @empresa

                        SELECT  '4.2'


              END



    END TRY

    BEGIN CATCH

        DECLARE @ErrorSeverity INTEGER --udtInteger
        DECLARE @ErrorState INTEGER --udtInteger
        DECLARE @ErrorMessage VARCHAR(2048) --udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
        END

GO

/*
* Actualiza el tamao de los campos de formula para que se puedan registrar formulas con mas variables
*/

IF (SELECT length FROM syscolumns
    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
    WHERE syscolumns.name = 'formula' AND sysobjects.name = 'conceptos') < 200

  ALTER TABLE conceptos ALTER COLUMN formula VARCHAR(200) null

GO



IF (SELECT length FROM syscolumns
    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
    WHERE syscolumns.name = 'mascara' AND sysobjects.name = 'conceptos') < 200

  ALTER TABLE conceptos ALTER COLUMN mascara VARCHAR(200) null

GO


IF (SELECT length FROM syscolumns
    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
    WHERE syscolumns.name = 'formula2' AND sysobjects.name = 'conceptos') < 200

  ALTER TABLE conceptos ALTER COLUMN formula2 VARCHAR(200) null

GO


IF (SELECT length FROM syscolumns
    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
    WHERE syscolumns.name = 'mascara2' AND sysobjects.name = 'conceptos') < 200

  ALTER TABLE conceptos ALTER COLUMN mascara2 VARCHAR(200) null

GO


IF (SELECT length FROM syscolumns
    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
    WHERE syscolumns.name = 'formula' AND sysobjects.name = 'kardex') < 200

  ALTER TABLE kardex ALTER COLUMN formula VARCHAR(200) null

GO


/**************************************************************************************************
 * Name          : sp_aud_acum_per
 * Project       : APSI Nomina
 * Description   : Septiembre 01, 2011
 *                 Auditor de acumulados de nominas cerradas
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 01, 2011
 * Parameters    : empresa,ejercicio
 **************************************************************************************************/

IF OBJECT_ID('dbo.sp_aud_acum_per') IS NOT NULL
    DROP PROCEDURE dbo.sp_aud_acum_per
GO


CREATE PROCEDURE dbo.sp_aud_acum_per
    @empresa INT = 0 ,
    @ejercicio INT = 0
AS
    SELECT  ka.tiponom ,
            ka.periodo ,
            ka.nomina ,
            ka.mes ,
            SUM(CASE WHEN ka.tpago_desc = 'P' THEN ka.importe
                     ELSE 0
                END) AS 'Percepciones' ,
            SUM(CASE WHEN ka.tpago_desc = 'D' THEN ka.importe
                     ELSE 0
                END) AS 'Deducciones' ,
            SUM(CASE WHEN ka.tpago_desc = 'I' THEN ka.importe
                     ELSE 0
                END) AS 'Provisiones' ,
            COUNT(DISTINCT ka.codigo) AS 'Trabajadores' ,
            SUM(CASE WHEN ka.num_conc IN ( 136, 636 ) THEN ka.importe
                     ELSE 0
                END) AS 'ISR' ,
            SUM(CASE WHEN ka.num_conc IN ( 36, 536 ) THEN ka.importe
                     ELSE 0
                END) AS 'CAS' ,
            SUM(CASE WHEN ka.num_conc <= 6 THEN ka.importe
                     ELSE 0
                END) AS 'Sueldos',
            (SELECT COUNT(DISTINCT ISNULL(rc.uuid,'')) FROM dbo.ResumenCFDIs AS rc WHERE ka.empresa = rc.Empresa
                                                AND ka.nomina = rc.Nomina
                                                AND ka.periodo = rc.Periodo
                                                AND ka.tiponom = rc.TipoNom
                                                AND ka.ayo_operacion = rc.Ayo ) AS 'Timbrados',
            SUM(CASE WHEN ka.num_conc = 216  THEN ka.importe
                     ELSE 0
                END) AS 'ISN'
    FROM    Kardex_anual AS ka
    WHERE   ka.empresa = @empresa
            AND ayo_operacion = @ejercicio
    GROUP BY ka.tiponom ,
            ka.periodo ,
            ka.nomina ,
            ka.mes ,
            ka.empresa,
            ka.ayo_operacion
    ORDER BY ka.periodo ,
            ka.mes


GO


/**************************************************************************************************
 * Name          : asp_variables_informe_ejecutivo
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Llena las tablas del reporte ejecutivo de tiempo extra e incapacidades
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 01, 2008
 * Parameters    : empresa,mes de operacion y ao de operacion
 **************************************************************************************************/
IF OBJECT_ID('dbo.asp_variables_informe_ejecutivo') IS NOT NULL
    DROP PROCEDURE dbo.asp_variables_informe_ejecutivo
GO


CREATE PROCEDURE dbo.asp_variables_informe_ejecutivo
    @empresa AS INT ,
    @mesOperacion AS INT ,
    @ayoOperacion AS INT
AS
    DECLARE @totalRegistrosTabla AS INT
    DECLARE @tiempoExtra AS FLOAT
    DECLARE @incapacidades AS FLOAT

    SET @totalRegistrosTabla = 0
    SET @tiempoExtra = 0
    SET @incapacidades = 0

    IF OBJECT_ID('dbo.tmp_ieVariables') IS NOT NULL
        DROP TABLE dbo.tmp_ieVariables


    SELECT  @totalRegistrosTabla = COUNT(*)
    FROM    dbo.Ie_variables


/*
Revisar si esta vacia la tabla llenarla con toda la informacion historica
*/
    IF @totalRegistrosTabla = 0
        BEGIN
        --Deducciones
            SELECT  empresa ,
                    ayo_operacion AS 'vyear' ,
                    mes_operacion AS 'mes' ,
                    SUM(CASE WHEN num_conc = 110 THEN dias
                             ELSE 0
                        END) AS 'riesgoTrabajo' ,
                    SUM(CASE WHEN num_conc = 111 THEN dias
                             ELSE 0
                        END) AS 'Maternidad' ,
                    SUM(CASE WHEN num_conc = 109 THEN dias
                             ELSE 0
                        END) AS 'EnfermedadGral' ,
                    SUM(dias) AS 'totalAusentismo' ,
                    @tiempoExtra AS 'LabDiasDescanso' ,
                    @tiempoExtra AS 'TExtra' ,
                    @tiempoExtra AS 'TExtraDoble' ,
                    @tiempoExtra AS 'TextraTriple'
            INTO    dbo.tmp_ieVariables
            FROM    dbo.deducciones
            WHERE   num_conc >= 109
                    AND num_conc <= 111
                    AND empresa = @empresa
            GROUP BY empresa ,
                    mes_operacion ,
                    ayo_operacion
            ORDER BY empresa ,
                    ayo_operacion ,
                    mes_operacion

        --Percepciones
            INSERT  INTO dbo.tmp_ieVariables
                    SELECT  empresa ,
                            ayo_operacion AS 'vyear' ,
                            mes_operacion AS 'mes' ,
                            @incapacidades AS 'riesgoTrabajo' ,
                            @incapacidades AS 'Maternidad' ,
                            @incapacidades AS 'EnfermedadGral' ,
                            @incapacidades AS 'totalAusentismo' ,
                            SUM(CASE WHEN num_conc = 10 THEN nomina
                                     ELSE 0
                                END) AS 'LabDiasDescanso' ,
                            SUM(nomina) AS 'TExtra' ,
                            SUM(CASE WHEN num_conc >= 11
                                          AND num_conc <= 12 THEN nomina
                                     ELSE 0
                                END) AS 'TExtraDoble' ,
                            SUM(CASE WHEN num_conc = 13 THEN nomina
                                     ELSE 0
                                END) AS 'TExtraTriple'
                    FROM    dbo.percepciones
                    WHERE   num_conc >= 10
                            AND num_conc <= 13
                            AND empresa = @empresa
                    GROUP BY empresa ,
                            mes_operacion ,
                            ayo_operacion
                    ORDER BY empresa ,
                            ayo_operacion ,
                            mes_operacion

        -- tmp_ieVariables
            INSERT  INTO dbo.ie_variables
                    SELECT  empresa ,
                            vyear ,
                            mes ,
                            SUM(riesgoTrabajo) AS 'riesgoTrabajo' ,
                            SUM(Maternidad) AS 'Maternidad' ,
                            SUM(EnfermedadGral) AS 'EnfermedadGral' ,
                            SUM(totalAusentismo) AS 'totalAusentismo' ,
                            SUM(LabDiasDescanso) AS 'LabDiasDescanso' ,
                            SUM(Textra) AS 'Textra' ,
                            SUM(TExtraDoble) AS 'TExtraDoble' ,
                            SUM(TExtraTriple) AS 'TExtraTriple'
                    FROM    dbo.tmp_ieVariables
                    WHERE   empresa = @empresa
                    GROUP BY empresa ,
                            vyear ,
                            mes
                    ORDER BY empresa ,
                            vyear ,
                            mes


        END
    ELSE
    /*
      Revisar solo el mes de operacion seleccionado
    */
        BEGIN
        --Deducciones
            SELECT  empresa ,
                    ayo_operacion AS 'vyear' ,
                    mes_operacion AS 'mes' ,
                    SUM(CASE WHEN num_conc = 110 THEN dias
                             ELSE 0
                        END) AS 'riesgoTrabajo' ,
                    SUM(CASE WHEN num_conc = 111 THEN dias
                             ELSE 0
                        END) AS 'Maternidad' ,
                    SUM(CASE WHEN num_conc = 109 THEN dias
                             ELSE 0
                        END) AS 'EnfermedadGral' ,
                    SUM(dias) AS 'totalAusentismo' ,
                    @tiempoExtra AS 'LabDiasDescanso' ,
                    @tiempoExtra AS 'TExtra' ,
                    @tiempoExtra AS 'TExtraDoble' ,
                    @tiempoExtra AS 'TextraTriple'
            INTO    dbo.tmp_ieVariables
            FROM    dbo.deducciones
            WHERE   num_conc >= 109
                    AND num_conc <= 111
                    AND empresa = @empresa
                    AND mes_operacion = @mesOperacion
                    AND ayo_operacion = @ayoOperacion
            GROUP BY empresa ,
                    mes_operacion ,
                    ayo_operacion
            ORDER BY empresa ,
                    ayo_operacion ,
                    mes_operacion

        --Percepciones
            INSERT  INTO dbo.tmp_ieVariables
                    SELECT  empresa ,
                            ayo_operacion AS 'vyear' ,
                            mes_operacion AS 'mes' ,
                            @incapacidades AS 'riesgoTrabajo' ,
                            @incapacidades AS 'Maternidad' ,
                            @incapacidades AS 'EnfermedadGral' ,
                            @incapacidades AS 'totalAusentismo' ,
                            SUM(CASE WHEN num_conc = 10 THEN nomina
                                     ELSE 0
                                END) AS 'LabDiasDescanso' ,
                            SUM(nomina) AS 'TExtra' ,
                            SUM(CASE WHEN num_conc >= 11
                                          AND num_conc <= 12 THEN nomina
                                     ELSE 0
                                END) AS 'TExtraDoble' ,
                            SUM(CASE WHEN num_conc = 13 THEN nomina
                                     ELSE 0
                                END) AS 'TExtraTriple'
                    FROM    dbo.percepciones
                    WHERE   num_conc >= 10
                            AND num_conc <= 13
                            AND empresa = @empresa
                            AND mes_operacion = @mesOperacion
                            AND ayo_operacion = @ayoOperacion
                    GROUP BY empresa ,
                            mes_operacion ,
                            ayo_operacion
                    ORDER BY empresa ,
                            ayo_operacion ,
                            mes_operacion

        --Borrar la informacion si existe, para que no haya conflicto con la insercion
            DELETE  dbo.ie_variables
            WHERE   empresa = @empresa
                    AND vyear = @ayoOperacion
                    AND mes = @mesOperacion

        -- tmp_ieVariables
            INSERT  INTO dbo.ie_variables
                    SELECT  empresa ,
                            vyear ,
                            mes ,
                            SUM(riesgoTrabajo) AS 'riesgoTrabajo' ,
                            SUM(Maternidad) AS 'Maternidad' ,
                            SUM(EnfermedadGral) AS 'EnfermedadGral' ,
                            SUM(totalAusentismo) AS 'totalAusentismo' ,
                            SUM(LabDiasDescanso) AS 'LabDiasDescanso' ,
                            SUM(Textra) AS 'Textra' ,
                            SUM(TExtraDoble) AS 'TExtraDoble' ,
                            SUM(TExtraTriple) AS 'TExtraTriple'
                    FROM    dbo.tmp_ieVariables
                    WHERE   empresa = @empresa
                            AND mes = @mesOperacion
                            AND vyear = @ayoOperacion
                    GROUP BY empresa ,
                            vyear ,
                            mes
                    ORDER BY empresa ,
                            vyear ,
                            mes


        END


GO

/**************************************************************************************************
 * Project       : APSI Nomina
 * Description   : Septiembre 26, 2011
 *                 Tablas para pension alimenticia
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Jorge Martinez (jorge.martinez@apsi.com.mx)
 * Creation date : Septiembre 26, 2011
 **************************************************************************************************/


IF OBJECT_ID('dbo.PensionAlimenticia') IS NULL
    CREATE TABLE dbo.PensionAlimenticia
        (
          empresa INT ,
          codigo INT ,
          consecutivo INT IDENTITY ,
          porcentaje FLOAT ,
          importe FLOAT ,
          fecha DATETIME ,
          uso CHAR(1) ,
          beneficiario VARCHAR(100) ,
          referencia VARCHAR(50) ,
          cuentaBanco VARCHAR(50),
          Domicilio VARCHAR(50),
          Colonia VARCHAR(50),
          Poblacion VARCHAR(50),
          Telefono CHAR(10),
          EMail VARCHAR(100)
          CONSTRAINT PK_PensionAlimenticia
          PRIMARY KEY CLUSTERED ( empresa, codigo, consecutivo )
        )
ELSE
   IF NOT EXISTS ( SELECT  syscolumns.name
                   FROM    syscolumns
                           LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                   WHERE   syscolumns.name = 'importe'
                           AND sysobjects.name = 'PensionAlimenticia' )
      ALTER TABLE dbo.PensionAlimenticia ADD importe FLOAT

GO


IF OBJECT_ID('dbo.PensionAlimenticiaConcepto') IS NULL
    BEGIN
        CREATE TABLE dbo.PensionAlimenticiaConcepto
            (
              empresa INT ,
              codigo INT ,
              consecutivo INT ,
              num_conc INT
            )

        ALTER TABLE dbo.PensionAlimenticiaConcepto ADD CONSTRAINT PensionAlimenticia01
        FOREIGN KEY (empresa,codigo,consecutivo)
        REFERENCES dbo.PensionAlimenticia(empresa,codigo,consecutivo)
    END

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Domicilio'
                        AND sysobjects.name = 'PENSIONALIMENTICIA' )
    BEGIN
        ALTER TABLE PensionAlimenticia
        ADD Domicilio VARCHAR(50) NULL

        ALTER TABLE PensionAlimenticia
        ADD Colonia VARCHAR(50) NULL

        ALTER TABLE PensionAlimenticia
        ADD Poblacion VARCHAR(50) NULL

        ALTER TABLE PensionAlimenticia
        ADD Telefono CHAR(10) NULL

        ALTER TABLE PensionAlimenticia
        ADD EMail VARCHAR(100) NULL
    END

GO


/**************************************************************************************************
 * Name          : fun_e_GetPensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Extraer los registros de pensiones alimenticias de un empleado
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetPensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetPensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_GetPensionesAlimenticias
    @empresa AS INT ,
    @codigo AS NUMERIC(8)
AS
    SET NOCOUNT OFF

    SELECT  ISNULL(porcentaje,0) AS 'Porcentaje' ,
            ISNULL(importe,0) AS 'Importe' ,
            referencia ,
            CASE WHEN uso = 'S' THEN 'SI'
                 ELSE 'NO'
            END AS 'Uso' ,
            beneficiario ,
            consecutivo
    FROM    dbo.PensionAlimenticia
    WHERE   empresa = @empresa
            AND codigo = @codigo
    ORDER BY consecutivo

GO



IF NOT EXISTS (SELECT syscolumns.name
               FROM syscolumns
               LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
               WHERE UPPER(syscolumns.name) = 'EXPEDIENTE' AND
                     UPPER(sysobjects.name) = 'PENSIONALIMENTICIA')
  BEGIN
    ALTER TABLE dbo.PensionAlimenticia ADD Expediente VARCHAR(100)  NULL
    ALTER TABLE dbo.PensionAlimenticia ADD Juzgado    VARCHAR(100)  NULL
  END

GO

/**************************************************************************************************
 * Name          : dbo.fun_e_GetPensionAlimenticiaByConsecutivo
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Extraer el registro de pensiones alimenticias de un empleado por el consecutivo,
 *                 para su edicion
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/


IF OBJECT_ID('dbo.fun_e_GetPensionAlimenticiaByConsecutivo') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetPensionAlimenticiaByConsecutivo
GO


CREATE PROCEDURE dbo.fun_e_GetPensionAlimenticiaByConsecutivo
    @empresa AS INT ,
    @codigo AS NUMERIC(8) ,
    @consecutivo AS INT
AS
    SET NOCOUNT OFF

    SELECT  ISNULL(porcentaje,0) AS 'Porcentaje' ,
            ISNULL(importe,0) AS 'Importe' ,
            fecha ,
            uso ,
            beneficiario ,
            referencia ,
            cuentaBanco ,
            Domicilio ,
            Colonia ,
            Poblacion ,
            Telefono ,
            EMail ,
            ISNULL(Expediente,'') ,
            ISNULL(Juzgado,'')
    FROM    dbo.PensionAlimenticia
    WHERE   empresa = @empresa
            AND codigo = @codigo
            AND consecutivo = @consecutivo

GO



/**************************************************************************************************
 * Name          : fun_e_GetConceptosPensionAlimenticia
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Extraer los registros de pensiones alimenticias de un empleado
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetConceptosPensionAlimenticia') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetConceptosPensionAlimenticia
GO


CREATE PROCEDURE dbo.fun_e_GetConceptosPensionAlimenticia
    @empresa AS INT ,
    @codigo AS NUMERIC(8) ,
    @consecutivo AS INT
AS
    SET NOCOUNT OFF

    SELECT  DISTINCT
            pc.num_conc ,
            ( SELECT TOP 1
                        c.concepto
              FROM      dbo.conceptos AS c
              WHERE     c.empresa = pc.empresa
                        AND c.num_conc = pc.num_conc
            ) AS 'Concepto' ,
            CASE WHEN pc.num_conc < 100 THEN 'Pago'
                 WHEN pc.num_conc >= 100
                      AND pc.num_conc <= 200 THEN 'Descuento'
                 WHEN pc.num_conc >= 1001
                      AND pc.num_conc <= 1099 THEN 'Descuento'
                 WHEN pc.num_conc >= 1101
                      AND pc.num_conc <= 1199 THEN 'Pago'
                 ELSE ''
            END AS 'Tipo',
			ISNULL( ( SELECT SUM(CASE WHEN k.tpago_desc = 'P' THEN k.importe
			                          WHEN k.tpago_desc = 'D' THEN k.importe * -1
									  ELSE 0 END) FROM dbo.kardex AS k
			  WHERE k.codigo = pc.codigo AND
			        k.empresa = pc.empresa AND
					k.num_conc = pc.num_conc AND
					k.nomina <> 'VAC' ),0) AS 'Importe'

    FROM    dbo.PensionAlimenticiaConcepto AS pc
    WHERE   pc.empresa = @empresa
            AND pc.codigo = @codigo
            AND pc.consecutivo = @consecutivo
    ORDER BY pc.num_conc

GO


/**************************************************************************************************
 * Name          : fun_e_GetEmpleadoPensionAlimenticia
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Extraer los registros de pensiones alimenticias de un empleado
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetEmpleadoPensionAlimenticia') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetEmpleadoPensionAlimenticia
GO


CREATE PROCEDURE dbo.fun_e_GetEmpleadoPensionAlimenticia
    @empresa AS INT ,
    @codigo AS NUMERIC(8)
AS
    SET NOCOUNT OFF

    SELECT  codigo ,
            RTRIM(ap_paterno) + ' ' + RTRIM(ap_materno) + RTRIM(nombre) AS 'Nombre'
    FROM    dbo.empleados
    WHERE   empresa = @empresa
            AND codigo = @codigo

GO



/**************************************************************************************************
 * Name          : fun_e_AddPensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Agregar registros a la tabla de pensionesAlimenticias
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_AddPensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_AddPensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_AddPensionesAlimenticias
    @empresa AS INT ,
    @codigo AS INT ,
    @porcentaje AS FLOAT ,
    @uso AS CHAR(1) ,
    @beneficiario AS VARCHAR(100) ,
    @referencia AS VARCHAR(50) ,
    @cuentaBanco AS VARCHAR(50) ,
    @conceptos AS VARCHAR(8000) ,
    @importe AS FLOAT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME ,
    @domicilio AS VARCHAR(50) ,
    @colonia AS VARCHAR(50) ,
    @poblacion AS VARCHAR(50) ,
    @telefono AS CHAR(10) ,
    @mail AS VARCHAR(100) ,
    @expediente AS VARCHAR(100) ,
    @juzgado AS VARCHAR(100)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @consecutivo AS INT

        INSERT  INTO dbo.PensionAlimenticia
                ( empresa ,
                  codigo ,
                  porcentaje ,
                  fecha ,
                  uso ,
                  beneficiario ,
                  referencia ,
                  cuentaBanco ,
                  importe ,
                  domicilio ,
                  colonia ,
                  poblacion ,
                  telefono ,
                  email ,
                  expediente ,
                  juzgado
                )
        VALUES  ( @empresa , -- empresa - int
                  @codigo , -- codigo - int
                  @porcentaje , -- porcentaje - float
                  @fecha , -- fecha - datetime
                  @uso , -- uso - char(1)
                  @beneficiario , -- beneficiario - varchar(100)
                  @referencia , -- referencia - varchar(50)
                  @cuentaBanco ,  -- cuentaBanco - varchar(50)
                  @importe ,
                  @domicilio ,
                  @colonia ,
                  @poblacion ,
                  @telefono ,
                  @mail ,
                  @expediente ,
                  @juzgado
                )

        SET @consecutivo = @@IDENTITY

        INSERT  dbo.PensionAlimenticiaConcepto
                SELECT  @empresa ,
                        @codigo ,
                        @consecutivo ,
                        valor AS 'num_conc'
                FROM    dbo.CadenaATabla(@conceptos, ',')

/*
        DECLARE @len AS INT
        DECLARE @contador AS INT
        DECLARE @valor AS CHAR(1)
        DECLARE @num_conc AS VARCHAR(10)

        SET @Len = LEN(RTRIM(@conceptos))
        SET @contador = 0
        SET @num_conc = ''
        SET @valor = ''
        PRINT @len
        WHILE @contador <= @Len
            BEGIN
                SET @valor = SUBSTRING(@conceptos, @contador, 1)
                IF @valor NOT IN ( ',' )
                    BEGIN
                        PRINT @valor
                        SET @num_conc = @num_conc + @valor
                    END
                ELSE
                    BEGIN
                        INSERT  dbo.PensionAlimenticiaConcepto
                                ( empresa ,
                                  codigo ,
                                  consecutivo ,
                                  num_conc
                                )
                        VALUES  ( @empresa , -- empresa - int
                                  @codigo , -- codigo - int
                                  @consecutivo , -- consecutivo - int
                                  CONVERT(INT, @num_conc)  -- num_conc - int
                                )
                        SET @num_conc = ''
                    END

                SET @contador = @contador + 1

            END
*/

         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Agregar pension alimenticia' ,
                        'Porcentaje :' + CONVERT(CHAR(10), @porcentaje)
                        + ' Importe :' + CONVERT(CHAR(15), @Importe) ,
                        'Consecutivo :' + CONVERT(CHAR(10), @consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_UpdatePensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Agregar registros a la tabla de pensionesAlimenticias
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_UpdatePensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdatePensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_UpdatePensionesAlimenticias
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @porcentaje AS FLOAT ,
    @beneficiario AS VARCHAR(100) ,
    @referencia AS VARCHAR(50) ,
    @cuentaBanco AS VARCHAR(50) ,
    @importe AS FLOAT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME ,
    @domicilio AS VARCHAR(50) ,
    @colonia AS VARCHAR(50) ,
    @poblacion AS VARCHAR(50) ,
    @telefono AS CHAR(10) ,
    @mail AS VARCHAR(100) ,
    @expediente AS VARCHAR(100) ,
    @juzgado AS VARCHAR(100)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY


        UPDATE  dbo.PensionAlimenticia
        SET     porcentaje = @porcentaje ,
                beneficiario = @beneficiario ,
                referencia = @referencia ,
                cuentaBanco = @cuentaBanco ,
                importe = @importe ,
                fecha = @fecha ,
                Domicilio = @domicilio ,
                Colonia = @colonia ,
                Poblacion = @poblacion ,
                Telefono = @telefono ,
                EMail = @mail ,
                Expediente = @expediente ,
                Juzgado = @juzgado
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Actualizar pension alimenticia' ,
                        'Porcentaje :' + CONVERT(CHAR(10), @porcentaje)
                        + ' Importe :' + CONVERT(CHAR(15), @Importe) ,
                        'Consecutivo :' + CONVERT(CHAR(10), @consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_GetCatalogoConceptosPensionAlimenticia
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2011
 *                 Extraer los registros de pensiones alimenticias de un empleado
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetCatalogoConceptosPensionAlimenticia') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetCatalogoConceptosPensionAlimenticia
GO


CREATE PROCEDURE dbo.fun_e_GetCatalogoConceptosPensionAlimenticia @empresa AS
    INT
AS
    SET NOCOUNT ON

    DECLARE @tConceptos AS TABLE
        (
          num_conc INTEGER ,
          concepto VARCHAR(100) ,
          tipo VARCHAR(20)
        )

    INSERT  INTO @tConceptos
            SELECT  DISTINCT
                    num_conc ,
                    '' AS concepto ,
                    CASE WHEN num_conc < 100 THEN 'Pago'
                         WHEN num_conc >= 100
                              AND num_conc <= 200 THEN 'Descuento'
                         WHEN num_conc >= 1001
                              AND num_conc <= 1099 THEN 'Descuento'
                         WHEN num_conc >= 1101
                              AND num_conc <= 1199 THEN 'Pago'
                         ELSE ''
                    END AS 'Tipo'
            FROM    dbo.conceptos
            WHERE   empresa = @empresa
                    AND uso = 'S'
                    AND ( num_conc < 200
                          OR num_conc > 1000
                        )
            ORDER BY num_conc

    UPDATE  tc
    SET     tc.concepto = c.concepto
    FROM    @tConceptos AS tc
            INNER JOIN dbo.conceptos AS c ON tc.num_conc = c.num_conc
    WHERE   c.empresa = @empresa

    SELECT  num_conc ,
            concepto ,
            tipo
    FROM    @tConceptos
    ORDER BY num_conc

GO



/**************************************************************************************************
 * Name          : fun_e_DelPensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Septiembre 29, 2011
 *                 Eliminar registros a la tabla de pensionesAlimenticias
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 29, 2011
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_DelPensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_DelPensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_DelPensionesAlimenticias
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DELETE  dbo.PensionAlimenticiaConcepto
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo

        DELETE  dbo.PensionAlimenticia
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Eliminar pension alimenticia' ,
                        '',
                        'Consecutivo :' + CONVERT(CHAR(10),@consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa


    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_UpdateUsoPensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Septiembre 29, 2011
 *                 actualiza el campo uso del registro de la tabla de pensionesAlimenticias
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 29, 2011
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_UpdateUsoPensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdateUsoPensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_UpdateUsoPensionesAlimenticias
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @usoActual AS CHAR(2)
        DECLARE @usoNuevo AS CHAR(2)

        SET @usoActual = ''
        SET @usoNuevo = ''

        SELECT  @usoActual = uso
        FROM    dbo.PensionAlimenticia
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


        UPDATE  dbo.PensionAlimenticia
        SET     uso = CASE WHEN uso = 'S' THEN 'N'
                           ELSE 'S'
                      END
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo

        SELECT  @usoNuevo = uso
        FROM    dbo.PensionAlimenticia
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Actualizar uso de pension alimenticia' ,
                        'valor actual :' + @usoActual + '  nuevo valor :' + @usoNuevo,
                        'Consecutivo :' + CONVERT(CHAR(10), @consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : fun_e_AddConceptoPensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Octubre 17, 2011
 *                 Agregar conceptos a la tabla de pensionesAlimenticiaConcepto
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 17, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_AddConceptoPensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_AddConceptoPensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_AddConceptoPensionesAlimenticias
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @num_conc AS INT ,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF NOT EXISTS ( SELECT  codigo
                        FROM    dbo.PensionAlimenticiaConcepto
                        WHERE   empresa = @empresa
                                AND codigo = @codigo
                                AND consecutivo = @consecutivo
                                AND num_conc = @num_conc )
            BEGIN
                INSERT  dbo.PensionAlimenticiaConcepto
                        ( empresa ,
                          codigo ,
                          consecutivo ,
                          num_conc

                        )
                VALUES  ( @empresa , -- empresa - int
                          @codigo , -- codigo - int
                          @consecutivo , -- consecutivo - int
                          CONVERT(INT, @num_conc)  -- num_conc - int

                        )


                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Agregar concepto pension '
                                + CONVERT(CHAR(4), @num_conc) ,
                                'Consecutivo :'
                                + CONVERT(CHAR(10), @consecutivo) ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_DelConceptoPensionesAlimenticias
 * Project       : APSI Nomina
 * Description   : Octubre 17, 2011
 *                 Eliminar conceptos a la tabla de pensionesAlimenticiaConcepto
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 17, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_DelConceptoPensionesAlimenticias') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_DelConceptoPensionesAlimenticias
GO


CREATE PROCEDURE dbo.fun_e_DelConceptoPensionesAlimenticias
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @num_conc AS INT ,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF EXISTS ( SELECT  codigo
                    FROM    dbo.PensionAlimenticiaConcepto
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                            AND consecutivo = @consecutivo
                            AND num_conc = @num_conc )
            BEGIN
                DELETE  dbo.PensionAlimenticiaConcepto
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                        AND num_conc = @num_conc
                        AND consecutivo = @consecutivo


                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Eliminar concepto pension '
                                + CONVERT(CHAR(4), @num_conc) ,
                                'Consecutivo :'
                                + CONVERT(CHAR(10), @consecutivo) ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : dbo.fun_e_GetPensionAlimenticiaInformeJuzgado
 * Project       : APSI Nomina
 * Description   : Septiembre 12, 2018
 *                 Extraer el registro de pensiones alimenticias de un empleado por el consecutivo,
 *                 para el reporte FORMATO PARA RENDIR INFORME AL JUZGADO DEL SUELDO Y DEMAS PRESTACIONES DE UN DEUDOR ALIMENTARIO
 * Copyright     : (c) Apsi 2009 - 2018. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 12, 2018
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/


IF OBJECT_ID('dbo.fun_e_GetPensionAlimenticiaInformeJuzgado') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetPensionAlimenticiaInformeJuzgado
GO


CREATE PROCEDURE dbo.fun_e_GetPensionAlimenticiaInformeJuzgado
    @empresa AS INT ,
    @codigo AS NUMERIC(8) ,
    @consecutivo AS INT
AS
    SET NOCOUNT OFF

	DECLARE @mes_operacion AS INTEGER
	DECLARE @ayo_operacion AS INTEGER
	DECLARE @dffSigmes AS DATETIME

	SELECT @mes_operacion = mes_operacion,
	       @ayo_operacion = ayo_operacion
    FROM dbo.empresas
	WHERE empresa = @empresa

	SET @dFfSigmes = dbo.fin_mes(@mes_operacion,@ayo_operacion)

    SELECT p.Expediente,
           RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre',
           e.fchantigua,
           e.fchalta,
           e.sueldo,
           tab.actividad,
           cc.nomdepto,
           d.aguinaldo,
           d.dias_vac,
           d.prima_vac,
           d.despensa,
           d.despensaim,
           d.fdoahopatp,
           d.fdoahopati,
		   n.nomina,
		   n.frecuencia,
		   n.periodicidadPagoSAT,
		   IsNULL(per.dias,0) AS 'Dias'
    FROM dbo.Pensionalimenticia AS p
    INNER JOIN dbo.empleados AS e ON p.codigo = e.codigo AND e.empresa = p.empresa
    INNER JOIN dbo.Llaves AS ll ON p.codigo = ll.codigo AND p.empresa = ll.empresa
    INNER JOIN dbo.tabulador AS tab ON ll.ocupacion = tab.ocupacion AND ll.empresa = tab.empresa
    INNER JOIN dbo.centros AS cc ON ll.centro = cc.centro AND ll.empresa = cc.empresa
	INNER JOIN dbo.Nominas AS n ON ll.tiponom = n.tiponom AND ll.empresa = n.empresa
	LEFT JOIN dbo.periodos AS per ON ll.tiponom = per.tiponom AND ll.empresa = per.empresa
    INNER JOIN dbo.tablas_int AS d ON ( ll.empresa = d.empresa AND
                                    ll.clase = d.clase AND
									CASE WHEN DATEDIFF(yy,e.fchantigua,@dffsigmes)
                                                              + CASE
                                                              WHEN YEAR(e.fchantigua) <= YEAR(@dffsigmes)
                                                              AND MONTH(e.fchantigua) <= MONTH(@dffsigmes)
                                                              AND (DAY(e.fchantigua) <= DAY(@dffsigmes) OR (DAY(e.fchantigua) = 31 AND DAY(@dffsigmes) = 30))
                                                              --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                              THEN 1
                                                              ELSE 0
                                                              END > 45 THEN 45
                                                              ELSE DATEDIFF(yy,
                                                              e.fchantigua,
                                                              @dffsigmes)
                                                              + CASE
                                                              WHEN YEAR(e.fchantigua) <= YEAR(@dffsigmes)
                                                              AND MONTH(e.fchantigua) <= MONTH(@dffsigmes)
                                                              AND (DAY(e.fchantigua) <= DAY(@dffsigmes) OR (DAY(e.fchantigua) = 31 AND DAY(@dffsigmes) = 30))
                                                              --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                              THEN 1
                                                              ELSE 0
                                                              END
                                                              END = CAST(d.ayos AS INT)
                                                          )
      WHERE  p.empresa = @empresa
            AND p.codigo = @codigo
            AND p.consecutivo = @consecutivo
			AND d.mes_operacion = @mes_operacion
			AND d.ayo_operacion = @ayo_operacion
			AND per.estatus = 'A'

GO



/**************************************************************************************************
 * Name          : RevisaSalariosMinimos
 * Project       : APSI Nomina
 * Description   : Enero 03, 2012
 *                 Revisa la tabla de salarios minimos y agrega los que corresponda, se debe actualizar cada
                   ao, a como se vayan apareciendo en el diario oficial
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 17, 2011
 * Parameters    : ao
 **************************************************************************************************/
IF OBJECT_ID('dbo.RevisaSalariosMinimos') IS NOT NULL
    DROP PROCEDURE dbo.RevisaSalariosMinimos
GO


CREATE PROCEDURE [dbo].[RevisaSalariosMinimos] @ayo INT
    --WITH ENCRYPTION
AS
    DECLARE @zona_a FLOAT
    DECLARE @zona_b FLOAT
    DECLARE @zona_c FLOAT
    DECLARE @fechaInicio DATETIME
    DECLARE @fechaTermino DATETIME
    DECLARE @contador INT
    DECLARE @Cambio27112012 INT
    DECLARE @fecha_ini DATETIME
    DECLARE @fecha_fin DATETIME
    DECLARE @zona_a1 DECIMAL(9,2)
    DECLARE @zona_b1 DECIMAL(9,2)

    SET @zona_a = 0
    SET @zona_b = 0
    SET @zona_c = 0
    SET @fechaInicio = CONVERT(DATETIME, CONVERT(CHAR(4), @ayo) + '0101')
    SET @fechaTermino = CONVERT(DATETIME, CONVERT(CHAR(4), @ayo) + '1231')
    SET @contador = 2006
    SET @Cambio27112012 = 0

    SELECT  @Cambio27112012 = zona_a
    FROM    dbo.salarios_minimos
    WHERE   fecha_ini = '20121127'

    --Pone el ultimo registro como 2999
/*
    IF @ayo = 2016
        BEGIN
            SET @fechaTermino = CONVERT(DATETIME, '29991231')

            WHILE @contador < @ayo
                BEGIN
                    UPDATE  dbo.salarios_minimos
                    SET     dbo.salarios_minimos.fecha_fin = CONVERT(DATETIME, CONVERT(CHAR(4), @contador)
                            + '1231')
                    FROM    dbo.salarios_minimos
                    WHERE   dbo.salarios_minimos.fecha_ini = CONVERT(DATETIME, CONVERT(CHAR(4), @contador)
                            + '0101')

                    SET @contador = @contador + 1
                END
        END

    IF @Cambio27112012 > 0
        UPDATE  dbo.salarios_minimos
        SET     fecha_fin = '20121126'
        WHERE   fecha_ini = '20120101'
                AND zona_a = 62.33


    SELECT  @zona_a = zona_a ,
            @zona_b = zona_b ,
            @zona_c = zona_c
    FROM    dbo.salarios_minimos
    WHERE   fecha_ini = @fechaInicio
*/
    --SELECT @zona_a, @zona_b, @zona_c, @fechaInicio

-- 2005
    IF @ayo = 2005
        BEGIN
            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 46.80
                        OR @zona_b <> 45.35
                        OR @zona_c <> 44.05
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 46.80 ,
                                zona_b = 45.35 ,
                                zona_c = 44.05
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c

                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          46.80 ,
                          45.35 ,
                          44.05
                        )
        END
    ELSE

        -- 2006
        IF @ayo = 2006
            BEGIN
                IF EXISTS ( SELECT  fecha_ini
                            FROM    salarios_minimos
                            WHERE   fecha_ini = @fechaInicio )
                    BEGIN
                        IF @zona_a <> 48.67
                            OR @zona_b <> 47.16
                            OR @zona_c <> 45.81
                            UPDATE  salarios_minimos
                            SET     fecha_ini = @fechaInicio ,
                                    fecha_fin = @fechaTermino ,
                                    zona_a = 48.67 ,
                                    zona_b = 47.16 ,
                                    zona_c = 45.81
                            WHERE   fecha_ini = @fechaInicio
                    END
                ELSE
                    INSERT  salarios_minimos
                            ( fecha_ini ,
                              fecha_fin ,
                              zona_a ,
                              zona_b ,
                              zona_c

                            )
                    VALUES  ( @fechaInicio ,
                              @fechaTermino ,
                              48.67 ,
                              47.16 ,
                              45.81
                            )
            END
        ELSE
            -- 2007
            IF @ayo = 2007
                BEGIN
                    IF EXISTS ( SELECT  fecha_ini
                                FROM    salarios_minimos
                                WHERE   fecha_ini = @fechaInicio )
                        BEGIN
                            IF @zona_a <> 50.57
                                OR @zona_b <> 49.00
                                OR @zona_c <> 47.60
                                UPDATE  salarios_minimos
                                SET     fecha_ini = @fechaInicio ,
                                        fecha_fin = @fechaTermino ,
                                        zona_a = 50.57 ,
                                        zona_b = 49.00 ,
                                        zona_c = 47.60
                                WHERE   fecha_ini = @fechaInicio
                        END
                    ELSE
                        INSERT  salarios_minimos
                                ( fecha_ini ,
                                  fecha_fin ,
                                  zona_a ,
                                  zona_b ,
                                  zona_c

                                )
                        VALUES  ( @fechaInicio ,
                                  @fechaTermino ,
                                  50.57 ,
                                  49.00 ,
                                  47.60

                                )
                END
            ELSE

                -- 2008
                IF @ayo = 2008
                    BEGIN
                        IF EXISTS ( SELECT  fecha_ini
                                    FROM    salarios_minimos
                                    WHERE   fecha_ini = @fechaInicio )
                            BEGIN
                                IF @zona_a <> 52.59
                                    OR @zona_b <> 50.96
                                    OR @zona_c <> 49.50
                                    UPDATE  salarios_minimos
                                    SET     fecha_ini = @fechaInicio ,
                                            fecha_fin = @fechaTermino ,
                                            zona_a = 52.59 ,
                                            zona_b = 50.96 ,
                                            zona_c = 49.50
                                    WHERE   fecha_ini = @fechaInicio
                            END
                        ELSE
                            INSERT  salarios_minimos
                                    ( fecha_ini ,
                                      fecha_fin ,
                                      zona_a ,
                                      zona_b ,
                                      zona_c

                                    )
                            VALUES  ( @fechaInicio ,
                                      @fechaTermino ,
                                      52.59 ,
                                      50.96 ,
                                      49.50

                                    )
                    END
                ELSE
                    -- 2009
                    IF @ayo = 2009
                        BEGIN
                            IF EXISTS ( SELECT  fecha_ini
                                        FROM    salarios_minimos
                                        WHERE   fecha_ini = @fechaInicio )
                                BEGIN

                                --SELECT @zona_a, @zona_b, @zona_c

                                    IF @zona_a <> 54.80
                                        OR @zona_b <> 53.26
                                        OR @zona_c <> 51.95
                                        BEGIN
                                        --PRINT '1'
                                            UPDATE  salarios_minimos
                                            SET     fecha_ini = @fechaInicio ,
                                                    fecha_fin = @fechaTermino ,
                                                    zona_a = 54.80 ,
                                                    zona_b = 53.26 ,
                                                    zona_c = 51.95
                                            WHERE   fecha_ini = @fechaInicio

                                        --    PRINT '2'
                                        END
                                END
                            ELSE
                                INSERT  salarios_minimos
                                        ( fecha_ini ,
                                          fecha_fin ,
                                          zona_a ,
                                          zona_b ,
                                          zona_c

                                        )
                                VALUES  ( @fechaInicio ,
                                          @fechaTermino ,
                                          54.80 ,
                                          53.26 ,
                                          51.95

                                        )
                        END
                    ELSE
                        -- 2010
                        IF @ayo = 2010
                            BEGIN
                                IF EXISTS ( SELECT  fecha_ini
                                            FROM    salarios_minimos
                                            WHERE   fecha_ini = @fechaInicio )
                                    BEGIN
                                        IF @zona_a = 57.46
                                            OR @zona_b = 55.84
                                            OR @zona_c = 54.47
                                            UPDATE  salarios_minimos
                                            SET     fecha_ini = @fechaInicio ,
                                                    fecha_fin = @fechaTermino ,
                                                    zona_a = 57.46 ,
                                                    zona_b = 55.84 ,
                                                    zona_c = 54.47
                                            WHERE   fecha_ini = @fechaInicio
                                    END
                                ELSE
                                    INSERT  salarios_minimos
                                            ( fecha_ini ,
                                              fecha_fin ,
                                              zona_a ,
                                              zona_b ,
                                              zona_c

                                            )
                                    VALUES  ( @fechaInicio ,
                                              @fechaTermino ,
                                              57.46 ,
                                              55.84 ,
                                              54.47

                                            )
                            END
    -- 2011
    IF @ayo = 2011
        BEGIN


            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 59.82
                        OR @zona_b <> 58.13
                        OR @zona_c <> 56.70
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 59.82 ,
                                zona_b = 58.13 ,
                                zona_c = 56.70
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c


                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          59.82 ,
                          58.13 ,
                          56.70


                        )
        END

    -- 2012
    IF @ayo = 2012
        BEGIN


            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 62.33
                        OR @zona_b <> 60.57
                        OR @zona_c <> 59.08
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 62.33 ,
                                zona_b = 60.57 ,
                                zona_c = 59.08
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c


                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          62.33 ,
                          60.57 ,
                          59.08

                        )
        END
    -- 2013
    IF @ayo = 2013
        BEGIN


            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 64.76
                        OR @zona_b <> 61.38
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 64.76 ,
                                zona_b = 61.38 ,
                                zona_c = 0.00
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c


                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          64.76 ,
                          61.38 ,
                          0.00

                        )
        END

    -- 2014
    IF @ayo = 2014
        BEGIN


            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 67.29
                        OR @zona_b <> 63.77
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 67.29 ,
                                zona_b = 63.77 ,
                                zona_c = 0.00
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c


                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          67.29 ,
                          63.77 ,
                          0.00

                        )
        END

    -- 2015
    IF @ayo = 2015
        BEGIN


            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 70.10
                        OR @zona_b <> 66.45
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 70.10 ,
                                zona_b = 66.45 ,
                                zona_c = 0.00
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c


                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          70.10 ,
                          66.45 ,
                          0.00

                        )
        END


    -- 2016
    IF @ayo = 2016
        BEGIN


            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 73.04
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 73.04 ,
                                zona_b = 0.00 ,
                                zona_c = 0.00
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c


                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          73.04 ,
                           0.00 ,
                           0.00

                        )
        END

    -- 2017
    IF @ayo = 2017
        BEGIN

            SET @fechaInicio = '20170101'
			SET @fechaTermino = '20171130'

            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 80.04
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 80.04 ,
                                zona_b = 0.00 ,
                                zona_c = 0.00 ,
                                UnidadReferencia_A = 80.04,
                                UnidadReferencia_B = 0
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c ,
                          UnidadReferencia_A,
                          UnidadReferencia_B
                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          80.04 ,
                           0.00 ,
                           0.00 ,
                          73.04 ,
                           0.00 )

            SET @fechaInicio = '20171201'
			SET @fechaTermino = '20171231'

            IF EXISTS ( SELECT  fecha_ini
                        FROM    salarios_minimos
                        WHERE   fecha_ini = @fechaInicio )
                BEGIN
                    IF @zona_a <> 88.36
                        UPDATE  salarios_minimos
                        SET     fecha_ini = @fechaInicio ,
                                fecha_fin = @fechaTermino ,
                                zona_a = 88.36 ,
                                zona_b = 0.00 ,
                                zona_c = 0.00 ,
                                UnidadReferencia_A = 75.49,
                                UnidadReferencia_B = 0
                        WHERE   fecha_ini = @fechaInicio
                END
            ELSE
                INSERT  salarios_minimos
                        ( fecha_ini ,
                          fecha_fin ,
                          zona_a ,
                          zona_b ,
                          zona_c ,
                          UnidadReferencia_A,
                          UnidadReferencia_B
                        )
                VALUES  ( @fechaInicio ,
                          @fechaTermino ,
                          88.36 ,
                           0.00 ,
                           0.00 ,
                          75.49 ,
                           0.00 )

        END


        --Desaparece la zona geografica C, se cambia por B, apartir del 27/11/2012
        --Revisa si la zona geografica es C, la cambia a B, para el ao 2013 en delante.
        UPDATE  dbo.empresas
        SET     zona_geografica = 'B'
        WHERE   zona_geografica = 'C'
                AND ayo_operacion >= 2013


        --Desaparece la zona geografica B, se cambia por A, apartir del 01/10/2015
        --Revisa si la zona geografica es B, la cambia a A, para el Octubre 2015 en delante.
	    --Para 2019, se creo la zona fronteriza se activo en la funcion I, la zona B, para que los clientes, que tienen en una misma
	    --Base de datos los 2 tipos de zonas, lo puedan configurar y el sistema tome la zona definidas, para mostrar el salario minimo (Mario 18/10/2019)
        UPDATE  dbo.empresas
        SET     zona_geografica = 'A'
        WHERE   zona_geografica = 'B'
                AND (ayo_operacion >= 2015 AND ayo_operacion < 2019)
                AND mes_operacion >= 10


        -- Salario Minimo 2019
		IF @ayo = 2019
		   BEGIN
             SET @fecha_ini = '20190101'
             SET @fecha_fin = '29991231'
             SET @zona_a1 = 102.68
             SET @zona_b1 = 176.72
             INSERT dbo.salarios_minimos (fecha_ini, fecha_fin, zona_a, zona_b, zona_c, UnidadReferencia_A, UnidadReferencia_B) SELECT @fecha_ini, @fecha_fin, @zona_a1, @zona_b1, 0, 0, 0 WHERE NOT EXISTS (SELECT 1 FROM dbo.salarios_minimos AS sm WHERE sm.fecha_ini = @fecha_ini)
           END

        -- Salario Minimo 2020
		IF @ayo = 2020
		   BEGIN
             SET @fecha_ini = '20200101'
             SET @fecha_fin = '29991231'
             SET @zona_a1 = 123.22
             SET @zona_b1 = 185.56
             INSERT dbo.salarios_minimos (fecha_ini, fecha_fin, zona_a, zona_b, zona_c, UnidadReferencia_A, UnidadReferencia_B) SELECT @fecha_ini, @fecha_fin, @zona_a1, @zona_b1, 0, 0, 0 WHERE NOT EXISTS (SELECT 1 FROM dbo.salarios_minimos AS sm WHERE sm.fecha_ini = @fecha_ini)
           END

        -- Salario Minimo 2021
		IF @ayo = 2021
		   BEGIN
             SET @fecha_ini = '20210101'
             SET @fecha_fin = '29991231'
             SET @zona_a1 = 141.70
             SET @zona_b1 = 213.39
             INSERT dbo.salarios_minimos (fecha_ini, fecha_fin, zona_a, zona_b, zona_c, UnidadReferencia_A, UnidadReferencia_B) SELECT @fecha_ini, @fecha_fin, @zona_a1, @zona_b1, 0, 0, 0 WHERE NOT EXISTS (SELECT 1 FROM dbo.salarios_minimos AS sm WHERE sm.fecha_ini = @fecha_ini)
           END

        -- Salario Minimo 2022
		IF @ayo = 2022
		   BEGIN
             SET @fecha_ini = '20220101'
             SET @fecha_fin = '29991231'
             SET @zona_a1 = 172.87
             SET @zona_b1 = 260.34
             INSERT dbo.salarios_minimos (fecha_ini, fecha_fin, zona_a, zona_b, zona_c, UnidadReferencia_A, UnidadReferencia_B) SELECT @fecha_ini, @fecha_fin, @zona_a1, @zona_b1, 0, 0, 0 WHERE NOT EXISTS (SELECT 1 FROM dbo.salarios_minimos AS sm WHERE sm.fecha_ini = @fecha_ini)
           END

        -- Salario Minimo 2023
		IF @ayo = 2023
		   BEGIN
             SET @fecha_ini = '20230101'
             SET @fecha_fin = '29991231'
             SET @zona_a1 = 207.44
             SET @zona_b1 = 312.41
             INSERT dbo.salarios_minimos (fecha_ini, fecha_fin, zona_a, zona_b, zona_c, UnidadReferencia_A, UnidadReferencia_B) SELECT @fecha_ini, @fecha_fin, @zona_a1, @zona_b1, 0, 0, 0 WHERE NOT EXISTS (SELECT 1 FROM dbo.salarios_minimos AS sm WHERE sm.fecha_ini = @fecha_ini)
           END

UPDATE salarioMinimo
SET salarioMinimo.fecha_fin = ISNULL((SELECT TOP 1
                                             fechaFin.fecha_ini - 1
                                      FROM dbo.salarios_minimos AS fechaFin
                                      WHERE fechaFin.fecha_ini > salarioMinimo.fecha_ini
                                      ORDER BY fechaFin.fecha_ini ASC), '29991231')
FROM dbo.salarios_minimos AS salarioMinimo


GO

/**********************************************************************************************
* Se actualizo la estructura de la tabla TABLAS_INT, se incremento a 4 decimales el campo
* DESPENSAIM, Mario Garcia 03/01/2012
**********************************************************************************************/
ALTER TABLE dbo.tablas_int ALTER COLUMN despensaim DECIMAL(12,4)

GO

/**************************************************************************************************
 * Name          : Fun_F_ListadoDeValidacionVariables
 * Project       : APSI Nomina
 * Description   : Enero 18, 2012
 *                 Prepara la informacion para la impresion del listado de validacion de variables
 *                 para fastreports tabla tmp_vars
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Enero 18, 2012
 * Parameters    : Empresa
 *                 mes inicial, cuando el reporte es bimestral se regista el primer del bimestre
 *                 mes final, cuando el reporte es bimestral se registra el segundo mes del bimestre
 *                 Ao de operacion
 *                 Tipo de reporte : 1 = Genera la informacion de los empleados con todos los conceptos
 *                                       registrados (detallado de conceptos integrables y no integrables)
 *                                   2 = Detallado de conceptos solo los integrables
 *                                   3 = Reporte solo de total general por empleado
 *                                   4 = Total de conceptos registrados en los meses seleccionados
 *                                   5 = Resumen de fechas de pago en los meses seleccionados
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_ListadoDeValidacionVariables') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_ListadoDeValidacionVariables
GO


CREATE PROCEDURE dbo.Fun_F_ListadoDeValidacionVariables
    (
      @nEmpresa INTEGER ,
      @nMesIni INT ,
      @nMesFin INT ,
      @nAyoOpe INT ,
      @nTipoReporte INT ,
      @cSoloRadial CHAR(1) ,
      @cCecytec CHAR(1),
      @dFf DATETIME
    )
AS
    SET NOCOUNT ON


    DECLARE @cTituloMeses AS VARCHAR(50)
    DECLARE @cNombreMesIni AS VARCHAR(20)
    DECLARE @cNombreMesFin AS VARCHAR(20)
    DECLARE @nSalDf AS FLOAT
    DECLARE @mesInicialNomina AS CHAR(5)
    DECLARE @mesFinalNomina AS CHAR(5)
    DECLARE @diasBaseDivisor AS VARCHAR(30)


    DECLARE @tListadoVariables TABLE
        (
          observa CHAR(2) ,
          codigo NUMERIC(8,0) ,
          nombre VARCHAR(70) ,
          cuotadia FLOAT,
          factor DECIMAL(10,4),
          varia_imss_total FLOAT,
          diastrba FLOAT,
          ausenba FLOAT,
          incapba FLOAT,
          parteVariableTotal FLOAT,
          sdi_nvo FLOAT,
          folio INTEGER,
          num_conc INTEGER,
          concepto VARCHAR(70),
          varia_imss FLOAT,
          parteVariableConcepto FLOAT,
          fch_real DATETIME,
          titulo VARCHAR(400),
          observaEmpleado VARCHAR(20),
          dia INT,
          mes INT,
          ano INT,
          nomina FLOAT,
          FactorAgi FLOAT

        )


    SELECT @nSalDf = zona_a FROM dbo.GetMinimumWage(@nMesIni,@nAyoOpe)

    SET @diasBaseDivisor = ( SELECT DivisorPercepcionesVariables
                             FROM   Empresas
                             WHERE  Empresa = @nEmpresa
                           )


    SET @cNombreMesIni = CASE WHEN @nMesIni = 01 THEN 'ENERO'
                              WHEN @nMesIni = 02 THEN 'FEBRERO'
                              WHEN @nMesIni = 03 THEN 'MARZO'
                              WHEN @nMesIni = 04 THEN 'ABRIL'
                              WHEN @nMesIni = 05 THEN 'MAYO'
                              WHEN @nMesIni = 06 THEN 'JUNIO'
                              WHEN @nMesIni = 07 THEN 'JULIO'
                              WHEN @nMesIni = 08 THEN 'AGOSTO'
                              WHEN @nMesIni = 09 THEN 'SEPTIEMBRE'
                              WHEN @nMesIni = 10 THEN 'OCTUBRE'
                              WHEN @nMesIni = 11 THEN 'NOVIEMBRE'
                              WHEN @nMesIni = 12 THEN 'DICIEMBRE'
                              ELSE ''
                         END

    SET @cNombreMesFin = CASE WHEN @nMesFin = 01 THEN 'ENERO'
                              WHEN @nMesFin = 02 THEN 'FEBRERO'
                              WHEN @nMesFin = 03 THEN 'MARZO'
                              WHEN @nMesFin = 04 THEN 'ABRIL'
                              WHEN @nMesFin = 05 THEN 'MAYO'
                              WHEN @nMesFin = 06 THEN 'JUNIO'
                              WHEN @nMesFin = 07 THEN 'JULIO'
                              WHEN @nMesFin = 08 THEN 'AGOSTO'
                              WHEN @nMesFin = 09 THEN 'SEPTIEMBRE'
                              WHEN @nMesFin = 10 THEN 'OCTUBRE'
                              WHEN @nMesFin = 11 THEN 'NOVIEMBRE'
                              WHEN @nMesFin = 12 THEN 'DICIEMBRE'
                              ELSE ''
                         END

    SET @mesInicialNomina = LEFT(@cNombreMesIni, 3)
        + RIGHT(CONVERT(CHAR(4), @nAyoOpe), 2)

    SET @mesFinalNomina = LEFT(@cNombreMesFin, 3)
        + RIGHT(CONVERT(CHAR(4), @nAyoOpe), 2)

    SET @cTituloMeses = CASE WHEN @nMesFin > @nMesIni
                              THEN 'DE LOS MESES : ' + @cNombreMesIni + '-'
                                   + @cNombreMesFin + ' DE '
                                   + CONVERT(CHAR(4), @nAyoOpe)
                              ELSE 'DEL MES : ' + @cNombreMesIni + ' DE '
                                   + CONVERT(CHAR(4), @nAyoOpe)
                         END

     SET @cTituloMeses = ''

    /* Reporte con detalle con todos los conceptos */
    IF @nTipoReporte = 1
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total' ,
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                p.folio ,
                p.num_conc ,
                c.concepto ,
                p.varia_imss ,
                CASE WHEN p.varia_imss > 0
                     THEN ROUND(( p.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END) ), 2)
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                p.fch_real ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                p.nomina,
                CASE WHEN p.varia_imss > p.nomina THEN ROUND((p.varia_imss/p.nomina),4)ELSE 0 END AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
                LEFT JOIN dbo.percepciones AS p ON ( e.empresa = p.empresa
                                                     AND e.codigo = p.codigo
                                                     AND p.mes_operacion >= @nMesIni
                                                     AND p.mes_operacion <= @nMesFin
                                                     AND p.ayo_operacion = @nAyoOpe
                                                   )
                LEFT JOIN dbo.conceptos AS c ON ( p.empresa = c.empresa
                                                   AND p.num_conc = c.num_conc
                                                   AND p.centro = c.centro
                                                   AND p.clase = c.clase
                                                 )
        WHERE   tv.empresa = @nempresa
        ORDER BY tv.observa ,
                tv.codigo ,
                p.fch_real ,
                p.num_conc

    /* Reporte con detalle solo con los conceptos integrables */
    IF @nTipoReporte = 2
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total',
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                p.folio ,
                p.num_conc ,
                c.concepto ,
                p.varia_imss ,
                CASE WHEN p.varia_imss > 0
                     THEN ROUND(( p.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END) ), 2)
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                p.fch_real ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     WHEN tv.observa = '5'
                     THEN 'EMPLEADOS SIN VARIABLES CON S.B.C. INCORRECTO '
                          + @cTituloMeses
                     WHEN tv.observa = '6'
                     THEN 'EMPLEADOS CON BAJA DE MESES ANTERIORES CON PAGOS EN EL BIMESTRE '
                          + @cTituloMeses

                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                p.nomina,
                CASE WHEN p.varia_imss > p.nomina THEN ROUND((p.varia_imss/p.nomina),4)ELSE 0 END AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
                LEFT JOIN dbo.percepciones AS p ON ( e.empresa = p.empresa
                                                     AND e.codigo = p.codigo
                                                     AND p.mes_operacion >= @nMesIni
                                                     AND p.mes_operacion <= @nMesFin
                                                     AND p.ayo_operacion = @nAyoOpe
                                                     AND (p.varia_imss > 0
                                                     OR (@cSoloRadial = 'S'
                                                         AND p.num_conc in (17,54,56)))

                                                   )
                LEFT JOIN dbo.conceptos AS c ON ( p.empresa = c.empresa
                                                   AND p.num_conc = c.num_conc
                                                   AND p.centro = c.centro
                                                   AND p.clase = c.clase
                                                 )
        WHERE   tv.empresa = @nempresa
        ORDER BY tv.observa ,
                tv.codigo ,
                p.fch_real ,
                p.num_conc

    /* Reporte solo totales de variables */
    IF @nTipoReporte = 3
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total',
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                NULL AS 'folio' ,
                NULL AS 'num_conc' ,
                NULL AS 'concepto' ,
                tv.varia_imss AS 'varia_imss' ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                NULL AS 'fch_real' ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     WHEN tv.observa = '5'
                     THEN 'EMPLEADOS SIN VARIABLES CON S.B.C. INCORRECTO '
                          + @cTituloMeses
                     WHEN tv.observa = '6'
                     THEN 'EMPLEADOS CON BAJA DE MESES ANTERIORES CON PAGOS EN EL BIMESTRE '
                          + @cTituloMeses

                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                0 AS 'nomina',
                0 AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
        WHERE   tv.empresa = @nempresa
        ORDER BY tv.observa ,
                tv.codigo


    /* Totales por concepto */
    IF @nTipoReporte = 4
        SELECT  p.num_conc ,
                MAX(c.concepto) AS 'concepto' ,
                SUM(p.nomina) AS 'Nomina',
                SUM(p.varia_imss) AS 'Varia_imss'
        FROM    percepciones AS p
                INNER JOIN dbo.conceptos AS c ON ( p.empresa = c.empresa
                                                   AND p.num_conc = c.num_conc
                                                   AND p.centro = c.centro
                                                   AND p.clase = c.clase
                                                 )
        WHERE   p.empresa = @nempresa
                AND p.mes_operacion >= @nMesIni
                AND p.mes_operacion <= @nMesFin
                AND p.ayo_operacion = @nAyoOpe
        GROUP BY p.num_conc
        ORDER BY p.num_conc


    /* Totales por periodo nominal */
    IF @nTipoReporte = 5
        SELECT  p.fch_real,
                SUM(p.nomina) AS 'Nomina',
                SUM(p.varia_imss) AS 'Varia_imss'
        FROM    percepciones AS p
        WHERE   p.empresa = @nempresa
                AND p.mes_operacion >= @nMesIni
                AND p.mes_operacion <= @nMesFin
                AND p.ayo_operacion = @nAyoOpe
        GROUP BY p.fch_real
        ORDER BY p.fch_real

    /* Periodos nominales cerrados, cuando se divide entre dias de nomina */
    IF @nTipoReporte = 6
        SELECT DISTINCT
                na.tiponom ,
                no.nomina ,
                CASE WHEN per.estatus = 'C' THEN 'Cerrado'
                     WHEN per.estatus = 'A' THEN 'Abierto'
                     ELSE ''
                END AS 'Estatus' ,
                na.periodo ,
                na.ayo_operacion ,
                per.inicio ,
                per.cierre ,
                per.pago ,
                per.dias
        FROM    dbo.nomina1_anual AS na
                INNER JOIN dbo.Nominas AS no ON ( na.empresa = no.empresa
                                                  AND na.tiponom = no.tiponom
                                                )
                INNER JOIN periodos AS per ON ( na.empresa = per.empresa
                                                AND na.tiponom = per.tiponom
                                                AND na.periodo = per.periodo
                                                AND na.ayo_operacion = per.ayo_operacion
                                              )
        WHERE   na.empresa = @nempresa
                AND ( na.mes = @mesInicialNomina
                      OR na.mes = @mesFinalNomina
                    )
        ORDER BY na.tiponom ,
                na.periodo

    IF @nTipoReporte = 7
        SELECT DISTINCT
                na.tiponom ,
                no.nomina ,
                CASE WHEN per.estatus = 'C' THEN 'Cerrado'
                     WHEN per.estatus = 'A' THEN 'Abierto'
                     ELSE ''
                END AS 'Estatus' ,
                na.periodo ,
                na.ayo_operacion ,
                per.inicio ,
                per.cierre ,
                per.pago ,
                per.dias
        FROM    dbo.nomina1_anual AS na
                INNER JOIN dbo.Nominas AS no ON ( na.empresa = no.empresa
                                                  AND na.tiponom = no.tiponom
                                                )
                INNER JOIN periodos AS per ON ( na.empresa = per.empresa
                                                AND na.tiponom = per.tiponom
                                                AND na.periodo = per.periodo
                                                AND na.ayo_operacion = per.ayo_operacion
                                              )
        WHERE   na.empresa = @nempresa
                AND na.mes = 'XXX99'
        ORDER BY na.tiponom ,
                na.periodo


    /*Para meter los conceptos de contras de Radial y Cecytec */
    IF (@cSoloRadial = 'S' OR @cCecytec = 'S') AND @nTipoReporte < 3
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total',
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                d.folio ,
                d.num_conc ,
                c.concepto ,
                d.descuento * -1 AS 'varia_imss' ,
                CASE WHEN d.descuento > 0
                     THEN ROUND(( d.descuento / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END) ), 2) * -1
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                d.fch_pago ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     WHEN tv.observa = '5'
                     THEN 'EMPLEADOS SIN VARIABLES CON S.B.C. INCORRECTO '
                          + @cTituloMeses
                     WHEN tv.observa = '6'
                     THEN 'EMPLEADOS CON BAJA DE MESES ANTERIORES CON PAGOS EN EL BIMESTRE '
                          + @cTituloMeses

                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                0 AS 'Nomina',
                0 AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
                LEFT JOIN dbo.deducciones AS d ON ( e.empresa = d.empresa
                                                     AND e.codigo = d.codigo
                                                   )
                INNER JOIN dbo.conceptos AS c ON ( d.empresa = c.empresa
                                                   AND d.num_conc- CASE WHEN d.num_conc > 1000 THEN 1000 ELSE 0 END = c.num_conc
                                                   AND d.centro = c.centro
                                                   AND d.clase = c.clase
                                                 )
        WHERE   tv.empresa = @nempresa
                AND d.mes_operacion >= @nMesIni
                AND d.mes_operacion <= @nMesFin
                AND d.ayo_operacion = @nAyoOpe
                AND c.imss = 'S'
                AND d.num_conc > 1000 OR (@cCecytec = 'S' AND d.num_conc = 145 AND d.mes_operacion >= @nMesIni AND d.mes_operacion <= @nMesFin AND d.ayo_operacion = @nAyoOpe )			



    /*Si el reporte es el detalle, regresar la consulta de la tabla temporal*/
    IF @nTipoReporte < 4
        BEGIN
            /* Observaciones para el listado de validacion */
            UPDATE @tListadoVariables SET observaEmpleado = '25 Vec. D.F.' WHERE sdi_nvo >= @nSalDf * 25
            UPDATE @tListadoVariables SET observaEmpleado = observaEmpleado + ' *' WHERE dbo.NvaFecha(dia,mes,ano+2000) > @dFF


            SELECT  *,CONVERT(INT,observa) AS 'TitReporte'
            FROM    @tListadoVariables
            ORDER BY observa ,
                    codigo ,
                    fch_real ,
                    num_conc

        END
GO

/**************************************************************************************************
 * Name          : dbo.sp_cataemp
 * Project       : APSI Nomina
 * Description   : Enero 18, 2012
 *                 Obtine el catalogo de empleados para consultarlo en la funcion E y F
 *                 Se va agregar el numero de afiliacion para que se muestre en los programas
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Enero 18, 2012
 * Parameters    : Empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.sp_cataemp') IS NOT NULL
    DROP PROCEDURE dbo.sp_cataemp
GO


CREATE PROCEDURE dbo.sp_cataemp ( @empresa INTEGER )
AS
    SET NOCOUNT ON

    SELECT  empleados.codigo ,
            empleados.ap_paterno ,
            empleados.ap_materno ,
            empleados.nombre ,
            Llaves.clase ,
            Llaves.centro ,
            Llaves.tiponom ,
            Infonavit.numcredito,
            empleados.afiliacion,
            empleados.digvera
    FROM    empleados
            LEFT JOIN Llaves ON ( empleados.empresa = Llaves.empresa
                                  AND empleados.codigo = Llaves.codigo
                                )
            LEFT JOIN Infonavit ON ( empleados.empresa = Infonavit.empresa
                                     AND empleados.codigo = Infonavit.codigo
                                   )
    WHERE   empleados.empresa = @empresa
            AND empleados.activo = 'S'
            AND empleados.borrado = 'N'
    ORDER BY empleados.ap_paterno ,
            empleados.ap_materno ,
            empleados.nombre

GO

IF OBJECT_ID('dbo.asp_cedula_analitica') IS NOT NULL
    DROP PROCEDURE dbo.asp_cedula_analitica

Go

CREATE PROCEDURE dbo.asp_cedula_analitica
    @nEmpresa INT ,
    @nMes_Ope INT ,
    @nAyo_Ope INT
AS
    SET NOCOUNT ON

    DECLARE @nMes_PVaria AS INTEGER
    DECLARE @nAyo_PVaria AS INTEGER

    SET @nMes_PVaria = CASE WHEN @nMes_Ope >= 01
                                 AND @nMes_Ope <= 02 THEN 12
                            WHEN @nMes_Ope >= 03
                                 AND @nMes_Ope <= 04 THEN 02
                            WHEN @nMes_Ope >= 05
                                 AND @nMes_Ope <= 06 THEN 04
                            WHEN @nMes_Ope >= 07
                                 AND @nMes_Ope <= 08 THEN 06
                            WHEN @nMes_Ope >= 09
                                 AND @nMes_Ope <= 10 THEN 08
                            WHEN @nMes_Ope >= 11
                                 AND @nMes_Ope <= 12 THEN 10
                       END

    SET @nAyo_PVaria = CASE WHEN @nMes_PVaria = 12 THEN @nAyo_Ope - 1
                            ELSE @nAyo_Ope
                       END


    SELECT  a.codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre) AS 'Nombre' ,
            a.mov ,
            a.fch_mov ,
            a.sueldo ,
            a.saldiaint ,
            a.saldiaint AS 'SaldiaInf' ,
            a.diastr ,
            a.ausen ,
            a.incap ,
            ISNULL(pv.parte_variable,0) AS 'varia_imss' ,
            ll.ocupacion ,
            tb.actividad ,
            ISNULL(ex.excepcion1, '') AS Excepcion ,
            e.jornada ,
            e.fchalta ,
            e.cotiza_imss
    FROM    avisos_imss AS a
            INNER JOIN empleados AS e ON ( a.codigo = e.codigo
                                           AND a.empresa = e.empresa
                                         )
            INNER JOIN llaves AS ll ON ( a.codigo = ll.codigo
                                         AND a.empresa = ll.empresa
                                       )
            INNER JOIN tabulador AS tb ON ( ll.ocupacion = tb.ocupacion
                                            AND ll.empresa = tb.empresa
                                          )
            LEFT JOIN excepciones AS ex ON ( a.codigo = ex.codigo
                                             AND a.empresa = ex.empresa
                                             AND ex.excepcion1 = 'NOIMSS'
                                           )
            LEFT JOIN dbo.Partes_variables AS pv ON ( e.codigo = pv.codigo
                                                      AND e.empresa = pv.empresa
                                                      AND pv.mes_operacion = @nMes_PVaria
                                                      AND pv.ayo_operacion = @nAyo_PVaria
                                                    )
    WHERE   a.mes_operacion = @nMes_Ope
            AND a.ayo_operacion = @nAyo_Ope
            AND a.empresa = @nEmpresa
--ORDER BY a.codigo
ORDER BY    RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre)

GO

If OBJECT_ID('dbo.asp_cedula_analitica_resumen_var') Is NOT NULL
  Drop Procedure dbo.asp_cedula_analitica_resumen_var

Go

CREATE PROCEDURE dbo.asp_cedula_analitica_resumen_var
@nEmpresa  INT,
@nMes_Op1  INT,
@nMes_Op2  INT,
@nAyo_Op   INT
AS
SELECT a.num_conc
,b.concepto
,SUM(a.nomina) AS nomina
,SUM(a.varia_imss) AS varia_imss
FROM percepciones AS a
LEFT JOIN conceptos AS b ON (a.num_conc = b.num_conc AND a.clase = b.clase AND a.centro = b.centro AND a.empresa = b.empresa)
WHERE (a.mes_operacion >= @nMes_Op1
       AND a.mes_operacion <= @nMes_Op2)
       AND a.ayo_operacion = @nAyo_Op
       AND a.empresa = @nEmpresa
GROUP BY a.num_conc,b.concepto
ORDER BY a.num_conc


GO


If OBJECT_ID('dbo.asp_cedula_analitica_detalle_var') Is NOT NULL
  Drop Procedure dbo.asp_cedula_analitica_detalle_var

Go


CREATE PROCEDURE dbo.asp_cedula_analitica_detalle_var
@nEmpresa  INT,
@nMes_Op1  INT,
@nMes_Op2  INT,
@nAyo_Op   INT

AS

SELECT a.codigo
,a.mov
,a.fch_mov
,a.diastr
,a.incap
,a.ausen
,a.sueldo
,a.saldiaint
,ISNULL((SELECT SUM(b.nomina) AS  nomina
         FROM percepciones AS b
         WHERE (b.mes_operacion >= @nMes_Op1  AND b.mes_operacion <= @nMes_Op2)
               AND b.ayo_operacion = @nAyo_Op
               AND a.codigo = b.codigo
               AND a.empresa = b.empresa),0) AS Nomina
,ISNULL((SELECT SUM(b.varia_imss) AS  nomina
         FROM percepciones AS b
         WHERE (b.mes_operacion >= @nMes_Op1  AND b.mes_operacion <= @nMes_Op2)
               AND b.ayo_operacion = @nAyo_Op
               AND a.codigo = b.codigo
               AND a.empresa = b.empresa),0) AS Varia_imss
,ISNULL((SELECT ISNULL(ex.excepcion1,'') FROM excepciones AS ex
         WHERE (a.codigo = ex.codigo AND a.empresa = ex.empresa AND ex.excepcion1 = 'NOIMSS')),'') AS NoImss
FROM avisos_imss AS a
WHERE (a.mes_operacion >= @nMes_Op1
      AND a.mes_operacion <= @nMes_Op2)
      AND a.ayo_operacion = @nAyo_Op
      AND a.empresa = @nEmpresa
ORDER BY a.codigo,a.fch_mov,a.serial

GO


IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'empresa'
                        AND sysobjects.name = 'perfil_centro' )
    ALTER TABLE perfil_centro ADD empresa BIGINT NULL

Go


/**************************************************************************************************
 * Name          : usuariosInsertaCentroDesdeNomina
 * Project       : Usuarios
 * Description   : Inserta un centro de costos desde la nomina
 * Table name    : perfil_centro
 * Copyright     :
 * Company       : Apsi (apsi@apsi.com.mx)
 * Author        : margarita valdez (margarita@apsi.com.mx)
 * Creation date : martes,3 de abril de 2012
 **************************************************************************************************/
IF OBJECT_ID('dbo.usuariosInsertaCentroDesdeNomina') IS NOT NULL
    DROP PROCEDURE dbo.usuariosInsertaCentroDesdeNomina
Go


CREATE PROCEDURE dbo.usuariosInsertaCentroDesdeNomina
    (
      @usuario VARCHAR(30) ,
      @centro CHAR(15) ,
      @empresa BIGINT
    )
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    DECLARE @idPerfil BIGINT
    DECLARE @existe BIGINT
    DECLARE @Marcados BIGINT

    SELECT  @idperfil = perfil_usuarios.idperfil
    FROM    perfil_usuarios ,
            perfiles
    WHERE   perfil_usuarios.usuario = @usuario
            AND perfil_usuarios.idperfil = perfiles.idperfil
            AND perfiles.sistema = 'NO'

    SELECT  @Marcados = COUNT(*)
    FROM    perfil_centro
    WHERE   idperfil = @idPerfil
            AND empresa = @empresa

    IF @Marcados > 0
        BEGIN

            SELECT  @existe = COUNT(*)
            FROM    perfil_centro
            WHERE   idperfil = @idPerfil
                    AND empresa = @empresa
                    AND centro = @centro

            IF @existe = 0
                BEGIN
                    INSERT  INTO perfil_centro
                            ( centro, idperfil, empresa )
                    VALUES  ( @centro, @idperfil, @empresa )
                END

        END
go

/*
Actualiza el nombre del campo de ISPT, por ISR, en la descripcion del reporteador
Actualiza el tamao de la campo de cuenta bancaria de 16 a 20 posiciones que es lo que se maneja en la base de datos
*/

UPDATE  dbo.gr_formas
SET     descrip = 'TOTAL DE I.S.R. EN PERIODO'
WHERE   descrip LIKE '%I.S.P.T%'

UPDATE  dbo.gr_catalogo
SET     descrip = 'TOTAL DE I.S.R. EN PERIODO'
WHERE   descrip LIKE '%I.S.P.T%'

UPDATE  dbo.gr_catalogo
SET     tamori = '20'
WHERE   campo = 'CTA_BCO_NO'
        AND numero = 46
        AND tamori = '16'

UPDATE  dbo.gr_formas
SET     tamori = '20'
WHERE   campo = 'CTA_BCO_NO'
        AND numero = 46
        AND tamori = '16'

GO

/**************************************************************************************************
 * Name          : dbo.asp_calcula_amortizacion
 * Project       : APSI Nomina
 * Description   : Determina las cuotas bimestrales de Sar e Infonavit
 * Table name    : Empleados, Infonavit, cuotas_imss_bim, avisos_imss
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Jorge Martinez (jorge.martinez@apsi.com.mx)
 * Creation date : Lunes 03 Septiembre 2012
 **************************************************************************************************/
IF OBJECT_ID('dbo.asp_calcula_amortizacion') IS NOT NULL
  DROP PROCEDURE dbo.asp_calcula_amortizacion
GO


CREATE PROCEDURE dbo.asp_calcula_amortizacion
    @nempresa NUMERIC(5, 0) ,
    @nayo INT ,
    @nmes_non INT ,
    @nmes_par INT ,
    @ndias_tope DECIMAL(5, 2) ,
    @czonageo CHAR(1) ,
    @ncodigo NUMERIC(8, 0)
AS
    DECLARE @nserial_bim INT
    DECLARE @nfolio INT
    DECLARE @csw CHAR(1)
    DECLARE @namortiza NUMERIC(12, 2)
    DECLARE @ninicio NUMERIC(8, 0)
    DECLARE @nfin NUMERIC(8, 0)
    DECLARE @naus_non DECIMAL(5, 2)
    DECLARE @naus_par DECIMAL(5, 2)
    DECLARE @ncodant NUMERIC(8, 0)
    DECLARE @ndias_non NUMERIC(5, 0)
    DECLARE @ndias_par NUMERIC(5, 0)
    DECLARE @nntd INT
    DECLARE @ninfo INT
    DECLARE @nporc_abono NUMERIC(8, 4)
    DECLARE @cdiaslab CHAR(1)
    DECLARE @cretenido CHAR(1)
    DECLARE @cpropcred CHAR(1)
    DECLARE @cconvenio CHAR(8)
    DECLARE @nsaldiaint NUMERIC(12, 2)
    DECLARE @nvsm NUMERIC(12, 2)
    DECLARE @nseg_viv NUMERIC(5, 2)
    DECLARE @dfch_ini_non DATETIME  -- @dfch_fin   datetime
    DECLARE @dfch_fin_non DATETIME  -- @dfch_ini   datetime
    DECLARE @dfch_ini_par DATETIME
    DECLARE @dfch_fin_par DATETIME
    DECLARE @ndiasprop INT
    DECLARE @ndiasnon INT
    DECLARE @ndiaspar INT
    DECLARE @nsal_a NUMERIC(10, 02)
    DECLARE @nsal_b NUMERIC(10, 02)
    DECLARE @nsal_c NUMERIC(10, 02)
    DECLARE @nsal_df NUMERIC(10, 02)
    DECLARE @nsal_min NUMERIC(10, 02)
    DECLARE @dfch_sube DATETIME
    DECLARE @nsaldf NUMERIC(10, 02)
    DECLARE @nsalmin NUMERIC(10, 02)
    DECLARE @dfchinisal DATETIME
    DECLARE @dfchfinsal DATETIME


    SET @nsal_df = 0
    SET @nsal_min = 0
    SET @dfch_sube = ' '
    SET @nsaldf = 0
    SET @nsalmin = 0
    SET @namortiza = 0
    SET @nserial_bim = 0
    SET @nfolio = 0
    SET @csw = 'F'
    SET @nntd = 0
    SET @ninfo = 0
    SET @nporc_abono = 0
    SET @cdiaslab = 'N'
    SET @cretenido = 'N'
    SET @cpropcred = 'N'
    SET @cconvenio = SPACE(8)
    SET @nsaldiaint = 0
    SET @nvsm = 0
    SET @nseg_viv = 0
    SET @dfch_ini_non = CAST(SUBSTRING(LTRIM(STR(@nayo + 10000)), 2, 4)
        + SUBSTRING(LTRIM(STR(@nmes_non + 100)), 2, 2) + '01' AS DATETIME)
    SET @dfch_fin_non = dbo.fin_mes(@nmes_non, @nayo)
    SET @ndiasnon = DATEDIFF(dd, @dfch_ini_non, @dfch_fin_non) + 1


    SET @ndiaspar = 0

    IF @nmes_par % 2 = 0
        BEGIN
            SET @dfch_ini_par = CAST(SUBSTRING(LTRIM(STR(@nayo + 10000)), 2, 4)
                + SUBSTRING(LTRIM(STR(@nmes_par + 100)), 2, 2) + '01' AS DATETIME)
            SET @dfch_fin_par = dbo.fin_mes(@nmes_par, @nayo)
            SET @ndiaspar = CASE WHEN @nmes_par % 2 = 0
                                 THEN DATEDIFF(dd, @dfch_ini_par,
                                               @dfch_fin_par) + 1
                                 ELSE 0
                            END
        END

    SET @ndiasprop = DATEDIFF(dd, @dfch_ini_non,
                              CASE WHEN @nmes_par % 2 = 1
                                   THEN dbo.fin_mes(@nmes_par + 1, @nayo)
                                   ELSE @dfch_fin_par
                              END) + 1



-- si la variable @ncodigo es cero
-- va a afectar a todos los trabajadores
-- si no solo afecta al codigo deseado
    IF @ncodigo = 0
        BEGIN
            SET @ninicio = 1
            SET @nfin = 99999999
        END
    ELSE
        BEGIN
            SET @ninicio = @ncodigo
            SET @nfin = @ncodigo
        END





-- saca parametros infonavit
    SELECT  @cdiaslab = CASE WHEN hrs_min2 = 999 THEN 'N'
                             ELSE 'S'
                        END ,
            @cretenido = CASE WHEN hrs_min3 = 999 THEN 'S'
                              ELSE 'N'
                         END ,
            @cpropcred = CASE WHEN marca2 = 'M' THEN 'N'
                              ELSE 'S'
                         END ,
            @cconvenio = variable1
    FROM    conceptos
    WHERE   empresa = @nempresa
            AND num_conc = 112


-- sacar salarios minimos
    DECLARE sal_min CURSOR
    FOR
    SELECT fecha_ini,
    fecha_fin,
    zona_a   ,
    zona_b   ,
    zona_c
    FROM salarios_minimos

    OPEN sal_min


    FETCH NEXT FROM sal_min INTO @dfchinisal, @dfchfinsal, @nsal_a, @nsal_b, @nsal_c

    WHILE ( @@fetch_status <> -1 )
        BEGIN


  --print @dfchinisal
  --print @dfchfinsal
  --print @dfch_ini_non
  --print case when @nmes_par % 2 = 0 then @dfch_fin_par else @dfch_fin_non end
  --print 'fin'

            IF @dfchinisal <= @dfch_ini_non
                AND @dfchfinsal >= @dfch_ini_non
                AND @dfchfinsal <= CASE WHEN @nmes_par % 2 = 0
                                        THEN @dfch_fin_par
                                        ELSE @dfch_fin_non
                                   END
                BEGIN

                    IF @nmes_par % 2 = 0
                        AND @dfchinisal <= @dfch_ini_non
                        AND @dfchfinsal >= @dfch_fin_par
                        BEGIN
                            SET @nsaldf = @nsal_a
                            SET @nsalmin = CASE WHEN @czonageo = 'A'
                                                THEN @nsal_a
                                                WHEN @czonageo = 'B'
                                                THEN @nsal_b
                                                WHEN @czonageo = 'C'
                                                THEN @nsal_c
                                           END
                        END
                    ELSE
                        BEGIN
                            SET @nsal_df = @nsal_a
                            SET @nsal_min = CASE WHEN @czonageo = 'A'
                                                 THEN @nsal_a
                                                 WHEN @czonageo = 'B'
                                                 THEN @nsal_b
                                                 WHEN @czonageo = 'C'
                                                 THEN @nsal_c
                                            END
                        END

       /*
       set @nsal_df  = @nsal_a
       set @nsal_min = case when @czonageo = 'A' then @nsal_a
                            when @czonageo = 'B' then @nsal_b
                            when @czonageo = 'C' then @nsal_c
                       end
       */

                END
            ELSE
                IF @dfchinisal >= @dfch_ini_non
                    AND @dfchfinsal <= CASE WHEN @nmes_par % 2 = 0
                                            THEN @dfch_fin_par
                                            ELSE @dfch_fin_non
                                       END
                    BEGIN
                        SET @nsal_df = @nsal_a
                        SET @nsal_min = CASE WHEN @czonageo = 'A' THEN @nsal_a
                                             WHEN @czonageo = 'B' THEN @nsal_b
                                             WHEN @czonageo = 'C' THEN @nsal_c
                                        END
                    END
                ELSE
                    IF @dfchinisal >= @dfch_ini_non
                        AND @dfchinisal <= CASE WHEN @nmes_par % 2 = 0
                                                THEN @dfch_fin_par
                                                ELSE @dfch_fin_non
                                           END
                        AND @dfchfinsal >= CASE WHEN @nmes_par % 2 = 0
                                                THEN @dfch_fin_par
                                                ELSE @dfch_fin_non
                                           END
                        BEGIN
                            SET @nsaldf = @nsal_a
                            SET @nsalmin = CASE WHEN @czonageo = 'A'
                                                THEN @nsal_a
                                                WHEN @czonageo = 'B'
                                                THEN @nsal_b
                                                WHEN @czonageo = 'C'
                                                THEN @nsal_c
                                           END

                            IF @dfchinisal > @dfch_ini_non
                                SET @dfch_sube = @dfchinisal
                        END
                    ELSE
                        IF @dfchinisal <= @dfch_ini_non
                            AND @dfchfinsal >= CASE WHEN @nmes_par % 2 = 0
                                                    THEN @dfch_fin_par
                                                    ELSE @dfch_fin_non
                                               END
                            BEGIN
                                SET @nsaldf = @nsal_a
                                SET @nsalmin = CASE WHEN @czonageo = 'A'
                                                    THEN @nsal_a
                                                    WHEN @czonageo = 'B'
                                                    THEN @nsal_b
                                                    WHEN @czonageo = 'C'
                                                    THEN @nsal_c
                                               END
                            END

            FETCH NEXT FROM sal_min INTO @dfchinisal, @dfchfinsal, @nsal_a, @nsal_b, @nsal_c
        END

    DEALLOCATE sal_min

--select @nsal_df, @nsal_min, @dfch_sube, @nsaldf, @nsalmin



-- creo una tabla temporal con movimientos del mes o bimestre
-- y los datos del credito infonavit
    SELECT  a.empresa ,
            a.ayo_operacion ,
            a.mes_operacion ,
            a.codigo ,
            a.serial ,
            @nserial_bim AS 'serial_bim' ,
            a.mov ,
            a.fch_mov ,
            a.saldiaint ,
            a.diastr ,
            a.ausen ,
            a.incap ,
            i.tipo_cred ,
            i.descuento ,
            CASE WHEN i.fecha < @dfch_ini_non
                 THEN CASE WHEN @dfch_ini_non < a.fch_mov
                                AND a.mov = 'A' THEN a.fch_mov
                           ELSE @dfch_ini_non
                      END
                 ELSE CASE WHEN i.fecha < a.fch_mov
                                AND a.mov = 'A' THEN a.fch_mov
                           ELSE i.fecha
                      END
            END AS 'fch_cred' ,
            i.fch_otorga ,
            @namortiza AS 'amortizacion' ,
            @nntd AS 'ntd' ,
            @ninfo AS 'info' ,
            i.descuento AS 'porc_abono' ,
            @nporc_abono AS 'vsm' ,
            i.seguro_vivienda ,
            i.fecha ,
            ISNULL(i.fechasuspension, i.fch_termino) AS fch_termino ,
            i.numcredito ,
            e.afiliacion ,
            e.digvera
    INTO    #tmp_inf
    FROM    infonavit AS i
            INNER JOIN avisos_imss AS a ON a.empresa = i.empresa
                                           AND a.codigo = i.codigo
                                           AND a.ayo_operacion = @nayo
                                           AND ( a.mes_operacion = @nmes_non
                                                 OR a.mes_operacion = @nmes_par
                                               )
            INNER JOIN empleados AS e ON e.empresa = i.empresa
                                         AND e.codigo = i.codigo
    WHERE   i.empresa = @nempresa
            AND i.fecha <= CASE WHEN @nmes_par % 2 = 0 THEN @dfch_fin_par
                                ELSE @dfch_fin_non
                           END
            AND ( ( ISNULL(i.fechasuspension, i.fch_termino) >= @dfch_ini_non
                    AND CASE WHEN @nmes_par % 2 = 0 THEN @dfch_fin_par
                             ELSE @dfch_fin_non
                        END <= ISNULL(i.fechasuspension, i.fch_termino)
                  )
                  OR ISNULL(i.fechasuspension, i.fch_termino) IS NULL
                  OR ISNULL(i.fechasuspension, i.fch_termino) = '19000101'
                )
            AND i.codigo BETWEEN @ninicio AND @nfin
            AND e.cotiza_imss = 'S'
            AND e.borrado = 'N'
    ORDER BY a.codigo ,
            a.ayo_operacion ,
            a.mes_operacion ,
            a.serial



-- para los creditos que tengan fecha de otorgamiento
-- hasta el 30/01/1998 y sean tipo 1
-- poner el saldiaint de inicio de bimestre en todos
-- los movimientos del trabajador
    UPDATE  a
    SET     a.saldiaint = ( SELECT TOP 1
                                    b.saldiaint
                            FROM    #tmp_inf AS b
                            WHERE   b.empresa = a.empresa
                                    AND b.codigo = a.codigo
                                    AND b.diastr > 0
                          )
    FROM    #tmp_inf AS a
    WHERE   a.tipo_cred = 1
            AND a.fch_otorga <= '19980130'
            AND @cpropcred = 'S'



-- cuando es bimestre borra el registro de IM del mes par
-- para mas delante calcular los dias por bimestre
    IF @nmes_par = 02
        OR @nmes_par = 04
        OR @nmes_par = 06
        OR @nmes_par = 08
        OR @nmes_par = 10
        OR @nmes_par = 12
        BEGIN
            DELETE  #tmp_inf
            WHERE   mov = 'IM'
                    AND diastr = 0
        END



-- inicializa en ceros el campo diastr
-- y asigna un folio consecituvo en campo serial_bim
    SET @ncodigo = 0

    UPDATE  #tmp_inf
    SET     diastr = 0 ,
            @nfolio = CASE WHEN @ncodigo <> codigo THEN 0
                           ELSE @nfolio
                      END ,
            @nfolio = @nfolio + 1 ,
            serial_bim = @nfolio ,
            @ncodigo = codigo



-- calcula dias cotizados
    UPDATE  t1
    SET     t1.diastr = CASE WHEN t1.fch_mov = t2.fch_mov
                                  AND t2.mov <> 'B' THEN 0
                             ELSE CASE WHEN t2.fch_mov IS NULL
                                       THEN DATEDIFF(dd, t1.fch_mov,
                                                     CASE WHEN @nmes_par % 2 = 0
                                                          THEN @dfch_fin_par
                                                          ELSE @dfch_fin_non
                                                     END) + 1
                                       ELSE DATEDIFF(dd, t1.fch_mov,
                                                     t2.fch_mov)
                                            + CASE WHEN t2.mov = 'B' THEN 1
                                                   ELSE 0
                                              END
                                  END
                        END
    FROM    #tmp_inf AS t1
            LEFT JOIN #tmp_inf AS t2 ON t1.codigo = t2.codigo
                                        AND t1.serial + 1 = t2.serial


-- dependiendo de la fecha del credito la acomoda
-- entre los avisos
    UPDATE  t1
    SET     t1.mov = CASE WHEN t1.fch_cred >= t1.fch_mov
                               AND t1.fch_cred <= t1.fch_mov + t1.diastr - 1
                               AND t1.mov <> 'B' THEN 'CR'
                          ELSE t1.mov
                     END ,
            t1.fch_mov = CASE WHEN t1.fch_cred >= t1.fch_mov
                                   AND t1.fch_cred <= t1.fch_mov + t1.diastr
                                   - 1
                                   AND t1.mov <> 'B' THEN t1.fch_cred
                              ELSE t1.fch_mov
                         END
    FROM    #tmp_inf AS t1
            LEFT JOIN #tmp_inf AS t2 ON t1.codigo = t2.codigo
                                        AND t1.serial + 1 = t2.serial


-- pone la marca 'CR' dependiendo de cuando inicie el credito
    UPDATE  t2
    SET     t2.mov = CASE WHEN t1.fch_cred >= t1.fch_mov
                               AND t1.fch_cred <= t1.fch_mov + t1.diastr - 1
                               AND t1.mov = 'B' THEN 'CR'
                          ELSE t2.mov
                     END
    FROM    #tmp_inf AS t1
            LEFT JOIN #tmp_inf AS t2 ON t1.codigo = t2.codigo
                                        AND t1.serial + 1 = t2.serial



-- vuelve a calcular los dias cotizados
-- los avisos anteriores a la marca CR no les calcula
-- dias los deja en ceros
    UPDATE  t1
    SET     @csw = CASE WHEN t1.serial_bim = 1 THEN 'F'
                        ELSE @csw
                   END ,
            @csw = CASE WHEN t1.mov = 'CR'
                             AND @csw = 'F' THEN 'T'
                        ELSE @csw
                   END ,
            t1.diastr = CASE WHEN @csw = 'T'
                             THEN CASE WHEN t1.mov = 'B' THEN 0
                                       ELSE CASE WHEN t1.fch_mov = t2.fch_mov
                                                      AND t2.mov <> 'B' THEN 0
                                                 ELSE CASE WHEN t2.fch_mov IS NULL
                                                           THEN DATEDIFF(dd,
                                                              t1.fch_mov,
                                                              CASE
                                                              WHEN @nmes_par
                                                              % 2 = 0
                                                              THEN @dfch_fin_par
                                                              ELSE @dfch_fin_non
                                                              END) + 1
                                                           ELSE DATEDIFF(dd,
                                                              t1.fch_mov,
                                                              t2.fch_mov)
                                                              + CASE
                                                              WHEN t2.mov = 'B'
                                                              THEN 1
                                                              ELSE 0
                                                              END
                                                      END
                                            END
                                  END
                             ELSE 0
                        END
    FROM    #tmp_inf AS t1
            LEFT JOIN #tmp_inf AS t2 ON t1.codigo = t2.codigo
                                        AND t1.serial_bim + 1 = t2.serial_bim


-- borra los registros anteriores a CR
-- no tiene caso que esten en la tabla
-- puesto que no se va usar ese registro
-- para calcular la amotizacion
    DELETE  t1
    FROM    #tmp_inf AS t1
            INNER JOIN #tmp_inf AS t2 ON t1.codigo = t2.codigo
                                         AND t2.mov = 'CR'
                                         AND t1.fch_mov < t2.fch_mov



-- vuelve a reconstruir el folio
    SET @ncodigo = 0
    UPDATE  #tmp_inf
    SET     @nfolio = CASE WHEN @ncodigo <> codigo THEN 0
                           ELSE @nfolio
                      END ,
            @nfolio = @nfolio + 1 ,
            serial_bim = @nfolio ,
            @ncodigo = codigo


    UPDATE  a
    SET     a.incap = 0 ,
            a.ausen = 0
    FROM    #tmp_inf AS a


-- ajusta los dias de incapcidad para cada movimiento
-- y lo guarda en la tabla temporal @tmp_incap
    SELECT  a.empresa ,
            a.codigo ,
            a.ayo_operacion ,
            a.mes_operacion ,
            a.serial ,
            CASE WHEN d.fchinicio <= a.fch_mov
                      AND d.fchinicio + d.dias - 1 >= a.fch_mov
                      AND d.fchinicio + d.dias - 1 <= a.fch_mov + a.diastr - 1
                 THEN DATEDIFF(dd, a.fch_mov, d.fchinicio + d.dias)
                 ELSE CASE WHEN d.fchinicio >= a.fch_mov
                                AND d.fchinicio + d.dias - 1 <= a.fch_mov
                                + a.diastr - 1 THEN d.dias
                           ELSE CASE WHEN d.fchinicio >= a.fch_mov
                                          AND d.fchinicio <= a.fch_mov
                                          + a.diastr - 1
                                          AND d.fchinicio + d.dias - 1 >= a.fch_mov
                                          + a.diastr - 1
                                     THEN DATEDIFF(dd, d.fchinicio,
                                                   a.fch_mov + a.diastr)
                                     ELSE CASE WHEN d.fchinicio <= a.fch_mov
                                                    AND d.fchinicio + d.dias
                                                    - 1 >= a.fch_mov
                                                    + a.diastr - 1
                                               THEN a.diastr
                                               ELSE 0
                                          END
                                END
                      END
            END AS 'incap'
    INTO    #tmp_incap
    FROM    #tmp_inf AS a
            LEFT JOIN deducciones AS d ON a.empresa = d.empresa
                                          AND a.codigo = d.codigo --and a.ayo_operacion = d.ayo_operacion and a.mes_operacion = d.mes_operacion and d.num_conc between 109 and 111
    WHERE   a.diastr > 0
            AND a.ayo_operacion = @nayo
            AND a.mes_operacion IN ( @nmes_non, @nmes_par )
            AND d.num_conc BETWEEN 109 AND 111



-- pasa de la tabla #tmp_incap el ajuste de las incapacidades
    UPDATE  a
    SET     a.incap = ISNULL(( SELECT   SUM(b.incap)
                               FROM     #tmp_incap AS b
                               WHERE    a.empresa = b.empresa
                                        AND a.codigo = b.codigo
                                        AND a.ayo_operacion = b.ayo_operacion
                                        AND a.mes_operacion = b.mes_operacion
                                        AND a.serial = b.serial
                             ), 0)
    FROM    #tmp_inf AS a
    WHERE   a.diastr > 0


-- ajusta los ausentismos y los guarda en la
-- tabla temporal #tmp_aus
    SELECT  a.empresa ,
            a.codigo ,
            a.ayo_operacion ,
            a.mes_operacion ,
            a.serial ,
            0 AS 'serial_bim' ,
            d.fchinicio ,
            d.dias ,
            CASE WHEN d.fchinicio <= a.fch_mov
                      AND d.fchinicio + d.dias - 1 >= a.fch_mov
                      AND d.fchinicio + d.dias - 1 <= a.fch_mov + a.diastr - 1
                 THEN DATEDIFF(dd, a.fch_mov, d.fchinicio + d.dias)
                 ELSE CASE WHEN d.fchinicio >= a.fch_mov
                                AND d.fchinicio + d.dias - 1 <= a.fch_mov
                                + a.diastr - 1 THEN d.dias
                           ELSE CASE WHEN d.fchinicio >= a.fch_mov
                                          AND d.fchinicio <= a.fch_mov
                                          + a.diastr - 1
                                          AND d.fchinicio + d.dias - 1 >= a.fch_mov
                                          + a.diastr - 1
                                     THEN DATEDIFF(dd, d.fchinicio,
                                                   a.fch_mov + a.diastr)
                                     ELSE CASE WHEN d.fchinicio <= a.fch_mov
                                                    AND d.fchinicio + d.dias
                                                    - 1 >= a.fch_mov
                                                    + a.diastr - 1
                                               THEN a.diastr
                                               ELSE 0
                                          END
                                END
                      END
            END AS 'aus' ,
            @naus_non AS 'aus_non' ,
            @naus_par AS 'aus_par'
    INTO    #tmp_aus
    FROM    #tmp_inf AS a
            LEFT JOIN deducciones AS d ON a.empresa = d.empresa
                                          AND a.codigo = d.codigo
                                          AND a.ayo_operacion = d.ayo_operacion
                                          AND ( d.mes_operacion = @nmes_non
                                                OR d.mes_operacion = @nmes_par
                                              )
                                          AND d.num_conc = 108
    WHERE   a.diastr > 0



-- los registros que no tengan ausentismo
-- los borra
    DELETE  #tmp_aus
    WHERE   aus = 0


-- inicializa en ceros los ausentismos
-- para cada mes (non y par)
    UPDATE  #tmp_aus
    SET     aus_non = CASE WHEN MONTH(fchinicio) = MONTH(@dfch_ini_non)
                           THEN aus
                           ELSE 0
                      END ,    --@nmes_non
            aus_par = CASE WHEN MONTH(fchinicio) = MONTH(@dfch_ini_par)
                           THEN aus
                           ELSE 0
                      END


    SET @nfolio = 0

-- reconstruye folio
    UPDATE  #tmp_aus
    SET     @nfolio = CASE WHEN @ncodant <> codigo THEN 0
                           ELSE @nfolio
                      END ,
            @nfolio = @nfolio + 1 ,
            serial_bim = @nfolio ,
            @ncodant = codigo


-- ajusta al tope los dias de ausentismo para cada mes (non y par)
    UPDATE  t
    SET     @ndias_non = CASE WHEN t.serial_bim = 1 THEN 0
                              ELSE @ndias_non
                         END ,
            @ndias_par = CASE WHEN t.serial_bim = 1 THEN 0
                              ELSE @ndias_par
                         END ,
            @ndias_non = @ndias_non + CASE WHEN t.aus_non IS NULL THEN 0
                                           ELSE t.aus_non
                                      END ,
            @ndias_par = @ndias_par + CASE WHEN t.aus_par IS NULL THEN 0
                                           ELSE t.aus_par
                                      END ,
            t.aus_non = CASE WHEN @ndias_non < @ndias_tope THEN t.aus_non
                             ELSE CASE WHEN t.aus_non - ( @ndias_non
                                                          - @ndias_tope ) < 0
                                       THEN 0
                                       ELSE t.aus_non - ( @ndias_non
                                                          - @ndias_tope )
                                  END
                        END ,
            t.aus_par = CASE WHEN @ndias_par < @ndias_tope THEN t.aus_par
                             ELSE CASE WHEN t.aus_par - ( @ndias_par
                                                          - @ndias_tope ) < 0
                                       THEN 0
                                       ELSE t.aus_par - ( @ndias_par
                                                          - @ndias_tope )
                                  END
                        END
    FROM    #tmp_aus AS t


-- pasa el ajuste de ausentismo a la tabla #tmp_inf
    UPDATE  a
    SET     a.ausen = ( SELECT  SUM(b.aus_non) + SUM(b.aus_par)
                        FROM    #tmp_aus AS b
                        WHERE   a.empresa = b.empresa
                                AND a.codigo = b.codigo
                                AND a.ayo_operacion = b.ayo_operacion
                                AND a.mes_operacion = b.mes_operacion
                                AND a.serial = b.serial
                      )
    FROM    #tmp_inf AS a
    WHERE   a.diastr > 0


-- para los registros que tienen null en ausen poner cero
    UPDATE  #tmp_inf
    SET     ausen = 0
    WHERE   empresa = @nempresa
            AND ayo_operacion = @nayo
            AND ( mes_operacion = @nmes_non
                  OR mes_operacion = @nmes_par
                )
            AND codigo BETWEEN @ninicio AND @nfin
            AND ausen IS NULL


-- los creditos que su fecha de otorgamiento hasta el 30/01/1998
-- y tengan tipo 1 y que el porcentaje sea 20,25,30
-- los ubica en la tabla de descuento
    UPDATE  #tmp_inf
    SET     ntd = CASE WHEN descuento = 20
                            AND fch_otorga <= '19980130' THEN 1
                       WHEN descuento = 25
                            AND fch_otorga <= '19980130' THEN 2
                       WHEN descuento = 30
                            AND fch_otorga <= '19980130' THEN 3
                       ELSE 0
                  END ,
            @nvsm = ROUND(saldiaint / @nsalmin, 2) ,
            vsm = @nvsm ,
            info = CASE WHEN @nvsm >= 0.01
                             AND @nvsm <= 02.50
                             AND fch_otorga <= '19980130' THEN 1
                        WHEN @nvsm >= 2.51
                             AND @nvsm <= 03.50
                             AND fch_otorga <= '19980130' THEN 2
                        WHEN @nvsm >= 3.51
                             AND @nvsm <= 04.50
                             AND fch_otorga <= '19980130' THEN 3
                        WHEN @nvsm >= 4.51
                             AND @nvsm <= 05.50
                             AND fch_otorga <= '19980130' THEN 4
                        WHEN @nvsm >= 5.51
                             AND @nvsm <= 06.50
                             AND fch_otorga <= '19980130' THEN 5
                        WHEN @nvsm >= 6.51
                             AND @nvsm <= 99.99
                             AND fch_otorga <= '19980130' THEN 6
                        ELSE 0
                   END ,
            porc_abono = CASE descuento
                           WHEN 20
                           THEN CASE WHEN @nvsm >= 0.01
                                          AND @nvsm <= 02.50
                                          AND fch_otorga <= '19980130'
                                     THEN 15.7
                                     WHEN @nvsm >= 2.51
                                          AND @nvsm <= 03.50
                                          AND fch_otorga <= '19980130'
                                     THEN 16.8
                                     WHEN @nvsm >= 3.51
                                          AND @nvsm <= 04.50
                                          AND fch_otorga <= '19980130'
                                     THEN 17.2
                                     WHEN @nvsm >= 4.51
                                          AND @nvsm <= 05.50
                                          AND fch_otorga <= '19980130'
                                     THEN 17.7
                                     WHEN @nvsm >= 5.51
                                          AND @nvsm <= 06.50
                                          AND fch_otorga <= '19980130'
                                     THEN 17.8
                                     WHEN @nvsm >= 6.51
                                          AND @nvsm <= 99.99
                                          AND fch_otorga <= '19980130'
                                     THEN 20.0
                                     ELSE descuento
                                END
                           WHEN 25
                           THEN CASE WHEN @nvsm >= 0.01
                                          AND @nvsm <= 02.50
                                          AND fch_otorga <= '19980130'
                                     THEN 19.6
                                     WHEN @nvsm >= 2.51
                                          AND @nvsm <= 03.50
                                          AND fch_otorga <= '19980130'
                                     THEN 21.0
                                     WHEN @nvsm >= 3.51
                                          AND @nvsm <= 04.50
                                          AND fch_otorga <= '19980130'
                                     THEN 21.5
                                     WHEN @nvsm >= 4.51
                                          AND @nvsm <= 05.50
                                          AND fch_otorga <= '19980130'
                                     THEN 22.1
                                     WHEN @nvsm >= 5.51
                                          AND @nvsm <= 06.50
                                          AND fch_otorga <= '19980130'
                                     THEN 22.3
                                     WHEN @nvsm >= 6.51
                                          AND @nvsm <= 99.99
                                          AND fch_otorga <= '19980130'
                                     THEN 25.0
                                     ELSE descuento
                                END
                           WHEN 30
                           THEN CASE WHEN @nvsm >= 0.01
                                          AND @nvsm <= 02.50
                                          AND fch_otorga <= '19980130'
                                     THEN 24.6
                                     WHEN @nvsm >= 2.51
                                          AND @nvsm <= 03.50
                                          AND fch_otorga <= '19980130'
                                     THEN 26.0
                                     WHEN @nvsm >= 3.51
                                          AND @nvsm <= 04.50
                                          AND fch_otorga <= '19980130'
                                     THEN 26.5
                                     WHEN @nvsm >= 4.51
                                          AND @nvsm <= 05.50
                                          AND fch_otorga <= '19980130'
                                     THEN 27.1
                                     WHEN @nvsm >= 5.51
                                          AND @nvsm <= 06.50
                                          AND fch_otorga <= '19980130'
                                     THEN 27.3
                                     WHEN @nvsm >= 6.51
                                          AND @nvsm <= 99.99
                                          AND fch_otorga <= '19980130'
                                     THEN 30.0
                                     ELSE descuento
                                END
                           ELSE descuento
                         END
    WHERE   tipo_cred = 1



    UPDATE  #tmp_inf
    SET     amortizacion = CASE tipo_cred
                             WHEN 1
                             THEN saldiaint * ( diastr - ausen
                                                - CASE WHEN @cconvenio = 'CONVENIO'
                                                       THEN 0
                                                       ELSE incap
                                                  END ) * ( porc_abono / 100 )
                             WHEN 2
                             THEN ( ( descuento * 2 ) / @ndiasprop )
                                  * CASE WHEN @cdiaslab = 'S'
                                         THEN ( diastr - ausen
                                                - CASE WHEN @cconvenio = 'CONVENIO'
                                                       THEN 0
                                                       ELSE incap
                                                  END )
                                         ELSE ( diastr - ausen
                                                - CASE WHEN @cconvenio = 'CONVENIO'
                                                       THEN 0
                                                       ELSE incap
                                                  END )
                                    END
                             WHEN 3
                             THEN ( ( descuento * 2 * @nsaldf ) / @ndiasprop )
                                  * ( diastr - ausen
                                      - CASE WHEN @cconvenio = 'CONVENIO'
                                             THEN 0
                                             ELSE incap
                                        END )
                             ELSE 0
                           END


-- inicializa los campo en cero
    UPDATE  i
    SET     i.amortiza = 0 ,
            i.ntd = 0 ,
            i.info = 0 ,
            i.val_desc = 0 ,
            i.tipo_cred = 0
    FROM    cuotas_imss_bim AS i



-- por ultimo pasa la amortizacion calculada a la tabla cuotas imss bim
    UPDATE  i
    SET     i.totalbim = totalbim + ISNULL(( SELECT SUM(t.amortizacion)
                                             FROM   #tmp_inf AS t
                                             WHERE  i.empresa = t.empresa
                                                    AND i.codigo = t.codigo
                                           ), 0) ,
            i.amortiza = ( SELECT   SUM(t.amortizacion)
                           FROM     #tmp_inf AS t
                           WHERE    i.empresa = t.empresa
                                    AND i.codigo = t.codigo
                         ) ,
            i.ntd = ISNULL(( SELECT TOP 1
                                    t.ntd
                             FROM   #tmp_inf AS t
                             WHERE  i.empresa = t.empresa
                                    AND i.codigo = t.codigo
                           ), 0) ,
            i.info = ISNULL(( SELECT TOP 1
                                        t.info
                              FROM      #tmp_inf AS t
                              WHERE     i.empresa = t.empresa
                                        AND i.codigo = t.codigo
                            ), 0) ,
            i.val_desc = ISNULL(( SELECT TOP 1
                                            t.porc_abono
                                  FROM      #tmp_inf AS t
                                  WHERE     i.empresa = t.empresa
                                            AND i.codigo = t.codigo
                                ), 0) ,
            i.tipo_cred = ISNULL(( SELECT TOP 1
                                            t.tipo_cred
                                   FROM     #tmp_inf AS t
                                   WHERE    i.empresa = t.empresa
                                            AND i.codigo = t.codigo
                                 ), 0) ,
            i.seguro_vivienda = ISNULL(( SELECT TOP 1
                                                t.seguro_vivienda
                                         FROM   #tmp_inf AS t
                                         WHERE  i.empresa = t.empresa
                                                AND i.codigo = t.codigo
                                       ), 'F') ,
            i.fch_otorga = ( SELECT TOP 1
                                    t.fch_otorga
                             FROM   #tmp_inf AS t
                             WHERE  i.empresa = t.empresa
                                    AND i.codigo = t.codigo
                           ) ,
            i.fecha = ( SELECT TOP 1
                                t.fecha
                        FROM    #tmp_inf AS t
                        WHERE   i.empresa = t.empresa
                                AND i.codigo = t.codigo
                      ) ,
            i.fch_termino = ( SELECT TOP 1
                                        t.fch_termino
                              FROM      #tmp_inf AS t
                              WHERE     i.empresa = t.empresa
                                        AND i.codigo = t.codigo
                            ) ,
            i.numcredito = ( SELECT TOP 1
                                    t.numcredito
                             FROM   #tmp_inf AS t
                             WHERE  i.empresa = t.empresa
                                    AND i.codigo = t.codigo
                           )
    FROM    cuotas_imss_bim AS i



    DROP TABLE #tmp_inf
    DROP TABLE #tmp_incap
    DROP TABLE #tmp_aus

GO



/**************************************************************************************************
 * Name          : dbo.Sp_RepCrdInf
 * Project       : APSI Nomina
 * Description   : Reporte de creditos de infonavit
 * Table name    : Empleados, Infonavit, cuotas_imss_bim
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Lunes 03 Septiembre 2012
 **************************************************************************************************/


IF OBJECT_ID('dbo.Sp_RepCrdInf') IS NOT NULL
   DROP PROCEDURE dbo.Sp_RepCrdInf
GO

CREATE PROCEDURE dbo.Sp_RepCrdInf
    @empresa AS INT ,
    @tiporeporte AS INT ,
    @mesopera AS INT ,
    @ayoopera AS INT
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    DECLARE @mesoperacion AS INT
    DECLARE @ayooperacion AS INT
    DECLARE @mesinicio AS INT
    DECLARE @mesfinal AS INT
    DECLARE @mes1 AS CHAR(5)
    DECLARE @mes2 AS CHAR(5)
    DECLARE @tretenciones AS TABLE
        (
          empresa INT ,
          codigo NUMERIC(8) ,
          importe FLOAT
        )

    DECLARE @tbaCedulaInfonavit AS TABLE
        (
          empresa INTEGER,
          codigo NUMERIC(8, 0) ,
          Infonavit FLOAT ,
          Amortiza FLOAT
        )

    DECLARE @fechainicio AS DATETIME
    DECLARE @fechafinal AS DATETIME

    DECLARE @fechaProceso AS DATETIME
    DECLARE @horaProceso AS VARCHAR(8)
    DECLARE @diasTope AS INT
    DECLARE @Proceso AS VARCHAR(50)
    DECLARE @periodoInicio1 AS VARCHAR(6)
    DECLARE @periodoInicio2 AS VARCHAR(6)
    DECLARE @periodoTermino1 AS VARCHAR(6)
    DECLARE @periodoTermino2 AS VARCHAR(6)
    DECLARE @fechaFinMes1 AS DATETIME
    DECLARE @fechaFinMes2 AS DATETIME


    SET @diasTope = 7
    SET @Proceso = 'ReporteInfonavitFunE'
    --SET @fechaProceso = CONVERT(DATETIME, GETDATE())
    --SET @horaProceso = CONVERT(TIME, GETDATE())
    SET @fechaProceso = CONVERT(DATETIME, CONVERT (char(10), GETDATE(), 112))
    SET @horaProceso = CONVERT(VARCHAR(8), GETDATE(), 108)

    IF @mesopera = 0
        AND @ayoopera = 0
        SELECT  @mesoperacion = mes_operacion ,
                @ayooperacion = ayo_operacion
        FROM    dbo.empresas
        WHERE   empresa = @empresa
    ELSE
        BEGIN
            SET @mesoperacion = @mesopera
            SET @ayooperacion = @ayoopera
        END

    SET @mesinicio = CASE WHEN @mesoperacion >= 01
                               AND @mesoperacion <= 02 THEN 01
                          WHEN @mesoperacion >= 03
                               AND @mesoperacion <= 04 THEN 03
                          WHEN @mesoperacion >= 05
                               AND @mesoperacion <= 06 THEN 05
                          WHEN @mesoperacion >= 07
                               AND @mesoperacion <= 08 THEN 07
                          WHEN @mesoperacion >= 09
                               AND @mesoperacion <= 10 THEN 09
                          WHEN @mesoperacion >= 11
                               AND @mesoperacion <= 12 THEN 11
                     END

    SET @mesfinal = CASE WHEN @mesoperacion >= 01
                              AND @mesoperacion <= 02 THEN 02
                         WHEN @mesoperacion >= 03
                              AND @mesoperacion <= 04 THEN 04
                         WHEN @mesoperacion >= 05
                              AND @mesoperacion <= 06 THEN 06
                         WHEN @mesoperacion >= 07
                              AND @mesoperacion <= 08 THEN 08
                         WHEN @mesoperacion >= 09
                              AND @mesoperacion <= 10 THEN 10
                         WHEN @mesoperacion >= 11
                              AND @mesoperacion <= 12 THEN 12
                    END

    SET @mes1 = CASE WHEN @mesinicio = 01 THEN 'ENE'
                     WHEN @mesinicio = 02 THEN 'FEB'
                     WHEN @mesinicio = 03 THEN 'MAR'
                     WHEN @mesinicio = 04 THEN 'ABR'
                     WHEN @mesinicio = 05 THEN 'MAY'
                     WHEN @mesinicio = 06 THEN 'JUN'
                     WHEN @mesinicio = 07 THEN 'JUL'
                     WHEN @mesinicio = 08 THEN 'AGO'
                     WHEN @mesinicio = 09 THEN 'SEP'
                     WHEN @mesinicio = 10 THEN 'OCT'
                     WHEN @mesinicio = 11 THEN 'NOV'
                     WHEN @mesinicio = 12 THEN 'DIC'
                END + RIGHT(CONVERT(CHAR(4), @ayooperacion), 2)

    SET @mes2 = CASE WHEN @mesfinal = 01 THEN 'ENE'
                     WHEN @mesfinal = 02 THEN 'FEB'
                     WHEN @mesfinal = 03 THEN 'MAR'
                     WHEN @mesfinal = 04 THEN 'ABR'
                     WHEN @mesfinal = 05 THEN 'MAY'
                     WHEN @mesfinal = 06 THEN 'JUN'
                     WHEN @mesfinal = 07 THEN 'JUL'
                     WHEN @mesfinal = 08 THEN 'AGO'
                     WHEN @mesfinal = 09 THEN 'SEP'
                     WHEN @mesfinal = 10 THEN 'OCT'
                     WHEN @mesfinal = 11 THEN 'NOV'
                     WHEN @mesfinal = 12 THEN 'DIC'
                END + RIGHT(CONVERT(CHAR(4), @ayooperacion), 2)

    SET @fechainicio = dbo.NvaFecha(01, @mesinicio, @ayooperacion)
    SET @fechafinal = dbo.fin_mes(@mesfinal, @ayooperacion)

    SET @fechaFinMes1 = dbo.fin_mes(@mesinicio, @ayoopera)
    SET @fechaFinMes2 = dbo.fin_mes(@mesfinal, @ayoopera)
    SET @periodoInicio1 = dbo.DateToChar(@fechaFinMes1, 'AAAAMMDD', '')
    SET @periodoTermino1 = dbo.DateToChar(@fechaFinMes1, 'AAAAMMDD', '')
    SET @periodoInicio2 = dbo.DateToChar(@fechaFinMes2, 'AAAAMMDD', '')
    SET @periodoTermino2 = dbo.DateToChar(@fechaFinMes2, 'AAAAMMDD', '')

    DELETE  dbo.AvisosImssTemporalCalculo
    WHERE   empresa = @empresa

    EXECUTE dbo.asp_excep_empleados @empresa

    EXECUTE dbo.asp_bim_ds @empresa, -- numeric
            @ayoopera, -- int
            @mesinicio, -- int
            @mesfinal, -- int
            0, -- numeric
            @fechafinal -- datetime

    EXECUTE dbo.asp_bim_aus @empresa, -- numeric
            @ayoopera, -- int
            @mesinicio, -- int
            @mesfinal, -- int
            0, -- numeric
            @diastope -- decimal

    EXECUTE dbo.asp_bim_inc @empresa, -- numeric
            @ayoopera, -- int
            @mesinicio, -- int
            @mesfinal, -- int
            0 -- numeric

    EXECUTE dbo.LlenaTablaAvisosImssTemporalCalculo @empresa, -- int
        @proceso, -- varchar(250)
        @fechaproceso, -- datetime
        @horaproceso, -- varchar(8)
        @periodoinicio1, -- varchar(6)
        @periodotermino2, -- varchar(6)
     	 'BIMESTRE'

    EXECUTE dbo.CalculaAmortizacionProcedureUMA @empresa, -- numeric
        @ayoopera, -- int
        @mesinicio, -- int
        @mesfinal, -- int
        @diastope, -- decimal
        'A', -- char(1)
         0, -- numeric
        'S', -- char(1)
        @proceso, -- varchar(250)
        @fechaproceso , -- datetime
        @horaproceso  -- varchar(8)

    INSERT  INTO @tbaCedulaInfonavit
            ( empresa ,
              codigo ,
              Infonavit
            )
            SELECT  empresa ,
                    codigo ,
                    SUM(aportacionInfonavit) AS 'PatronInfonavit'
            FROM    dbo.LlenaCedulaBimestralUMA(@empresa, 0, @ayoOpera,
                                                @mesinicio, @mesfinal,
                                                @Proceso, @fechaProceso,
                                                @horaProceso, 0, 1)
            GROUP BY empresa,codigo


    UPDATE  tbainfo
    SET     tbaInfo.Amortiza = ISNULL(ta.amortizacion, 0)
    FROM    @tbaCedulaInfonavit AS tbainfo
            LEFT JOIN dbo.TemporalAmortizacion AS ta ON ta.empresa = tbainfo.empresa
                                                        AND ta.codigo = tbainfo.codigo

    EXECUTE dbo.DepuraTablaAvisosImssTemporalCalculo @empresa ,@Proceso , @fechaProceso, @HoraProceso

    --SELECT @mes1,@mes2,@mesinicio,@mesfinal

    --Descuentos dentro del bimestre natural
    INSERT  INTO @tretenciones
            SELECT  empresa ,
                    codigo ,
                    SUM(CASE WHEN ( fch_inicio >= @fechainicio
                                    AND fch_cierre <= @fechafinal
                                  ) THEN importe
                             WHEN ( fch_inicio >= @fechainicio
                                    AND fch_inicio <= @fechafinal AND fch_cierre >= @fechafinal
                                  )
                             THEN ( importe / (CASE WHEN dias <= 1 THEN 1 ELSE dias END) * ( DATEDIFF(dd, fch_inicio,
                                                              @fechafinal) + 1 ) )
                             WHEN ( fch_cierre >= @fechainicio
                                    AND fch_cierre <= @fechafinal
                                  )
                             THEN ( importe / (CASE WHEN dias <= 1 THEN 1 ELSE dias END) * ( DATEDIFF(dd,
                                                              @fechainicio,
                                                              fch_cierre) + 1 ) )
                             ELSE 0
                        END) AS 'importe'
            FROM    dbo.kardex_anual
            WHERE   empresa = @empresa
                    --AND mes IN ( @mes1, @mes2)
                    AND ( ( fch_inicio >= @fechainicio
                            AND fch_cierre <= @fechafinal
                          )
                          OR ( fch_inicio >= @fechainicio AND fch_inicio <= @fechafinal
                               AND fch_cierre > @fechafinal
                             )
                          OR ( fch_cierre >= @fechainicio
                               AND fch_cierre <= @fechafinal
                             )
                        )
                    AND YEAR(fch_cierre) = @ayooperacion --ayo_operacion = @ayooperacion
                    AND num_conc = 112

					-- 12/03/2020 JCMM se agrego este filtro para que en el comparativo retenido nomina vs pago sua
					-- no tome en cuenta las diferencias aplicadas del bimestre anterior
					AND tipo_mov = CASE WHEN @tiporeporte = 4 THEN 'INF' ELSE tipo_mov END
            GROUP BY empresa ,
                    codigo


    IF @tiporeporte = 1
        SELECT  infonavit.Codigo ,
                infonavit.NumCredito ,
                RTRIM(empleados.Ap_Paterno) + ' ' + RTRIM(empleados.Ap_Materno)
                + ' ' + RTRIM(empleados.NOMBRE) AS 'nombre' ,
                infonavit.Fch_Otorga ,
                infonavit.Fecha ,
                ISNULL(cuotas_imss_bim.infonavit, 0) AS 'infonavit' ,
                infonavit.Descuento ,
                ISNULL(ret.importe, infonavit.Amortizacion_Retenido) AS 'Amortizacion_Retenido' , --infonavit.Amortizacion_Retenido ,
                ISNULL(cuotas_imss_bim.amortiza, 0) AS 'amotizacion_cedula' ,
                infonavit.Tipo_Cred ,
                empleados.Activo ,
                empleados.ultfchmov ,
                empleados.ultmov ,
                CASE WHEN ISNULL(ret.importe, infonavit.Amortizacion_Retenido) > ISNULL(cuotas_imss_bim.amortiza,
                                                          0)
                     THEN ( ISNULL(ret.importe, infonavit.Amortizacion_Retenido)
                            - ISNULL(cuotas_imss_bim.amortiza, 0) )
                     ELSE 0
                END AS 'Favor' ,
                CASE WHEN ISNULL(ret.importe, infonavit.Amortizacion_Retenido) < ISNULL(cuotas_imss_bim.amortiza,
                                                          0)
                     THEN ( ISNULL(cuotas_imss_bim.amortiza, 0)
                            - ISNULL(ret.importe, infonavit.Amortizacion_Retenido) )
                     ELSE 0
                END AS 'Contra'
        FROM    dbo.empleados
                INNER JOIN dbo.infonavit ON ( empleados.CODIGO = infonavit.Codigo
                                              AND ISNULL(infonavit.fechasuspension,
                                                         infonavit.fch_termino) >= @fechainicio
                                              AND empleados.empresa = infonavit.empresa
                                            )
                INNER JOIN @tbaCedulaInfonavit AS cuotas_imss_bim ON ( infonavit.empresa = cuotas_imss_bim.empresa
                                                AND infonavit.codigo = cuotas_imss_bim.codigo
                                              )
                LEFT JOIN @tretenciones AS ret ON ( empleados.codigo = ret.codigo
                                                    AND dbo.empleados.empresa = ret.empresa
                                                  )
        WHERE   dbo.empleados.empresa = @empresa
                AND dbo.empleados.ultmov <> 'B'
        ORDER BY infonavit.tipo_cred,infonavit.Codigo

    IF @tiporeporte = 2
        SELECT  infonavit.Codigo ,
                infonavit.NumCredito ,
                RTRIM(empleados.Ap_Paterno) + ' ' + RTRIM(empleados.Ap_Materno)
                + ' ' + RTRIM(empleados.NOMBRE) AS 'nombre' ,
                infonavit.Fch_Otorga ,
                infonavit.Fecha ,
                ISNULL(cuotas_imss_bim.infonavit, 0) AS 'infonavit' ,
                infonavit.Descuento ,
                ISNULL(ret.importe, infonavit.Amortizacion_Retenido) AS 'Amortizacion_Retenido' , --infonavit.Amortizacion_Retenido ,
                ISNULL(cuotas_imss_bim.amortiza, 0) AS 'amotizacion_cedula' ,
                infonavit.Tipo_Cred ,
                empleados.Activo ,
                empleados.ultfchmov ,
                empleados.ultmov ,
                CASE WHEN ISNULL(ret.importe, infonavit.Amortizacion_Retenido) > ISNULL(cuotas_imss_bim.amortiza,
                                                          0)
                     THEN ( ISNULL(ret.importe, infonavit.Amortizacion_Retenido)
                            - ISNULL(cuotas_imss_bim.amortiza, 0) )
                     ELSE 0
                END AS 'Favor' ,
                CASE WHEN ISNULL(ret.importe, infonavit.Amortizacion_Retenido) < ISNULL(cuotas_imss_bim.amortiza,
                                                          0)
                     THEN ( ISNULL(cuotas_imss_bim.amortiza, 0)
                            - ISNULL(ret.importe, infonavit.Amortizacion_Retenido) )
                     ELSE 0
                END AS 'Contra'
        FROM    dbo.empleados
                INNER JOIN dbo.infonavit ON ( empleados.CODIGO = infonavit.Codigo
                                              AND ISNULL(infonavit.fechasuspension,
                                                         infonavit.fch_termino) >= @fechainicio
                                              AND empleados.empresa = infonavit.empresa
                                            )
                INNER JOIN @tbaCedulaInfonavit AS cuotas_imss_bim ON ( infonavit.empresa = cuotas_imss_bim.empresa
                                                AND infonavit.codigo = cuotas_imss_bim.codigo
                                              )
                LEFT JOIN @tretenciones AS ret ON ( empleados.codigo = ret.codigo
                                                    AND dbo.empleados.empresa = ret.empresa
                                                  )
        WHERE   dbo.empleados.empresa = @empresa
                AND dbo.empleados.ultmov = 'B'
        ORDER BY infonavit.tipo_cred,infonavit.Codigo

    IF @tiporeporte = 3
        SELECT  infonavit.Codigo ,
                infonavit.NumCredito ,
                RTRIM(empleados.Ap_Paterno) + ' ' + RTRIM(empleados.Ap_Materno)
                + ' ' + RTRIM(empleados.NOMBRE) AS 'nombre' ,
                infonavit.Fch_Otorga ,
                infonavit.Fecha ,
                ISNULL(cuotas_imss_bim.infonavit, 0) AS 'infonavit' ,
                infonavit.Descuento ,
                ISNULL(ret.importe, infonavit.Amortizacion_Retenido) AS 'Amortizacion_Retenido' , --infonavit.Amortizacion_Retenido ,
                ISNULL(cuotas_imss_bim.amortiza, 0) AS 'amotizacion_cedula' ,
                infonavit.Tipo_Cred ,
                empleados.Activo ,
                empleados.ultfchmov ,
                empleados.ultmov ,
                CASE WHEN ISNULL(ret.importe, infonavit.Amortizacion_Retenido) > ISNULL(cuotas_imss_bim.amortiza,
                                                          0)
                     THEN ( ISNULL(ret.importe, infonavit.Amortizacion_Retenido)
                            - ISNULL(cuotas_imss_bim.amortiza, 0) )
                     ELSE 0
                END AS 'Favor' ,
                CASE WHEN ISNULL(ret.importe, infonavit.Amortizacion_Retenido) < ISNULL(cuotas_imss_bim.amortiza,
                                                          0)
                     THEN ( ISNULL(cuotas_imss_bim.amortiza, 0)
                            - ISNULL(ret.importe, infonavit.Amortizacion_Retenido) )
                     ELSE 0
                END AS 'Contra'
        FROM    dbo.empleados
                INNER JOIN dbo.infonavit ON ( empleados.CODIGO = infonavit.Codigo
                                              AND ISNULL(infonavit.fechasuspension,
                                                         infonavit.fch_termino) >= @fechainicio
                                              AND empleados.empresa = infonavit.empresa
                                            )
                INNER JOIN @tbaCedulaInfonavit AS cuotas_imss_bim ON ( infonavit.empresa = cuotas_imss_bim.empresa
                                                AND infonavit.codigo = cuotas_imss_bim.codigo
                                              )
                LEFT JOIN @tretenciones AS ret ON ( empleados.codigo = ret.codigo
                                                    AND dbo.empleados.empresa = ret.empresa
                                                  )
        WHERE   dbo.empleados.empresa = @empresa
        ORDER BY infonavit.tipo_cred,infonavit.Codigo


    IF @tiporeporte = 4
       BEGIN
         SELECT retenciones.empresa, retenciones.codigo, LTRIM(RTRIM(empleado.ap_paterno)) + ' ' + LTRIM(RTRIM(empleado.ap_materno)) + ' ' + LTRIM(RTRIM(empleado.nombre)) AS nombre, empleado.afiliacion, empleado.digvera, retenciones.importe, llaves.tiponom, infonavit.tipo_cred
         FROM @tretenciones AS retenciones
              INNER JOIN dbo.empleados AS empleado ON retenciones.codigo = empleado.codigo
                                                      AND retenciones.empresa = empleado.empresa
              INNER JOIN dbo.Llaves AS llaves ON retenciones.codigo = llaves.codigo
                                                      AND retenciones.empresa = llaves.empresa
              INNER JOIN dbo.infonavit ON ( retenciones.CODIGO = infonavit.Codigo
                                            AND ISNULL(infonavit.fechasuspension,
                                                       infonavit.fch_termino) >= @fechainicio
                                            AND retenciones.empresa = infonavit.empresa
                                          )
         ORDER BY LTRIM(RTRIM(empleado.ap_paterno)) + ' ' + LTRIM(RTRIM(empleado.ap_materno)) + ' ' + LTRIM(RTRIM(empleado.nombre))
       END

GO


/**************************************************************************************************
 * Name          : Fun_EyF_BorradoMasivo
 * Project       : APSI Nomina
 * Description   : Septiembre 27, 2012
 *                 Eliminar conceptos del periodo activo de las tablas de deducciones o percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2012
 * Parameters    : empresa,codigo,tipo de nomina,periodo, ao operacion,numero de concepto,
 *                 tipo de concepto (deduccion o percepcion),usuario,opcion 2 de bitacora, opcion 3 de bitacora
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_EyF_BorradoMasivo') IS NOT NULL
    DROP PROCEDURE dbo.Fun_EyF_BorradoMasivo
GO


CREATE PROCEDURE dbo.Fun_EyF_BorradoMasivo
    @empresa AS INT ,
    @tiponom AS INT ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @num_conc AS INT ,
    @tipoRegistro AS CHAR(1) ,
    @usuario AS VARCHAR(20) ,
    @opcion2 AS VARCHAR(50) ,
    @opcion3 AS VARCHAR(50)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF @tipoRegistro = 'D'
            DELETE  dbo.deducciones
            WHERE   empresa = @empresa
                    AND tiponom = @tiponom
                    AND periodo = @periodo
                    AND ayo_operacion = @ayo_operacion
                    AND num_conc = @num_conc
        ELSE
            DELETE  dbo.percepciones
            WHERE   empresa = @empresa
                    AND tiponom = @tiponom
                    AND periodo = @periodo
                    AND ayo_operacion = @ayo_operacion
                    AND num_conc = @num_conc



                 -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema


                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        CASE WHEN @tipoRegistro = 'D' THEN 'E'
                             ELSE 'F'
                        END ,
                        0,
                        'Borrado masivo' ,
                        @opcion2 ,
                        @opcion3 ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : FunK_GetPeriodosSimISR
 * Project       : APSI Nomina
 * Description   : Octubre 09, 2012
 *                 Obtener los periodos, activos y cerrados para el simulador de ISR
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 09, 2012
 * Parameters    : empresa,tipo de nomina
 **************************************************************************************************/
IF OBJECT_ID('dbo.FunK_GetPeriodosSimISR') IS NOT NULL
    DROP PROCEDURE dbo.FunK_GetPeriodosSimISR
GO


CREATE PROCEDURE dbo.FunK_GetPeriodosSimISR
    @empresa AS INT ,
    @tiponom AS INT
AS
    SET NOCOUNT ON

    DECLARE @periodos AS TABLE
        (
          estatus CHAR(1) ,
          periodo INT ,
          ayo_operacion INT ,
          inicio DATETIME ,
          cierre DATETIME ,
          pago DATETIME ,
          dias FLOAT ,
          nombre VARCHAR(50)
        )

    INSERT  INTO @periodos
            SELECT  p.estatus ,
                    p.periodo ,
                    p.ayo_operacion ,
                    p.inicio ,
                    p.cierre ,
                    p.pago ,
                    p.dias ,
                    n.nomina
            FROM    dbo.Periodos AS p
                    INNER JOIN nominas AS n ON ( p.empresa = n.empresa
                                                 AND p.tiponom = n.tiponom
                                               )
            WHERE   p.empresa = @empresa
                    AND p.tiponom = @tiponom
                    AND p.estatus = 'A'

    INSERT  INTO @periodos
            SELECT  p.estatus ,
                    p.periodo ,
                    p.ayo_operacion ,
                    p.inicio ,
                    p.cierre ,
                    p.pago ,
                    p.dias ,
                    n.nomina
            FROM    dbo.Periodos AS p
                    INNER JOIN nominas AS n ON ( p.empresa = n.empresa
                                                 AND p.tiponom = n.tiponom
                                               )
            WHERE   p.empresa = @empresa
                    AND p.tiponom = @tiponom
                    AND p.estatus = 'C'


    SELECT  estatus ,
            periodo ,
            ayo_operacion ,
            inicio ,
            cierre ,
            pago ,
            dias ,
            nombre
    FROM    @periodos
    ORDER BY ayo_operacion DESC ,
            periodo DESC



GO



/**************************************************************************************************
 * Name          : FunK_GetEmpleadosXPeriodo
 * Project       : APSI Nomina
 * Description   : Octubre 09, 2012
 *                 Obtener los empleados con sus importes gravables, para el simulador de ISR
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 09, 2012
 * Parameters    : empresa,tipo de nomina
 **************************************************************************************************/
IF OBJECT_ID('dbo.FunK_GetEmpleadosXPeriodo') IS NOT NULL
    DROP PROCEDURE dbo.FunK_GetEmpleadosXPeriodo
GO


CREATE PROCEDURE dbo.FunK_GetEmpleadosXPeriodo
    @empresa AS INT ,
    @tiponom AS INT ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @estatus AS CHAR(1)
AS
    SET NOCOUNT ON

    DECLARE @nominas AS CHAR(3)

    SET @nominas = CASE WHEN @tiponom = 1 THEN 'SEM'
                        WHEN @tiponom = 2 THEN 'DEC'
                        WHEN @tiponom = 3 THEN 'CAT'
                        WHEN @tiponom = 4 THEN 'QNA'
                        WHEN @tiponom = 5 THEN 'MES'
                        WHEN @tiponom = 6 THEN 'ESP'
                   END


    IF @estatus = 'A'
        SELECT  n.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                ll.centro ,
                ll.tiponom ,
                n.dias_pagar ,
                n.aus ,
                n.incap ,
                n.perc_grava ,
                n.dedu_grava,
                e.sueldo,
                e.saldiaint
        FROM    dbo.empleados AS e
                LEFT JOIN dbo.nomina_tot AS n ON ( n.empresa = e.empresa
                                                   AND n.codigo = e.codigo
                                                 )
                INNER JOIN dbo.Llaves AS ll ON ( e.empresa = ll.empresa
                                                 AND e.codigo = ll.codigo
                                               )
        WHERE   n.empresa = @empresa
                AND ll.tiponom = @tiponom
        ORDER BY n.codigo


    ELSE
        SELECT  n.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                n.centro ,
                n.tiponom ,
                n.dias_pagar ,
                n.aus ,
                n.incap ,
                n.perc_grava ,
                n.dedu_grava ,
                e.sueldo,
                e.saldiaint
        FROM    dbo.nomina1_anual AS n
                INNER JOIN dbo.empleados AS e ON ( n.empresa = e.empresa
                                                   AND n.codigo = e.codigo
                                                 )
        WHERE   n.empresa = @empresa
                AND n.periodo = @periodo
                AND n.ayo_operacion = @ayo_operacion
                AND n.tiponom = @tiponom
        ORDER BY n.codigo


GO


/**************************************************************************************************
 * Name          : FunE_GetInfonavitCambios
 * Project       : APSI Nomina
 * Description   : Noviembre 20, 2012
 *                 Obtener los cambios a los creditos infonavit
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Noviembre 20, 2012
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.FunE_GetInfonavitCambios') IS NOT NULL
    DROP PROCEDURE dbo.FunE_GetInfonavitCambios
GO


CREATE PROCEDURE dbo.FunE_GetInfonavitCambios
    @empresa AS INT ,
    @codigo AS INT
AS
    SET NOCOUNT ON

    SELECT  cambio ,
            CASE WHEN cambio = 'ICV' THEN 'Inicio de credito de vivienda'
                 WHEN cambio = 'FSD' THEN 'Suspension de credito'
                 WHEN cambio = 'RD' THEN 'Reinicio de descuento'
                 WHEN cambio = 'MTD' THEN 'Modificacion tipo de descuento'
                 WHEN cambio = 'MVD' THEN 'Modificacion valor del descuento'
                 WHEN cambio = 'MNC' THEN 'Modificacion numero de credito'
                 WHEN cambio = 'MFO' THEN 'Modificacion fecha de otorgamiento'
                 WHEN cambio = 'MFI' THEN 'Modificacion fecha de inicio'
                 WHEN cambio = 'MFL' THEN 'Modificacion fecha de liberacion'
                 WHEN cambio = 'MSV'
                 THEN 'Modificacion a marca de seguro de vivienda'
                 ELSE 'Desconocido'
            END AS 'Motivo' ,
            fecha ,
            tipo_cred ,
            descuento ,
            periodo ,
            ayo_operacion ,
            numcredito ,
            id_infocambio
    FROM    dbo.infonavit_cambios
    WHERE   empresa = @empresa
            AND codigo = @codigo
    ORDER BY fecha


GO

/**************************************************************************************************
 * Name          : fun_e_AddCreditoInfonavit
 * Project       : APSI Nomina
 * Description   : Novimbre 21, 2012
 *                 Agregar registros a la tabla de infonavit e infonavit_cambios
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_AddCreditoInfonavit') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_AddCreditoInfonavit
GO


CREATE PROCEDURE dbo.fun_e_AddCreditoInfonavit
    @empresa AS INT ,
    @codigo AS INT ,
    @tipo_cred AS INT ,
    @numcredito AS NUMERIC(10, 0) ,
    @descuento AS FLOAT ,
    @fechainicio AS DATETIME ,
    @fch_otorga AS DATETIME ,
    @fch_termino AS DATETIME ,
    @seguro_vivienda AS CHAR(1) ,
    @cambio AS CHAR(3) ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @monto AS FLOAT
        DECLARE @existe AS NUMERIC(10, 0)

        SET @monto = 0
        SET @existe = 0

        SELECT  @existe = ISNULL(codigo, 0)
        FROM    dbo.infonavit
        WHERE   empresa = @empresa
                AND codigo = @codigo

        IF @existe = 0
            INSERT  INTO dbo.infonavit
                    ( empresa ,
                      codigo ,
                      tipo_cred ,
                      numcredito ,
                      descuento ,
                      amortizacion_cedula ,
                      amortizacion_retenido ,
                      amortizacion_sigmes ,
                      fecha ,
                      fch_otorga ,
                      fch_termino ,
                      ntd ,
                      info ,
                      porc_abono ,
                      seguro_vivienda ,
                      exportado ,
                      fechaSuspension
                    )
            VALUES  ( @empresa , -- empresa - numeric
                      @codigo , -- codigo - numeric
                      @tipo_cred , -- tipo_cred - int
                      @numcredito , -- numcredito - numeric
                      @descuento , -- descuento - numeric
                      @monto , -- amortizacion_cedula - numeric
                      @monto , -- amortizacion_retenido - numeric
                      @monto , -- amortizacion_sigmes - numeric
                      @fechainicio , -- fecha - datetime
                      @fch_otorga , -- fch_otorga - datetime
                      @fch_termino , -- fch_termino - datetime
                      0 , -- ntd - int
                      0 , -- info - int
                      NULL , -- porc_abono - numeric
                      @seguro_vivienda , -- seguro_vivienda - char(1)
                      '' , -- exportado - char(1)
                      NULL  -- fechaSuspension - datetime
                    )
        ELSE
            UPDATE  dbo.infonavit
            SET     tipo_cred = @tipo_cred ,
                    numcredito = @numcredito ,
                    descuento = @descuento ,
                    fecha = @fechainicio ,
                    fch_otorga = @fch_otorga ,
                    fch_termino = @fch_termino ,
                    seguro_vivienda = @seguro_vivienda ,
                    fechaSuspension = NULL
            WHERE   codigo = @codigo
                    AND empresa = @empresa




        INSERT  INTO dbo.infonavit_cambios
                ( empresa ,
                  codigo ,
                  fecha ,
                  tipo_cred ,
                  descuento ,
                  cambio ,
                  periodo ,
                  ayo_operacion ,
                  numcredito
                )
        VALUES  ( @empresa , -- empresa - numeric
                  @codigo , -- codigo - numeric
                  @Fecha , --@fechainicio , -- fecha - datetime
                  @tipo_cred , -- tipo_cred - int
                  @descuento , -- descuento - decimal
                  @cambio , -- cambio - char(2)
                  @periodo , -- periodo - int
                  @ayo_operacion , -- ayo_operacion - int
                  @numcredito  -- numcredito - numeric
                )

         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Actualizar credito infonavit ' + @cambio ,
                        'Nmero de credito :' + CONVERT(CHAR(10), @numcredito)
                        + ' Tipo :' + CONVERT(CHAR(15), @tipo_cred) ,
                        'Descuento :' + CONVERT(CHAR(10), @descuento) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_UpdFechaSuspensionCreditoInfonavit
 * Project       : APSI Nomina
 * Description   : Novimbre 21, 2012
 *                 Agregar registros a la tabla de infonavit e infonavit_cambios
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_UpdFechaSuspensionCreditoInfonavit') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdFechaSuspensionCreditoInfonavit
GO


CREATE PROCEDURE dbo.fun_e_UpdFechaSuspensionCreditoInfonavit
    @empresa AS INT ,
    @codigo AS INT ,
    @fechaSuspension AS DATETIME ,
    @cambio AS CHAR(3) ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @fechaInicio AS DATETIME
        DECLARE @tipo_cred AS INT
        DECLARE @descuento AS FLOAT
        DECLARE @numcredito AS NUMERIC(10, 0)

        SELECT  @fechainicio = fch_otorga ,
                @tipo_cred = tipo_cred ,
                @descuento = descuento ,
                @numcredito = numcredito
        FROM    dbo.infonavit
        WHERE   empresa = @empresa
                AND codigo = @codigo


        IF @numcredito > 0
            BEGIN
                UPDATE  dbo.infonavit
                SET     fechaSuspension = @fechaSuspension
                WHERE   empresa = @empresa
                        AND codigo = @codigo

                INSERT  INTO dbo.infonavit_cambios
                        ( empresa ,
                          codigo ,
                          fecha ,
                          tipo_cred ,
                          descuento ,
                          cambio ,
                          periodo ,
                          ayo_operacion ,
                          numcredito
                        )
                VALUES  ( @empresa , -- empresa - numeric
                          @codigo , -- codigo - numeric
                          @fechaSuspension , -- fecha - datetime
                          @tipo_cred , -- tipo_cred - int
                          @descuento , -- descuento - decimal
                          @cambio , -- cambio - char(2)
                          @periodo , -- periodo - int
                          @ayo_operacion , -- ayo_operacion - int
                          @numcredito  -- numcredito - numeric
                        )



         -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Registrar fecha de suspension' ,
                                'Fecha suspension :'
                                + CONVERT(CHAR(10), @fechaSuspension) ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_UpdTipoDeCreditoInfonavit
 * Project       : APSI Nomina
 * Description   : Novimbre 21, 2012
 *                 Actualiza el tipo de credito en la tabla infonavit y agrega el registro en la tabla
                   infonavit cambios.
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo,tipo credito,fecha cambio,descuento,clave de cambio,periodo, ao, usuario
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_UpdTipoDeCreditoInfonavit') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdTipoDeCreditoInfonavit
GO


CREATE PROCEDURE dbo.fun_e_UpdTipoDeCreditoInfonavit
    @empresa AS INT ,
    @codigo AS INT ,
    @tipo_cred AS INT ,
    @fechaCambio AS DATETIME ,
    @descuento AS FLOAT ,
    @cambio AS CHAR(3) ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @tipo_credFinal AS INT
        DECLARE @descuentoFinal AS FLOAT
        DECLARE @numcreditoFinal AS NUMERIC(10, 0)
        DECLARE @numcredito AS NUMERIC(10, 0)

        SELECT  @numcredito = numcredito
        FROM    dbo.infonavit
        WHERE   empresa = @empresa
                AND codigo = @codigo

        IF @numcredito > 0
            BEGIN
                INSERT  INTO dbo.infonavit_cambios
                        ( empresa ,
                          codigo ,
                          fecha ,
                          tipo_cred ,
                          descuento ,
                          cambio ,
                          periodo ,
                          ayo_operacion ,
                          numcredito

                        )
                VALUES  ( @empresa , -- empresa - numeric
                          @codigo , -- codigo - numeric
                          @fechaCambio , -- fecha - datetime
                          @tipo_cred , -- tipo_cred - int
                          @descuento , -- descuento - decimal
                          @cambio , -- cambio - char(2)
                          @periodo , -- periodo - int
                          @ayo_operacion , -- ayo_operacion - int
                          @numcredito  -- numcredito - numeric

                        )

                SELECT  @tipo_credFinal = tipo_cred ,
                        @descuentoFinal = descuento ,
                        @numcreditoFinal = numcredito
                FROM    dbo.infonavit_cambios
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                ORDER BY fecha ,
                        id_infocambio

                UPDATE  dbo.infonavit
                SET     tipo_cred = @tipo_credFinal ,
                        descuento = @descuentoFinal ,
                        numcredito = @numcreditoFinal
                WHERE   empresa = @empresa
                        AND codigo = @codigo


                -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema


                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Cambio tipo credito' ,
                                'Fecha cambio :'
                                + CONVERT(CHAR(10), @fechaCambio) ,
                                'Tipo de credito :'
                                + CONVERT(CHAR(10), @tipo_cred)
                                + ' Descuento :'
                                + CONVERT(CHAR(10), @descuento) ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END
    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO



/**************************************************************************************************
 * Name          : fun_e_DeleteInfonavitCambios
 * Project       : APSI Nomina
 * Description   : Novimbre 23, 2012
 *                 Elimina el ultimo registro en la tabla Infonavit_Cambios y actualiza la informacion
                   de la tabla infonavit con el valor final de la tabla infonavit_cambios
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Noviembre 23, 2012
 * Parameters    : empresa,codigo,usuario,fecha
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_DeleteInfonavitCambios') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_DeleteInfonavitCambios
GO


CREATE PROCEDURE dbo.fun_e_DeleteInfonavitCambios
    @empresa AS INT ,
    @codigo AS INT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @tipo_credFinal AS INT
        DECLARE @descuentoFinal AS FLOAT
        DECLARE @numcreditoFinal AS NUMERIC(10, 0)
        DECLARE @id_infocambio AS NUMERIC(10, 0)
        DECLARE @fechaCambio AS DATETIME
        DECLARE @numcredito AS NUMERIC(10, 0)
        DECLARE @cambio AS CHAR(3)
        DECLARE @tipo_cred AS INT
        DECLARE @descuento AS FLOAT
        DECLARE @cambioFinal AS CHAR(3)
        DECLARE @fechaCambioFinal AS DATETIME


        SELECT  @id_infocambio = id_infocambio ,
                @fechaCambio = fecha ,
                @numcredito = numcredito ,
                @cambio = cambio ,
                @tipo_cred = tipo_cred ,
                @descuento = descuento
        FROM    dbo.infonavit_cambios
        WHERE   empresa = @empresa
                AND codigo = @codigo
        ORDER BY fecha ,
                id_infocambio

        IF @id_infocambio > 0
            BEGIN

                DELETE  dbo.infonavit_cambios
                WHERE   codigo = @codigo
                        AND empresa = @empresa
                        AND id_infocambio = @id_infocambio

                SET @id_infocambio = 0

                SELECT  @tipo_credFinal = tipo_cred ,
                        @descuentoFinal = descuento ,
                        @numcreditoFinal = numcredito ,
                        @id_infoCambio = id_infocambio ,
                        @cambioFinal = cambio ,
                        @fechaCambioFinal = fecha
                FROM    dbo.infonavit_cambios
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                ORDER BY fecha ,
                        id_infocambio


                IF @id_infoCambio > 0
                    UPDATE  dbo.infonavit
                    SET     tipo_cred = @tipo_credFinal ,
                            descuento = @descuentoFinal ,
                            numcredito = @numcreditoFinal ,
                            fechaSuspension = CASE WHEN @cambioFinal = 'FSD'
                                                   THEN @fechaCambioFinal
                                                   ELSE NULL
                                              END ,
                            fecha = CASE WHEN @cambioFinal = 'ICV'
                                         THEN @fechaCambioFinal
                                         ELSE fecha
                                    END
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                ELSE
                    DELETE  dbo.infonavit
                    WHERE   codigo = @codigo
                            AND empresa = @empresa


                -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema


                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Eliminar registro infonavit_cambios' ,
                                'Fecha  :' + CONVERT(CHAR(10), @fechaCambio) ,
                                'Mov :' + @cambio + ' Tipo Crd : '
                                + CONVERT(CHAR(03), @tipo_cred) + ' Dscto :'
                                + CONVERT(CHAR(10), @descuento) ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END
    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_UpdDescuentoCreditoInfonavit
 * Project       : APSI Nomina
 * Description   : Novimbre 21, 2012
 *                 Actualizar el descuento de la tabla de infonavit y agregar el registro del cambio
                   en la tabla de infonavit_cambios
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 27, 2011
 * Parameters    : empresa,codigo,tipo credito,fecha cambio,descuento,clave de cambio,periodo, ao, usuario
 **************************************************************************************************/
IF OBJECT_ID('fun_e_UpdDescuentoCreditoInfonavit') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdDescuentoCreditoInfonavit
GO


CREATE PROCEDURE dbo.fun_e_UpdDescuentoCreditoInfonavit
    @empresa AS INT ,
    @codigo AS INT ,
    @tipo_cred AS INT ,
    @fechaCambio AS DATETIME ,
    @descuento AS FLOAT ,
    @cambio AS CHAR(3) ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @usuario AS VARCHAR(20) ,
    @fecha AS DATETIME
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @tipo_credFinal AS INT
        DECLARE @descuentoFinal AS FLOAT
        DECLARE @numcreditoFinal AS NUMERIC(10, 0)
        DECLARE @numcredito AS NUMERIC(10, 0)

        SELECT  @numcredito = numcredito
        FROM    dbo.infonavit
        WHERE   empresa = @empresa
                AND codigo = @codigo

        IF @numcredito > 0
            BEGIN
                INSERT  INTO dbo.infonavit_cambios
                        ( empresa ,
                          codigo ,
                          fecha ,
                          tipo_cred ,
                          descuento ,
                          cambio ,
                          periodo ,
                          ayo_operacion ,
                          numcredito

                        )
                VALUES  ( @empresa , -- empresa - numeric
                          @codigo , -- codigo - numeric
                          @fechaCambio , -- fecha - datetime
                          @tipo_cred , -- tipo_cred - int
                          @descuento , -- descuento - decimal
                          @cambio , -- cambio - char(2)
                          @periodo , -- periodo - int
                          @ayo_operacion , -- ayo_operacion - int
                          @numcredito  -- numcredito - numeric

                        )

                SELECT  @tipo_credFinal = tipo_cred ,
                        @descuentoFinal = descuento ,
                        @numcreditoFinal = numcredito
                FROM    dbo.infonavit_cambios
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                ORDER BY fecha ,
                        id_infocambio

                UPDATE  dbo.infonavit
                SET     tipo_cred = @tipo_credFinal ,
                        descuento = @descuentoFinal ,
                        numcredito = @numcreditoFinal
                WHERE   empresa = @empresa
                        AND codigo = @codigo


                -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema


                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Actualizar descuento infonavit' ,
                                'Fecha cambio :'
                                + CONVERT(CHAR(10), @fechaCambio) ,
                                'Tipo de credito :'
                                + CONVERT(CHAR(10), @tipo_cred)
                                + ' Descuento :'
                                + CONVERT(CHAR(10), @descuento) ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END
    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : dbo.GetConceptListByTotalConceptos
 * Project       : APSI Nomina
 * Description   : Marzo 21, 2013
 *                 Reporte de los conceptos que utilizan la variable M (total conceptos)
                   detallado por los conceptos que se selecciona el usuario.
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Marzo 21 2013
 * Parameters    : empresa
 **************************************************************************************************/


IF OBJECT_ID('dbo.GetConceptListByTotalConceptos') IS NOT NULL
    DROP PROCEDURE dbo.GetConceptListByTotalConceptos
GO


CREATE PROCEDURE dbo.GetConceptListByTotalConceptos @empresa AS INT
AS

    SET NOCOUNT ON

    DECLARE @catalogo TABLE
        (
          num_conc INT ,
          clase CHAR(2),
          centro CHAR(15),
          concepto VARCHAR(50) ,
          mascara VARCHAR(200) ,
          totales VARCHAR(300) ,
          serial INT
        )

    DECLARE @seleccionados TABLE
        (
          num_conc INT ,
          clase CHAR(2),
          centro CHAR(15),
          concepto VARCHAR(50) ,
          mascara VARCHAR(200) ,
          num_concSele INT ,
          conceptoSele VARCHAR(50) ,
          claseSele CHAR(2) ,
          centroSele CHAR(14)
        )

    DECLARE @conceptos AS VARCHAR(8000)
    DECLARE @lenConceptos AS INT


    INSERT  INTO @catalogo
            SELECT  num_conc ,
                    clase,
                    centro,
                    concepto ,
                    mascara ,
                    totales ,
                    dense_rank() OVER ( PARTITION  BY empresa ORDER BY num_conc, clase ) serial
            FROM    dbo.conceptos
            WHERE   empresa = @empresa
                    AND CHARINDEX('M', mascara) > 0
                    AND num_conc < 300
                    AND clase <> '0'

    UPDATE  @catalogo
    SET     totales = REPLACE(totales, '{', '')
    UPDATE  @catalogo
    SET     totales = REPLACE(totales, '}', '')
    UPDATE  @catalogo
    SET     totales = REPLACE(totales, 'S', '')
    UPDATE  @catalogo
    SET     totales = REPLACE(totales, 'R', '')

    SELECT  @lenConceptos = MAX(serial)
    FROM    @catalogo


    DECLARE @contador AS INT
    DECLARE @totales AS VARCHAR(8000)
    DECLARE @num_conc AS INT
    DECLARE @clase AS CHAR(2)
    DECLARE @centro AS CHAR(15)
    DECLARE @concepto AS VARCHAR(50)
    DECLARE @mascara AS VARCHAR(250)

    SET @contador = 1


    WHILE @contador <= @lenConceptos
        BEGIN
            SELECT  @num_conc = num_conc ,
                    @clase = clase,
                    @centro = centro,
                    @concepto = concepto ,
                    @mascara = mascara ,
                    @totales = totales
            FROM    @catalogo
            WHERE   serial = @contador


            INSERT  INTO @seleccionados
                    SELECT  @num_conc ,
                            @clase,
                            @centro,
                            @concepto ,
                            @mascara ,
                            c.num_conc ,
                            c.concepto ,
                            c.clase ,
                            c.centro
                    FROM    dbo.CadenaATabla(@totales, ',') AS dc
                            INNER JOIN dbo.conceptos AS c ON ( dc.valor = c.num_conc
                                                              AND c.empresa = @empresa
                                                             )
                    WHERE c.clase <> '0'
                    ORDER BY c.num_conc ,
                            c.clase ,
                            c.centro



            SET @contador = @contador + 1
        END


    SELECT  num_conc ,
            clase,
            centro,
            concepto ,
            mascara ,
            num_concSele ,
            conceptoSele ,
            claseSele ,
            centroSele
    FROM    @seleccionados
    ORDER BY num_conc ,
             clase,
             centro,
            num_concSele ,
            claseSele ,
            centroSele


GO

/**************************************************************************************************
 * Project       : APSI Nomina
 * Description   : Marzo 26, 2013
 *                 Tabla para primas del ISSSTE
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Marzo 26, 2011
 **************************************************************************************************/


IF OBJECT_ID('dbo.Primas_ISSSTE') IS NULL
    BEGIN
        CREATE TABLE dbo.Primas_ISSSTE
            (
              num_conc_empleado INT ,
              num_conc_patron INT ,
              uso CHAR(1) ,
              porcentaje_empleado FLOAT ,
              porcentaje_patron FLOAT ,
              fecha_inicio DATETIME ,
              fecha_termino DATETIME ,
              regimen_seguridad_social INT ,
              descripcion_empleado VARCHAR(200) ,
              descripcion_patron VARCHAR(200) ,
              fundamentoLegal_empleado VARCHAR(2000) ,
              fundamentoLegal_patron VARCHAR(2000) ,
              topeMinimo FLOAT ,
              topeMaximo FLOAT ,
              baseTopeMinimo CHAR(1) ,
              baseTopeMaximo CHAR(1)
                CONSTRAINT PK_PrimasISSSTE
                PRIMARY KEY CLUSTERED
                ( regimen_seguridad_social, num_conc_empleado, num_conc_patron, fecha_inicio )
            )


    END

GO
/*
Cargar los valores de las primas_issste del regimen de ISSSTE LEON
*/
IF NOT EXISTS ( SELECT  *
                FROM    dbo.Primas_Issste
                WHERE   num_conc_empleado > 0
                AND regimen_seguridad_social = 2 )
    BEGIN
    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 101 , -- num_conc_empleado - int
              201 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              4.5 , -- porcentaje_empleado - float
              5.5 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              'SEGURO DE ENFERMEDADES Y MATERNIDAD' , -- descripcion_empleado - varchar(200)
              'SEGURO DE ENFERMEDADES Y MATERNIDAD' , -- descripcion_patron - varchar(200)
              'ISSSTE LEON ART. 21 FRACC. I (REFORMADA P.O. 29/12/1999)' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. I (REFORMADA PRIMER PARRAFO P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 102 , -- num_conc_empleado - int
              202 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              6.0 , -- porcentaje_empleado - float
              6.0 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              'SISTEMA CERTIFICADO PARA JUBILACION' , -- descripcion_empleado - varchar(200)
              'SISTEMA CERTIFICADO PARA JUBILACION' , -- descripcion_patron - varchar(200)
              'ISSSTE LEON ART. 21 FRACC. II (REFORMADA P.O. 29/12/1999)' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. III (REFORMADA PRIMER PARRAFO P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 103 , -- num_conc_empleado - int
              203 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              1.0 , -- porcentaje_empleado - float
              1.0 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              'PENSION POR INVALIDEZ, PENSION POR CAUSA DE MUERTE' , -- descripcion_empleado - varchar(200)
              'PENSION POR INVALIDEZ, PENSION POR CAUSA DE MUERTE' , -- descripcion_patron - varchar(200)
              'ISSSTE LEON ART. 21 FRACC. III (REFORMADA P.O. 29/12/1999)' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. IV (REFORMADA PRIMER PARRAFO P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              10.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 104 , -- num_conc_empleado - int
              204 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.5 , -- porcentaje_empleado - float
              0.5 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              'SEGURO DE VIDA' , -- descripcion_empleado - varchar(200)
              'SEGURO DE VIDA' , -- descripcion_patron - varchar(200)
              'ISSSTE LEON ART. 21 FRACC. IV (REFORMADA P.O. 29/12/1999)' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. V (REFORMADA PRIMER PARRAFO P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 105 , -- num_conc_empleado - int
              205 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.25 , -- porcentaje_empleado - float
              0.25 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              'PRESTAMOS A CORTO Y LARGO PLAZO' , -- descripcion_empleado - varchar(200)
              'PRESTAMOS A CORTO Y LARGO PLAZO' , -- descripcion_patron - varchar(200)
              'ISSSTE LEON ART. 21 FRACC. V (REFORMADA P.O. 29/12/1999)' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. VI (REFORMADA PRIMER PARRAFO P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 0 , -- num_conc_empleado - int
              206 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.0 , -- porcentaje_empleado - float
              0.50 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              '' , -- descripcion_empleado - varchar(200)
              'SEGUROS DE RIESGO DE TRABAJO' , -- descripcion_patron - varchar(200)
              '' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. II (REFORMADA PRIMER PARRAFO P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 0 , -- num_conc_empleado - int
              207 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.0 , -- porcentaje_empleado - float
              5.0 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              2 , -- regimen_seguridad_social - int
              '' , -- descripcion_empleado - varchar(200)
              'VIVIENDA' , -- descripcion_patron - varchar(200)
              '' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE LEON ART. 25 FRACC. VII (ADICIONADA P.O. 29/12/1999)' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    END

GO

/*
Actualiza el campo de regimen_seguridad_social, para que no marque error el calculo de nomina, ya que con este campo se distigue
Si se calcula para IMSS o ISSSTE
24/04/2013
*/
UPDATE  dbo.empresas
SET     Regimen_Seguridad_Social = '1'
WHERE   Regimen_Seguridad_Social = 'A'
        OR Regimen_Seguridad_Social = '0'

GO

/*Procesos almacenados que se utilizan en la captura masiva, no estaban incluidos en los archivos de actualizacion Mario Garcia 03/11/2022 */

IF OBJECT_ID('dbo.asp_insert_mov_sig_mes') IS NOT NULL
   DROP PROCEDURE dbo.asp_insert_mov_sig_mes
GO


CREATE PROCEDURE [dbo].[asp_insert_mov_sig_mes]
@nempresa INT,
@dff      DATETIME

AS

DECLARE @dinimessig DATETIME
DECLARE @dfinmessig DATETIME
DECLARE @nsigmes    INT
DECLARE @dfinext    DATETIME
DECLARE @dffnext    DATETIME
DECLARE @pmes       INT
DECLARE @pyear      INT
DECLARE @ndiasnext  INT

SET @dinimessig = @dff
SET @dfinmessig = @dff
SET @nsigmes    = 0
SET @dfinext    = @dff
SET @dffnext    = @dff
SET @pmes       = MONTH(@dff)
SET @pyear      = YEAR(@dff)

SET @dinimessig = (SELECT MAX(inicio)
FROM periodos
WHERE inicio > @dff
AND estatus = 'A')

SET @dfinmessig = (SELECT MAX(cierre)
FROM periodos
WHERE cierre > @dff
AND estatus = 'A')

IF @dinimessig > @dff OR @dfinmessig > @dff
BEGIN
   SET @nsigmes   = 1
   SET @dfinext   = @dff + 1
   SET @pmes      = MONTH(@dfinext)
   SET @pyear     = YEAR(@dfinext)
   SET @dffnext   = dbo.fin_mes(@pmes,@pyear)
   SET @ndiasnext = DATEDIFF(Day,@dffnext,@dfinext)
END

--Insertar el movimiento del siguiente mes, para que lo pueda cargar la captura masiva
IF @nsigmes = 1
 BEGIN
   INSERT INTO avisos_imss (empresa,codigo,serial,mes_operacion,ayo_operacion,fch_mov,mov,saldiaint,saldiaiv,sueldo)
   SELECT empresa
          ,codigo
          ,100 as serial
          ,Month(@dfinext) AS mes_operacion
          ,Year(@dfinext) AS ayo_operacion
          ,CASE WHEN fchalta >= @dfinext THEN fchalta ELSE @dfinext END AS fch_mov
          ,CASE WHEN fchalta >= @dfinext THEN 'A' ELSE 'IM' END AS mov
          ,saldiaint
          ,0.00 AS saldiaiv
          ,sueldo
          FROM empleados
          WHERE empresa = @nempresa  
          AND activo = 'S'
          AND pagar_nomina = 'S'
          AND ultmov <> 'B'
          AND ultfchmov < @dfinext
          ORDER by codigo


    --Calcular los dias
    EXEC asp_ds     @nempresa,0,@pyear,@pmes,@dffnext
    EXEC asp_ds_aus @nempresa,0,@pyear,@pmes,@ndiasnext
    EXEC asp_ds_inc @nempresa,0,@pyear,@pmes

END

GO


IF OBJECT_ID('dbo.Asp_capmas_Saca_faltas') IS NOT NULL
   DROP PROCEDURE dbo.Asp_capmas_Saca_faltas
GO


CREATE Procedure [dbo].[Asp_capmas_Saca_faltas]
@nEmpresa INT,
@nTiponom INT
As
/* SOLO EL CONCEPTO 108 */
/* RUTINA PARA SUMAR LAS FALTAS EN TABLA DE DIAS_A_PAGAR */


-- Agrega las faltas a Dias_a_pagar --
Select
		a.Codigo
		,Case
			When (Max(b.fchinicio) between Max(a.inicio_per) and Max(a.cierre_per)) and ( Max(b.fchtermino) <= Max(a.cierre_per) ) Then Sum(b.dias)
			When (Max(b.fchinicio)+Max(b.dias)-1 between Max(a.inicio_per) and Max(a.cierre_per)) Then Datediff(day, Max(a.inicio_per) ,Max(b.fchtermino))+1
			When (Max(b.fchinicio) between Max(a.inicio_per) and Max(a.cierre_per)) and ( Max(b.fchtermino) > Max(a.cierre_per) ) Then Datediff(day, Max(b.fchinicio) ,Max(a.cierre_per))+1
			When (Max(b.fchinicio) <= Max(a.inicio_per)) and (Max(b.fchtermino) >= Max(a.cierre_per)) Then Max(a.Dias)
		End as faltas
--		,Sum(b.dias) as dias
        Into
         	##Tmp_faltas
	From
		Dias_laborados a 
			inner join Deducciones b
		on a.Codigo = b.Codigo AND a.empresa = b.empresa
	Where
		b.num_conc = 108
		and
		((b.fchinicio between a.inicio_per and a.cierre_per) or (b.fchinicio+b.dias-1 between a.inicio_per and a.cierre_per) or ( (b.fchinicio <= a.inicio_per) and (b.fchtermino >= a.cierre_per) ))
		and
		a.Codigo = b.Codigo
                and
                a.empresa = @nEmpresa
	Group by
		a.Codigo

Update Dias_laborados 
	Set
		faltas = b.faltas

	From
		Dias_laborados a 
			inner join ##Tmp_faltas b
		on a.Codigo = b.Codigo 
	Where
		a.Codigo = b.Codigo 
                AND 
                a.empresa = @nEmpresa


Drop table ##Tmp_faltas


GO


IF OBJECT_ID('dbo.Asp_capmas_Saca_incap') IS NOT NULL
   DROP PROCEDURE dbo.Asp_capmas_Saca_incap
GO


CREATE Procedure [dbo].[Asp_capmas_Saca_incap]
@nEmpresa INT,
@nTiponom INT

As
/* SOLO EL CONCEPTO 109,110,111 */
/* RUTINA PARA SUMAR LAS FALTAS EN TABLA DE DIAS_A_PAGAR */


-- Agrega las faltas a Dias_a_pagar --
Select
		a.Codigo
		,Case
			When (Max(b.fchinicio) between Max(a.inicio_per) and Max(a.cierre_per)) and ( Max(b.fchtermino) <= Max(a.cierre_per) ) Then Sum(b.dias)
			When (Max(b.fchinicio)+Max(b.dias)-1 between Max(a.inicio_per) and Max(a.cierre_per)) Then Datediff(day, Max(a.inicio_per) ,Max(b.fchtermino))+1
			When (Max(b.fchinicio) between Max(a.inicio_per) and Max(a.cierre_per)) and ( Max(b.fchtermino) > Max(a.cierre_per) ) Then Datediff(day, Max(b.fchinicio) ,Max(a.cierre_per))+1
			When (Max(b.fchinicio) <= Max(a.inicio_per)) and (Max(b.fchtermino) >= Max(a.cierre_per)) Then Max(a.Dias)
		End as incap
--		,Sum(b.dias) as dias
        Into
         	##Tmp_faltas
	From
		Dias_laborados a 
			inner join Deducciones b
		on a.Codigo = b.Codigo AND a.empresa = b.empresa
	Where
		b.num_conc IN (109,110,111)
		and
		((b.fchinicio between a.inicio_per and a.cierre_per) or (b.fchinicio+b.dias-1 between a.inicio_per and a.cierre_per) or ( (b.fchinicio <= a.inicio_per) and (b.fchtermino >= a.cierre_per) ))
		and
		a.Codigo = b.Codigo
                and
                a.empresa = @nEmpresa
	Group by
		a.Codigo

Update Dias_laborados 
	Set
		incap = b.incap

	From
		Dias_laborados a 
			inner join ##Tmp_faltas b
		on a.Codigo = b.Codigo 
	Where
		a.Codigo = b.Codigo AND a.empresa = @nEmpresa




Drop table ##Tmp_faltas


GO



/*
 * Name          : dbo.asp_Calc_Dias_laborados
 * Project       : APSI Nomina
 * Description   : Marzo 21, 2013
 *                 LLena la tabla de empleados para la captura masiva de la funcion E y F, se actualizo, porque al cambio de
 *                 ao, si la empresa estaba en diciembre y las nominas en enero, al importar archivos marcaba que no existian empleados.
 * Copyright     : (c) Apsi 2009 - 2018. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Enero 10 2018
 * Parameters    : empresa,tipo de nomina, y Fecha de fin de mes
*/

IF OBJECT_ID('dbo.asp_Calc_Dias_laborados') IS NOT NULL
   DROP PROCEDURE dbo.asp_Calc_Dias_laborados
GO


CREATE procedure dbo.asp_Calc_Dias_laborados
@nempresa INT,
@ntiponom INT,
@dff      DATETIME
AS

--Tabla temporal para calcular los dias trabajados del periodo y los ausentismos
IF OBJECT_ID('dias_laborados') IS NOT NULL
BEGIN
    DROP TABLE dbo.Dias_Laborados
END

--Variables del mes y ao de operacion de empresas
declare @pmes int
declare @pyear int
declare @pmesNext int
declare @pyearNext int

select @pmes = mes_operacion, @pyear = ayo_operacion from empresas where empresa = @nempresa
declare @pinicio DATETIME
declare @pcierre DATETIME
DECLARE @dinimessig1 DATETIME
DECLARE @dfinmessig1 DATETIME
DECLARE @nsigmes1 INT
DECLARE @dFiNext DATETIME

SET  @dinimessig1 = @dff
SET @nsigmes1     = 0
SET @dFiNext = @dFF + 1

If year(@dFiNext) > Year(@dFF)
   BEGIN
       SET @pMesNext = Month(@dFiNext)
       SET @pYearNext = Year(@dFiNext)
   END
ELSE
   BEGIN
      SET @pMesNext = @pMes
      SET @pYearNext = @pYear
   END

--Proceso almaceando para calcular los dias trabajados en Avisos_Imss
exec asp_ds @nempresa,0,@pyear,@pmes,@dff

SET @dinimessig1 = (SELECT MAX(inicio)
FROM periodos
WHERE inicio > @dff
AND estatus = 'A')


SET @dfinmessig1 = (SELECT MAX(Cierre)
FROM periodos
WHERE Cierre > @dff
AND estatus = 'A')

print @dinimessig1
print @dfinmessig1
Print @dFF
Print @pmes
Print @pyear
Print @pmesNext
Print @pyearNext

--Si la fecha de alguna nomina es mayor a la fecha final de mes, insertar los registros de movimientos en avisos_imss
IF @dinimessig1 > @dff
BEGIN
   SET @nsigmes1   = 1
   EXEC asp_insert_mov_sig_mes @nempresa,@dff
END

--Si la fecha de alguna nomina es mayor a la fecha final de mes, insertar los registros de movimientos en avisos_imss
IF @dfinmessig1 > @dff AND @nsigmes1 = 0
BEGIN
   SET @nsigmes1   = 1
   EXEC asp_insert_mov_sig_mes @nempresa,@dff
END

--Query para llenar los movimientos que caen en los periodos nominales
Print 'AvImss'

SELECT a.empresa,
       a.codigo,
       CASE WHEN a.fch_mov <= c.inicio THEN c.inicio ELSE a.fch_mov END AS 'inicio_per',
       CASE WHEN a.fch_mov + a.diastr - 1 > c.cierre THEN c.cierre ELSE a.fch_mov+a.diastr-1 END AS 'cierre_per' ,
       a.sueldo,
       a.saldiaint,
       b.tiponom,
       b.clase,
       b.centro,
       b.horario,
       b.ocupacion,

       --CASE WHEN DATEDIFF(Year,d.fchantigua,c.cierre) = 0 THEN 1 ELSE CASE WHEN DATEDIFF(Year,d.fchantigua,c.cierre) > 45 THEN 45 ELSE DATEDIFF(Year,d.fchantigua,c.cierre)+1 END END AS 'Ayos_ant',

       dbo.CalculaAntiguedad(d.fchantigua, c.cierre) as 'Ayos_Ant',

       c.periodo,
       c.dias,
       c.ayo_operacion,
       0 AS 'dias_labor',
       0 AS 'faltas',
       0 AS 'incap',
       d.factorsd AS 'Factor_Int'
INTO dbo.Dias_Laborados
FROM dbo.Avisos_imss    AS a
LEFT JOIN dbo.llaves    AS b ON (a.codigo = b.codigo AND a.empresa = b.empresa)
LEFT JOIN dbo.periodos  AS c ON (b.tiponom = c.tiponom AND b.empresa = c.empresa)
LEFT JOIN dbo.empleados AS d ON (a.codigo = d.codigo AND a.empresa = d.empresa)
WHERE (a.fch_mov + a.diastr - CASE WHEN a.mov = 'B' THEN 0 ELSE 1 END >= c.inicio AND
       a.fch_mov <= c.cierre ) AND
       a.empresa = @nempresa AND
       ((a.mes_operacion >= @pmes AND
       a.ayo_operacion = @pyear) OR ( (a.mes_operacion = @pmesNext AND a.ayo_operacion = @pYearNext))) AND
       a.diastr > 0 AND
       c.Estatus = 'A' AND
       c.tiponom > 0 AND
       d.pagar_nomina = 'S' AND
       d.activo = 'S'
ORDER BY a.codigo,a.serial

UPDATE dias_laborados
       SET
       factor_int = b.factor
       FROM dias_laborados AS a
       INNER JOIN tablas_int AS b ON (a.empresa = b.empresa AND a.clase = b.clase AND a.ayos_ant = CAST( b.ayos AS INT ))
       WHERE b.mes_operacion = @pmes AND b.ayo_operacion = @pyear

UPDATE dias_laborados SET dias_labor = DATEDIFF(Day,inicio_per,cierre_per) + 1
       WHERE empresa = @nempresa

exec Asp_capmas_Saca_faltas @nempresa,@ntiponom
exec Asp_capmas_Saca_incap  @nempresa,@ntiponom

--Borrar los registros de avisos_imss, si se crearon para el siguiente periodo
DELETE avisos_imss WHERE empresa = @nempresa
AND serial = 100 AND mov = 'IM'


GO


/*
 * Name          : dbo.asp_fill_Formumas_deducc
 * Project       : APSI Nomina
 * Description   : Marzo 21, 2013
 *                 Obtiene los conceptos de captura masiva de las deducciones, para el llenado de la tabla que se muestra en el programa
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Mayo 28 2013
 * Parameters    : empresa,tipo de nomina, y Fecha de fin de mes
*/
IF OBJECT_ID('dbo.asp_fill_Formumas_deducc') IS NOT NULL
    DROP PROCEDURE dbo.asp_fill_Formumas_deducc
GO


CREATE PROCEDURE dbo.asp_fill_Formumas_deducc
    @nempresa INT ,
    @ntiponom INT ,
    @dff DATETIME
AS
    EXEC asp_calc_dias_laborados @nempresa, @ntiponom, @dff

    --Tabla temporal para calcular los dias trabajados del periodo y los ausentismos
    IF OBJECT_ID('dbo.Formumas') IS NOT NULL
        BEGIN
            DROP TABLE dbo.Formumas
        END

    SELECT  a.empresa ,
            a.codigo ,
            MAX(a.sueldo) AS 'sueldo' ,
            MAX(a.saldiaint) AS 'saldiaint' ,
            MAX(a.tiponom) AS 'tiponom' ,
            MAX(a.clase) AS 'clase' ,
            MAX(a.centro) AS 'centro' ,
            MAX(a.horario) AS 'horario' ,
            SUM(a.dias_labor) AS 'dias' ,
            SUM(a.faltas) AS 'aus' ,
            SUM(a.incap) AS 'inc' ,
            MAX(a.Factor_int) AS 'factor' ,
            MAX(a.periodo) AS 'periodo' ,
            MAX(a.ayo_operacion) AS 'ayo_operacion'
    INTO    #tmp_captura_masiva
    FROM    dias_laborados AS a
    WHERE   a.empresa = @nempresa
    GROUP BY a.empresa ,
            a.codigo

    SELECT  a.empresa ,
            a.codigo ,
            RTRIM(c.ap_paterno) + ' ' + RTRIM(c.ap_materno) + ' '
            + RTRIM(c.nombre) AS 'nombre' ,
            d.sueldo ,
            d.saldiaint ,

            CASE WHEN a.num_conc in (108,109,110,111)
                 THEN a.dias
                 ELSE d.dias
            END AS dias ,

            CASE WHEN a.num_conc in (108,109,110,111)
                 THEN 0
                 ELSE d.inc
            END AS inc ,

            CASE WHEN a.num_conc in (108,109,110,111)
                 THEN 0
                 ELSE d.aus
            END AS aus ,

            --d.inc ,
            --d.aus ,

            a.varia1 ,
            a.varia2 ,
            a.varia3 ,
            a.varia4 ,
            a.num_conc ,
            a.descuento ,
            0.00 AS 'gravable' ,
            0.00 AS 'exento' ,
            0.00 AS 'varia_imss' ,
            d.centro ,
            d.clase ,
            d.tiponom ,
            b.formula ,
            b.ispt ,
            b.imss ,
            b.ptu ,
            b.mca_agui ,
            b.concepto ,
            a.siempre ,

            CASE WHEN a.num_conc in (108,109,110,111)
                 THEN dbo.DateToChar(a.fchinicio,'DD/MM/YYYY','/')
                 ELSE b.ispt_ng
            END AS ispt_ng ,

            CASE WHEN a.num_conc = 108
                 THEN a.justificar
                 ELSE b.imss_ni
            END AS imss_ni ,

            d.factor ,
            b.marca2 ,
            a.credito ,
            a.saldo ,
            a.plazo ,
            a.numeroinc,
            a.num_cr,
			ISNULL(a.dias,0) AS 'CadaCuantosPeriodos'
    INTO    dbo.Formumas
    FROM    deducciones AS a
            LEFT JOIN conceptos AS b ON ( a.num_conc = b.num_conc
                                          AND a.clase = b.clase
                                          AND a.centro = b.centro
                                          AND a.empresa = b.empresa
                                        )
            LEFT JOIN empleados AS c ON ( a.codigo = c.codigo
                                          AND a.empresa = c.empresa
                                        )
            LEFT JOIN #tmp_captura_masiva AS d ON ( a.codigo = d.codigo
                                                    AND a.empresa = d.empresa
                                                  )
            LEFT JOIN periodos AS e ON ( d.tiponom = e.tiponom
                                         AND d.empresa = e.empresa
                                         AND a.periodo = d.periodo
                                         AND a.ayo_operacion = d.ayo_operacion
                                       )
            LEFT JOIN llaves AS f ON ( a.codigo = f.codigo
                                       AND a.empresa = f.empresa
                                     )
    WHERE   a.masivo = 'T'
            AND a.empresa = @nempresa
            AND e.estatus = 'A'
            AND a.periodo = e.periodo
            AND a.ayo_operacion = e.ayo_operacion
            AND a.tiponom = f.tiponom
    ORDER BY a.codigo ,
            a.folio

    DROP TABLE #tmp_captura_masiva

GO


/*
 * Name          : dbo.asp_fill_Formumas_Percep
 * Project       : APSI Nomina
 * Description   : Marzo 21, 2013
 *                 Obtiene los conceptos de captura masiva de las percepciones, para el llenado de la tabla que se muestra en el programa
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Mayo 28 2013
 * Parameters    : empresa,tipo de nomina, y Fecha de fin de mes
*/
IF OBJECT_ID('dbo.asp_fill_Formumas_Percep') IS NOT NULL
    DROP PROCEDURE dbo.asp_fill_Formumas_Percep
GO


CREATE PROCEDURE dbo.asp_fill_Formumas_Percep
    @nempresa INT ,
    @ntiponom INT ,
    @dff DATETIME
AS
    EXEC asp_calc_dias_laborados @nempresa, @ntiponom, @dff

    --Tabla temporal para calcular los dias trabajados del periodo y los ausentismos
    IF OBJECT_ID('dbo.Formumas') IS NOT NULL
        BEGIN
            DROP TABLE dbo.Formumas
        END

    SELECT  a.empresa ,
            a.codigo ,
            MAX(a.sueldo) AS 'sueldo' ,
            MAX(a.saldiaint) AS 'saldiaint' ,
            MAX(a.tiponom) AS 'tiponom' ,
            MAX(a.clase) AS 'clase' ,
            MAX(a.centro) AS 'centro' ,
            MAX(a.horario) AS 'horario' ,
            SUM(a.dias_labor) AS 'dias' ,
            SUM(a.faltas) AS 'aus' ,
            SUM(a.incap) AS 'inc' ,
            MAX(a.Factor_int) AS 'factor' ,
            MAX(a.periodo) AS 'periodo' ,
            MAX(a.ayo_operacion) AS 'ayo_operacion'
    INTO    #tmp_captura_masiva
    FROM    dias_laborados AS a
    WHERE   a.empresa = @nempresa
    GROUP BY a.empresa ,
            a.codigo

    SELECT  a.empresa ,
            a.codigo ,
            RTRIM(c.ap_paterno) + ' ' + RTRIM(c.ap_materno) + ' '
            + RTRIM(c.nombre) AS 'nombre' ,
            d.sueldo ,
            d.saldiaint ,
            d.dias ,
            d.inc ,
            d.aus ,
            a.varia1 ,
            a.varia2 ,
            a.varia3 ,
            CASE WHEN a.num_conc in (10,11,12,13)
                 THEN a.Horas_Ex
                 ELSE a.varia4
            END AS varia4 ,
            a.num_conc ,
            a.nomina ,
            0.00 AS 'gravable' ,
            0.00 AS 'exento' ,
            a.varia_imss ,
            d.centro ,
            d.clase ,
            d.tiponom ,
            b.formula ,
            b.ispt ,
            b.imss ,
            b.ptu ,
            b.mca_agui ,
            b.concepto ,
            a.siempre ,
            b.ispt_ng ,
            b.imss_ni ,
            d.factor
--       a.periodo,
--       a.ayo_operacion
    INTO    dbo.Formumas
    FROM    percepciones AS a
            LEFT JOIN conceptos AS b ON ( a.num_conc = b.num_conc
                                          AND a.clase = b.clase
                                          AND a.centro = b.centro
                                          AND a.empresa = b.empresa
                                        )
            LEFT JOIN empleados AS c ON ( a.codigo = c.codigo
                                          AND a.empresa = c.empresa
                                        )
            LEFT JOIN #tmp_captura_masiva AS d ON ( a.codigo = d.codigo
                                                    AND a.empresa = d.empresa
                                                  )
            LEFT JOIN periodos AS e ON ( d.tiponom = e.tiponom
                                         AND d.empresa = e.empresa
                                         AND a.periodo = d.periodo
                                         AND a.ayo_operacion = d.ayo_operacion
                                       )
            LEFT JOIN llaves AS f ON ( a.codigo = f.codigo
                                       AND a.empresa = f.empresa
                                     )
    WHERE   a.masivo = 'T'
            AND a.empresa = @nempresa
            AND e.estatus = 'A'
            AND a.periodo = e.periodo
            AND a.ayo_operacion = e.ayo_operacion
            AND a.tiponom = f.tiponom
    ORDER BY a.codigo ,
            a.folio

    DROP TABLE #tmp_captura_masiva

GO


/*
Descripcion : Actualiza la longitud de los campos libres 7,8 y 9 del reporteador, para que soporte 9 digitos
Fecha : 11/09/2013
Autor : Mario Garcia
*/
UPDATE  dbo.gr_formas
SET     longitud = 9 ,
        tamori = '9'
WHERE   campo IN ( 'CAMPO_07', 'CAMPO_08', 'CAMPO_09' )
        AND longitud = 4
GO

/*
Descripcion : Amplia el campo de val_desc en la tabla cuotas_imss_bim, porque marcaba error el proceso almacenado asp_cuotas_bimestre
              y no calculaba la amortizacion para Infonavit, en el listado de creditos infonavit.
Fecha : 12/09/2013
Autor : Jorge Mtz
*/

ALTER TABLE dbo.cuotas_imss_bim ALTER COLUMN val_desc NUMERIC(15,6)

GO


/* Proceso almancenados para la reforma del 2014  (18/10/2013) */


/*
 * ER/Studio 8.0 SQL Code Generation
 * Project :      Art27LSS.DM1
 *
 * Date Created : Monday, September 23, 2013 17:15:20
 * Target DBMS : Microsoft SQL Server 2008
 */

/*
 * TABLE: Art27LSS
 */

IF OBJECT_ID('dbo.Art27LSS') IS NULL
    CREATE TABLE dbo.Art27LSS
        (
          empresa INT NOT NULL ,
          num_conc INT NOT NULL ,
          fraccion VARCHAR(100) NOT NULL ,
          baseVariables VARCHAR(50) NOT NULL ,
          inicia DATETIME NOT NULL ,
          termina DATETIME NOT NULL ,
          CONSTRAINT Art27Lss_PK1 PRIMARY KEY NONCLUSTERED
            ( empresa, num_conc )
        )
go



/*
Nombre      : Fun_F_LlenaArt27LSS
Descripcion : Actualizar el catalogo Art27Lss, con los conceptos que se van a considerar del kardex_anual, en su parte gravable
            : En funcion de los conceptos por dafault de NominaTiss-Sar
Autor       : Mario Garcia
Fecha       : 23/09/2013
Version     : 1.0 23/09/2013
*/

IF OBJECT_ID('dbo.Fun_F_LlenaArt27LSS') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_LlenaArt27LSS
GO

CREATE PROCEDURE dbo.Fun_F_LlenaArt27LSS @empresa AS INTEGER
AS
    IF NOT EXISTS ( SELECT  num_conc
                    FROM    dbo.Art27LSS
                    WHERE empresa = @empresa )
        BEGIN
            /*Fondo de Ahorro */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      27 , -- num_conc - int
                      'II' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )
            /* P.T.U. */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      15 , -- num_conc - int
                      'IV' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            /* Despensa Vales y Efectivo */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      31 , -- num_conc - int
                      'VI' , -- fraccion - varchar(100)
                      'Integrable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      18 , -- num_conc - int
                      'VI' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )


            /* Premio Puntualidad */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      37 , -- num_conc - int
                      'VII' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            /* Premio Asistencia */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      38 , -- num_conc - int
                      'VII' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            /* Tiempo extra Labores dias de descanso */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      10 , -- num_conc - int
                      'IX' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            /* Tiempo extra Dobles */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      11 , -- num_conc - int
                      'IX' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            /* Tiempo extra Dobles */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      12 , -- num_conc - int
                      'IX' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

            /* Tiempo extra Triples */
            INSERT  INTO dbo.Art27LSS
                    ( empresa ,
                      num_conc ,
                      fraccion ,
                      baseVariables ,
                      inicia ,
                      termina
                    )
            VALUES  ( @empresa , -- empresa - int
                      13 , -- num_conc - int
                      'IX' , -- fraccion - varchar(100)
                      'Gravable' , -- baseVariables - varchar(50)
                      '20140101' , -- inicia - datetime
                      '20991231'  -- termina - datetime
                    )

        END

GO




/*
Nombre      : dbo.Fun_I_AddArt27LSS
Descripcion : Actualizar el catalogo Art27Lss, agregar nuevo registro
Autor       : Mario Garcia
Fecha       : 16/10/2013
Version     : 1.0 16/10/2013
*/

IF OBJECT_ID('dbo.Fun_I_AddArt27LSS') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_AddArt27LSS
GO

CREATE PROCEDURE dbo.Fun_I_AddArt27LSS
    @empresa AS INTEGER ,
    @num_conc AS INTEGER ,
    @fraccion AS VARCHAR(100) ,
    @baseVariable AS VARCHAR(50) ,
    @inicia AS DATETIME ,
    @termina AS DATETIME
AS
    IF NOT EXISTS ( SELECT  num_conc
                    FROM    dbo.Art27LSS
                    WHERE   empresa = @empresa
                            AND num_conc = @num_conc )
        INSERT  INTO dbo.Art27LSS
                ( empresa ,
                  num_conc ,
                  fraccion ,
                  baseVariables ,
                  inicia ,
                  termina
                )
        VALUES  ( @empresa , -- empresa - int
                  @num_conc , -- num_conc - int
                  @fraccion , -- fraccion - varchar(100)
                  @baseVariable , -- baseVariables - varchar(50)
                  @inicia , -- inicia - datetime
                  @termina  -- termina - datetime
                )
    ELSE
        UPDATE  dbo.Art27LSS
        SET     fraccion = @fraccion ,
                baseVariables = @baseVariable ,
                inicia = @inicia ,
                termina = @termina
        WHERE   empresa = @empresa
                AND num_conc = @num_conc


GO


/*
Nombre      : dbo.Fun_I_DelArt27LSS
Descripcion : Actualizar el catalogo Art27Lss, eliminar un registro
Autor       : Mario Garcia
Fecha       : 16/10/2013
Version     : 1.0 16/10/2013
*/

IF OBJECT_ID('dbo.Fun_I_DelArt27LSS') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_DelArt27LSS
GO

CREATE PROCEDURE dbo.Fun_I_DelArt27LSS
    @empresa AS INTEGER ,
    @num_conc AS INTEGER
AS
    DELETE  dbo.Art27LSS
    WHERE   empresa = @empresa
            AND num_conc = @num_conc

GO



/**************************************************************************************************
 * Name          : asp_calcular_salario_variables_2014
 * Project       : APSI Nomina
 * Description   : Julio 30, 2013
 *                 Listado de validacion de variables considerando las partes gravables de los conceptos
 *                 con la nueva reforma que se propuso.
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia, Actualizado Jesus Frias
 * Creation date : Julio 30, 2013
 **************************************************************************************************/
IF OBJECT_ID('dbo.asp_calcular_salario_variables_2014') IS NOT NULL
    DROP PROCEDURE dbo.asp_calcular_salario_variables_2014

Go


CREATE PROCEDURE dbo.asp_calcular_salario_variables_2014
    @nEmpresa INT ,
    @nAyo INT ,
    @nMes1 INT ,
    @nMes2 INT ,
    @dFFMes1 DATETIME ,
    @dFFMes2 DATETIME ,
    @nSalDF DECIMAL(10, 2),
    @EsRadial AS CHAR(1),
    @EsCecytec AS CHAR(1)

AS
    PRINT @nMes1
    PRINT @nMes2
    PRINT @dFFmes1
    PRINT @dFfmes2


    SET NOCOUNT ON

    /*
    DECLARE @nEmpresa INT
    DECLARE @nAyo INT
    DECLARE @nMes1 INT
    DECLARE @nMes2 INT
    DECLARE @dFFMes1 DATETIME
    DECLARE @dFFMes2 DATETIME
    DECLARE @nSalDF DECIMAL(10, 2)
    DECLARE @EsRadial AS CHAR(1)
    DECLARE @EsCecytec AS CHAR(1)

    SET @nEmpresa = 14
    SET @nAyo = 2011
    SET @nMes1 = 1
    SET @nMes2 = 2
    SET @dFFMes1 = '20110131'
    SET @dFFMes2 = '20110228'
    SET @nSalDF = 50
    SET @EsRadial = 'S'
    SET @EsCecytec = 'N'
    */

    DECLARE @dFF AS DATETIME
    DECLARE @dFFSigMes AS DATETIME
    DECLARE @nExedeDesp AS DECIMAL(10, 2)
    DECLARE @nDias1 AS DECIMAL(5, 2)
    DECLARE @nDias2 AS DECIMAL(5, 2)
    DECLARE @nError AS INT
    DECLARE @cConTope AS VARCHAR(30)
    DECLARE @nSalMin AS DECIMAL(10, 2)
    DECLARE @cRegPat AS CHAR(10)
    DECLARE @fechaFinBimAnt AS DATETIME
    DECLARE @mesBimAnt AS INT
    DECLARE @ayoBimAnt AS INT
    DECLARE @mesInicialNomina AS CHAR(5)
    DECLARE @mesFinalNomina AS CHAR(5)
    DECLARE @diasBaseDivisor AS VARCHAR(30)

    DECLARE @tba_percepciones AS TABLE (empresa INT,
                                        codigo NUMERIC(8,0),
                                        num_conc INT,
                                        variable FLOAT,
                                        varia_imss FLOAT,
                                        nomina FLOAT,
                                        origen VARCHAR(20),
                                        periodo INT,
                                        ayo_operacion INT)

    SET @nDias1 = DAY(@dFFMes1)
    SET @nDias2 = DAY(@dFFMes2)
    SET @nError = 0

    SET @fechaFinBimAnt = dbo.NvaFecha(01,MONTH(@dFFmes1),YEAR(@dFfMes1)) - 1
    SET @mesBimAnt = MONTH(@fechaFinBimAnt)
    SET @ayoBimAnt = YEAR(@fechaFinBimAnt)

    SET @cRegPat = ( SELECT Registro_Patronal
                     FROM   Empresas
                     WHERE  Empresa = @nEmpresa
                   )

    SET @diasBaseDivisor = ( SELECT DivisorPercepcionesVariables
                             FROM   Empresas
                             WHERE  Empresa = @nEmpresa
                           )

   SET @mesInicialNomina = CASE WHEN @nMes1 = 01 THEN 'ENE'
                                WHEN @nMes1 = 02 THEN 'FEB'
                                WHEN @nMes1 = 03 THEN 'MAR'
                                WHEN @nMes1 = 04 THEN 'ABR'
                                WHEN @nMes1 = 05 THEN 'MAY'
                                WHEN @nMes1 = 06 THEN 'JUN'
                                WHEN @nMes1 = 07 THEN 'JUL'
                                WHEN @nMes1 = 08 THEN 'AGO'
                                WHEN @nMes1 = 09 THEN 'SEP'
                                WHEN @nMes1 = 10 THEN 'OCT'
                                WHEN @nMes1 = 11 THEN 'NOV'
                                ELSE 'DIC'
                           END + RIGHT(CONVERT(CHAR(4), @nAyo), 2)

   SET @mesFinalNomina = CASE WHEN @nMes2 = 01 THEN 'ENE'
                              WHEN @nMes2 = 02 THEN 'FEB'
                              WHEN @nMes2 = 03 THEN 'MAR'
                              WHEN @nMes2 = 04 THEN 'ABR'
                              WHEN @nMes2 = 05 THEN 'MAY'
                              WHEN @nMes2 = 06 THEN 'JUN'
                              WHEN @nMes2 = 07 THEN 'JUL'
                              WHEN @nMes2 = 08 THEN 'AGO'
                              WHEN @nMes2 = 09 THEN 'SEP'
                              WHEN @nMes2 = 10 THEN 'OCT'
                              WHEN @nMes2 = 11 THEN 'NOV'
                              ELSE 'DIC'
                         END + RIGHT(CONVERT(CHAR(4), @nAyo), 2)

 PRINT @mesInicialNomina
 PRINT @mesFinalNomina
 PRINT @diasBaseDivisor


--Actualiza los dias del primer mes del bimestre
    EXEC asp_ds @nEmpresa, 0, @nAyo, @nMes1, @dFFMes1
    EXEC asp_ds_aus @nEmpresa, 0, @nAyo, @nMes1, @nDias1
    EXEC asp_ds_inc @nEmpresa, 0, @nAyo, @nMes1

--Actualiza los dias del segundo mes del bimestre
    EXEC asp_ds @nEmpresa, 0, @nAyo, @nMes2, @dFFMes2
    EXEC asp_ds_aus @nEmpresa, 0, @nAyo, @nMes2, @nDias2
    EXEC asp_ds_inc @nEmpresa, 0, @nAyo, @nMes2


--Variables de calculo para los exedentes y la fecha de antiguedad
    SET @dFF = @dFFMes2
    SET @nExedeDesp = ROUND(@nSalDf * 0.40, 2)

-- Obtiene la fecha final del siguiente mes de la fecha final del bimestre para calcular la antiguedad, para integracion
    EXEC ASP_UltimoDiaMesProximo @dFF, @dFFSigMes OUTPUT
    SET @dFfSigMes = CONVERT(VARCHAR(8), @dFFsigMes, 112)
--Print @dFFSigMes

    --Llena la tabla Art27LSS, por si no exiten registros, para los que se van a considerar en su parte gravable.
    EXECUTE dbo.Fun_F_LlenaArt27LSS @nempresa


--select @dFfSigMes

   /*Considerar los conceptos de percepciones a excepcion de la tabla Art27LSS, que se van a considerar de kardex_anual */
   INSERT   INTO @tba_percepciones
            SELECT  empresa ,
                    codigo ,
                    num_conc,
                    variable ,
                    varia_imss ,
                    nomina ,
                    'percepciones',
                    periodo,
                    ayo_operacion
            FROM    dbo.percepciones
            WHERE   ( ( mes_operacion = @nMes1
                        OR mes_operacion = @nMes2
                      )
                      AND ayo_operacion = @nAyo
                    )
                    AND empresa = @nEmpresa
                    AND num_conc NOT IN ( SELECT num_conc
                                     FROM   dbo.Art27LSS
                                     WHERE  empresa = @nEmpresa )

   /*Considerar los conceptos de kardex_anual que existan en la tabla Art27LSS */
   INSERT   INTO @tba_percepciones
            SELECT  ka.empresa ,
                    ka.codigo ,
                    ka.num_conc,
                    CASE WHEN art.baseVariables = 'Gravable' THEN ka.igravable
                         ELSE ka.variaimss
                    END AS 'variable' ,
                    CASE WHEN art.baseVariables = 'Gravable' THEN ka.igravable
                         ELSE ka.variaimss
                    END AS 'varia_imss' ,
                    ka.importe AS 'nomina' ,
                    'kardex_anual',
                    periodo,
                    ayo_operacion
            FROM    dbo.kardex_anual AS ka
                    INNER JOIN dbo.Art27LSS AS art ON ka.empresa = art.empresa
                                                      AND ka.num_conc = art.num_conc
            WHERE   ( ( ka.mes = @mesInicialNomina
                        OR ka.mes = @mesFinalNomina
                      )
                      AND ka.ayo_operacion = @nAyo
                    )
                    AND ka.empresa = @nEmpresa
                    AND ka.tpago_desc = 'P'

/*
     SELECT * FROM @tba_percepciones
     ORDER BY codigo,num_conc


     SELECT * FROM @tba_percepciones
     WHERE origen = 'percepciones'
     ORDER BY codigo,num_conc

     SELECT * FROM @tba_percepciones
     WHERE origen = 'kardex_anual'
     ORDER BY codigo,num_conc
*/


--Buscar la marca para ver si se topa la despensa (03/07/2009 Mario)
    SELECT  @cConTope = variable2
    FROM    conceptos
    WHERE   num_conc = 31
            AND empresa = @nEmpresa

    SELECT  @nSalMin = CASE WHEN e.zona_geografica = 'A' THEN s.zona_a
                            WHEN e.zona_geografica = 'B' THEN s.zona_b
                            ELSE s.zona_c
                       END
    FROM    salarios_minimos AS s
            INNER JOIN empresas AS e ON ( e.empresa = @nEmpresa )
    WHERE   YEAR(s.fecha_ini) = @nAyo


    -- Buscar las fechas de antiguedad reales de acuerdo al mes del listado
    -- sobre todo para meses anteriores y empleados que tienen B y RI
    --DECLARE @tAntigua TABLE (Codigo INTEGER, FchAntigua DATETIME)

    IF OBJECT_ID('#Tmp_Antigua') IS NOT NULL
      DROP TABLE #Tmp_Antigua

    --INSERT INTO @tAntigua
    SELECT Codigo,
           FchAntigua
    INTO #Tmp_Antigua
    FROM Empleados
    WHERE Empresa = @nEmpresa

    IF NOT EXISTS (SELECT Empresa FROM Empresas WHERE Empresa = @nEmpresa AND Mes_Operacion = @nMes2 AND Ayo_Operacion = @nAyo)
      UPDATE tAntigua
      SET FchAntigua = ISNULL( (SELECT TOP 1 Campo_07 FROM Avisos_Imss WHERE Codigo = tAntigua.Codigo AND Mov = 'B' AND Fch_Mov >= dbo.NvaFecha(1,@nMes1,@nAyo) AND Empresa = @nEmpresa ORDER BY fch_mov), Empleados.FchAntigua)
      FROM #Tmp_Antigua AS tAntigua
      INNER JOIN Empleados ON Empleados.Codigo = tAntigua.Codigo And Empleados.Empresa = @nEmpresa
    --

--Borra la tabla tmp_vars, para llenarla con el calculo de los variables
    DELETE  tmp_vars
    WHERE   empresa = @nEmpresa

    IF @@ERROR = 0
        BEGIN
	--Insert en tmp_vars, los dias del bimestre, el ultimo sueldo y los ausentismos
            INSERT  INTO tmp_vars
                    ( empresa ,
                      codigo ,
                      diastrba ,
                      incapba ,
                      ausenba ,
                      cuotadia ,
                      saldiaint ,
                      baja ,
                      fecha ,
                      dia ,
                      mes ,
                      ano ,
                      variable ,
                      varia_imss ,
                      nomina
                    )
                    SELECT  a.empresa ,
                            a.codigo ,
                            SUM(a.diastr) AS Diastr ,
                            SUM(a.incap) AS incap ,
                            SUM(a.ausen) AS ausen ,
--	       max(b.sueldo) AS sueldo,
--	       max(b.saldiaint) AS saldiaint,
                            ( SELECT TOP 1
                                        sueldo
                              FROM      avisos_imss
                              WHERE     avisos_imss.empresa = @nempresa
                                        AND avisos_imss.codigo = a.codigo
                                        AND ((SUBSTRING(LTRIM(avisos_imss.ayo_operacion
                                                            + 10000), 2, 4)
                                        + SUBSTRING(LTRIM(avisos_imss.mes_operacion
                                                          + 100), 2, 2) BETWEEN SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes1
                                                              + 100), 2, 2)
                                                              AND
                                                              SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes2
                                                              + 100), 2, 2)) OR (@dFF + 1 = dbo.NvaFecha(1,1,YEAR(@dFF)+1) AND fch_mov = @dFF+1))
                                        AND avisos_imss.mov <> 'B'
                              ORDER BY  fch_mov DESC ,
                                        serial DESC
                            ) AS 'sueldo' ,
                            ( SELECT TOP 1
                                        saldiaint
                              FROM      avisos_imss
                              WHERE     avisos_imss.empresa = @nempresa
                                        AND avisos_imss.codigo = a.codigo
                                        AND ((SUBSTRING(LTRIM(avisos_imss.ayo_operacion
                                                            + 10000), 2, 4)
                                        + SUBSTRING(LTRIM(avisos_imss.mes_operacion
                                                          + 100), 2, 2) BETWEEN SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes1
                                                              + 100), 2, 2)
                                                              AND
                                                              SUBSTRING(LTRIM(@nayo
                                                              + 10000), 2, 4)
                                                              + SUBSTRING(LTRIM(@nmes2
                                                              + 100), 2, 2)) OR (@dFF + 1 = dbo.NvaFecha(1,1,YEAR(@dFF)+1) AND fch_mov = @dFF+1))
                                        AND avisos_imss.mov <> 'B'
                              ORDER BY  fch_mov DESC ,
                                        serial DESC
                            ) AS 'saldiaint' ,

                            CASE WHEN ( SELECT TOP 1 Mov
                                        FROM Avisos_Imss
                                        WHERE Avisos_Imss.Codigo = a.Codigo AND
                                              Avisos_Imss.Mes_Operacion IN (@nMes1, @nMes2) AND
                                              Avisos_Imss.Ayo_Operacion = @nAyo AND
                                              Avisos_Imss.Empresa = @nEmpresa
                                        ORDER BY fch_mov DESC, Serial DESC ) = 'B'
                                 THEN 'B'
                                 ELSE ''
                            END AS ultmov,

                            /*
                            CASE MAX(b.ultmov)
                              WHEN 'B' THEN MAX(b.ultmov)
                              ELSE ''
                            END AS ultmov ,
                            */

                            @dFF + 1 AS fecha ,
                            RIGHT('00' + RTRIM(CONVERT(CHAR(2), DATEPART(day,
                                                              @dFF + 1))), 2) AS dia ,
                            RIGHT('00' + RTRIM(CONVERT(CHAR(2), DATEPART(month,
                                                              @dFF + 1))), 2) AS mes ,
                            RIGHT(DATEPART(yy, @dFF + 1), 2) AS ano ,
                            0 AS variable ,
                            0 AS varia_imss ,
                            0 AS nomina
                    FROM    avisos_imss AS a
                            INNER JOIN empleados AS b ON ( a.codigo = b.Codigo
                                                           AND a.empresa = b.empresa
                                                         )
                    WHERE   ( ( a.mes_operacion = @nMes1
                                OR a.mes_operacion = @nMes2
                              )
                              AND a.ayo_operacion = @nAyo
                            )
                            AND a.empresa = @nEmpresa

                            -- Si se envia un listado de validacion de meses anteriores, no salen
                            -- los empleados que tienen BAJA y REINGRESO...porque empleados guarda solo
                            -- la fecha del ultimo reingreso y no se cumple la condicion
                            -- P.E. Listado de validacion de Mayo y Junio del 2009
                            --      Un empleado viene del 2008 pero tuvo B y RI en Febrero del 2010
                            --AND b.fchalta <= @dFFMes2

                            AND EXISTS (SELECT TOP 1 Codigo FROM Avisos_Imss WHERE Codigo = b.codigo AND Mes_Operacion IN (@nMes1,@nMes2) AND Ayo_Operacion = @nAyo AND Empresa = @nEmpresa)


                            AND
              --b.activo = 'S' AND
                            b.borrado = 'N'  --AND
             -- (b.ultmov <> 'B' OR b.ultfchmov > @dFF)
                    GROUP BY a.empresa ,
                            a.codigo

            IF @@ERROR = 0
                BEGIN
		-- Suma los importes variables, del bimestre para actualizar la tabla TMP_VARS
                    SELECT  a.empresa ,
                            a.codigo ,
                            SUM(b.variable) AS variable ,
                            SUM(b.varia_imss) AS varia_imss ,
                            SUM(b.nomina) AS nomina,
                            CONVERT(NUMERIC(12,2),0) AS contras
                    INTO    #tmp_sum_variable
                    FROM    dbo.tmp_vars AS a
                            INNER JOIN @tba_percepciones AS b ON ( a.codigo = b.codigo
                                                              AND a.empresa = b.empresa
                                                            )
                    WHERE   a.empresa = @nEmpresa
                    GROUP BY a.empresa ,
                            a.codigo

        --Actualiza la tabla temporal con las contras para Radial y Cecytec
               IF @EsRadial = 'S'
                  UPDATE    tsm
                  SET       tsm.contras = ISNULL(d.descuento,0)
                  FROM      #tmp_sum_variable AS tsm
                  INNER JOIN (SELECT dbo.deducciones.codigo,
                                     SUM(dbo.deducciones.descuento) as descuento
                              FROM dbo.deducciones
                              WHERE dbo.deducciones.mes_operacion IN (@nMes1,@nMes2) AND
                                    dbo.deducciones.ayo_operacion = @nAyo AND
                                    dbo.deducciones.num_conc > 1000 AND
                                    EXISTS (SELECT TOP 1 Imss FROM dbo.conceptos WHERE dbo.conceptos.num_conc = dbo.deducciones.num_conc-1000 AND dbo.conceptos.imss = 'S' AND dbo.conceptos.empresa = @nEmpresa) AND
                                    dbo.deducciones.empresa = @nEmpresa
                              GROUP BY dbo.deducciones.Codigo) AS d ON d.codigo = tsm.Codigo

               IF @EsCecytec = 'S'
                  UPDATE    tsm
                  SET       tsm.contras = ISNULL(d.descuento,0)
                  FROM      #tmp_sum_variable AS tsm
                  INNER JOIN (SELECT dbo.deducciones.codigo,
                                     SUM(dbo.deducciones.descuento) as descuento
                              FROM dbo.deducciones
                              WHERE dbo.deducciones.num_conc = 145 AND
                                    dbo.deducciones.mes_operacion IN (@nMes1,@nMes2) AND
                                    dbo.deducciones.ayo_operacion = @nAyo AND
                                    dbo.deducciones.num_conc > 1000 AND
                                    dbo.deducciones.empresa = @nEmpresa
                              GROUP BY dbo.deducciones.Codigo) AS d ON d.codigo = tsm.Codigo


		--Actualiza la tabla TMP_VARS, con la sumatoria de los importes variables del bimestre
                    UPDATE  tmp_vars
                    SET     variable = ISNULL(b.variable, 0) - ISNULL(b.contras,0),
                            varia_imss = ISNULL(b.varia_imss, 0) - ISNULL(b.contras,0) ,
                            nomina = ISNULL(b.nomina, 0)- ISNULL(b.contras,0)
                    FROM    tmp_vars AS a
                            INNER JOIN #tmp_sum_variable AS b ON ( a.codigo = b.codigo
                                                              AND a.empresa = b.empresa
                                                              )

                    DROP TABLE #tmp_sum_variable

       --Actualiza los dias laborados, en funcion de la marca si, se consideran los periodos cerrados de nomina.
                    IF @diasBaseDivisor = 'DIASNOMINA'
                        BEGIN

                            DECLARE @tDiasNomina TABLE
                                (
                                  empresa INT ,
                                  codigo NUMERIC(8, 0) ,
                                  diastr_nom FLOAT
                                )


                            INSERT  INTO @tDiasNomina
                                    SELECT  empresa ,
                                            codigo ,
                                            SUM(diastr_nom) AS 'diastr_nom'
                                    FROM    dbo.nomina1_anual
                                    WHERE   empresa = @nEmpresa
                                            AND ( mes = @mesInicialNomina
                                                  OR mes = @mesFinalNomina
                                                )
                                    GROUP BY empresa ,
                                            codigo
                                    ORDER BY empresa ,
                                            codigo

                            UPDATE  tv
                            SET     tv.diastrba = isnull(na.diastr_nom,1) ,
                                    tv.ausenba = 0 ,
                                    tv.incapba = 0
                            FROM    tmp_vars AS tv
                                    LEFT JOIN @tDiasNomina AS na ON ( tv.codigo = na.codigo
                                                              AND tv.empresa = na.empresa
                                                              )
                            WHERE   tv.empresa = @nEmpresa


                            UPDATE  tmp_vars
                            SET     diastrba = 1
                            WHERE   diastrba <= 0
                                    AND empresa = @nEmpresa

                        END

		--Comienza el calculo de salario diario integrado, para actualizar tmp_vars
		--Extrae los campos de las tablas de integracion para determinar el salario variable
                    SELECT  a.empresa ,
                            a.codigo ,
                            a.cuotadia ,
                            b.fchantigua ,
                            c.clase ,
                            CASE WHEN DATEDIFF(yy, tAntigua.fchantigua, @dffsigmes)
                                      + CASE WHEN YEAR(tAntigua.fchantigua) <= YEAR(@dffsigmes)
                                                  AND MONTH(tAntigua.fchantigua) <= MONTH(@dffsigmes)
                                                  --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                  AND (DAY(tAntigua.fchantigua) <= DAY(@dffsigmes) OR (DAY(tAntigua.fchantigua) = 31 AND DAY(@dffsigmes) = 30))
                                             THEN 1
                                             ELSE 0
                                        END > 45 THEN 45
                                 ELSE DATEDIFF(yy, tAntigua.fchantigua, @dffsigmes)
                                      + CASE WHEN YEAR(tAntigua.fchantigua) <= YEAR(@dffsigmes)
                                                  AND MONTH(tAntigua.fchantigua) <= MONTH(@dffsigmes)
                                                  --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                  AND (DAY(tAntigua.fchantigua) <= DAY(@dffsigmes) OR (DAY(tAntigua.fchantigua) = 31 AND DAY(@dffsigmes) = 30))
                                             THEN 1
                                             ELSE 0
                                        END
                            END AS ayos ,
		       --d.factor,
                            ROUND(1 + ( d.aguinaldo / 365 ) + -- aguinaldo
                          ( ( d.dias_vac / 365 ) * ( d.prima_vac / 100 ) )
                                  + -- prima vacacional
                          ( d.pmavacdias / 365 ) + -- dias de prima vac.
                          ( d.dias_ayo / 365 ) + -- dias x ao
                          ( d.porc_ayo / 100 ) + -- % x ao
                          ( d.porc_mes / 100 ) + -- % x mes
                          ( d.porc_dia / 100 ) + -- % x dia
                          ( d.pmo1ayopor / 100 ) + -- % premio anual 1
                          ( d.pmo2ayopor / 100 ) + -- % premio anual 2
                          ( d.dias_mes / 030.4167 )
                                  + -- dias x mes

                          -- si el fdo. de ahorro del Patron, es mayor al del Trabajador
                          -- integrarlo todo...sumar el % al factor y si tiene $ fijo ponerlo aparte
                          CASE WHEN @cRegPat <> 'C121910510'
                               THEN CASE WHEN ISNULL(ROUND(a.cuotadia
                                                           * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                     + d.fdoahopati, 0) > ISNULL(ROUND(a.cuotadia
                                                              * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                              + d.fdoahotrai,
                                                              0)
                                         THEN d.fdoahopatp / 100
                                         ELSE 0
                                    END
                               ELSE CASE WHEN d.fdoahopatp > d.fdoahotrap
                                              AND d.fdoahopati = 0
                                              AND d.fdoahotrai = 0
                                         THEN ( d.fdoahopatp / 100 )
                                              - ( d.fdoahotrap / 100 )
                                         ELSE 0
                                    END
                          END, 4) AS factor ,

                          --CASE WHEN d.fdoahopatp > d.fdoahotrap AND d.fdoahopati = 0 AND d.fdoahotrai = 0 THEN (d.fdoahopatp / 100) - CASE WHEN @cRegPat = 'C121910510' THEN (d.fdoahotrap / 100) ELSE 0 END  ELSE 0 END ,4) as factor, -- fdo de ahorro, solo si el % del patron es mayor al del empleado y no tiene importes ni patron ni trabajador

		--       d.despensa,
		--       d.despensaim,
		--       d.imp_ayo,
		--       d.imp_mes,
		--       d.imp_dia,
		--       d.fdoahopatp,
		--       d.fdoahopati,
		--       d.fdoahotrap,
		--       d.fdoahotrai,
		--       d.pmo1ayoimp,
		--       d.pmo2ayoimp,
                            CASE WHEN ROUND(( ( a.cuotadia * ( d.despensa
                                                              / 100 ) )
                                              + d.despensaim ), 2) > @nExedeDesp
                                 THEN ROUND(( ( a.cuotadia * ( d.despensa
                                                              / 100 ) )
                                              + d.despensaim ), 2)
                                      - @nExedeDesp
                                 ELSE 0
                            END AS exedente_desp ,
                            ISNULL(( ROUND(d.imp_ayo / 365, 2)
                                     + ROUND(d.pmo1ayoimp / 365, 2)
                                     + ROUND(d.pmo2ayoimp / 365, 2)
                                     + ROUND(d.Imp_mes / 30.4167, 2)
                                     + d.imp_dia ), 0) AS importes_fijos ,

               -- Si el fdo. de ahorro del Patron es mayor al del Trabajador
               -- si tiene $ fijo ponerlo aparte porque no va en el factor
                            CASE WHEN @cRegPat <> 'C121910510'
                                 THEN CASE WHEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                       + d.fdoahopati, 0) > ISNULL(ROUND(a.cuotadia
                                                              * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                              + d.fdoahotrai,
                                                              0)
                                           THEN d.fdoahopati
                                           ELSE 0
                                      END
                                 ELSE CASE WHEN d.fdoahopatp = d.fdoahotrap
                                                OR d.fdoahopati > 0
                                                OR d.fdoahotrai > 0
                                           THEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                       + d.fdoahopati, 0)
                                           ELSE 0
                                      END
                            END AS FdoAhoPat ,
                            CASE WHEN @cRegPat <> 'C121910510'
                                 THEN CASE WHEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahopatp
                                                              / 100 ), 2)
                                                       + d.fdoahopati, 0) > ISNULL(ROUND(a.cuotadia
                                                              * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                              + d.fdoahotrai,
                                                              0)
                                           THEN d.fdoahotrai
                                           ELSE 0
                                      END
                                 ELSE CASE WHEN d.fdoahopatp = d.fdoahotrap
                                                OR d.fdoahopati > 0
                                                OR d.fdoahotrai > 0
                                           THEN ISNULL(ROUND(a.cuotadia
                                                             * ( d.fdoahotrap
                                                              / 100 ), 2)
                                                       + d.fdoahotrai, 0)
                                           ELSE 0
                                      END
                            END AS FdoAhoTra ,
                            CASE WHEN a.varia_Imss > 0
                                 THEN ROUND(a.varia_imss
                                            / CASE WHEN ( a.diastrba
                                                          - ( a.incapba
                                                              + a.ausenba ) ) = 0
                                                   THEN 1
                                                   ELSE ( a.diastrba
                                                          - ( a.incapba
                                                              + a.ausenba ) )
                                              END, 2)
                                 ELSE 0
                            END AS ParteVar ,
                            --b.varia_imss AS varia_ant
                            ISNULL(pv.parte_variable,0) AS 'varia_ant'
                    INTO    #tmp_calc_variable
                    FROM    tmp_vars AS a
                            INNER JOIN empleados AS b ON ( a.codigo = b.codigo
                                                           AND a.empresa = b.empresa
                                                         )
                            INNER JOIN llaves AS c ON ( a.codigo = c.codigo
                                                        AND a.empresa = c.empresa
                                                      )

                            INNER JOIN #Tmp_Antigua AS tAntigua ON tAntigua.Codigo = a.codigo

                            INNER JOIN tablas_int AS d ON ( a.empresa = d.empresa
                                                            AND c.clase = d.clase
                                                            AND CASE
                                                              WHEN DATEDIFF(yy,
                                                              tAntigua.fchantigua,
                                                              @dffsigmes)
                                                              + CASE
                                                              WHEN YEAR(tAntigua.fchantigua) <= YEAR(@dffsigmes)
                                                              AND MONTH(tAntigua.fchantigua) <= MONTH(@dffsigmes)
                                                              AND (DAY(tAntigua.fchantigua) <= DAY(@dffsigmes) OR (DAY(tAntigua.fchantigua) = 31 AND DAY(@dffsigmes) = 30))
                                                              --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                              THEN 1
                                                              ELSE 0
                                                              END > 45 THEN 45
                                                              ELSE DATEDIFF(yy,
                                                              tAntigua.fchantigua,
                                                              @dffsigmes)
                                                              + CASE
                                                              WHEN YEAR(tAntigua.fchantigua) <= YEAR(@dffsigmes)
                                                              AND MONTH(tAntigua.fchantigua) <= MONTH(@dffsigmes)
                                                              AND (DAY(tAntigua.fchantigua) <= DAY(@dffsigmes) OR (DAY(tAntigua.fchantigua) = 31 AND DAY(@dffsigmes) = 30))
                                                              --AND DAY(b.fchantigua) <= DAY(@dffsigmes)
                                                              THEN 1
                                                              ELSE 0
                                                              END
                                                              END = CAST(d.ayos AS INT)
                                                          )
                            LEFT JOIN partes_variables AS pv ON (a.codigo = pv.codigo AND a.empresa = pv.empresa AND pv.mes_operacion = @mesBimAnt AND pv.ayo_operacion = @ayoBimAnt)

                    WHERE   d.mes_operacion = @nMes2
                            AND d.ayo_operacion = @nAyo
                    ORDER BY a.codigo

-- select * from tmp_calc_variable where codigo = 551

                -- Asi estaba, pero las tablas de integracion del @nmes2 aun no existen
                -- por ejemplo: estoy en Junio, para calcular las variables del 1o. de Julio...pero las tablas de Julio no existen
		--WHERE d.mes_operacion = @nMes2 AND d.ayo_operacion = @nAyo

        --Si la despensa esta topada ajustar el monto, del excedente, apartir del 31/07/2009
                    IF @cConTope = 'CONTOPE'
                        AND @dFfMes1 >= '20090731'
                        UPDATE  #tmp_calc_variable
                        SET     exedente_desp = CASE WHEN exedente_desp > ( @nSalmin
                                                              - ( @nSalDf
                                                              * 0.40 ) )
                                                     THEN ( @nSalmin
                                                            - ( @nSalDf * 0.40 ) )
                                                     ELSE exedente_desp
                                                END



		--Select * from #tmp_calc_variable
		--Actualiza el salario base de cotizacion del siguiente bimestre, con el calculo de variables.
                    UPDATE  tmp_vars
                    SET     sdi_nvo = ROUND(( a.cuotadia * a.factor )
                                            + ISNULL(a.exedente_desp, 0)
                                            + ISNULL(a.importes_fijos, 0)
                                            + ( CASE WHEN ISNULL(a.FdoAhoPat,
                                                              0) > ISNULL(a.FdoAhoTra,
                                                              0)
                                                     THEN ISNULL(a.FdoAhoPat,
                                                              0)
                                                          - CASE
                                                              WHEN @cRegPat = 'C121910510'
                                                              THEN a.FdoAhoTra
                                                              ELSE 0
                                                            END
                                                     ELSE 0
                                                END ) + ISNULL(a.ParteVar, 0),
                                            2) , -- EL REGISTRO PATRONAL ES DEL ITESO, QUE SOLO INTEGRA LA DIFERENCIA
                            factor = a.factor ,
                            excedentes = a.exedente_desp ,
                            otrosfijos = a.importes_fijos
                            + ( CASE WHEN a.FdoAhoPat > a.FdoAhoTra
                                     THEN a.FdoAhoPat
                                          - CASE WHEN @cRegPat = 'C121910510'
                                                 THEN a.FdoAhoTra
                                                 ELSE 0
                                            END
                                     ELSE 0
                                END ) ,
                            observa = ( CASE WHEN ( baja <> 'B'
                                                    AND varia_imss > 0
                                                  ) THEN '1' --Cuando tienen percepciones variables y no son baja
                                             WHEN ( baja = 'B'
                                                    AND Varia_imss > 0
                                                  ) THEN '2' --Cuando tienen percepciones variables y es baja
                                             WHEN ( baja <> 'B'
                                                    AND varia_imss = 0
                                                    AND a.varia_ant > 0
                                                  ) THEN '3' --Cuando no tienen percepciones variables en el bimestre, pero tuvo el bimestre anterior  y no es baja
                                             WHEN ( variable > 0
                                                    AND varia_imss = 0
                                                  ) THEN '4' --Cuando tienen percepciones que NO integran, solo informativo
                                             ELSE '5' --Cualquier otro caso que no este contemplado para analizarlo
                                        END )
                    FROM    tmp_vars AS b
                            INNER JOIN #tmp_calc_variable AS a ON ( a.empresa = b.empresa
                                                              AND a.codigo = b.codigo
                                                              )

                          --select * from tmp_vars

                -- Si el salario variable es menor al minimo o cero registrar el minimo integrado por el factor del empleado
                -- 07/11/2013 Mario, reportado por Luz Maria en nomina no Fiscal
                   UPDATE   tv
                   SET      tv.sdi_nvo = @nSalMin * tv.factor
                   FROM     dbo.tmp_vars AS tv
                            INNER JOIN dbo.empleados AS e ON tv.empresa = e.empresa
                                                             AND tv.codigo = e.codigo
                   WHERE    tv.empresa = @nEmpresa
                            AND tv.sdi_nvo <= @nSalMin
                            AND e.jornada < 6


                    DROP TABLE #tmp_calc_variable

                --Borra los registros que no tiene variable, ni modificacion en salario diario integrado o
                --los que la nueva MS es igual al SBC anterior
                    DELETE  tmp_vars
                    WHERE   empresa = @nEmpresa
                            AND nomina = 0
                            AND variable = 0
                            AND ABS(saldiaint - sdi_nvo) <= 0.03

                END
            ELSE
                BEGIN
             --Existe un error en la insercion de TMP_VARS
                    RETURN(2)
                END
        END
    ELSE
        BEGIN
       --Existe un error en el borrado de la tabla tmp_vars
            RETURN(1)
        END
--Select * from tmp_vars


    SET NOCOUNT OFF
GO


/**************************************************************************************************
 * Name          : Fun_F_ListadoDeValidacionVariables_2014
 * Project       : APSI Nomina
 * Description   : Enero 18, 2012
 *                 Prepara la informacion para la impresion del listado de validacion de variables
 *                 para fastreports tabla tmp_vars, con la reforma al Art. 27 Lss, donde se consideran algunos
 *                 conceptos de la tabla kardex_anual, en su parte gravable, para integrarlos.
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 25, 2013
 * Parameters    : Empresa
 *                 mes inicial, cuando el reporte es bimestral se regista el primer del bimestre
 *                 mes final, cuando el reporte es bimestral se registra el segundo mes del bimestre
 *                 Ao de operacion
 *                 Tipo de reporte : 1 = Genera la informacion de los empleados con todos los conceptos
 *                                       registrados (detallado de conceptos integrables y no integrables)
 *                                   2 = Detallado de conceptos solo los integrables
 *                                   3 = Reporte solo de total general por empleado
 *                                   4 = Total de conceptos registrados en los meses seleccionados
 *                                   5 = Resumen de fechas de pago en los meses seleccionados
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_ListadoDeValidacionVariables_2014') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_ListadoDeValidacionVariables_2014
GO


CREATE PROCEDURE dbo.Fun_F_ListadoDeValidacionVariables_2014
    (
      @nEmpresa INTEGER ,
      @nMesIni INT ,
      @nMesFin INT ,
      @nAyoOpe INT ,
      @nTipoReporte INT ,
      @cSoloRadial CHAR(1) ,
      @cCecytec CHAR(1),
      @dFf DATETIME
    )
AS
    SET NOCOUNT ON


    DECLARE @cTituloMeses AS VARCHAR(50)
    DECLARE @cNombreMesIni AS VARCHAR(20)
    DECLARE @cNombreMesFin AS VARCHAR(20)
    DECLARE @nSalDf AS FLOAT
    DECLARE @mesInicialNomina AS CHAR(5)
    DECLARE @mesFinalNomina AS CHAR(5)
    DECLARE @diasBaseDivisor AS VARCHAR(30)


    DECLARE @tListadoVariables TABLE
        (
          observa CHAR(2) ,
          codigo NUMERIC(8,0) ,
          nombre VARCHAR(70) ,
          cuotadia FLOAT,
          factor DECIMAL(10,4),
          varia_imss_total FLOAT,
          diastrba FLOAT,
          ausenba FLOAT,
          incapba FLOAT,
          parteVariableTotal FLOAT,
          sdi_nvo FLOAT,
          folio INTEGER,
          num_conc INTEGER,
          concepto VARCHAR(70),
          varia_imss FLOAT,
          parteVariableConcepto FLOAT,
          fch_real DATETIME,
          titulo VARCHAR(400),
          observaEmpleado VARCHAR(20),
          dia INT,
          mes INT,
          ano INT,
          nomina FLOAT,
          FactorAgi FLOAT

        )

    DECLARE @tba_percepciones AS TABLE (empresa INT,
                                        codigo NUMERIC(8,0),
                                        num_conc INT,
                                        variable FLOAT,
                                        varia_imss FLOAT,
                                        nomina FLOAT,
                                        origen VARCHAR(20),
                                        periodo INT,
                                        ayo_operacion INT,
                                        folio BIGINT,
                                        fch_real DATETIME,
                                        concepto VARCHAR(200))



    --Llena la tabla Art27LSS, por si no exiten registros, para los que se van a considerar en su parte gravable.
    EXECUTE dbo.Fun_F_LlenaArt27LSS @nempresa

    SELECT @nSalDf = zona_a FROM dbo.GetMinimumWage(@nMesIni,@nAyoOpe)

    SET @diasBaseDivisor = ( SELECT DivisorPercepcionesVariables
                             FROM   Empresas
                             WHERE  Empresa = @nEmpresa
                           )


    SET @cNombreMesIni = CASE WHEN @nMesIni = 01 THEN 'ENERO'
                              WHEN @nMesIni = 02 THEN 'FEBRERO'
                              WHEN @nMesIni = 03 THEN 'MARZO'
                              WHEN @nMesIni = 04 THEN 'ABRIL'
                              WHEN @nMesIni = 05 THEN 'MAYO'
                              WHEN @nMesIni = 06 THEN 'JUNIO'
                              WHEN @nMesIni = 07 THEN 'JULIO'
                              WHEN @nMesIni = 08 THEN 'AGOSTO'
                              WHEN @nMesIni = 09 THEN 'SEPTIEMBRE'
                              WHEN @nMesIni = 10 THEN 'OCTUBRE'
                              WHEN @nMesIni = 11 THEN 'NOVIEMBRE'
                              WHEN @nMesIni = 12 THEN 'DICIEMBRE'
                              ELSE ''
                         END

    SET @cNombreMesFin = CASE WHEN @nMesFin = 01 THEN 'ENERO'
                              WHEN @nMesFin = 02 THEN 'FEBRERO'
                              WHEN @nMesFin = 03 THEN 'MARZO'
                              WHEN @nMesFin = 04 THEN 'ABRIL'
                              WHEN @nMesFin = 05 THEN 'MAYO'
                              WHEN @nMesFin = 06 THEN 'JUNIO'
                              WHEN @nMesFin = 07 THEN 'JULIO'
                              WHEN @nMesFin = 08 THEN 'AGOSTO'
                              WHEN @nMesFin = 09 THEN 'SEPTIEMBRE'
                              WHEN @nMesFin = 10 THEN 'OCTUBRE'
                              WHEN @nMesFin = 11 THEN 'NOVIEMBRE'
                              WHEN @nMesFin = 12 THEN 'DICIEMBRE'
                              ELSE ''
                         END

    SET @mesInicialNomina = LEFT(@cNombreMesIni, 3)
        + RIGHT(CONVERT(CHAR(4), @nAyoOpe), 2)

    SET @mesFinalNomina = LEFT(@cNombreMesFin, 3)
        + RIGHT(CONVERT(CHAR(4), @nAyoOpe), 2)

    SET @cTituloMeses = CASE WHEN @nMesFin > @nMesIni
                              THEN 'DE LOS MESES : ' + @cNombreMesIni + '-'
                                   + @cNombreMesFin + ' DE '
                                   + CONVERT(CHAR(4), @nAyoOpe)
                              ELSE 'DEL MES : ' + @cNombreMesIni + ' DE '
                                   + CONVERT(CHAR(4), @nAyoOpe)
                         END

   /*Considerar los conceptos de percepciones a excepcion de la tabla Art27LSS, que se van a considerar de kardex_anual */
   INSERT   INTO @tba_percepciones
            SELECT  p.empresa ,
                    p.codigo ,
                    p.num_conc,
                    p.variable ,
                    p.varia_imss ,
                    p.nomina ,
                    'percepciones',
                    p.periodo,
                    p.ayo_operacion,
                    p.folio,
                    p.fch_real,
                    c.concepto
            FROM    dbo.percepciones AS p
            LEFT JOIN dbo.conceptos AS c ON ( p.empresa = c.empresa
                                                   AND p.num_conc = c.num_conc
                                                   AND p.centro = c.centro
                                                   AND p.clase = c.clase
                                                 )

            WHERE   ( ( p.mes_operacion = @nMesIni
                        OR p.mes_operacion = @nMesFin
                      )
                      AND p.ayo_operacion = @nAyoOpe
                    )
                    AND p.empresa = @nEmpresa
                    AND p.num_conc NOT IN ( SELECT art.num_conc
                                     FROM   dbo.Art27LSS AS art
                                     WHERE  art.empresa = @nEmpresa )

   /*Considerar los conceptos de kardex_anual que existan en la tabla Art27LSS */
   INSERT   INTO @tba_percepciones
            SELECT  ka.empresa ,
                    ka.codigo ,
                    ka.num_conc,
                    CASE WHEN art.baseVariables = 'Gravable' THEN ka.igravable
                         ELSE ka.variaimss
                    END AS 'variable' ,
                    CASE WHEN art.baseVariables = 'Gravable' THEN ka.igravable
                         ELSE ka.variaimss
                    END AS 'varia_imss' ,
                    ka.importe AS 'nomina' ,
                    'kardex_anual',
                    ka.periodo,
                    ka.ayo_operacion,
                    ka.folio,
                    ka.fch_pago AS 'fch_real',
                    ka.concepto
            FROM    dbo.kardex_anual AS ka
                    INNER JOIN dbo.Art27LSS AS art ON ka.empresa = art.empresa
                                                      AND ka.num_conc = art.num_conc
            WHERE   ( ( ka.mes = @mesInicialNomina
                        OR ka.mes = @mesFinalNomina
                      )
                      AND ka.ayo_operacion = @nAyoOpe
                    )
                    AND ka.empresa = @nEmpresa
                    AND ka.tpago_desc = 'P'



    /* Reporte con detalle con todos los conceptos */
    IF @nTipoReporte = 1
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total' ,
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                p.folio ,
                p.num_conc ,
                p.concepto ,
                p.varia_imss ,
                CASE WHEN p.varia_imss > 0
                     THEN ROUND(( p.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END) ), 2)
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                p.fch_real ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                p.nomina,
                CASE WHEN p.varia_imss > p.nomina THEN ROUND((p.varia_imss/p.nomina),4)ELSE 0 END AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
                LEFT JOIN @tba_percepciones AS p ON ( e.empresa = p.empresa
                                                     AND e.codigo = p.codigo
                                                     AND p.ayo_operacion = @nAyoOpe
                                                   )
        WHERE   tv.empresa = @nempresa
        ORDER BY tv.observa ,
                tv.codigo ,
                p.fch_real ,
                p.num_conc

    /* Reporte con detalle solo con los conceptos integrables */
    IF @nTipoReporte = 2
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total',
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                p.folio ,
                p.num_conc ,
                p.concepto ,
                p.varia_imss ,
                CASE WHEN p.varia_imss > 0
                     THEN ROUND(( p.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END) ), 2)
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                p.fch_real ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                p.nomina,
                CASE WHEN p.varia_imss > p.nomina THEN ROUND((p.varia_imss/p.nomina),4)ELSE 0 END AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
                LEFT JOIN @tba_percepciones AS p ON ( e.empresa = p.empresa
                                                     AND e.codigo = p.codigo
                                                     AND p.ayo_operacion = @nAyoOpe
                                                     AND (p.varia_imss > 0
                                                     OR (@cSoloRadial = 'S'
                                                         AND p.num_conc in (17,54,56)))

                                                   )
        WHERE   tv.empresa = @nempresa
        ORDER BY tv.observa ,
                tv.codigo ,
                p.fch_real ,
                p.num_conc

    /* Reporte solo totales de variables */
    IF @nTipoReporte = 3
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total',
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                NULL AS 'folio' ,
                NULL AS 'num_conc' ,
                NULL AS 'concepto' ,
                tv.varia_imss AS 'varia_imss' ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                NULL AS 'fch_real' ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                0 AS 'nomina',
                0 AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
        WHERE   tv.empresa = @nempresa
        ORDER BY tv.observa ,
                tv.codigo


    /* Totales por concepto */
    IF @nTipoReporte = 4
        SELECT  p.num_conc ,
                MAX(p.concepto) AS 'concepto' ,
                SUM(p.nomina) AS 'Nomina',
                SUM(p.varia_imss) AS 'Varia_imss'
        FROM    @tba_percepciones AS p
        WHERE   p.empresa = @nempresa
                AND p.ayo_operacion = @nAyoOpe
        GROUP BY p.num_conc
        ORDER BY p.num_conc


    /* Totales por periodo nominal */
    IF @nTipoReporte = 5
        SELECT  p.fch_real,
                SUM(p.nomina) AS 'Nomina',
                SUM(p.varia_imss) AS 'Varia_imss'
        FROM    @tba_percepciones AS p
        WHERE   p.empresa = @nempresa
                AND p.ayo_operacion = @nAyoOpe
        GROUP BY p.fch_real
        ORDER BY p.fch_real

    /* Periodos nominales cerrados, cuando se divide entre dias de nomina */
    IF @nTipoReporte = 6
        SELECT DISTINCT
                na.tiponom ,
                no.nomina ,
                CASE WHEN per.estatus = 'C' THEN 'Cerrado'
                     WHEN per.estatus = 'A' THEN 'Abierto'
                     ELSE ''
                END AS 'Estatus' ,
                na.periodo ,
                na.ayo_operacion ,
                per.inicio ,
                per.cierre ,
                per.pago ,
                per.dias
        FROM    dbo.nomina1_anual AS na
                INNER JOIN dbo.Nominas AS no ON ( na.empresa = no.empresa
                                                  AND na.tiponom = no.tiponom
                                                )
                INNER JOIN periodos AS per ON ( na.empresa = per.empresa
                                                AND na.tiponom = per.tiponom
                                                AND na.periodo = per.periodo
                                                AND na.ayo_operacion = per.ayo_operacion
                                              )
        WHERE   na.empresa = @nempresa
                AND ( na.mes = @mesInicialNomina
                      OR na.mes = @mesFinalNomina
                    )
        ORDER BY na.tiponom ,
                na.periodo

    IF @nTipoReporte = 7
        SELECT DISTINCT
                na.tiponom ,
                no.nomina ,
                CASE WHEN per.estatus = 'C' THEN 'Cerrado'
                     WHEN per.estatus = 'A' THEN 'Abierto'
                     ELSE ''
                END AS 'Estatus' ,
                na.periodo ,
                na.ayo_operacion ,
                per.inicio ,
                per.cierre ,
                per.pago ,
                per.dias
        FROM    dbo.nomina1_anual AS na
                INNER JOIN dbo.Nominas AS no ON ( na.empresa = no.empresa
                                                  AND na.tiponom = no.tiponom
                                                )
                INNER JOIN periodos AS per ON ( na.empresa = per.empresa
                                                AND na.tiponom = per.tiponom
                                                AND na.periodo = per.periodo
                                                AND na.ayo_operacion = per.ayo_operacion
                                              )
        WHERE   na.empresa = @nempresa
                AND na.mes = 'XXX99'
        ORDER BY na.tiponom ,
                na.periodo


    /*Para meter los conceptos de contras de Radial y Cecytec */
    IF (@cSoloRadial = 'S' OR @cCecytec = 'S') AND @nTipoReporte < 3
       INSERT INTO @tListadoVariables
        SELECT  tv.observa ,
                tv.codigo ,
                RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                + RTRIM(e.nombre) AS 'Nombre' ,
                tv.cuotadia ,
                tv.factor ,
                tv.varia_imss AS 'varia_imss_total',
                tv.diastrba ,
                tv.ausenba ,
                tv.incapba ,
                CASE WHEN tv.varia_imss > 0
                     THEN ROUND(( tv.varia_imss / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END)), 2)
                     ELSE 0
                END AS 'ParteVariableTotal' ,
                tv.sdi_nvo ,
                d.folio ,
                d.num_conc ,
                c.concepto ,
                d.descuento * -1 AS 'varia_imss' ,
                CASE WHEN d.descuento > 0
                     THEN ROUND(( d.descuento / (CASE WHEN ( tv.diastrba - tv.ausenba - tv.incapba ) <= 0 THEN 1 ELSE ( tv.diastrba - tv.ausenba - tv.incapba ) END) ), 2) * -1
                     ELSE 0
                END AS 'ParteVariableConcepto' ,
                d.fch_pago ,
                CASE WHEN tv.observa = '1'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES ' + @cTituloMeses
                     WHEN tv.observa = '2'
                     THEN 'LISTADO DE PERCEPCIONES VARIABLES A TRABAJADORES DADOS DE BAJAS '
                          + @cTituloMeses
                     WHEN tv.observa = '3'
                     THEN 'TRABAJADORES CON TIPO DE SALARIO VARIABLE SIN REPORTE DE VARIABLE '
                          + @cTituloMeses
                     WHEN tv.observa = '4'
                     THEN 'TRABAJADORES CON PAGOS NOMINALES QUE NO SE CONSIDERAN INTEGRABLES '
                          + @cTituloMeses
                     ELSE ''
                END AS 'Titulo',
                '' AS 'observaEmpleado',
                tv.dia,
                tv.mes,
                tv.ano,
                0 AS 'Nomina',
                0 AS 'FactorAgi'
        FROM    dbo.tmp_vars AS tv
                INNER JOIN dbo.empleados AS e ON ( tv.empresa = e.empresa
                                                   AND tv.codigo = e.codigo
                                                 )
                LEFT JOIN dbo.deducciones AS d ON ( e.empresa = d.empresa
                                                     AND e.codigo = d.codigo
                                                   )
                INNER JOIN dbo.conceptos AS c ON ( d.empresa = c.empresa
                                                   AND d.num_conc-1000 = c.num_conc
                                                   AND d.centro = c.centro
                                                   AND d.clase = c.clase
                                                 )
        WHERE   tv.empresa = @nempresa
                AND d.mes_operacion >= @nMesIni
                AND d.mes_operacion <= @nMesFin
                AND d.ayo_operacion = @nAyoOpe
                AND c.imss = 'S'
                AND d.num_conc > 1000



    /*Si el reporte es el detalle, regresar la consulta de la tabla temporal*/
    IF @nTipoReporte < 4
        BEGIN
            /* Observaciones para el listado de validacion */
            UPDATE @tListadoVariables SET observaEmpleado = '25 Vec. D.F.' WHERE sdi_nvo >= @nSalDf * 25
            UPDATE @tListadoVariables SET observaEmpleado = observaEmpleado + ' *' WHERE dbo.NvaFecha(dia,mes,ano+2000) > @dFF

            SELECT  *
            FROM    @tListadoVariables
            ORDER BY observa ,
                    codigo ,
                    fch_real ,
                    num_conc

        END

GO


/**************************************************************************************************
 * Name          : Fun_F_ListadoDeValidacionVariables_XLS_2014
 * Project       : APSI Nomina
 * Description   : Enero 18, 2012
 *                 Prepara la informacion para la impresion del listado de validacion de variables, en Excel
 *                 para fastreports tabla tmp_vars, con la reforma al Art. 27 Lss, donde se consideran algunos
 *                 conceptos de la tabla kardex_anual, en su parte gravable, para integrarlos.
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 25, 2013
 * Parameters    : Empresa
 *                 mes inicial, cuando el reporte es bimestral se regista el primer del bimestre
 *                 mes final, cuando el reporte es bimestral se registra el segundo mes del bimestre
 *                 Ao de operacion
 *                 Tipo de reporte : 1 = Genera la informacion de los empleados con todos los conceptos
 *                                       registrados (detallado de conceptos integrables y no integrables)
 *                                   2 = Detallado de conceptos solo los integrables
 *                                   3 = Reporte solo de total general por empleado
 *                                   4 = Total de conceptos registrados en los meses seleccionados
 *                                   5 = Resumen de fechas de pago en los meses seleccionados
 **************************************************************************************************/

IF OBJECT_ID('dbo.Fun_F_ListadoDeValidacionVariables_XLS_2014') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_ListadoDeValidacionVariables_XLS_2014

GO


CREATE PROCEDURE dbo.Fun_F_ListadoDeValidacionVariables_XLS_2014
    (
      @nEmpresa INTEGER ,
      @nMesIni INT ,
      @nMesFin INT ,
      @nAyoOpe INT ,
      @nTipoReporte INT ,
      @cSoloRadial CHAR(1) ,
      @cCecytec CHAR(1) ,
      @dFf DATETIME ,
      @simulador CHAR(1)
    )
AS
    SET NOCOUNT ON


    DECLARE @cTituloMeses AS VARCHAR(50)
    DECLARE @cNombreMesIni AS VARCHAR(20)
    DECLARE @cNombreMesFin AS VARCHAR(20)
    DECLARE @nSalDf AS FLOAT
    DECLARE @mesInicialNomina AS CHAR(5)
    DECLARE @mesFinalNomina AS CHAR(5)
    DECLARE @diasBaseDivisor AS VARCHAR(30)



    DECLARE @tba_percepciones AS TABLE
        (
          codigo NUMERIC(8, 0) ,
          num_conc INT ,
          varia_imss FLOAT ,
          nomina FLOAT
        )

    DECLARE @tba_conceptos AS TABLE ( num_conc INT )


    DECLARE @tba_fechasConceptos AS TABLE
        (
          fch_real DATETIME ,
          num_conc INT ,
          varia_imss FLOAT ,
          nomina FLOAT
        )

    DECLARE @tba_fechas AS TABLE
        (
          fch_real DATETIME ,
          varia_imss FLOAT ,
          nomina FLOAT
        )



    --Llena la tabla Art27LSS, por si no exiten registros, para los que se van a considerar en su parte gravable.
    EXECUTE dbo.Fun_F_LlenaArt27LSS @nempresa

    SELECT  @nSalDf = zona_a
    FROM    dbo.GetMinimumWage(@nMesIni, @nAyoOpe)

    SET @diasBaseDivisor = ( SELECT DivisorPercepcionesVariables
                             FROM   Empresas
                             WHERE  Empresa = @nEmpresa
                           )


    SET @cNombreMesIni = CASE WHEN @nMesIni = 01 THEN 'ENERO'
                              WHEN @nMesIni = 02 THEN 'FEBRERO'
                              WHEN @nMesIni = 03 THEN 'MARZO'
                              WHEN @nMesIni = 04 THEN 'ABRIL'
                              WHEN @nMesIni = 05 THEN 'MAYO'
                              WHEN @nMesIni = 06 THEN 'JUNIO'
                              WHEN @nMesIni = 07 THEN 'JULIO'
                              WHEN @nMesIni = 08 THEN 'AGOSTO'
                              WHEN @nMesIni = 09 THEN 'SEPTIEMBRE'
                              WHEN @nMesIni = 10 THEN 'OCTUBRE'
                              WHEN @nMesIni = 11 THEN 'NOVIEMBRE'
                              WHEN @nMesIni = 12 THEN 'DICIEMBRE'
                              ELSE ''
                         END

    SET @cNombreMesFin = CASE WHEN @nMesFin = 01 THEN 'ENERO'
                              WHEN @nMesFin = 02 THEN 'FEBRERO'
                              WHEN @nMesFin = 03 THEN 'MARZO'
                              WHEN @nMesFin = 04 THEN 'ABRIL'
                              WHEN @nMesFin = 05 THEN 'MAYO'
                              WHEN @nMesFin = 06 THEN 'JUNIO'
                              WHEN @nMesFin = 07 THEN 'JULIO'
                              WHEN @nMesFin = 08 THEN 'AGOSTO'
                              WHEN @nMesFin = 09 THEN 'SEPTIEMBRE'
                              WHEN @nMesFin = 10 THEN 'OCTUBRE'
                              WHEN @nMesFin = 11 THEN 'NOVIEMBRE'
                              WHEN @nMesFin = 12 THEN 'DICIEMBRE'
                              ELSE ''
                         END

    SET @mesInicialNomina = LEFT(@cNombreMesIni, 3)
        + RIGHT(CONVERT(CHAR(4), @nAyoOpe), 2)

    SET @mesFinalNomina = LEFT(@cNombreMesFin, 3)
        + RIGHT(CONVERT(CHAR(4), @nAyoOpe), 2)

    SET @cTituloMeses = CASE WHEN @nMesFin > @nMesIni
                             THEN 'DE LOS MESES : ' + @cNombreMesIni + '-'
                                  + @cNombreMesFin + ' DE '
                                  + CONVERT(CHAR(4), @nAyoOpe)
                             ELSE 'DEL MES : ' + @cNombreMesIni + ' DE '
                                  + CONVERT(CHAR(4), @nAyoOpe)
                        END

    /*Tipo de Opcion para obtener informacion
      1 = Encabezados de conceptos
      2 = Suma de conceptos por codigo, y numero de conceptos
    */

    IF @nTipoReporte = 1
        BEGIN
            IF @simulador = 'S'
                OR @nAyoOpe >= 2014
                BEGIN
                    INSERT  INTO @tba_conceptos
                            SELECT  DISTINCT
                                    p.num_conc
                            FROM    dbo.percepciones AS p
                            WHERE   ( ( p.mes_operacion = @nMesIni
                                        OR p.mes_operacion = @nMesFin
                                      )
                                      AND p.ayo_operacion = @nAyoOpe
                                    )
                                    AND p.empresa = @nEmpresa
                                    AND p.num_conc NOT IN (
                                    SELECT  art.num_conc
                                    FROM    dbo.Art27LSS AS art
                                    WHERE   art.empresa = @nEmpresa )

                    INSERT  INTO @tba_conceptos
                            SELECT  DISTINCT
                                    ka.num_conc
                            FROM    dbo.kardex_anual AS ka
                                    INNER JOIN dbo.Art27LSS AS art ON ka.empresa = art.empresa
                                                              AND ka.num_conc = art.num_conc
                            WHERE   ( ( ka.mes = @mesInicialNomina
                                        OR ka.mes = @mesFinalNomina
                                      )
                                      AND ka.ayo_operacion = @nAyoOpe
                                    )
                                    AND ka.empresa = @nEmpresa
                                    AND ka.tpago_desc = 'P'



                END
            ELSE
                INSERT  INTO @tba_conceptos
                        SELECT  DISTINCT
                                p.num_conc
                        FROM    dbo.percepciones AS p
                        WHERE   ( ( p.mes_operacion = @nMesIni
                                    OR p.mes_operacion = @nMesFin
                                  )
                                  AND p.ayo_operacion = @nAyoOpe
                                )
                                AND p.empresa = @nEmpresa


        END

    IF @nTipoReporte = 2
        BEGIN
            IF @simulador = 'S'
                OR @nAyoOpe >= 2014
                BEGIN

                    /*Considerar los conceptos de percepciones a excepcion de la tabla Art27LSS, que se van a considerar de kardex_anual */
                    INSERT  INTO @tba_percepciones
                            SELECT  p.codigo ,
                                    p.num_conc ,
                                    SUM(p.nomina) AS 'Nomina',
                                    SUM(p.varia_imss) AS 'varia_imss'
                            FROM    dbo.percepciones AS p
                            WHERE   ( ( p.mes_operacion = @nMesIni
                                        OR p.mes_operacion = @nMesFin
                                      )
                                      AND p.ayo_operacion = @nAyoOpe
                                    )
                                    AND p.empresa = @nEmpresa
                                    AND p.num_conc NOT IN (
                                    SELECT  art.num_conc
                                    FROM    dbo.Art27LSS AS art
                                    WHERE   art.empresa = @nEmpresa )
                            GROUP BY p.codigo ,
                                    p.num_conc

                    /*Considerar los conceptos de kardex_anual que existan en la tabla Art27LSS */
                    INSERT  INTO @tba_percepciones
                            SELECT  ka.codigo ,
                                    ka.num_conc ,
                                    SUM(ka.importe) AS 'nomina',
                                    SUM(CASE WHEN art.baseVariables = 'Gravable'
                                             THEN ka.igravable
                                             ELSE ka.variaimss
                                        END) AS 'varia_imss'
                            FROM    dbo.kardex_anual AS ka
                                    INNER JOIN dbo.Art27LSS AS art ON ka.empresa = art.empresa
                                                              AND ka.num_conc = art.num_conc
                            WHERE   ( ( ka.mes = @mesInicialNomina
                                        OR ka.mes = @mesFinalNomina
                                      )
                                      AND ka.ayo_operacion = @nAyoOpe
                                    )
                                    AND ka.empresa = @nEmpresa
                                    AND ka.tpago_desc = 'P'
                            GROUP BY ka.codigo ,
                                    ka.num_conc

                END

            ELSE
                INSERT  INTO @tba_percepciones
                        SELECT  p.codigo ,
                                p.num_conc ,
                                SUM(p.nomina) AS 'Nomina',
                                SUM(p.varia_imss) AS 'varia_imss'
                        FROM    dbo.percepciones AS p
                        WHERE   ( ( p.mes_operacion = @nMesIni
                                    OR p.mes_operacion = @nMesFin
                                  )
                                  AND p.ayo_operacion = @nAyoOpe
                                )
                                AND p.empresa = @nEmpresa
                        GROUP BY p.codigo ,
                                p.num_conc

        END


    IF @nTipoReporte = 3
        BEGIN
            IF @simulador = 'S'
                OR @nAyoOpe >= 2014
                BEGIN

                    /*Considerar los conceptos de percepciones a excepcion de la tabla Art27LSS, que se van a considerar de kardex_anual */
                    INSERT  INTO @tba_fechasConceptos
                            SELECT  p.fch_real ,
                                    p.num_conc ,
                                    SUM(p.varia_imss) AS 'varia_imss' ,
                                    SUM(p.nomina) AS 'Nomina'
                            FROM    dbo.percepciones AS p
                            WHERE   ( ( p.mes_operacion = @nMesIni
                                        OR p.mes_operacion = @nMesFin
                                      )
                                      AND p.ayo_operacion = @nAyoOpe
                                    )
                                    AND p.empresa = @nEmpresa
                                    AND p.num_conc NOT IN (
                                    SELECT  art.num_conc
                                    FROM    dbo.Art27LSS AS art
                                    WHERE   art.empresa = @nEmpresa )
                            GROUP BY p.fch_real ,
                                    p.num_conc

                    /*Considerar los conceptos de kardex_anual que existan en la tabla Art27LSS */
                    INSERT  INTO @tba_fechasConceptos
                            SELECT  ka.fch_pago ,
                                    ka.num_conc ,
                                    SUM(CASE WHEN art.baseVariables = 'Gravable'
                                             THEN ka.igravable
                                             ELSE ka.variaimss
                                        END) AS 'varia_imss' ,
                                    SUM(ka.importe) AS 'nomina'
                            FROM    dbo.kardex_anual AS ka
                                    INNER JOIN dbo.Art27LSS AS art ON ka.empresa = art.empresa
                                                              AND ka.num_conc = art.num_conc
                            WHERE   ( ( ka.mes = @mesInicialNomina
                                        OR ka.mes = @mesFinalNomina
                                      )
                                      AND ka.ayo_operacion = @nAyoOpe
                                    )
                                    AND ka.empresa = @nEmpresa
                                    AND ka.tpago_desc = 'P'
                            GROUP BY ka.fch_pago ,
                                    ka.num_conc

                END

            ELSE
                INSERT  INTO @tba_fechasConceptos
                        SELECT  p.fch_real ,
                                p.num_conc ,
                                SUM(p.varia_imss) AS 'varia_imss' ,
                                SUM(p.nomina) AS 'Nomina'
                        FROM    dbo.percepciones AS p
                        WHERE   ( ( p.mes_operacion = @nMesIni
                                    OR p.mes_operacion = @nMesFin
                                  )
                                  AND p.ayo_operacion = @nAyoOpe
                                )
                                AND p.empresa = @nEmpresa
                        GROUP BY p.fch_real ,
                                p.num_conc

        END

    IF @nTipoReporte = 4
        BEGIN
            IF @simulador = 'S'
                OR @nAyoOpe >= 2014
                BEGIN

                    /*Considerar los conceptos de percepciones a excepcion de la tabla Art27LSS, que se van a considerar de kardex_anual */
                    INSERT  INTO @tba_fechas
                            SELECT  p.fch_real ,
                                    SUM(p.varia_imss) AS 'varia_imss' ,
                                    SUM(p.nomina) AS 'Nomina'
                            FROM    dbo.percepciones AS p
                            WHERE   ( ( p.mes_operacion = @nMesIni
                                        OR p.mes_operacion = @nMesFin
                                      )
                                      AND p.ayo_operacion = @nAyoOpe
                                    )
                                    AND p.empresa = @nEmpresa
                                    AND p.num_conc NOT IN (
                                    SELECT  art.num_conc
                                    FROM    dbo.Art27LSS AS art
                                    WHERE   art.empresa = @nEmpresa )
                            GROUP BY p.fch_real

                    /*Considerar los conceptos de kardex_anual que existan en la tabla Art27LSS */
                    INSERT  INTO @tba_fechas
                            SELECT  ka.fch_pago ,
                                    SUM(CASE WHEN art.baseVariables = 'Gravable'
                                             THEN ka.igravable
                                             ELSE ka.variaimss
                                        END) AS 'varia_imss' ,
                                    SUM(ka.importe) AS 'nomina'
                            FROM    dbo.kardex_anual AS ka
                                    INNER JOIN dbo.Art27LSS AS art ON ka.empresa = art.empresa
                                                              AND ka.num_conc = art.num_conc
                            WHERE   ( ( ka.mes = @mesInicialNomina
                                        OR ka.mes = @mesFinalNomina
                                      )
                                      AND ka.ayo_operacion = @nAyoOpe
                                    )
                                    AND ka.empresa = @nEmpresa
                                    AND ka.tpago_desc = 'P'
                            GROUP BY ka.fch_pago


                END

            ELSE
                INSERT  INTO @tba_fechas
                        SELECT  p.fch_real ,
                                SUM(p.varia_imss) AS 'varia_imss' ,
                                SUM(p.nomina) AS 'Nomina'
                        FROM    dbo.percepciones AS p
                        WHERE   ( ( p.mes_operacion = @nMesIni
                                    OR p.mes_operacion = @nMesFin
                                  )
                                  AND p.ayo_operacion = @nAyoOpe
                                )
                                AND p.empresa = @nEmpresa
                        GROUP BY p.fch_real

        END


    IF @nTipoReporte = 1
        SELECT  num_conc
        FROM    @tba_conceptos
        ORDER BY num_conc

    IF @nTipoReporte = 2
        SELECT  codigo ,
                num_conc ,
                varia_imss ,
                nomina
        FROM    @tba_percepciones
        ORDER BY codigo ,
                num_conc


    IF @nTipoReporte = 3
        SELECT  fch_real ,
                num_conc ,
                SUM(nomina) AS 'nomina' ,
                SUM(varia_imss) AS 'varia_imss'
        FROM    @tba_fechasConceptos
        GROUP BY fch_real ,
                num_conc
        ORDER BY fch_real ,
                num_conc


    IF @nTipoReporte = 4
        SELECT  fch_real ,
                SUM(nomina) AS 'nomina' ,
                SUM(varia_imss) AS 'varia_imss'
        FROM    @tba_fechas
        GROUP BY fch_real
        ORDER BY fch_real

GO


/**************************************************************************************************
 * Name          : fun_I_GetCatalogoConceptosPagosNoArt27LSS
 * Project       : APSI Nomina
 * Description   : Octubre 14, 2013
 *                 Muestra los conceptos de pago, que aun no estan incluidos en la tabla Art27Lss, para que
 *                 puedan ser seleccionados por el usuario
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 14, 2013
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_GetCatalogoConceptosPagosNoArt27LSS') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_GetCatalogoConceptosPagosNoArt27LSS
GO


CREATE PROCEDURE dbo.fun_I_GetCatalogoConceptosPagosNoArt27LSS @empresa AS INT
AS
    SET NOCOUNT OFF

    SELECT  DISTINCT
            num_conc ,
            concepto ,
            CASE WHEN num_conc < 100 THEN 'Pago'
                 WHEN num_conc >= 100
                      AND num_conc <= 200 THEN 'Descuento'
                 WHEN num_conc >= 1001
                      AND num_conc <= 1099 THEN 'Descuento'
                 WHEN num_conc >= 1101
                      AND num_conc <= 1199 THEN 'Pago'
                 ELSE ''
            END AS 'Tipo'
    FROM    dbo.conceptos
    WHERE   empresa = @empresa
            AND uso = 'S'
            AND num_conc > 38
            AND num_conc < 100
            AND num_conc NOT IN ( SELECT    art.num_conc
                                  FROM      dbo.Art27LSS AS art
                                  WHERE     art.empresa = @Empresa )
    ORDER BY num_conc

GO


/**************************************************************************************************
 * Name          : fun_I_GetCatalogoConceptosPagosArt27LSS
 * Project       : APSI Nomina
 * Description   : Octubre 14, 2013
 *                 Muestra los conceptos de pago, que aun no estan incluidos en la tabla Art27Lss, para que
 *                 puedan ser seleccionados por el usuario
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 14, 2013
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_GetCatalogoConceptosPagosArt27LSS') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_GetCatalogoConceptosPagosArt27LSS
GO


CREATE PROCEDURE dbo.fun_I_GetCatalogoConceptosPagosArt27LSS @empresa AS INT
AS
    SET NOCOUNT OFF

    SELECT  DISTINCT
            a27.num_conc ,
            c.concepto ,
            a27.fraccion
    FROM    dbo.Art27LSS AS a27
            INNER JOIN dbo.conceptos AS c ON a27.empresa = c.empresa
                                             AND a27.num_conc = c.num_conc
    WHERE   a27.empresa = @empresa
            AND c.uso = 'S'
    ORDER BY a27.num_conc

GO


/****************************************************************************************************************
 * Project       : APSI Nomina
 * Description   : Octubre 14, 2013
 *                 Se agrego el campo fonacot a la tabla EmpleadoAdicional, para guardar ese dato, y utilizarlo
 *                 en los reportes, tambien se cambio el tipo de dato de deducciones del campo num_cr, a bigint
 *                 para que soporte mas numeros.
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 14, 2013
*******************************************************************************************************************/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'fonacot'
                        AND sysobjects.name = 'EmpleadoAdicional' )
    ALTER TABLE dbo.EmpleadoAdicional ADD fonacot NUMERIC(10,0) NULL

GO


IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'deducciones')
                    AND OBJECTPROPERTY(id, N'IsUserTable') = 1 )
    BEGIN
        ALTER TABLE dbo.deducciones ALTER COLUMN num_cr BIGINT
    END

GO


/****************************************************************************************************************************
* Name          : dbo.Fun_E_ActualizarFonacot
* Project       : APSI Nomina
* Description   : Octubre 14, 2013
*                 Actualiza el campo Fonacot de la tabla empleadosAdicional, para registrar esta informacion
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Octubre 14, 2013
* Parameters    : empresa,codigo,fonacot
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_E_ActualizarFonacot') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_ActualizarFonacot
GO

CREATE PROCEDURE dbo.Fun_E_ActualizarFonacot
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @fonacot AS NUMERIC(10, 0),
	@cUser AS VARCHAR(20)
AS

DECLARE @periodo AS INTEGER
DECLARE @ayoOperacion AS INTEGER
DECLARE @tiponom AS INTEGER

BEGIN TRANSACTION
 BEGIN TRY

     SELECT  @tiponom = ISNULL(tiponom, 0)
     FROM    dbo.Llaves
     WHERE   empresa = @empresa
             AND codigo = @codigo

     SELECT  @periodo = ISNULL(periodo, 0) ,
             @ayoOperacion = ISNULL(ayo_operacion, 0) 
     FROM    dbo.Periodos
     WHERE   estatus = 'A'
             AND tiponom = @tiponom
             AND empresa = @empresa


      IF NOT EXISTS ( SELECT  codigo
                    FROM    dbo.EmpleadoAdicional
                    WHERE   empresa = @empresa
                            AND codigo = @codigo )
        BEGIN
            INSERT  INTO dbo.EmpleadoAdicional
                    ( empresa ,
                      codigo ,
                      discapacitado ,
                      fonacot
                    )
            VALUES  ( @empresa , -- empresa - numeric
                      @codigo , -- codigo - numeric
                      'N' , -- discapacitado - char(1)
                      @fonacot  -- fonacot - numeric
                    )
        END
    ELSE
        UPDATE  dbo.EmpleadoAdicional
        SET     fonacot = @fonacot
        WHERE   empresa = @empresa
                AND codigo = @codigo

   -- Actualizar la bitacora
   INSERT  INTO dbo.Bitacora
               ( Empresa ,
                 Fecha ,
                 Hora ,
                 Funcion ,
                 Codigo ,
                 Opcion ,
                 Opcion2 ,
                 Opcion3 ,
                 Usuario ,
                 Clave ,
                 RegPat ,
                 Sistema
                 )
         SELECT  @empresa ,
                 GETDATE() ,
                 SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                 'E' ,
                 @Codigo ,
                'Actualizar clave FONACOT' ,
                'Periodo : ' + dbo.padl(@periodo,'',2,'0') + '-' + dbo.padl(@ayoOperacion,'',4,'0') + ' TN :' + CONVERT(CHAR(1),@tiponom),
                'Numero FONACOT :' + CONVERT(CHAR(12),@Fonacot),
                 @cUser ,
                '' ,
                LEFT(Empresas.Registro_Patronal, 10) ,
               'NO'
         FROM    Empresas
         WHERE   Empresa = @empresa



 END TRY
    BEGIN CATCH
	    DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: '
                          + LTRIM(RTRIM(STR(@ErrorState))) + CHAR(13) + CHAR(10)
                          + 'Severity: ' + LTRIM(RTRIM(STR(@ErrorSeverity)))
                          + CHAR(13) + CHAR(10) + 'Error number:  '
                          + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
                          + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13)
                          + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                          + CHAR(13) + CHAR(10) + 'Line: '
                          + LTRIM(RTRIM(STR(ERROR_LINE())))

         IF ( XACT_STATE() ) = -1 OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

            RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
       COMMIT TRANSACTION


GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_ObtenerFonacot
* Project       : APSI Nomina
* Description   : Octubre 14, 2013
*                 Obtener el numero de fonacot, para mostrarlo en la captura de prestamos en la funcion E.
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Octubre 14, 2013
* Parameters    : empresa,codigo,fonacot
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_E_ObtenerFonacot') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_ObtenerFonacot
GO

CREATE PROCEDURE dbo.Fun_E_ObtenerFonacot
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0)
AS
    SELECT  ISNULL(fonacot, 0) AS 'Fonacot'
    FROM    dbo.EmpleadoAdicional
    WHERE   empresa = @empresa
            AND codigo = @codigo

GO



/*
 * PROCEDURE: sp_insert_deducciones_1
 * Se actualizo el campo num_cr, para que soporte el tipo de dato BigInt.
 */
IF OBJECT_ID('dbo.sp_insert_deducciones_1') IS NOT NULL
    DROP PROCEDURE dbo.sp_insert_deducciones_1
GO

CREATE PROCEDURE [dbo].[sp_insert_deducciones_1]
    (
      @empresa_1 [numeric] ,
      @codigo_2 [numeric] ,
      @folio_3 [int] ,
      @num_conc_4 [int] ,
      @centro_5 [char](15) ,
      @clase_6 [char](2) ,
      @mes_operacion_7 [int] ,
      @ayo_operacion_8 [int] ,
      @tiponom_9 [int] ,
      @periodo_10 [int] ,
      @tipoinc_11 [char](1) ,
      @dias_12 [decimal](6, 2) ,
      @fch_pago_13 [datetime] ,
      @numeroinc_14 [varchar](12) ,
      @num_cr_15 [bigint] ,
      @fchinicio_16 [datetime] ,
      @fchtermino_17 [datetime] ,
      @inicsubs_18 [char](1) ,
      @credito_19 [decimal](10, 2) ,
      @plazo_20 [int] ,
      @descuento_21 [decimal](10, 2) ,
      @saldo_22 [decimal](10, 2) ,
      @justificar_23 [char](1) ,
      @siempre_24 [char](1) ,
      @varia1_25 [decimal](10, 2) ,
      @varia2_26 [decimal](10, 2) ,
      @varia3_27 [decimal](10, 2) ,
      @varia4_28 [decimal](10, 2) ,
      @masivo_29 [char](1) ,
      @minutos_30 [int] ,
      @baja_31 [char](1) ,
      @origen_32 [char](1)
    )
AS
    INSERT  INTO [deducciones]
            ( [empresa] ,
              [codigo] ,
              [folio] ,
              [num_conc] ,
              [centro] ,
              [clase] ,
              [mes_operacion] ,
              [ayo_operacion] ,
              [tiponom] ,
              [periodo] ,
              [tipoinc] ,
              [dias] ,
              [fch_pago] ,
              [numeroinc] ,
              [num_cr] ,
              [fchinicio] ,
              [fchtermino] ,
              [inicsubs] ,
              [credito] ,
              [plazo] ,
              [descuento] ,
              [saldo] ,
              [justificar] ,
              [siempre] ,
              [varia1] ,
              [varia2] ,
              [varia3] ,
              [varia4] ,
              [masivo] ,
              [minutos] ,
              [baja] ,
              [origen]
            )
    VALUES  ( @empresa_1 ,
              @codigo_2 ,
              @folio_3 ,
              @num_conc_4 ,
              @centro_5 ,
              @clase_6 ,
              @mes_operacion_7 ,
              @ayo_operacion_8 ,
              @tiponom_9 ,
              @periodo_10 ,
              @tipoinc_11 ,
              @dias_12 ,
              @fch_pago_13 ,
              @numeroinc_14 ,
              @num_cr_15 ,
              @fchinicio_16 ,
              @fchtermino_17 ,
              @inicsubs_18 ,
              @credito_19 ,
              @plazo_20 ,
              @descuento_21 ,
              @saldo_22 ,
              @justificar_23 ,
              @siempre_24 ,
              @varia1_25 ,
              @varia2_26 ,
              @varia3_27 ,
              @varia4_28 ,
              @masivo_29 ,
              @minutos_30 ,
              @baja_31 ,
              @origen_32
            )
    IF @@error != 0
        RETURN (-99)
    ELSE
        RETURN 0

GO


/****************************************************************************************************************************
* Name          : dbo.Fun_E_FonacotObtieneNominas
* Project       : APSI Nomina
* Description   : Noviembre 06, 2013
*                 Obtener los tipos de nominas y periodos de un mes y ao
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Noviembre 06, 2013
* Parameters    : empresa, mes, ao
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_E_FonacotObtieneNominas') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_FonacotObtieneNominas
GO


CREATE PROCEDURE dbo.Fun_E_FonacotObtieneNominas
    @empresa AS INTEGER ,
    @mesOperacion AS INTEGER ,
    @ayoOperacion AS INTEGER
AS

    SET NOCOUNT ON

    DECLARE @tbaPeriodos AS TABLE
        (
          tiponom INTEGER ,
          nomina VARCHAR(50) ,
          periodo INTEGER
        )


    INSERT  INTO @tbaPeriodos
            SELECT  n.tiponom ,
                    n.nomina ,
                    p.periodo
            FROM    dbo.Nominas AS n
                    INNER JOIN dbo.Periodos AS p ON n.empresa = p.empresa
                                                    AND n.tiponom = p.tiponom
            WHERE   MONTH(p.pago) = @mesOperacion
                    AND YEAR(p.pago) = @ayoOperacion
                    AND n.empresa = @empresa
            ORDER BY n.tiponom ,
                    p.periodo



    SELECT  tiponom ,
            nomina ,
            MIN(periodo) AS 'PeriodoInicial' ,
            MAX(periodo) AS 'PeriodoFinal'
    FROM    @tbaPeriodos
    GROUP BY tiponom ,
            nomina
    ORDER BY tiponom


GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_FonacotObtieneCreditos
* Project       : APSI Nomina
* Description   : Noviembre 06, 2013
*                 Obtener los conceptos de creditos fonacot, concepto 117, para un mes y ao
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Noviembre 06, 2013
* Parameters    : empresa, mes, ao
*******************************************************************************************************************************/


IF OBJECT_ID('dbo.Fun_E_FonacotObtieneCreditos') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_FonacotObtieneCreditos
GO


CREATE PROCEDURE dbo.Fun_E_FonacotObtieneCreditos
    @empresa AS INTEGER ,
    @mesOperacion AS INTEGER ,
    @ayoOperacion AS INTEGER
AS
    SET NOCOUNT ON

    DECLARE @cMes AS CHAR(05)
    DECLARE @cNombreMes AS VARCHAR(20)
    DECLARE @inicioMes AS DATETIME
    DECLARE @finMes AS DATETIME
    DECLARE @tbaFonacot AS TABLE
        (
          empresa INTEGER ,
          codigo NUMERIC(8, 0) ,
          nombre VARCHAR(100) ,
          rfc VARCHAR(20) ,
          referencia VARCHAR(20) ,
          importe FLOAT ,
          fonacot NUMERIC(10, 0) ,
          cuotasPagadas INT ,
          incidencia CHAR(2) ,
          inicio DATETIME ,
          termino DATETIME,
          saldo FLOAT
        )

    DECLARE @tbaCuotasPagadas AS TABLE
        (
          empresa INTEGER ,
          codigo NUMERIC(8, 0) ,
          referencia VARCHAR(20) ,
          cuotasPagadas INTEGER
        )

    DECLARE @tbaIncapacidadesDetalle AS TABLE
        (
          empresa INTEGER ,
          codigo NUMERIC(8, 0) ,
          inicio DATETIME ,
          termino DATETIME
        )

    DECLARE @tbaIncapacidadesTotales AS TABLE
        (
          empresa INTEGER ,
          codigo NUMERIC(8, 0) ,
          inicio DATETIME ,
          termino DATETIME
        )

    DECLARE @tbaBajas AS TABLE
        (
          empresa INTEGER ,
          codigo NUMERIC(8, 0) ,
          fch_mov DATETIME
        )


    SET @cNombreMes = CASE WHEN @mesOperacion = 01 THEN 'ENERO'
                           WHEN @mesOperacion = 02 THEN 'FEBRERO'
                           WHEN @mesOperacion = 03 THEN 'MARZO'
                           WHEN @mesOperacion = 04 THEN 'ABRIL'
                           WHEN @mesOperacion = 05 THEN 'MAYO'
                           WHEN @mesOperacion = 06 THEN 'JUNIO'
                           WHEN @mesOperacion = 07 THEN 'JULIO'
                           WHEN @mesOperacion = 08 THEN 'AGOSTO'
                           WHEN @mesOperacion = 09 THEN 'SEPTIEMBRE'
                           WHEN @mesOperacion = 10 THEN 'OCTUBRE'
                           WHEN @mesOperacion = 11 THEN 'NOVIEMBRE'
                           WHEN @mesOperacion = 12 THEN 'DICIEMBRE'
                           ELSE ''
                      END



    SET @cMes = LEFT(@cNombreMes, 3) + RIGHT(CONVERT(CHAR(4), @AyoOperacion),
                                             2)

    SET @inicioMes = dbo.DateToChar(dbo.NvaFecha(1, @mesOperacion,
                                                 @ayoOperacion), 'YYYYMMDD',
                                    '')
    SET @finMes = dbo.DateToChar(dbo.fin_mes(@mesOperacion, @ayoOperacion),
                                 'YYYYMMDD', '')

    INSERT  INTO @tbaFonacot
            ( empresa ,
              codigo ,
              nombre ,
              rfc ,
              referencia ,
              importe ,
              fonacot ,
              saldo
            )
            SELECT  ka.empresa ,
                    ka.codigo ,
                    MAX(RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                        + RTRIM(e.nombre)) AS 'Nombre' ,
                    MAX(e.rfcalfa + CONVERT(CHAR(6), e.rfcnum) + e.rfchomo) AS 'RFC' ,
                    ka.referencia ,
                    SUM(ka.importe) AS 'Importe' ,
                    MAX(ISNULL(ea.fonacot, 0)) AS 'Fonacot',
                    MIN(ka.saldo) AS 'Saldo'
            FROM    dbo.kardex_anual AS ka
                    INNER JOIN dbo.empleados AS e ON ka.empresa = e.empresa
                                                     AND ka.codigo = e.codigo
                    LEFT JOIN dbo.EmpleadoAdicional AS ea ON e.empresa = ea.empresa
                                                             AND e.codigo = ea.codigo
            WHERE   ka.num_conc = 117
                    AND ka.mes = @cMes
                    AND ka.empresa = @empresa
            GROUP BY ka.empresa ,
                    ka.codigo ,
                    ka.referencia
            ORDER BY ka.codigo ,
                    ka.referencia


    INSERT  @tbaCuotasPagadas
            SELECT  tbaf.empresa ,
                    tbaF.codigo ,
                    tbaF.referencia ,
                    COUNT(ka.periodo) AS 'CuotasPagadas'
            FROM    @tbaFonacot AS tbaF
                    LEFT JOIN dbo.kardex_anual AS ka ON tbaF.codigo = ka.codigo
                                                        AND tbaF.empresa = ka.empresa
                                                        AND tbaF.referencia = ka.referencia
            WHERE   ka.num_conc = 117
                    AND ka.importe > 0
            GROUP BY tbaf.empresa ,
                    tbaF.codigo ,
                    tbaF.referencia

    /*Incapacitados en el mes*/
    INSERT  INTO @tbaIncapacidadesDetalle
            ( empresa ,
              codigo ,
              inicio ,
              termino
            )
            SELECT  d.empresa ,
                    d.codigo ,
                    CASE WHEN ( d.fchinicio >= @inicioMes
                                AND d.fchtermino <= @finMes
                              ) THEN d.fchinicio
                         WHEN ( d.fchinicio < @inicioMes
                                AND ( d.fchtermino >= @inicioMes
                                      AND d.fchtermino <= @finMes
                                    )
                              ) THEN @inicioMes
                         WHEN ( d.fchinicio >= @inicioMes
                                AND d.fchInicio <= @finMes
                              ) THEN d.fchInicio
                    END AS 'fchInicio' ,
                    CASE WHEN ( d.fchinicio >= @inicioMes
                                AND d.fchtermino <= @finMes
                              ) THEN d.fchtermino
                         WHEN ( d.fchinicio < @inicioMes
                                AND ( d.fchtermino >= @inicioMes
                                      AND d.fchtermino <= @finMes
                                    )
                              ) THEN d.fchtermino
                         WHEN ( d.fchinicio >= @inicioMes
                                AND d.fchInicio <= @finMes
                              ) THEN @finMes
                    END AS 'fchTermino'
            FROM    dbo.deducciones AS d
            WHERE   d.num_conc >= 109
                    AND d.num_conc <= 111
                    AND d.empresa = @empresa
                    AND d.mes_operacion = @mesOperacion
                    AND d.ayo_operacion = @ayoOperacion

    INSERT  INTO @tbaIncapacidadesTotales
            SELECT  empresa ,
                    codigo ,
                    MIN(inicio) AS 'Inicio' ,
                    MAX(termino) AS 'Termino'
            FROM    @tbaIncapacidadesDetalle
            GROUP BY empresa ,
                    codigo
            ORDER BY empresa ,
                    codigo


   /*Bajas del mes*/
    INSERT  INTO @tbaBajas
            SELECT  e.empresa ,
                    e.codigo ,
                    ( SELECT TOP 1
                                a.fch_mov
                      FROM      dbo.avisos_imss AS a
                      WHERE     a.empresa = e.empresa
                                AND e.codigo = a.codigo
                                AND a.mes_operacion = @mesOperacion
                                AND a.ayo_operacion = @ayoOperacion
                      ORDER BY  a.fch_mov DESC
                    ) AS 'fch_mov'
            FROM    dbo.empleados AS e
            WHERE   e.empresa = @empresa
                    AND ( SELECT TOP 1
                                    a.mov
                          FROM      dbo.avisos_imss AS a
                          WHERE     a.empresa = e.empresa
                                    AND e.codigo = a.codigo
                                    AND a.mes_operacion = @mesOperacion
                                    AND a.ayo_operacion = @ayoOperacion
                          ORDER BY  a.fch_mov DESC
                        ) = 'B'


    UPDATE  tbaF
    SET     tbaF.cuotasPagadas = tbaC.cuotasPagadas
    FROM    @tbaFonacot AS tbaF
            INNER JOIN @tbaCuotasPagadas AS tbaC ON tbaF.empresa = tbaC.empresa
                                                    AND tbaF.codigo = tbaC.codigo
                                                    AND tbaF.referencia = tbaC.referencia

    UPDATE  tbaF
    SET     tbaF.incidencia = 'I' ,
            tbaF.inicio = tbaC.inicio ,
            tbaF.termino = tbaC.termino
    FROM    @tbaFonacot AS tbaF
            INNER JOIN @tbaIncapacidadesTotales AS tbaC ON tbaF.empresa = tbaC.empresa
                                                           AND tbaF.codigo = tbaC.codigo


    UPDATE  tbaF
    SET     tbaF.incidencia = 'B' ,
            tbaF.inicio = tbaC.fch_mov
    FROM    @tbaFonacot AS tbaF
            INNER JOIN @tbaBajas AS tbaC ON tbaF.empresa = tbaC.empresa
                                            AND tbaF.codigo = tbaC.codigo


    SELECT  codigo ,
            nombre ,
            rfc ,
            fonacot ,
            referencia ,
            importe ,
            cuotasPagadas,
            incidencia ,
            inicio ,
            termino,
            saldo
    FROM    @tbaFonacot
    ORDER BY codigo ,
            referencia

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_FonacotValidarCredito
* Project       : APSI Nomina
* Description   : Noviembre 06, 2013
*                 Obtener los conceptos de creditos fonacot, concepto 117, para un mes y ao
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Noviembre 06, 2013
* Parameters    : empresa, mes, ao
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_E_FonacotValidarCredito') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_FonacotValidarCredito
GO


CREATE PROCEDURE dbo.Fun_E_FonacotValidarCredito
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @rfc AS VARCHAR(20) ,
    @numCredito AS VARCHAR(20) ,
    @fonacot AS NUMERIC(10, 0) ,
    @retencionMes AS FLOAT ,
    @plazo AS INTEGER
AS
    SET NOCOUNT ON

    DECLARE @observacion AS VARCHAR(1000)
    DECLARE @numFonacot AS NUMERIC(10, 0)
    DECLARE @tiponom AS INT
    DECLARE @periodo AS INT
    DECLARE @ayoOperacion AS INT
    DECLARE @rfcAlfa AS CHAR(4)
    DECLARE @rfcNum AS CHAR(6) --NUMERIC(6, 0)
    DECLARE @rfcHomo AS CHAR(3)
    DECLARE @existeCredito AS FLOAT
    DECLARE @diasPago AS FLOAT
    DECLARE @descuento AS FLOAT
    DECLARE @existeEmpleado AS INT
    DECLARE @credito AS FLOAT
    DECLARE @codigoFonacot AS NUMERIC(8, 0)
    DECLARE @errorDiasNomina AS INT
    DECLARE @diasMes AS FLOAT



    DECLARE @tbaObserva AS TABLE
        (
          codigo NUMERIC(8, 0) ,
          observacion VARCHAR(200) ,
          credito FLOAT ,
          descuento FLOAT
        )

    SET @observacion = ''
    SET @numFonacot = 0
    SET @rfcAlfa = SUBSTRING(@rfc, 1, 4)
    SET @rfcNum = SUBSTRING(@rfc, 5, 6) --CONVERT(NUMERIC(6, 0), SUBSTRING(@rfc, 5, 6))
    SET @rfcHomo = SUBSTRING(@rfc, 11, 3)
    SET @existeCredito = 0
    SET @descuento = 0
    SET @existeEmpleado = 1
    SET @tiponom = 0
    SET @codigoFonacot = @codigo
    SET @errorDiasNomina = 0
    SET @diasMes = 30.4166666

    IF @plazo = 0
       SET @plazo = 1

    IF @codigo > 0
        SELECT  @tiponom = ISNULL(tiponom, 0)
        FROM    dbo.Llaves
        WHERE   empresa = @empresa
                AND codigo = @codigo

    PRINT @tiponom

    IF @tiponom = 0
        BEGIN
            SELECT  @codigo = ISNULL(codigo, 0)
            FROM    dbo.empleados
            WHERE   rfcalfa = @rfcAlfa
                    AND rfcnum = @rfcNum
                    AND rfchomo = @rfcHomo
                    AND empresa = @empresa

            SELECT  @tiponom = ISNULL(tiponom, 0)
            FROM    dbo.Llaves
            WHERE   empresa = @empresa
                    AND codigo = @codigo

        END

    IF NOT EXISTS ( SELECT  codigo
                    FROM    dbo.empleados
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                            AND activo = 'S'
                            AND pagar_nomina = 'S'
                            AND ultmov <> 'B' )
        SET @existeEmpleado = 0



    IF @tiponom > 0
        SELECT  @periodo = ISNULL(periodo, 0) ,
                @ayoOperacion = ISNULL(ayo_operacion, 0) ,
                @diasPago = ISNULL(dias, 0)
        FROM    dbo.Periodos
        WHERE   estatus = 'A'
                AND tiponom = @tiponom
                AND empresa = @empresa


    IF @periodo > 0
        AND @ayoOperacion > 0
        AND @codigo > 0
        AND @tiponom > 0
        BEGIN
            SELECT  @existeCredito = ISNULL(credito, 0) ,
                    @credito = ISNULL(credito, 0) ,
                    @descuento = ISNULL(descuento, 0)
            FROM    dbo.deducciones
            WHERE   codigo = @codigo
                    AND periodo = @periodo
                    AND ayo_operacion = @ayoOperacion
                    AND tiponom = @tiponom
                    AND num_conc = 117
                    AND empresa = @empresa
                    AND ( num_cr = @numCredito
                          OR @numCredito = CASE WHEN ISNUMERIC(numeroinc) > 0
                                                THEN FLOOR(numeroinc)
                                                ELSE 0
                                           END
                        )

            SELECT  @numFonacot = ISNULL(fonacot, 0)
            FROM    dbo.EmpleadoAdicional
            WHERE   codigo = @codigo
                    AND empresa = @empresa

            IF @diasPago > @diasMes
                SET @diasMes = @diasPago


            IF @diasPago > 0
                AND @retencionMes > 0
                SET @descuento = ROUND(@retencionMes / CONVERT(INT, ( @diasMes
                                                              / @diasPago )),
                                       2)
            ELSE
                SET @errorDiasNomina = 1

        END

    IF @existeEmpleado = 0
        INSERT  @tbaObserva
                ( codigo ,
                  observacion
                )
        VALUES  ( @codigo , -- codigo - numeric
                  '01.-No existe el empleado o es baja'  -- observacion - varchar(200)

                )
    ELSE
        BEGIN

            IF @numFonacot <> @fonacot
                INSERT  INTO @tbaObserva
                        ( codigo ,
                          observacion
                        )
                VALUES  ( @codigo , -- codigo - numeric
                          '02.-No esta registrado el numero de fonacot'  -- observacion - varchar(200)

                        )

            IF @existeCredito = 0 --AND @descuento = 0
                INSERT  INTO @tbaObserva
                        ( codigo ,
                          observacion ,
                          credito ,
                          descuento
                        )
                VALUES  ( @codigo , -- codigo - numeric
                          '03.-Credito nuevo para importar' ,  -- observacion - varchar(200)
                          ROUND(@retencionMes * @plazo, 2) ,
                          @descuento
                        )

            IF @existeCredito > 0 --OR @descuento > 0
                INSERT  INTO @tbaObserva
                        ( codigo ,
                          observacion ,
                          credito ,
                          descuento
                        )
                VALUES  ( @codigo , -- codigo - numeric
                          '04.-El credito ya existe' ,  -- observacion - varchar(200)
                          @credito ,
                          @descuento
                        )

            IF @codigo <> @codigoFonacot
                INSERT  INTO @tbaObserva
                        ( codigo ,
                          observacion ,
                          credito ,
                          descuento
                        )
                VALUES  ( @codigo , -- codigo - numeric
                          '05.-El numero de empleado del archivo fonacot, es diferente al de nomina' ,  -- observacion - varchar(200)
                          @credito ,
                          @descuento
                        )

            IF @errorDiasNomina > 0
                INSERT  INTO @tbaObserva
                        ( codigo ,
                          observacion ,
                          credito ,
                          descuento
                        )
                VALUES  ( @codigo , -- codigo - numeric
                          '06.-Los dias de pago de nomina son cero o no tiene descuento' ,  -- observacion - varchar(200)
                          @credito ,
                          @retencionMes
                        )


        END

    SELECT  codigo ,
            observacion ,
            credito ,
            descuento
    FROM    @tbaObserva
    ORDER BY observacion


GO



/****************************************************************************************************************************
* Name          : dbo.Fun_E_FonacotAddCredito
* Project       : APSI Nomina
* Description   : Noviembre 12, 2013
*                 Agregar un nuevo credito de fonacot a deducciones
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Noviembre 12, 2013
* Parameters    : empresa, codigo,numero de credito, credito, descuento, plazo
*******************************************************************************************************************************/


IF OBJECT_ID('dbo.Fun_E_FonacotAddCredito') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_FonacotAddCredito
GO


CREATE PROCEDURE dbo.Fun_E_FonacotAddCredito
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @numCredito AS VARCHAR(20) ,
    @credito AS FLOAT ,
    @descuento AS FLOAT ,
    @plazo AS INTEGER,
	@cUser AS VARCHAR(20)
AS
    SET NOCOUNT ON

    DECLARE @periodo AS INT
    DECLARE @tiponom AS INT
    DECLARE @ayoOperacion AS INT
    DECLARE @folio AS BIGINT
    DECLARE @num_conc AS INT
    DECLARE @inicio AS DATETIME
    DECLARE @cierre AS DATETIME
    DECLARE @pago AS DATETIME
    DECLARE @mesOperacion AS INT

    SET @num_conc = 117

BEGIN TRANSACTION
 BEGIN TRY


    SELECT  @tiponom = ISNULL(tiponom, 0)
    FROM    dbo.Llaves
    WHERE   empresa = @empresa
            AND codigo = @codigo

    SELECT  @periodo = ISNULL(periodo, 0) ,
            @ayoOperacion = ISNULL(ayo_operacion, 0) ,
            @inicio = inicio ,
            @cierre = cierre ,
            @pago = pago
    FROM    dbo.Periodos
    WHERE   estatus = 'A'
            AND tiponom = @tiponom
            AND empresa = @empresa


    SELECT  @folio = ISNULL(MAX(folio), 0)
    FROM    dbo.deducciones
    WHERE   tiponom = @tiponom
            AND periodo = @periodo
            AND ayo_operacion = @ayoOperacion
            AND codigo = @codigo
            AND empresa = @empresa

    SET @folio = @folio + 1
    SET @mesOperacion = MONTH(@pago)

    IF NOT EXISTS ( SELECT  codigo
                    FROM    dbo.deducciones
                    WHERE   tiponom = @tiponom
                            AND periodo = @periodo
                            AND ayo_operacion = @ayoOperacion
                            AND num_conc = @num_conc
                            AND numeroinc = @numCredito
                            AND codigo = @codigo )

        INSERT  INTO dbo.deducciones
                ( empresa ,
                  codigo ,
                  folio ,
                  num_conc ,
                  centro ,
                  clase ,
                  mes_operacion ,
                  ayo_operacion ,
                  tiponom ,
                  periodo ,
                  tipoinc ,
                  dias ,
                  fch_pago ,
                  numeroinc ,
                  num_cr ,
                  fchinicio ,
                  fchtermino ,
                  inicsubs ,
                  credito ,
                  plazo ,
                  descuento ,
                  saldo ,
                  justificar ,
                  siempre ,
                  varia1 ,
                  varia2 ,
                  varia3 ,
                  varia4 ,
                  masivo ,
                  minutos ,
                  baja ,
                  origen
                )
        VALUES  ( @empresa , -- empresa - numeric
                  @codigo , -- codigo - numeric
                  @folio , -- folio - int
                  @num_conc , -- num_conc - int
                  '' , -- centro - char(15)
                  '' , -- clase - char(2)
                  @mesOperacion , -- mes_operacion - int
                  @ayoOperacion , -- ayo_operacion - int
                  @tiponom , -- tiponom - int
                  @periodo , -- periodo - int
                  'D' , -- tipoinc - char(1)
                  1 , -- dias - decimal
                  @pago , -- fch_pago - datetime
                  @numCredito , -- numeroinc - varchar(12)
                  CONVERT(BIGINT, @numCredito) , -- num_cr - bigint
                  @inicio , -- fchinicio - datetime
                  @cierre , -- fchtermino - datetime
                  '' , -- inicsubs - char(1)
                  @credito , -- credito - decimal
                  @plazo , -- plazo - int
                  @descuento , -- descuento - decimal
                  @credito , -- saldo - decimal
                  '' , -- justificar - char(1)
                  'N' , -- siempre - char(1)
                  0.00 , -- varia1 - decimal
                  0.00 , -- varia2 - decimal
                  0.00 , -- varia3 - decimal
                  0.00 , -- varia4 - decimal
                  'F' , -- masivo - char(1)
                  1 , -- minutos - int
                  '' , -- baja - char(1)
                  'C'  -- origen - char(1)
                )

                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema
                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @Codigo ,
                                'Importacion desde FONACOT Concepto 117' ,
                                'Periodo : ' + dbo.padl(@periodo,'',2,'0') + '-' + dbo.padl(@ayoOperacion,'',4,'0') + ' TN :' + CONVERT(CHAR(1),@tiponom),
                                'Credito : ' + CONVERT(CHAR(12),@credito) + ' Descuento : ' + CONVERT(CHAR(12),@descuento),
                                @cUser ,
                                '' ,
                                LEFT(Empresas.Registro_Patronal, 10) ,
                                'NO'
                        FROM    Empresas
                        WHERE   Empresa = @empresa



 END TRY
    BEGIN CATCH
	    DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: '
                          + LTRIM(RTRIM(STR(@ErrorState))) + CHAR(13) + CHAR(10)
                          + 'Severity: ' + LTRIM(RTRIM(STR(@ErrorSeverity)))
                          + CHAR(13) + CHAR(10) + 'Error number:  '
                          + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
                          + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13)
                          + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                          + CHAR(13) + CHAR(10) + 'Line: '
                          + LTRIM(RTRIM(STR(ERROR_LINE())))

         IF ( XACT_STATE() ) = -1 OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

            RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
       COMMIT TRANSACTION


GO


/*
Nuevo campo a la tabla de empresas, para registrar el numero de Fonacot, que se utiliza para generar el
archivo de empleados que se debe enviar a Fonacot.
*/

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'fonacot'
                        AND sysobjects.name = 'empresas' )
    ALTER TABLE dbo.empresas ADD fonacot NUMERIC(10,0) NULL

GO


/****************************************************************************************************************************
* Name          : dbo.Fun_E_ObtenerFonacotEmpresa
* Project       : APSI Nomina
* Description   : Noviembre 14, 2013
*                 Obtener el numero de fonacot, de la empresa, para generar el archivo de empleados
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Noviembre 14, 2013
* Parameters    : empresa
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_E_ObtenerFonacotEmpresa') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_ObtenerFonacotEmpresa
GO

CREATE PROCEDURE dbo.Fun_E_ObtenerFonacotEmpresa @empresa AS INTEGER
AS
    SELECT  ISNULL(fonacot, 0) AS 'Fonacot'
    FROM    dbo.empresas
    WHERE   empresa = @empresa

GO


/****************************************************************************************************************************
* Name          : dbo.Fun_E_ActualizarFonacotEmpresa
* Project       : APSI Nomina
* Description   : Octubre 14, 2013
*                 Actualiza el campo Fonacot de la tabla empleadosAdicional, para registrar esta informacion
* Copyright     : (c) Apsi 2009 - 2014. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Octubre 14, 2013
* Parameters    : empresa,codigo,fonacot
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_E_ActualizarFonacotEmpresa') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_ActualizarFonacotEmpresa
GO

CREATE PROCEDURE dbo.Fun_E_ActualizarFonacotEmpresa
    @empresa AS INTEGER ,
    @fonacot AS NUMERIC(10, 0)
AS
    UPDATE  dbo.empresas
    SET     fonacot = ISNULL(@fonacot, 0)
    WHERE   empresa = @empresa


GO


/*
* Tabla para claves de conceptos nominales para los recibos fiscales
*/

IF OBJECT_ID('dbo.CatalogoTipoConceptoCFDI') IS NULL
    CREATE TABLE dbo.CatalogoTipoConceptoCFDI
        (
          idClave INT NOT NULL ,
          descripcion VARCHAR(250) NOT NULL,
          tipo CHAR(1) NOT NULL
        )
GO


IF OBJECT_ID('dbo.CatalogoTipoConceptoCFDI') IS NOT NULL
    BEGIN
        IF NOT EXISTS ( SELECT  catalogo.idClave
                        FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo )
            BEGIN
                BEGIN TRANSACTION
                BEGIN TRY

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 001 ,'Sueldos, Salarios Rayas y Jornales' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave , descripcion ,tipo )
                    VALUES  ( 002 ,'Gratificacin Anual (Aguinaldo)' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave , descripcion , tipo )
                    VALUES  ( 003 ,'Participacin de los Trabajadores en las Utilidades PTU' ,'P')


                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 004,'Reembolso de Gastos Mdicos Dentales y Hospitalarios' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave , descripcion ,tipo)
                    VALUES  ( 005,'Fondo de Ahorro' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 006,'Caja de ahorro' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 007,'Vales' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 008,'Ayudas' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 009,'Contribuciones a Cargo del Trabajador Pagadas por el Patrn' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 010,'Premios por puntualidad' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 011,'Prima de Seguro de vida' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 012,'Seguro de Gastos Medicos Mayores' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 013,'Cuotas Sindicales Pagadas por el Patrn' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 014,'Subsidios por incapacidad' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 015,'Becas para trabajadores y/o hijos' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 016,'Otros' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 017,'Subsidio para el empleo' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 018,'Fomento al primer empleo' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 019,'Horas extra' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 020,'Prima dominical' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 021,'Prima vacacional' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 022,'Prima por antigedad' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 023,'Pagos por separacin' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 024,'Seguro de retiro' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 025,'Indemnizaciones' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 026,'Reembolso por funeral' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 027,'Cuotas de seguridad social pagadas por el patrn' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 028,'Comisiones' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 001,'Seguridad social' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 002,'ISR' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 003,'Aportaciones a retiro, cesanta en edad avanzada y vejez.' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 004,'Otros' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 005,'Aportaciones a Fondo de vivienda' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 006,'Descuento por incapacidad' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 007,'Pensin alimenticia' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 008,'Renta' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 009,'Prstamos provenientes del Fondo Nacional de la Vivienda para los Trabajadores' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 010,'Pago por crdito de vivienda' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 011,'Pago de abonos INFONACOT' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 012,'Anticipo de salarios' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 013,'Pagos hechos con exceso al trabajador' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 014,'Errores' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 015,'Prdidas' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 016,'Averas' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 017,'Adquisicin de artculos producidos por la empresa o establecimiento' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 018,'Cuotas para la constitucin y fomento de sociedades cooperativas y de cajas de ahorro' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 019,'Cuotas sindicales' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 020,'Ausencia (Ausentismo)' ,'D')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 021,'Cuotas obrero patronales' ,'D')

                END TRY
                BEGIN CATCH

                    DECLARE @ErrorSeverity udtInteger
                    DECLARE @ErrorState udtInteger
                    DECLARE @ErrorMessage udtStringSize2048

                    SET @ErrorSeverity = ERROR_SEVERITY()
                    SET @ErrorState = ERROR_STATE()
                    SET @ErrorMessage = 'State: '
                        + LTRIM(RTRIM(STR(@ErrorState))) + CHAR(13) + CHAR(10)
                        + 'Severity: ' + LTRIM(RTRIM(STR(@ErrorSeverity)))
                        + CHAR(13) + CHAR(10) + 'Error number:  '
                        + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
                        + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13)
                        + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                        + CHAR(13) + CHAR(10) + 'Line: '
                        + LTRIM(RTRIM(STR(ERROR_LINE())))

                    IF ( XACT_STATE() ) = -1
                        OR @@TRANCOUNT > 0
                        ROLLBACK TRANSACTION

                    RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

                END CATCH

                IF @@TRANCOUNT > 0
                    COMMIT TRANSACTION


            END
    END

GO

/*
* Se agrego la clave del SAT en la tabla de bancos, para la generacion del recibo fiscal
*/
IF NOT EXISTS (SELECT syscolumns.name
               FROM syscolumns
               LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
               WHERE syscolumns.name = 'claveSAT' AND sysobjects.name='bancos')
  BEGIN
    ALTER TABLE dbo.bancos ADD claveSAT INTEGER NULL
  END
GO

UPDATE dbo.bancos SET claveSAT = 014 WHERE banco = 1 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 000 WHERE banco = 2 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 021 WHERE banco = 3 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 014 WHERE banco = 4 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 012 WHERE banco = 5 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 072 WHERE banco = 6 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 012 WHERE banco = 7 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 000 WHERE banco = 8 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 002 WHERE banco = 9 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 062 WHERE banco = 10 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 044 WHERE banco = 11 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 002 WHERE banco = 12 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 058 WHERE banco = 13 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 030 WHERE banco = 14 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 131 WHERE banco = 15 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 108 WHERE banco = 16 AND claveSAT IS NULL
UPDATE dbo.bancos SET claveSAT = 000 WHERE banco = 99 AND claveSAT IS NULL

GO

/*
Actualizacion al catalogo de claves SAT, para los CFDI 28/12/2013
Se borraron las claves 7,8,18
Se agregaron del 29 al 39
*/

IF OBJECT_ID('dbo.CatalogoTipoConceptoCFDI') IS NOT NULL
    BEGIN

        DELETE dbo.CatalogoTipoConceptoCFDI WHERE idClave IN (7,8,18) AND tipo = 'P'

        IF NOT EXISTS ( SELECT  catalogo.idClave
                        FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                        WHERE catalogo.idClave = 29 AND tipo = 'P')
            BEGIN
                BEGIN TRANSACTION
                BEGIN TRY

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 029 ,'Vales de despensa' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 030 ,'Vales de restaurante' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 031 ,'Vales de gasolina' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 032 ,'Vales de ropa' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 033 ,'Ayuda para renta' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 034 ,'Ayuda para artculos escolares' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 035 ,'Ayuda para anteojos' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 036 ,'Ayuda para transporte' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 037 ,'Ayuda para gastos de funeral' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 038 ,'Otros ingresos por salarios' ,'P')

                    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
                            ( idClave ,descripcion ,tipo )
                    VALUES  ( 039 ,'Jubilaciones, pensiones o haberes de retiro' ,'P')


                END TRY
                BEGIN CATCH

                    DECLARE @ErrorSeverity udtInteger
                    DECLARE @ErrorState udtInteger
                    DECLARE @ErrorMessage udtStringSize2048

                    SET @ErrorSeverity = ERROR_SEVERITY()
                    SET @ErrorState = ERROR_STATE()
                    SET @ErrorMessage = 'State: '
                        + LTRIM(RTRIM(STR(@ErrorState))) + CHAR(13) + CHAR(10)
                        + 'Severity: ' + LTRIM(RTRIM(STR(@ErrorSeverity)))
                        + CHAR(13) + CHAR(10) + 'Error number:  '
                        + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
                        + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13)
                        + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                        + CHAR(13) + CHAR(10) + 'Line: '
                        + LTRIM(RTRIM(STR(ERROR_LINE())))

                    IF ( XACT_STATE() ) = -1
                        OR @@TRANCOUNT > 0
                        ROLLBACK TRANSACTION

                    RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

                END CATCH

                IF @@TRANCOUNT > 0
                    COMMIT TRANSACTION


            END
    END

GO

--Se corrigio la descripcion de la clave 25, estaba mal.
UPDATE dbo.CatalogoTipoConceptoCFDI SET descripcion = 'Indemnizaciones'  WHERE idClave = 25 AND tipo = 'P'

GO

--Se borraron las deducciones de las claves 7,8 y 18, por error
IF NOT EXISTS ( SELECT  catalogo.idClave
                FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                WHERE   catalogo.idClave = 07
                        AND tipo = 'D' )
    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
            ( idClave, descripcion, tipo )
    VALUES  ( 007, 'Pensin alimenticia', 'D' )

GO

IF NOT EXISTS ( SELECT  catalogo.idClave
                FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                WHERE   catalogo.idClave = 08
                        AND tipo = 'D' )
    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
            ( idClave, descripcion, tipo )
    VALUES  ( 008, 'Renta', 'D' )

GO

IF NOT EXISTS ( SELECT  catalogo.idClave
                FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                WHERE   catalogo.idClave = 18
                        AND tipo = 'D' )
    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
            ( idClave ,
              descripcion ,
              tipo
            )
    VALUES  ( 018 ,
              'Cuotas para la constitucin y fomento de sociedades cooperativas y de cajas de ahorro' ,
              'D'
            )
GO

/*
Se agregaron las claves 40,41 y 42 de percepciones que sirven para los gobiernos y paraestatales 15/12/2014
*/

IF NOT EXISTS ( SELECT  catalogo.idClave
                FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                WHERE   catalogo.idClave = 40
                        AND tipo = 'P' )
    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
            ( idClave, descripcion, tipo )
    VALUES  ( 040, 'Ingreso pagado por Entidades federativas, municipios, o demarcaciones territoriales del Distrito Federal, organismos autnomos y entidades paraestatales y paramunicipales con ingresos propios.', 'P' )

GO

IF NOT EXISTS ( SELECT  catalogo.idClave
                FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                WHERE   catalogo.idClave = 41
                        AND tipo = 'P' )
    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
            ( idClave, descripcion, tipo )
    VALUES  ( 041, 'Ingreso por Entidades federativas, municipios, o demarcaciones territoriales del Distrito Federal, organismos autnomos y entidades paraestatales y paramunicipales con ingresos federales.', 'P' )

GO

IF NOT EXISTS ( SELECT  catalogo.idClave
                FROM    dbo.CatalogoTipoConceptoCFDI AS catalogo
                WHERE   catalogo.idClave = 42
                        AND tipo = 'P' )
    INSERT  INTO dbo.CatalogoTipoConceptoCFDI
            ( idClave, descripcion, tipo )
    VALUES  ( 042, 'Ingreso pagado por Entidades federativas, municipios, o demarcaciones territoriales del Distrito Federal, organismos autnomos y entidades paraestatales y paramunicipales con ingresos propios y federales.', 'P' )

GO


/*Campos de RH, que se agregaron para los contratos, se agrego aqui por si no utilizan el modulo de RH.
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Av_priv_correo'
                        AND sysobjects.name = 'rhindicacng' )
    BEGIN
        ALTER TABLE dbo.rhindicacng ADD Av_priv_correo VARCHAR(100)
        ALTER TABLE dbo.rhindicacng ADD Av_priv_direccion VARCHAR(100)
        ALTER TABLE dbo.rhindicacng ADD Av_priv_nombre VARCHAR(100)
        ALTER TABLE dbo.rhindicacng ADD Av_priv_telefono VARCHAR(100)
    END

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_Y_ObtenerPoliza
* Project       : APSI Nomina
* Description   : Junio 11, 2014
*                 Obtiene los registros de acum_conc, para generar el archivo de polizas
* Copyright     : (c) Apsi 2009 - 2016. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Junio 11, 2014
* Parameters    : empresas,ejercicio,totales
*******************************************************************************************************************************/


IF OBJECT_ID('dbo.Fun_Y_ObtenerPoliza') IS NOT NULL
    DROP PROCEDURE dbo.Fun_Y_ObtenerPoliza
GO

CREATE PROCEDURE dbo.Fun_Y_ObtenerPoliza
    @empresas AS VARCHAR(8000) ,
    @ejecicio AS INTEGER ,
    @totales AS CHAR(1)
AS
    IF @totales = 'N'
        BEGIN
            SELECT  ll.centro ,
                    MAX(cc.nomdepto) AS 'NombreCentro',
                    ac.num_conc ,
                    SUM(ac.imp_acum) AS 'importe' ,
                    SUM(ac.dia_acum) AS 'dias' ,
                    SUM(ac.horas) AS 'horas',
                    0 AS 'tipo'
            FROM    dbo.acum_conc AS ac
                    INNER JOIN dbo.acum_emps AS ae ON ac.codigo = ae.codigo
                                                      AND ac.ejercicio = ae.ejercicio
                                                      AND ac.empresa = ae.empresa
                    INNER JOIN dbo.Llaves AS ll ON ae.codigo = ll.codigo
                                                   AND ae.empresa = ll.empresa
                    INNER JOIN dbo.CadenaATabla(@empresas, ',') AS emp ON ac.empresa = emp.valor
                    INNER JOIN dbo.centros AS cc ON ll.centro = cc.centro
                                                    AND ll.empresa = cc.empresa
            WHERE   ac.ejercicio = @ejecicio
            GROUP BY ll.centro ,
                    ac.num_conc
            ORDER BY ll.centro ,
                    ac.num_conc
        END
    ELSE
        BEGIN
            SELECT  MAX('99999999999999') AS 'centro' ,
                    'TOTAL GENERAL' AS 'NombreCentro',
                    ac.num_conc ,
                    SUM(ac.imp_acum) AS 'importe' ,
                    SUM(ac.dia_acum) AS 'dias' ,
                    SUM(ac.horas) AS 'horas',
                    0 AS 'tipo'
            FROM    dbo.acum_conc AS ac
                    INNER JOIN dbo.acum_emps AS ae ON ac.codigo = ae.codigo
                                                      AND ac.ejercicio = ae.ejercicio
                                                      AND ac.empresa = ae.empresa
                    INNER JOIN dbo.CadenaATabla(@empresas, ',') AS emp ON ac.empresa = emp.valor
            WHERE   ac.ejercicio = @ejecicio
            GROUP BY ac.num_conc
            ORDER BY ac.num_conc
        END


GO

/*
Se amplio la longitud de los campos de domicilio,colonia y poblacion a los que se consideran para el CFDI.
*/

UPDATE  dbo.gr_catalogo
SET     longitud = 100
WHERE   campo = 'COLONIA'
        OR campo = 'DOMICILIO'
        AND longitud < 100

UPDATE  dbo.gr_catalogo
SET     longitud = 150
WHERE   campo = 'POBLACION'
        AND longitud < 150


UPDATE  dbo.gr_formas
SET     longitud = 50 ,
        tamori = '100'
WHERE   campo = 'COLONIA'
        OR campo = 'DOMICILIO'
        AND longitud < 100

UPDATE  dbo.gr_formas
SET     longitud = 50 ,
        tamori = '150'
WHERE   campo = 'POBLACION'
        AND longitud < 150


GO


/*
Sp para cancelar los CFDIS timbrados
*/
IF OBJECT_ID('dbo.Fun_U_CancelarCFDI') IS NOT NULL
    DROP PROCEDURE dbo.Fun_U_CancelarCFDI
GO

CREATE PROCEDURE dbo.Fun_U_CancelarCFDI
    @empresa AS INTEGER ,
    @archivoXML AS VARCHAR(1000) ,
    @folioCancela AS VARCHAR(200) ,
    @selloSAT AS VARCHAR(1000) ,
    @noCertificadoSAT AS VARCHAR(1000) ,
    @selloCFD AS VARCHAR(1000) ,
    @fechaTimbrado AS VARCHAR(1000) ,
    @UUID AS VARCHAR(1000) ,
    @cadenaOriginal AS VARCHAR(1000) ,
    @certificadoCSD AS VARCHAR(1000) ,

    @usuario AS VARCHAR(50)
AS
    BEGIN
        BEGIN TRANSACTION
        BEGIN TRY

            INSERT  INTO dbo.CancelaCFDIs
                    SELECT  Empresa ,
                            Codigo ,
                            Periodo ,
                            Ayo ,
                            TipoNom ,
                            Nomina ,
                            ArchivoXML ,
                            CorreoEnviado ,

                            IIF(@UUID = '',SelloSAT,@selloSAT) ,
                            IIF(@UUID = '',NoCertificadoSAT,@noCertificadoSAT) ,
                            IIF(@UUID = '',SelloCFD,@sellOCFD) ,
                            IIF(@UUID = '',FechaTimbrado,@fechaTimbrado) ,
                            IIF(@UUID = '',UUID,@UUID) ,
                            IIF(@UUID = '',CadenaOriginal,@cadenaOriginal) ,
                            IIF(@UUID = '',CertificadoCSD,@certificadoCSD) ,

                            GETDATE() ,
                            @folioCancela ,
                            @Usuario
                    FROM    dbo.ResumenCFDIs
                    WHERE   ArchivoXML = @archivoXML
                            AND Empresa = @empresa

            DELETE  dbo.ResumenCFDIs
            WHERE   Empresa = @empresa
                    AND archivoXML = @archivoXML

        END TRY
        BEGIN CATCH

            DECLARE @ErrorSeverity udtInteger
            DECLARE @ErrorState udtInteger
            DECLARE @ErrorMessage udtStringSize2048

            SET @ErrorSeverity = ERROR_SEVERITY()
            SET @ErrorState = ERROR_STATE()
            SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
                + CHAR(13) + CHAR(10) + 'Severity: '
                + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
                + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER())))
                + CHAR(13) + CHAR(10) + 'Message: ' + ERROR_MESSAGE()
                + CHAR(13) + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                + CHAR(13) + CHAR(10) + 'Line: '
                + LTRIM(RTRIM(STR(ERROR_LINE())))

            IF ( XACT_STATE() ) = -1
                OR @@TRANCOUNT > 0
                ROLLBACK TRANSACTION

            RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

        END CATCH

        IF @@TRANCOUNT > 0
            COMMIT TRANSACTION


    END



GO


IF OBJECT_ID(N'dbo.usuariosInsertaFuncionNueva') IS NOT NULL
    DROP PROCEDURE dbo.usuariosInsertaFuncionNueva
GO

CREATE PROCEDURE dbo.usuariosInsertaFuncionNueva
    (
      @opcion VARCHAR(2) ,
      @funcion VARCHAR(2) ,
      @sistema VARCHAR(2)
    )
AS
    BEGIN
        DECLARE @idPerfil BIGINT

        DECLARE perfilesCursor CURSOR FOR
        SELECT idPerfil FROM perfiles  WHERE sistema=@sistema
        OPEN perfilesCursor
        FETCH NEXT FROM perfilesCursor  INTO @idPerfil
        WHILE @@fetch_status = 0
            BEGIN
                IF NOT EXISTS ( SELECT  idperfil
                                FROM    dbo.perfil_funcion
                                WHERE   funcion = @funcion
                                        AND idperfil = @idPerfil
                                        AND opcion = @opcion )
                    INSERT  INTO perfil_funcion
                    VALUES  ( @funcion, @opcion, @idPerfil )

                FETCH NEXT FROM perfilesCursor INTO @idPerfil
            END
        CLOSE perfilesCursor
        DEALLOCATE perfilesCursor
    END
GO


IF NOT EXISTS ( SELECT  opcion
                FROM    dbo.opciones
                WHERE   funcion = 'K'
                        AND sistema = 'NO'
                        AND opcion = '14' )
    BEGIN

        INSERT  INTO dbo.opciones
                ( opcion ,
                  sistema ,
                  funcion ,
                  descripcion
                )
        VALUES  ( '14' , -- opcion - char(2)
                  'NO' , -- sistema - char(2)
                  'K' , -- funcion - char(2)
                  'Historico de Movimientos'  -- descripcion - varchar(100)
                )

        EXECUTE dbo.usuariosInsertaFuncionNueva '14','K','NO'

    END

GO

/*
Cargar los valores de las primas_issste del regimen 3 de ISSSTE
*/
IF NOT EXISTS ( SELECT  *
                FROM    dbo.Primas_Issste
                WHERE   num_conc_empleado > 0
                AND regimen_seguridad_social = 3 )
    BEGIN
    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 101 , -- num_conc_empleado - int
              201 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              2.75 , -- porcentaje_empleado - float
              7.375 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              'SEGURO DE SALUD TRABAJ. EN ACTIVO' , -- descripcion_empleado - varchar(200)
              'SEGURO DE SALUD TRABAJ. EN ACTIVO' , -- descripcion_patron - varchar(200)
              'ISSSTE ART. 42 FRACC. I INCISO A, DOF 31/03/2007' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 42 FRACC. II INCISO A, DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 102 , -- num_conc_empleado - int
              202 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.625 , -- porcentaje_empleado - float
              0.720 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              'SEGURO DE SALUD TRABAJ. PENSIONADOS' , -- descripcion_empleado - varchar(200)
              'SEGURO DE SALUD TRABAJ. PENSIONADOS' , -- descripcion_patron - varchar(200)
              'ISSSTE ART. 42 FRACC. I INCISO B, DOF 31/03/2007' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 42 FRACC. II INCISO B, DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 103 , -- num_conc_empleado - int
              203 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.625 , -- porcentaje_empleado - float
              0.625 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              'SEGURO DE INVALIDEZ Y VIDA' , -- descripcion_empleado - varchar(200)
              'SEGURO DE INVALIDEZ Y VIDA' , -- descripcion_patron - varchar(200)
              'ISSSTE ART. 140 FRACC. I, DOF 31/03/2007' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 140 FRACC. II, DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              10.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 104 , -- num_conc_empleado - int
              204 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.5 , -- porcentaje_empleado - float
              0.5 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              'SEGURO DE SERVICIOS SOCIALES Y CULTURALES' , -- descripcion_empleado - varchar(200)
              'SEGURO DE SERVICIOS SOCIALES Y CULTURALES' , -- descripcion_patron - varchar(200)
              'ISSSTE ART. 199 FRACC. I, DOF 31/03/2007' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 199 FRACC. II, DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 105 , -- num_conc_empleado - int
              205 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              6.125 , -- porcentaje_empleado - float
              3.175 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              'SEGURO DE CESANTIA EN EDAD AVANZADA Y VEJEZ' , -- descripcion_empleado - varchar(200)
              'SEGURO DE CESANTIA EN EDAD AVANZADA Y VEJEZ' , -- descripcion_patron - varchar(200)
              'ISSSTE ART. 102 FRACC. I, DOF 31/03/2007' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 102 FRACC. II, DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 0 , -- num_conc_empleado - int
              206 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.0 , -- porcentaje_empleado - float
              2.0 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              '' , -- descripcion_empleado - varchar(200)
              'SEGURO DE AHORRO PARA EL RETIRO (SAR)' , -- descripcion_patron - varchar(200)
              '' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 102 FRACC. II DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )


    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 0 , -- num_conc_empleado - int
              207 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.0 , -- porcentaje_empleado - float
              0.75 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              '' , -- descripcion_empleado - varchar(200)
              'SEGUROS DE RIESGO DE TRABAJO' , -- descripcion_patron - varchar(200)
              '' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ART. 75 DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    INSERT INTO dbo.Primas_ISSSTE
            ( num_conc_empleado ,
              num_conc_patron ,
              uso ,
              porcentaje_empleado ,
              porcentaje_patron ,
              fecha_inicio ,
              fecha_termino ,
              regimen_seguridad_social ,
              descripcion_empleado ,
              descripcion_patron ,
              fundamentoLegal_empleado ,
              fundamentoLegal_patron ,
              topeMinimo ,
              topeMaximo ,
              baseTopeMinimo ,
              baseTopeMaximo
            )
    VALUES  ( 0 , -- num_conc_empleado - int
              208 , -- num_conc_patron - int
              'S' , -- uso - char(1)
              0.0 , -- porcentaje_empleado - float
              5.0 , -- porcentaje_patron - float
              '20000101' , -- fecha_inicio - datetime
              '29991231' , -- fecha_termino - datetime
              3 , -- regimen_seguridad_social - int
              '' , -- descripcion_empleado - varchar(200)
              'FONDO DE LA VIVIENDA (FOVISSSTE)' , -- descripcion_patron - varchar(200)
              '' , -- fundamentoLegal_empleado - varchar(2000)
              'ISSSTE ARTICULO 194 DOF 31/03/2007' , -- fundamentoLegal_patron - varchar(2000)
              1.0 , -- topeMinimo - float
              25.0 , -- topeMaximo - float
              'B' , -- baseTopeMinimo - char(1)
              'A'  -- baseTopeMaximo - char(1)
            )

    END

GO


/*Se agrega el campo primas_ISSSTE, para indicar la lista de conceptos de seguridad social, que se consideraran en el calculo de ISSSTE
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'Primas_ISSSTE'
                        AND sysobjects.name = 'conceptos' )
    BEGIN
        ALTER TABLE dbo.conceptos ADD Primas_ISSSTE VARCHAR(2000)
    END


GO


/*Se agrega el campo ISSSTE, para indicar que conceptos forman la base de ISSSTE, antes se utilizaba el campo IMSS, pero al momento de consultar
conceptos automaticos, y esos conceptos no estar seleccionados, se volvian habilitar ya que la nomina les cambian la marca en el campo IMSS.
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'ISSSTE'
                        AND sysobjects.name = 'conceptos' )
    BEGIN
        ALTER TABLE dbo.conceptos ADD ISSSTE CHAR(1)
    END


GO

/*
Actualizar la tabla de conceptos,campo Primas_ISSSTE, con los conceptos de las primas que se aplican, solo para la empresas
de Regimen de seguridad social mayor 1, ISSSTE LEON e ISSSTE
*/
UPDATE  c
SET     c.issste = c.imss
FROM    dbo.conceptos AS c
INNER JOIN dbo.empresas AS e ON c.empresa = e.empresa
WHERE  e.Regimen_Seguridad_Social > 1
       AND c.ISSSTE IS NULL

GO


/*
Actualizar la tabla de conceptos,campo Primas_ISSSTE, con los conceptos de las primas que se aplican, solo para la empresas
de Regimen de seguridad social mayor 1, ISSSTE LEON e ISSSTE
*/
UPDATE  c
SET     c.primas_issste = '{101,102,103,104,105,201,202,203,204,205,206,207,208}'
FROM    dbo.conceptos AS c
INNER JOIN dbo.empresas AS e ON c.empresa = e.empresa
WHERE  e.Regimen_Seguridad_Social > 1
       AND c.issste = 'S'
       AND c.Primas_ISSSTE IS NULL

GO


/*
Se agrega campo DiasTope, para la dependecias que tienen ISSSTE, puedan registrar el tope maximo de dias, ya que algunas utilizan 15.20 y otros 15
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'diasTope'
                        AND sysobjects.name = 'Primas_ISSSTE' )
    BEGIN
        ALTER TABLE dbo.Primas_ISSSTE ADD diasTope FLOAT
    END


GO

UPDATE  dbo.Primas_ISSSTE
SET     diasTope = 15.20
WHERE  Regimen_Seguridad_Social > 1
       AND diasTope IS NULL

GO


/*
Rutinas para actualizar la tabla primas_ISSSTE
*/
IF OBJECT_ID('dbo.Fun_I_ObtenerConceptosPrimasISSSTEEmpleado') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_ObtenerConceptosPrimasISSSTEEmpleado
GO

CREATE PROCEDURE dbo.Fun_I_ObtenerConceptosPrimasISSSTEEmpleado
    @RegimenSeguridadSocial AS INTEGER
AS
    SELECT  num_conc_empleado
    FROM    dbo.Primas_ISSSTE
    WHERE   regimen_seguridad_social = @RegimenSeguridadSocial
    ORDER BY num_conc_empleado

GO


IF OBJECT_ID('dbo.Fun_I_ObtenerConceptosPrimasISSSTEPatron') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_ObtenerConceptosPrimasISSSTEPatron
GO

CREATE PROCEDURE dbo.Fun_I_ObtenerConceptosPrimasISSSTEPatron
    @RegimenSeguridadSocial AS INTEGER
AS
    SELECT  num_conc_patron
    FROM    dbo.Primas_ISSSTE
    WHERE   regimen_seguridad_social = @RegimenSeguridadSocial
    ORDER BY num_conc_patron

GO

IF OBJECT_ID('dbo.Fun_I_ModificarPrimasISSSTE') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_ModificarPrimasISSSTE
GO

CREATE PROCEDURE dbo.Fun_I_ModificarPrimasISSSTE
    @empresa AS INTEGER ,
    @RegimenSeguridadSocial AS INTEGER ,
    @num_conc_Empleado AS INTEGER ,
    @num_conc_Patron AS INTEGER ,
    @porcentaje_Empleado AS FLOAT ,
    @porcentaje_Patron AS FLOAT ,
    @descripcion_Empleado AS VARCHAR(200) ,
    @descripcion_Patron AS VARCHAR(200) ,
    @fundamentoLegal_Empleado AS VARCHAR(2000) ,
    @fundamentoLegal_Patron AS VARCHAR(2000) ,
    @topeMinimo AS FLOAT ,
    @topeMaximo AS FLOAT ,
    @baseTopeMinimo AS CHAR(1) ,
    @baseTopeMaximo AS CHAR(1) ,
    @usuario AS VARCHAR(50)
AS
    BEGIN
        BEGIN TRANSACTION
        BEGIN TRY

            UPDATE  dbo.Primas_ISSSTE
            SET     porcentaje_empleado = @porcentaje_Empleado ,
                    porcentaje_patron = @porcentaje_Patron ,
                    descripcion_empleado = @descripcion_Empleado ,
                    descripcion_patron = @descripcion_Patron ,
                    fundamentoLegal_empleado = @fundamentoLegal_Empleado ,
                    fundamentoLegal_patron = @fundamentoLegal_Patron ,
                    topeMinimo = @topeMinimo ,
                    topeMaximo = @topeMaximo ,
                    baseTopeMinimo = @baseTopeMinimo ,
                    baseTopeMaximo = @baseTopeMaximo
            WHERE   regimen_seguridad_social = @RegimenSeguridadSocial
                    AND num_conc_empleado = @num_conc_Empleado
                    AND num_conc_patron = @num_conc_Patron

            INSERT  INTO dbo.bitacora
                    ( empresa ,
                      fecha ,
                      hora ,
                      funcion ,
                      codigo ,
                      opcion ,
                      opcion2 ,
                      opcion3 ,
                      usuario ,
                      clave ,
                      regpat ,
                      sistema
                    )
            VALUES  ( @empresa , -- empresa - numeric
                      GETDATE() , -- fecha - datetime
                      CONVERT(VARCHAR(10), GETDATE(), 108) , -- hora - char(10)
                      'I' , -- funcion - varchar(20)
                      0 , -- codigo - decimal
                      'Primas Seguridad social' , -- opcion - varchar(50)
                      'Actualizar prima seguridad social Regimen '
                      + CONVERT(CHAR(1), @RegimenSeguridadSocial) , -- opcion2 - varchar(50)
                      'Concepto Empleado '
                      + CONVERT(CHAR(3), @num_conc_Empleado) + ' Patron '
                      + CONVERT(CHAR(3), @num_conc_Patron) , -- opcion3 - varchar(50)
                      @usuario , -- usuario - varchar(20)
                      '' , -- clave - varchar(20)
                      '' , -- regpat - varchar(10)
                      'NO'  -- sistema - char(2)
                    )


        END TRY
        BEGIN CATCH

            DECLARE @ErrorSeverity udtInteger
            DECLARE @ErrorState udtInteger
            DECLARE @ErrorMessage udtStringSize2048

            SET @ErrorSeverity = ERROR_SEVERITY()
            SET @ErrorState = ERROR_STATE()
            SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
                + CHAR(13) + CHAR(10) + 'Severity: '
                + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
                + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER())))
                + CHAR(13) + CHAR(10) + 'Message: ' + ERROR_MESSAGE()
                + CHAR(13) + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                + CHAR(13) + CHAR(10) + 'Line: '
                + LTRIM(RTRIM(STR(ERROR_LINE())))

            IF ( XACT_STATE() ) = -1
                OR @@TRANCOUNT > 0
                ROLLBACK TRANSACTION

            RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

        END CATCH

        IF @@TRANCOUNT > 0
            COMMIT TRANSACTION


    END


GO


IF OBJECT_ID('dbo.Fun_I_EliminarPrimasISSSTE') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_EliminarPrimasISSSTE
GO

CREATE PROCEDURE dbo.Fun_I_EliminarPrimasISSSTE
    @empresa AS INTEGER ,
    @RegimenSeguridadSocial AS INTEGER ,
    @num_conc_Empleado AS INTEGER ,
    @num_conc_Patron AS INTEGER ,
    @usuario AS VARCHAR(50)
AS
    BEGIN
        BEGIN TRANSACTION
        BEGIN TRY

            DELETE  dbo.Primas_ISSSTE
            WHERE   regimen_seguridad_social = @RegimenSeguridadSocial
                    AND num_conc_empleado = @num_conc_Empleado
                    AND num_conc_patron = @num_conc_Patron

            INSERT  INTO dbo.bitacora
                    ( empresa ,
                      fecha ,
                      hora ,
                      funcion ,
                      codigo ,
                      opcion ,
                      opcion2 ,
                      opcion3 ,
                      usuario ,
                      clave ,
                      regpat ,
                      sistema
                    )
            VALUES  ( @empresa , -- empresa - numeric
                      GETDATE() , -- fecha - datetime
                      CONVERT(VARCHAR(10), GETDATE(), 108) , -- hora - char(10)
                      'I' , -- funcion - varchar(20)
                      0 , -- codigo - decimal
                      'Primas Seguridad social' , -- opcion - varchar(50)
                      'Eliminar prima seguridad social Regimen '
                      + CONVERT(CHAR(1), @RegimenSeguridadSocial) , -- opcion2 - varchar(50)
                      'Concepto Empleado '
                      + CONVERT(CHAR(3), @num_conc_Empleado) + ' Patron '
                      + CONVERT(CHAR(3), @num_conc_Patron) , -- opcion3 - varchar(50)
                      @usuario , -- usuario - varchar(20)
                      '' , -- clave - varchar(20)
                      '' , -- regpat - varchar(10)
                      'NO'  -- sistema - char(2)
                    )


        END TRY
        BEGIN CATCH

            DECLARE @ErrorSeverity udtInteger
            DECLARE @ErrorState udtInteger
            DECLARE @ErrorMessage udtStringSize2048

            SET @ErrorSeverity = ERROR_SEVERITY()
            SET @ErrorState = ERROR_STATE()
            SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
                + CHAR(13) + CHAR(10) + 'Severity: '
                + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
                + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER())))
                + CHAR(13) + CHAR(10) + 'Message: ' + ERROR_MESSAGE()
                + CHAR(13) + CHAR(10) + 'Procedure: ' + ERROR_PROCEDURE()
                + CHAR(13) + CHAR(10) + 'Line: '
                + LTRIM(RTRIM(STR(ERROR_LINE())))

            IF ( XACT_STATE() ) = -1
                OR @@TRANCOUNT > 0
                ROLLBACK TRANSACTION

            RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

        END CATCH

        IF @@TRANCOUNT > 0
            COMMIT TRANSACTION


    END


GO

/**************************************************************************************************
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Tablas para FovISSSTE
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 **************************************************************************************************/


IF OBJECT_ID('dbo.FovIssste') IS NULL
    CREATE TABLE dbo.FovIssste
        (
          empresa INT ,
          codigo INT ,
          consecutivo INT IDENTITY ,
          porcentaje FLOAT ,
          importe FLOAT ,
          fecha DATETIME ,
          uso CHAR(1) ,
          concepto INTEGER,
          referencia VARCHAR(300)
            CONSTRAINT PK_FovIssste
            PRIMARY KEY CLUSTERED ( empresa, codigo, consecutivo )
        )

GO


IF OBJECT_ID('dbo.FovIsssteConcepto') IS NULL
    BEGIN
        CREATE TABLE dbo.FovIsssteConcepto
            (
              empresa INT ,
              codigo INT ,
              consecutivo INT ,
              num_conc INT
            )

        ALTER TABLE dbo.FovIsssteConcepto ADD CONSTRAINT FovIsssteConcepto01
        FOREIGN KEY (empresa,codigo,consecutivo)
        REFERENCES dbo.FovIssste(empresa,codigo,consecutivo)
    END

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'CalcularSeguro'
                        AND sysobjects.name = 'FovIssste' )
    ALTER TABLE dbo.FovIssste ADD CalcularSeguro CHAR(1) NULL

GO


/**************************************************************************************************
 * Name          : fun_e_GetFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Extraer los registros de FovIssste de un empleado
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetFovIssste
GO


CREATE PROCEDURE dbo.fun_e_GetFovIssste
    @empresa AS INT ,
    @codigo AS NUMERIC(8)
AS
    SET NOCOUNT OFF

    SELECT  ISNULL(porcentaje,0) AS 'Porcentaje' ,
            ISNULL(importe,0) AS 'Importe' ,
            CASE WHEN uso = 'S' THEN 'SI'
                 ELSE 'NO'
            END AS 'Uso' ,
            consecutivo,
            referencia,
            calcularSeguro
    FROM    dbo.FovIssste
    WHERE   empresa = @empresa
            AND codigo = @codigo
    ORDER BY consecutivo

GO

/**************************************************************************************************
 * Name          : fun_e_GetConceptosFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Extraer los registros de conceptos de FovIssste
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetConceptosFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetConceptosFovIssste
GO


CREATE PROCEDURE dbo.fun_e_GetConceptosFovIssste
    @empresa AS INT ,
    @codigo AS NUMERIC(8) ,
    @consecutivo AS INT
AS
    SET NOCOUNT OFF

    SELECT  DISTINCT
            pc.num_conc ,
            ( SELECT TOP 1
                        c.concepto
              FROM      dbo.conceptos AS c
              WHERE     c.empresa = pc.empresa
                        AND c.num_conc = pc.num_conc
            ) AS 'Concepto' ,
            CASE WHEN pc.num_conc < 100 THEN 'Pago'
                 WHEN pc.num_conc >= 100
                      AND pc.num_conc <= 200 THEN 'Descuento'
                 WHEN pc.num_conc >= 1001
                      AND pc.num_conc <= 1099 THEN 'Descuento'
                 WHEN pc.num_conc >= 1101
                      AND pc.num_conc <= 1199 THEN 'Pago'
                 ELSE ''
            END AS 'Tipo'
    FROM    dbo.FovIsssteConcepto AS pc
    WHERE   pc.empresa = @empresa
            AND pc.codigo = @codigo
            AND pc.consecutivo = @consecutivo
    ORDER BY pc.num_conc

GO


/**************************************************************************************************
 * Name          : dbo.fun_e_GetFovIsssteByConsecutivo
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Extraer el registro de FovIssste de un empleado por el consecutivo,
 *                 para su edicion
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_GetFovIsssteByConsecutivo') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_GetFovIsssteByConsecutivo
GO


CREATE PROCEDURE dbo.fun_e_GetFovIsssteByConsecutivo
    @empresa AS INT ,
    @codigo AS NUMERIC(8) ,
    @consecutivo AS INT
AS
    SET NOCOUNT OFF

    SELECT  ISNULL(porcentaje,0) AS 'Porcentaje' ,
            ISNULL(importe,0) AS 'Importe' ,
            fecha ,
            uso ,
            referencia,
            CalcularSeguro
    FROM    dbo.FovIssste
    WHERE   empresa = @empresa
            AND codigo = @codigo
            AND consecutivo = @consecutivo

GO


/**************************************************************************************************
 * Name          : fun_e_AddFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 157, 2015
 *                 Agregar registros a la tabla de FovIssste y FovIsssteConceptos
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_AddFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_AddFovIssste
GO


CREATE PROCEDURE dbo.fun_e_AddFovIssste
    @empresa AS INTEGER	 ,
    @codigo AS INTEGER ,
    @porcentaje AS FLOAT ,
    @importe AS FLOAT ,
    @referencia AS VARCHAR(300) ,
    @fecha AS DATETIME ,
    @uso AS CHAR(1) ,
    @concepto AS INTEGER,
    @conceptos AS VARCHAR(8000) ,
    @usuario AS VARCHAR(20),
    @calcularSeguro AS CHAR(1)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @consecutivo AS INT

        INSERT INTO dbo.FovIssste
                ( empresa ,
                  codigo ,
                  porcentaje ,
                  importe ,
                  fecha ,
                  uso ,
                  concepto ,
                  referencia,
                  CalcularSeguro
                )
        VALUES  ( @empresa , -- empresa - int
                  @codigo , -- codigo - int
                  @porcentaje, -- porcentaje - float
                  @importe, -- importe - float
                  @fecha , -- fecha - datetime
                  @uso , -- uso - char(1)
                  @concepto , -- concepto - int
                  @referencia,  -- referencia - varchar(300)
                  @calcularSeguro
                )


        SET @consecutivo = @@IDENTITY

        INSERT  dbo.FovIsssteConcepto
                SELECT  @empresa ,
                        @codigo ,
                        @consecutivo ,
                        valor AS 'num_conc'
                FROM    dbo.CadenaATabla(@conceptos, ',')


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Agregar crdito FovIssste' ,
                        'Porcentaje :' + CONVERT(CHAR(10), @porcentaje)
                        + ' Importe :' + CONVERT(CHAR(15), @Importe) ,
                        'Consecutivo :' + CONVERT(CHAR(10), @consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_UpdateFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Actualizar registros a la tabla de FovIssste
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_UpdateFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdateFovIssste
GO


CREATE PROCEDURE dbo.fun_e_UpdateFovIssste
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @porcentaje AS FLOAT ,
    @importe AS FLOAT ,
    @referencia AS VARCHAR(50) ,
    @fecha AS DATETIME ,
    @usuario AS VARCHAR(20),
    @calcularSeguro AS CHAR(1)

AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY


        UPDATE  dbo.FovIssste
        SET     porcentaje = @porcentaje ,
                referencia = @referencia ,
                importe = @importe ,
                fecha = @fecha,
                CalcularSeguro = @calcularSeguro
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Actualizar crdito FovIssste' ,
                        'Porcentaje :' + CONVERT(CHAR(10), @porcentaje)
                        + ' Importe :' + CONVERT(CHAR(15), @Importe) ,
                        'Consecutivo :' + CONVERT(CHAR(10), @consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : fun_e_DelFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Eliminar registros a la tabla de FovIssste y FovIsssteConceptos
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_DelFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_DelFovIssste
GO


CREATE PROCEDURE dbo.fun_e_DelFovIssste
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DELETE  dbo.FovIsssteConcepto
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo

        DELETE  dbo.FovIssste
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Eliminar crdito FovIssste' ,
                        '',
                        'Consecutivo :' + CONVERT(CHAR(10),@consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa


    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : fun_e_UpdateUsoFovIssste
 * Project       : APSI Nomina
 * Description   : Septiembre 29, 2011
 *                 actualiza el campo uso del registro de la tabla de pensionesAlimenticias
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 29, 2011
 * Parameters    : empresa,codigo,consecutivo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_UpdateUsoFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_UpdateUsoFovIssste
GO


CREATE PROCEDURE dbo.fun_e_UpdateUsoFovIssste
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @usoActual AS CHAR(2)
        DECLARE @usoNuevo AS CHAR(2)

        SET @usoActual = ''
        SET @usoNuevo = ''

        SELECT  @usoActual = uso
        FROM    dbo.FovIssste
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


        UPDATE  dbo.FovIssste
        SET     uso = CASE WHEN uso = 'S' THEN 'N'
                           ELSE 'S'
                      END
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo

        SELECT  @usoNuevo = uso
        FROM    dbo.FovIssste
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND consecutivo = @consecutivo


         -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Actualizar uso de crdito FovIssste' ,
                        'valor actual :' + @usoActual + '  nuevo valor :' + @usoNuevo,
                        'Consecutivo :' + CONVERT(CHAR(10), @consecutivo) ,
                        @usuario ,
                        '' ,
                        LEFT(registro_patronal, 10) ,
                        'NO'
                FROM    dbo.empresas
                WHERE   empresa = @empresa



    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_AddConceptoFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Agregar conceptos a la tabla de FovIsssteConcepto
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_AddConceptoFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_AddConceptoFovIssste
GO


CREATE PROCEDURE dbo.fun_e_AddConceptoFovIssste
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @num_conc AS INT ,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF NOT EXISTS ( SELECT  codigo
                        FROM    dbo.FovIsssteConcepto
                        WHERE   empresa = @empresa
                                AND codigo = @codigo
                                AND consecutivo = @consecutivo
                                AND num_conc = @num_conc )
            BEGIN
                INSERT  dbo.FovIsssteConcepto
                        ( empresa ,
                          codigo ,
                          consecutivo ,
                          num_conc

                        )
                VALUES  ( @empresa , -- empresa - int
                          @codigo , -- codigo - int
                          @consecutivo , -- consecutivo - int
                          CONVERT(INT, @num_conc)  -- num_conc - int

                        )


                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Agregar concepto FovIssste '
                                + CONVERT(CHAR(4), @num_conc) ,
                                'Consecutivo :'
                                + CONVERT(CHAR(10), @consecutivo) ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : fun_e_DelConceptoFovIssste
 * Project       : APSI GNomina
 * Description   : Septiembre 15, 2015
 *                 Eliminar conceptos a la tabla FovIsssteConcepto
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa,codigo,consecutivo,usuario
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_e_DelConceptoFovIssste') IS NOT NULL
    DROP PROCEDURE dbo.fun_e_DelConceptoFovIssste
GO


CREATE PROCEDURE dbo.fun_e_DelConceptoFovIssste
    @empresa AS INT ,
    @codigo AS INT ,
    @consecutivo AS INT ,
    @num_conc AS INT ,
    @usuario AS VARCHAR(20)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF EXISTS ( SELECT  codigo
                    FROM    dbo.FovIsssteConcepto
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                            AND consecutivo = @consecutivo
                            AND num_conc = @num_conc )
            BEGIN
                DELETE  dbo.FovIsssteConcepto
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                        AND num_conc = @num_conc
                        AND consecutivo = @consecutivo


                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'E' ,
                                @codigo ,
                                'Eliminar concepto FovIssste '
                                + CONVERT(CHAR(4), @num_conc) ,
                                'Consecutivo :'
                                + CONVERT(CHAR(10), @consecutivo) ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Project       : APSI Nomina
 * Description   : Septiembre 15, 2015
 *                 Tabla para el catalogo de Mano de obra
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 **************************************************************************************************/


IF OBJECT_ID('dbo.ManoObra') IS NULL
    CREATE TABLE dbo.ManoObra
        (
          empresa INT ,
          clave CHAR(1) ,
          descripcion VARCHAR(200)
            CONSTRAINT PK_ManoObra PRIMARY KEY CLUSTERED ( empresa, clave )
        )

GO


/*
Agregar las claves iniciales para la tabla de mano de obra si no existen
D.-Directos
I.-Indirectos
 .-Sin definir
*/
IF NOT EXISTS ( SELECT  clave
                FROM    dbo.ManoObra
                WHERE   clave = ' ' )
    INSERT  INTO dbo.ManoObra
            SELECT  e.empresa ,
                    ' ' AS 'Clave' ,
                    'Sin definicin' AS 'Descripcion'
            FROM    dbo.empresas AS e

GO


IF NOT EXISTS ( SELECT  clave
                FROM    dbo.ManoObra
                WHERE   clave = 'D' )
    INSERT  INTO dbo.ManoObra
            SELECT  e.empresa ,
                    'D' AS 'Clave' ,
                    'Directos' AS 'Descripcion'
            FROM    dbo.empresas AS e

GO


IF NOT EXISTS ( SELECT  clave
                FROM    dbo.ManoObra
                WHERE   clave = 'I' )
    INSERT  INTO dbo.ManoObra
            SELECT  e.empresa ,
                    'I' AS 'Clave' ,
                    'Indirectos' AS 'Descripcion'
            FROM    dbo.empresas AS e

GO

/*
Elimina las restricciones de la tabla de empleados para que permita registrar mas tipos de mano de obra, solo admitita '','D','I'
*/
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'[DF__empleados__manoo__3E1D39E1]')
                    AND type = 'D' )
    BEGIN
        ALTER TABLE [dbo].[empleados] DROP CONSTRAINT [DF__empleados__manoo__3E1D39E1]
    END

GO

IF EXISTS ( SELECT  *
            FROM    sys.check_constraints
            WHERE   object_id = OBJECT_ID(N'[dbo].[CK__empleados__manoo__3F115E1A]')
                    AND parent_object_id = OBJECT_ID(N'[dbo].[empleados]') )
    ALTER TABLE [dbo].[empleados] DROP CONSTRAINT [CK__empleados__manoo__3F115E1A]

GO

IF EXISTS ( SELECT  *
            FROM    sys.check_constraints
            WHERE   object_id = OBJECT_ID(N'[dbo].[CK__empleados__manoo__58D1301D]')
                    AND parent_object_id = OBJECT_ID(N'[dbo].[empleados]') )
    ALTER TABLE [dbo].[empleados] DROP CONSTRAINT [CK__empleados__manoo__58D1301D]

GO

/**************************************************************************************************
 * Name          : dbo.fun_I_GetManoObra
 * Project       : APSI Nomina
 * Description   : Septiembre 15, 2015
 *                 Extraer los registros de ManoObra
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_GetManoObra') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_GetManoObra
GO


CREATE PROCEDURE dbo.fun_I_GetManoObra @empresa AS INT
AS
    SET NOCOUNT OFF

    SELECT  clave ,
            descripcion
    FROM    dbo.ManoObra
    WHERE   empresa = @empresa
    ORDER BY clave

GO


/**************************************************************************************************
 * Name          : dbo.fun_I_AddManoObra
 * Project       : APSI Nomina
 * Description   : Septiembre 15, 2015
 *                 Agregar un registro a la tabla ManoObra
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_AddManoObra') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_AddManoObra
GO


CREATE PROCEDURE dbo.fun_I_AddManoObra
    @empresa AS INT ,
    @clave AS CHAR(1) ,
    @descripcion AS VARCHAR(200) ,
    @usuario AS VARCHAR(50)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF NOT EXISTS ( SELECT  clave
                        FROM    dbo.ManoObra
                        WHERE   empresa = @empresa
                                AND clave = @clave )
            BEGIN
                INSERT  INTO dbo.ManoObra
                        ( empresa, clave, descripcion )
                VALUES  ( @empresa, -- empresa - int
                          @clave, -- clave - char(1)
                          @descripcion  -- descripcion - varchar(200)
                          )

                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'I' ,
                                0 ,
                                'Agregar registro ManoObra ' + @clave ,
                                '' ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

/**************************************************************************************************
 * Name          : dbo.fun_I_UpdManoObra
 * Project       : APSI Nomina
 * Description   : Septiembre 15, 2015
 *                 Actualizar un registro a la tabla ManoObra
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_UpdManoObra') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_UpdManoObra
GO


CREATE PROCEDURE dbo.fun_I_UpdManoObra
    @empresa AS INT ,
    @clave AS CHAR(1) ,
    @descripcion AS VARCHAR(200) ,
    @usuario AS VARCHAR(50)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF EXISTS ( SELECT  clave
                    FROM    dbo.ManoObra
                    WHERE   empresa = @empresa
                            AND clave = @clave )
            BEGIN

                UPDATE  dbo.ManoObra
                SET     descripcion = @descripcion
                WHERE   empresa = @empresa
                        AND clave = @clave

                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'I' ,
                                0 ,
                                'Actualizar registro ManoObra ' + @clave ,
                                '' ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/**************************************************************************************************
 * Name          : dbo.fun_I_DelManoObra
 * Project       : APSI Nomina
 * Description   : Septiembre 15, 2015
 *                 Eliminar un registro a la tabla ManoObra
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Septiembre 15, 2015
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_DelManoObra') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_DelManoObra
GO


CREATE PROCEDURE dbo.fun_I_DelManoObra
    @empresa AS INT ,
    @clave AS CHAR(1) ,
    @usuario AS VARCHAR(50)
AS
    SET NOCOUNT OFF

    BEGIN TRANSACTION
    BEGIN TRY

        IF EXISTS ( SELECT  clave
                    FROM    dbo.ManoObra
                    WHERE   empresa = @empresa
                            AND clave = @clave )
            BEGIN

                /* Envia a los empleados con la clave de mano de obra a Eliminar a la no definidos */
                UPDATE  dbo.empleados
                SET     manoobra = ' '
                WHERE   empresa = @empresa
                        AND manoobra = @clave

                DELETE  dbo.ManoObra
                WHERE   empresa = @empresa
                        AND clave = @clave

                 -- Actualizar la bitacora
                INSERT  INTO dbo.Bitacora
                        ( Empresa ,
                          Fecha ,
                          Hora ,
                          Funcion ,
                          Codigo ,
                          Opcion ,
                          Opcion2 ,
                          Opcion3 ,
                          Usuario ,
                          Clave ,
                          RegPat ,
                          Sistema

                        )
                        SELECT  @empresa ,
                                GETDATE() ,
                                SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                                'I' ,
                                0 ,
                                'Eliminar registro ManoObra ' + @clave ,
                                '' ,
                                '' ,
                                @usuario ,
                                '' ,
                                LEFT(registro_patronal, 10) ,
                                'NO'
                        FROM    dbo.empresas
                        WHERE   empresa = @empresa

            END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/*
Se agrego nuevo campo, para saber como se van a dividir los dias de variables :
DiasNaturales .- Igual como siempre se ha hecho sobre los dias de avisos_imss
Diasnomina    .- De la tabla nomina1_anual, se consideraran los dias, ausentismos e incapacidades,
                 De los periodos que esten dentro del bimestre
                 24/08/2012
*/
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'codigo'
                        AND sysobjects.name = 'Supervisores' )
    ALTER TABLE dbo.supervisores ADD codigo NUMERIC(8,0) NULL

GO

IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'passwordPortal'
                        AND sysobjects.name = 'Supervisores' )
    ALTER TABLE dbo.supervisores ADD passwordPortal VARCHAR(100) NULL

GO


IF NOT EXISTS (SELECT syscolumns.name
               FROM syscolumns
               LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
               WHERE UPPER(syscolumns.name) = 'EMAIL' AND
                     UPPER(sysobjects.name) = 'SUPERVISORES')

  ALTER TABLE dbo.Supervisores ADD EMail VARCHAR(100) NULL

GO


/**************************************************************************************************
 * Name          : dbo.fun_I_GetSupervisores
 * Project       : APSI Nomina
 * Description   : Octubre 05, 2015
 *                 Obtener catalogo de supervisores, relacionado con empleados
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 05, 2015
 * Parameters    : empresa
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_GetSupervisores') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_GetSupervisores
GO


CREATE PROCEDURE dbo.fun_I_GetSupervisores @empresa AS INT
AS
    SET NOCOUNT OFF

    SELECT  s.supervisor ,
            s.nombre ,
            s.turno ,
            ISNULL(s.codigo, 0) AS 'Empleado' ,
            ISNULL(RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
                   + RTRIM(e.nombre), '') AS 'NombreEmpleado',
            s.empresa,
            s.email
    FROM    dbo.supervisores AS s
            LEFT JOIN empleados AS e ON s.empresa = e.empresa
                                        AND s.codigo = e.codigo
    WHERE   s.empresa = @empresa
            AND s.supervisor > 0
    ORDER BY s.supervisor

GO






/**************************************************************************************************
 * Name          : dbo.fun_I_BuscarEmpleadoSupervisor
 * Project       : APSI Nomina
 * Description   : Octubre 05, 2015
 *                 Buscar si el numero de empleado esta activo y no es supervisor
 * Copyright     : (c) Apsi 2009 - 2015. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com.mx/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : Octubre 05, 2015
 * Parameters    : empresa,codigo
 **************************************************************************************************/
IF OBJECT_ID('dbo.fun_I_BuscarEmpleadoSupervisor') IS NOT NULL
    DROP PROCEDURE dbo.fun_I_BuscarEmpleadoSupervisor
GO


CREATE PROCEDURE dbo.fun_I_BuscarEmpleadoSupervisor
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0)
AS
    SET NOCOUNT OFF

    SELECT  codigo ,
            RTRIM(ap_paterno) + ' ' + RTRIM(ap_materno) + ' ' + RTRIM(nombre) AS 'Nombre' ,
            activo ,
            ultmov ,
            ultfchmov ,
            ISNULL(( SELECT    supervisor
              FROM      supervisores
              WHERE     empresa = @empresa
                        AND codigo = @codigo
            ),0) AS 'Supervisor'
    FROM    empleados
    WHERE   empresa = @empresa
            AND codigo = @codigo

GO

/*
Ampliar la longitud para el nombre completo del empleado a 60 caracteres para el reporteador.
*/
UPDATE  dbo.gr_catalogo
SET     longitud = 60 ,
        tamori = '60'
WHERE   numero = 4
        AND longitud < 60

GO

UPDATE  dbo.gr_formas
SET     longitud = 60 ,
        tamori = '60'
WHERE   numero = 4
        AND longitud < 60

GO


IF OBJECT_ID('dbo.fun_Y_ReporteFoliosFiscales') IS NOT NULL
    DROP PROCEDURE dbo.fun_Y_ReporteFoliosFiscales
GO


CREATE PROCEDURE dbo.fun_Y_ReporteFoliosFiscales
    @empresas AS VARCHAR(MAX) ,
    @ejercicio AS INT
AS
    SET NOCOUNT OFF

    SELECT  rc.empresa ,
            rc.Codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre) AS 'Nombre' ,
            e.rfcalfa ,
            e.rfcnum ,
            e.rfchomo ,
            rc.periodo ,
            rc.Ayo ,
            rc.TipoNom ,
            rc.Nomina ,
            rc.UUID ,
            rc.FechaTimbrado ,
            rc.ArchivoXML ,
            rc.CorreoEnviado,
            n.nomina
    FROM    dbo.ResumenCFDIs AS rc
            INNER JOIN dbo.empleados AS e ON rc.Empresa = e.empresa
                                             AND rc.Codigo = e.codigo
            INNER JOIN dbo.CadenaATabla(@empresas, ',') AS emp ON rc.Empresa = emp.valor
            INNER JOIN dbo.Nominas AS n ON rc.Empresa = n.empresa AND rc.TipoNom = n.tiponom
    WHERE   rc.Ayo = @ejercicio
    ORDER BY rc.empresa ,
            rc.Codigo ,
            rc.Periodo ,
            rc.tiponom

GO


IF OBJECT_ID('dbo.fun_Y_ReporteNoTimbrados') IS NOT NULL
    DROP PROCEDURE dbo.fun_Y_ReporteNoTimbrados
GO


CREATE PROCEDURE dbo.fun_Y_ReporteNoTimbrados
    @empresas AS VARCHAR(MAX) ,
    @ejercicio AS INT
AS
    SET NOCOUNT OFF

    SELECT DISTINCT
            k.empresa ,
            k.codigo ,
            MAX(RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre)) AS 'Nombre' ,
            MAX(e.rfcalfa) AS 'rfcalfa' ,
            MAX(e.rfcnum) AS 'rfcnum' ,
            MAX(e.rfchomo) AS 'rfchomo' ,
            k.periodo ,
            k.ayo_operacion,
            k.tiponom ,
            n.nomina ,
            k.nomina ,
			SUM(CASE WHEN k.tpago_desc = 'P' THEN k.importe ELSE 0 END) AS 'Percepciones',
			SUM(CASE WHEN k.tpago_desc = 'D' THEN k.importe ELSE 0 END) AS 'Deducciones',
			SUM(CASE WHEN k.tpago_desc = 'P' THEN k.importe ELSE k.importe * -1 END) AS 'Neto'
    FROM    dbo.kardex_anual AS k
            INNER JOIN dbo.empleados AS e ON k.empresa = e.empresa
                                             AND k.codigo = e.codigo
            --INNER JOIN dbo.CadenaATabla(@empresas, ',') AS emp ON k.Empresa = emp.valor
            INNER JOIN dbo.Nominas AS n ON k.Empresa = n.empresa AND k.TipoNom = n.tiponom
    WHERE   k.ayo_operacion = @ejercicio
            AND NOT EXISTS ( SELECT r.Codigo
                             FROM   dbo.ResumenCFDIs AS r
                             WHERE  k.empresa = r.Empresa
                                    AND r.Ayo = k.ayo_operacion
                                    AND r.TipoNom = k.tiponom
                                    AND r.Nomina = k.nomina
                                    AND r.Periodo = k.periodo
                                    AND r.Codigo = k.codigo )
            AND k.empresa IN (SELECT CONVERT(INT,valor) FROM dbo.CadenaATabla(@empresas, ',') )
			AND k.tpago_desc <> 'I'
    GROUP BY k.empresa ,
            k.periodo ,
			K.ayo_operacion,
            k.tiponom ,
            k.nomina,
            k.codigo,
			n.nomina
    ORDER BY k.empresa ,
            k.periodo ,
            k.tiponom ,
            k.nomina,
            k.codigo

GO

/*
Actualiza el nombre de la descripcion en el reporteador 16/02/2016 Mario Garcia.
*/
UPDATE  dbo.gr_catalogo
SET     descrip = 'CUOTA DIARIA'
WHERE   numero = 6
        AND descrip = 'SUELDO O CUOTA DIARIA'

UPDATE  dbo.gr_catalogo
SET     descrip = 'SALARIO BASE DE COTIZACION'
WHERE   numero = 8
        AND descrip = 'SAL. DIARIO INTEGRADO (IMSS)'

UPDATE  dbo.gr_formas
SET     descrip = 'CUOTA DIARIA'
WHERE   numero = 6
        AND descrip = 'SUELDO O CUOTA DIARIA'

UPDATE  dbo.gr_formas
SET     descrip = 'SALARIO BASE DE COTIZACION'
WHERE   numero = 8
        AND descrip = 'SAL. DIARIO INTEGRADO (IMSS)'

GO


/* Nuevas tablas y procedimientos para el registro de la subcontratacion para el timbrado de nomina ver 1.2 Mario Garcia 28/10/2016 */
/*
 * TABLE: SubContratacionEmpleado
 */
IF OBJECT_ID('SubContratacionEmpleado') IS NULL
    CREATE TABLE dbo.SubContratacionEmpleado
        (
          empresa INT NOT NULL ,
          codigo NUMERIC(8, 0) NOT NULL ,
          RFC CHAR(13) NOT NULL ,
          tiponom INT NOT NULL ,
          periodo INT NOT NULL ,
          ayo_operacion INT NOT NULL ,
          porcentaje FLOAT NOT NULL ,
          CONSTRAINT SubContratacionPK2 PRIMARY KEY CLUSTERED
            ( empresa, codigo, RFC, tiponom, periodo, ayo_operacion )
        )
go

/*
 * TABLE: SubContratacionPatron
 */

IF OBJECT_ID('SubContratacionPatron') IS NULL
    CREATE TABLE dbo.SubContratacionPatron
        (
          RFC CHAR(13) NOT NULL ,
          RazonSocial VARCHAR(200) NULL ,
          CONSTRAINT SubcontratacionPK1 PRIMARY KEY CLUSTERED ( RFC )
        )
go


/*
 * INDEX: SubContratacionRef11
 */
IF NOT EXISTS ( SELECT  *
                FROM    sys.indexes
                WHERE   object_id = OBJECT_ID('SubContratacionEmpleado')
                        AND name = 'SubContratacionRef11' )
    BEGIN

        CREATE INDEX SubContratacionRef11 ON SubContratacionEmpleado(RFC)

/*
 * TABLE: SubContratacionEmpleado
 */

        ALTER TABLE dbo.SubContratacionEmpleado ADD CONSTRAINT RefSubContratacionPatron1
        FOREIGN KEY (RFC)
        REFERENCES SubContratacionPatron(RFC)

    END


go


IF OBJECT_ID('dbo.Fun_I_AddSubcontratacionRFC') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_AddSubcontratacionRFC
GO

CREATE PROCEDURE dbo.Fun_I_AddSubcontratacionRFC
    @empresa AS INTEGER ,
    @rfc AS CHAR(13) ,
    @razonSocial AS VARCHAR(200) ,
    @cUser AS VARCHAR(50)
AS
    SET NOCOUNT ON
    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @opcion AS VARCHAR(50)

        IF NOT EXISTS ( SELECT  razonsocial
                        FROM    dbo.SubContratacionPatron
                        WHERE   RFC = @rfc )
            BEGIN
                INSERT  INTO dbo.SubContratacionPatron
                        ( RFC, RazonSocial )
                VALUES  ( @rfc, -- RFC - char(13)
                          @razonSocial  -- RazonSocial - varchar(200)
                          )
                SET @opcion = 'Agregar RFC SubContratacion'
            END
        ELSE
            BEGIN
                UPDATE  dbo.SubContratacionPatron
                SET     RazonSocial = @razonSocial
                WHERE   RFC = @rfc
                SET @opcion = 'Actualizar Razon social SubContratacion'

            END

        -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'I' ,
                        0 ,
                        @opcion ,
                        'R.F.C. :' + @rfc ,
                        SUBSTRING(@razonSocial,1,50) ,
                        @cUser ,
                        '' ,
                        LEFT(Empresas.Registro_Patronal, 10) ,
                        'NO'
                FROM    dbo.Empresas
                WHERE   Empresa = @empresa


    END TRY

    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO


IF OBJECT_ID('dbo.Fun_I_DelSubcontratacionRFC') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_DelSubcontratacionRFC
GO

CREATE PROCEDURE dbo.Fun_I_DelSubcontratacionRFC
    @empresa AS INTEGER ,
    @rfc AS CHAR(13) ,
    @razonSocial AS VARCHAR(200) ,
    @cUser AS VARCHAR(50)
AS
    SET NOCOUNT ON
    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @opcion AS VARCHAR(50)
        SET @opcion = 'Eliminar R.F.C. SubContratacion'

        DELETE  dbo.SubContratacionPatron
        WHERE   RFC = @rfc


        -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'I' ,
                        0 ,
                        @opcion ,
                        'R.F.C. :' + @rfc ,
                        SUBSTRING(@razonSocial,1,50) ,
                        @cUser ,
                        '' ,
                        LEFT(Empresas.Registro_Patronal, 10) ,
                        'NO'
                FROM    dbo.Empresas
                WHERE   Empresa = @empresa


    END TRY

    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO


IF OBJECT_ID('dbo.Fun_I_GetSubcontratacionRFC') IS NOT NULL
    DROP PROCEDURE dbo.Fun_I_GetSubcontratacionRFC
GO

CREATE PROCEDURE dbo.Fun_I_GetSubcontratacionRFC
AS
    SET NOCOUNT ON
    SELECT  RFC ,
            RazonSocial
    FROM    dbo.SubContratacionPatron
    ORDER BY rfc

GO



IF OBJECT_ID('dbo.Fun_F_AddSubcontratacionPorcentaje') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_AddSubcontratacionPorcentaje
GO

CREATE PROCEDURE dbo.Fun_F_AddSubcontratacionPorcentaje
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @rfc AS CHAR(13) ,
    @tiponom AS INTEGER ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER ,
    @porcentaje AS FLOAT ,
    @funcion AS CHAR(20) ,
    @cUser AS VARCHAR(50) ,
	@fechaInicial AS DATETIME,
	@fechaFinal AS DATETIME
AS
    SET NOCOUNT ON
    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @opcion AS VARCHAR(50)

        IF NOT EXISTS ( SELECT  porcentaje
                        FROM    dbo.SubContratacionEmpleado
                        WHERE   empresa = @empresa
                                AND codigo = @codigo
                                AND LTRIM(RFC) = LTRIM(@rfc)
                                AND tiponom = @tiponom
                                AND periodo = @periodo
                                AND ayo_operacion = @ayo_operacion )
            BEGIN

                INSERT  INTO dbo.SubContratacionEmpleado
                        ( empresa ,
                          codigo ,
                          RFC ,
                          tiponom ,
                          periodo ,
                          ayo_operacion ,
                          porcentaje,
						  FechaInicial,
						  FechaFinal
                        )
                VALUES  ( @empresa , -- empresa - int
                          @codigo , -- codigo - numeric
                          @rfc , -- RFC - char(13)
                          @tiponom , -- tiponom - int
                          @periodo , -- periodo - int
                          @ayo_operacion , -- ayo_operacion - int
                          @porcentaje,  -- porcentaje - float
						  @fechaInicial,
						  @fechaFinal
                        )

                SET @opcion = 'Agregar porcentaje SubContratacion'
            END
        ELSE
            BEGIN
                UPDATE  dbo.SubContratacionEmpleado
                SET     porcentaje = @porcentaje,
				        fechaInicial = @fechaInicial,
						fechaFinal = @fechaFinal
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                        AND RFC = @rfc
                        AND tiponom = @tiponom
                        AND periodo = @periodo
                        AND ayo_operacion = @ayo_operacion

                /*Como se agregaron las fechas cuando las actualicen tambien se actualicen las que tengan valor nulo 20/02/2018 */
                UPDATE  dbo.SubContratacionEmpleado
                SET     fechaInicial = @fechaInicial,
						fechaFinal = @fechaFinal
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                        AND RFC = @rfc
						AND fechaInicial IS NULL
						AND fechaFinal IS NULL

                SET @opcion = 'Modificar porcentaje SubContratacion'

            END

        -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        @funcion ,
                        @codigo ,
                        @opcion ,
                        'R.F.C. :' + @rfc ,
                        'Porcentaje :' + CONVERT(CHAR(15), @porcentaje) ,
                        @cUser ,
                        '' ,
                        LEFT(Empresas.Registro_Patronal, 10) ,
                        'NO'
                FROM    dbo.Empresas
                WHERE   Empresa = @empresa


    END TRY

    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO


IF OBJECT_ID('dbo.Fun_F_DelSubcontratacionPorcentaje') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_DelSubcontratacionPorcentaje
GO

CREATE PROCEDURE dbo.Fun_F_DelSubcontratacionPorcentaje
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @rfc AS CHAR(13) ,
    @tiponom AS INTEGER ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER ,
    @porcentaje AS FLOAT ,
    @funcion AS CHAR(20) ,
    @cUser AS VARCHAR(50)
AS
    SET NOCOUNT ON
    BEGIN TRANSACTION
    BEGIN TRY

        DECLARE @opcion AS VARCHAR(50)
        SET @opcion = 'Eliminar porcentaje SubContratacion'


        DELETE  dbo.SubContratacionEmpleado
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND RFC = @rfc
                AND tiponom = @tiponom
                AND periodo = @periodo
                AND ayo_operacion = @ayo_operacion

        -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        @funcion ,
                        @codigo ,
                        @opcion ,
                        'R.F.C. :' + @rfc ,
                        'Porcentaje :' + CONVERT(CHAR(15), @porcentaje) ,
                        @cUser ,
                        '' ,
                        LEFT(Empresas.Registro_Patronal, 10) ,
                        'NO'
                FROM    dbo.Empresas
                WHERE   Empresa = @empresa


    END TRY

    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO


IF OBJECT_ID('dbo.Fun_F_GetSubcontratacionPorcentaje') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_GetSubcontratacionPorcentaje
GO

CREATE PROCEDURE dbo.Fun_F_GetSubcontratacionPorcentaje
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @tiponom AS INTEGER ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER
AS
    SET NOCOUNT ON

    SELECT  se.RFC ,
            sp.RazonSocial,
            se.porcentaje ,
			se.fechaInicial,
			se.fechaFinal
    FROM    dbo.SubContratacionEmpleado AS se
    INNER JOIN dbo.SubContratacionPatron AS sp ON se.RFC = sp.RFC
    WHERE   se.empresa = @empresa
            AND se.codigo = @codigo
            AND se.tiponom = @tiponom
            AND se.periodo = @periodo
            AND se.ayo_operacion = @ayo_operacion
    ORDER BY se.RFC

GO


IF OBJECT_ID('dbo.Fun_F_GetSubcontratacionByRfc') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_GetSubcontratacionByRfc
GO

CREATE PROCEDURE dbo.Fun_F_GetSubcontratacionByRfc
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @tiponom AS INTEGER ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER ,
    @rfc AS CHAR(13)
AS
    SET NOCOUNT ON

    SELECT  se.RFC ,
            sp.RazonSocial,
            se.porcentaje,
			se.fechaInicial,
			se.fechaFinal
    FROM    dbo.SubContratacionEmpleado AS se
    INNER JOIN dbo.SubContratacionPatron AS sp ON se.RFC = sp.RFC
    WHERE   se.empresa = @empresa
            AND se.codigo = @codigo
            AND se.tiponom = @tiponom
            AND se.periodo = @periodo
            AND se.ayo_operacion = @ayo_operacion
            AND se.RFC = @rfc

GO


IF OBJECT_ID('dbo.Fun_F_GetSubcontratacionTiponomXCodigo') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_GetSubcontratacionTiponomXCodigo
GO

CREATE PROCEDURE dbo.Fun_F_GetSubcontratacionTiponomXCodigo
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0),
    @rfc AS CHAR(13)

AS
    SET NOCOUNT ON

    SELECT  DISTINCT se.tiponom,
	                 n.nomina
    FROM    dbo.SubContratacionEmpleado AS se
	INNER JOIN dbo.nominas AS n ON se.empresa = n.empresa AND n.tiponom = se.tiponom
    WHERE   se.empresa = @empresa
            AND se.codigo = @codigo
			AND se.rfc = @rfc
    ORDER BY se.tiponom

GO


IF OBJECT_ID('dbo.Fun_F_GetSubcontratacionPeriodosXCodigo') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_GetSubcontratacionPeriodosXCodigo
GO

CREATE PROCEDURE dbo.Fun_F_GetSubcontratacionPeriodosXCodigo
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0),
	@tiponom AS INTEGER,
    @rfc AS CHAR(13)

AS
    SET NOCOUNT ON

    SELECT  DISTINCT se.periodo,
	                 se.ayo_operacion,
					 p.estatus
    FROM    dbo.SubContratacionEmpleado AS se
	INNER JOIN dbo.periodos AS p ON se.empresa = p.empresa AND se.tiponom = p.tiponom AND se.periodo = p.periodo AND se.ayo_operacion = p.ayo_operacion
    WHERE   se.empresa = @empresa
            AND se.codigo = @codigo
			AND se.tiponom = @tiponom
			AND se.rfc = @rfc
			AND NOT EXISTS (SELECT rc.uuid FROM dbo.ResumenCFDIS AS rc WHERE rc.empresa = se.empresa
			                                                            AND rc.codigo = se.codigo
											    						AND rc.tiponom = se.tiponom
																		AND rc.periodo = se.periodo
																		AND rc.ayo = se.ayo_operacion)

    ORDER BY se.ayo_operacion DESC, se.periodo DESC

GO


IF NOT EXISTS ( SELECT  opcion
                FROM    dbo.opciones
                WHERE   funcion = 'I'
                        AND sistema = 'NO'
                        AND opcion = 'T' )
    BEGIN

        INSERT  INTO dbo.opciones
                ( opcion ,
                  sistema ,
                  funcion ,
                  descripcion
                )
        VALUES  ( 'T' , -- opcion - char(2)
                  'NO' , -- sistema - char(2)
                  'I' , -- funcion - char(2)
                  'Registro RFCs SubContratacion'  -- descripcion - varchar(100)
                )

        EXECUTE dbo.usuariosInsertaFuncionNueva 'T','I','NO'

    END

GO

IF NOT EXISTS ( SELECT  opcion
                FROM    dbo.opciones
                WHERE   funcion = 'I'
                        AND sistema = 'NO'
                        AND opcion = 'T1' )
    BEGIN

        INSERT  INTO dbo.opciones
                ( opcion ,
                  sistema ,
                  funcion ,
                  descripcion
                )
        VALUES  ( 'T1' , -- opcion - char(2)
                  'NO' , -- sistema - char(2)
                  'I' , -- funcion - char(2)
                  'Agregar RFC SubContratacion'  -- descripcion - varchar(100)
                )

        EXECUTE dbo.usuariosInsertaFuncionNueva 'T1','I','NO'

    END

IF NOT EXISTS ( SELECT  opcion
                FROM    dbo.opciones
                WHERE   funcion = 'I'
                        AND sistema = 'NO'
                        AND opcion = 'T2' )
    BEGIN

        INSERT  INTO dbo.opciones
                ( opcion ,
                  sistema ,
                  funcion ,
                  descripcion
                )
        VALUES  ( 'T2' , -- opcion - char(2)
                  'NO' , -- sistema - char(2)
                  'I' , -- funcion - char(2)
                  'Modificar RFC SubContratacion'  -- descripcion - varchar(100)
                )

        EXECUTE dbo.usuariosInsertaFuncionNueva 'T2','I','NO'

    END

GO

IF OBJECT_ID('dbo.Fun_F_SubContracionValidarImportacion') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_SubContracionValidarImportacion
GO

CREATE PROCEDURE dbo.Fun_F_SubContracionValidarImportacion
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @Rfc AS CHAR(13) ,
    @porcentaje AS FLOAT,
	@fechaInicial AS DATETIME,
	@fechaFinal AS DATETIME
AS
    SET NOCOUNT ON

    DECLARE @observacion AS VARCHAR(200)
    DECLARE @razonSocial AS VARCHAR(200)
    DECLARE @nombre AS VARCHAR(100)
    DECLARE @tiponom AS INTEGER
    DECLARE @periodo AS INTEGER
    DECLARE @ayo_operacion AS INTEGER
	DECLARE @FechaAlta AS DATETIME
	DECLARE @ultmov AS CHARACTER(2)
	DECLARE @ultfchmov AS DATETIME

    SET @observacion = ''
    SET @nombre = ''
    SET @razonSocial = ''


    IF NOT EXISTS ( SELECT  codigo
                    FROM    dbo.empleados
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                            AND activo = 'S' )
        SET @observacion = '01.-No existe el empleado o no esta activo'
    ELSE
        BEGIN
            SELECT  @nombre = RTRIM(ap_paterno) + ' ' + RTRIM(ap_materno)
                    + ' ' + nombre,
					@FechaAlta = fchalta,
					@ultmov = ultmov,
					@ultfchmov = ultfchmov
            FROM    dbo.empleados
            WHERE   empresa = @empresa
                    AND codigo = @codigo
                    AND activo = 'S'

            SELECT  @tiponom = ll.tiponom ,
                    @periodo = p.periodo ,
                    @ayo_operacion = p.ayo_operacion
            FROM    dbo.Llaves AS ll
                    INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                                    AND ll.tiponom = p.tiponom
            WHERE   ll.codigo = @codigo
                    AND ll.empresa = @empresa
                    AND p.estatus = 'A'

        END

        IF @fechaInicial < @fechaAlta
           SET @observacion = '05.-Fecha inicial de subcontratacion menor a la fecha de alta del empleado'

	    IF @ultmov = 'B' AND @fechaFinal > @ultFchMov
           SET @observacion = '06.-Fecha final de subcontratacion mayor a la fecha de baja del empleado'


    IF NOT EXISTS ( SELECT  RFC
                    FROM    dbo.SubContratacionPatron
                    WHERE   LTRIM(RFC) = LTRIM(@Rfc) )
        SET @observacion = '02.-No existe el R.F.C.'
    ELSE
        SELECT  @razonSocial = RazonSocial
        FROM    dbo.SubContratacionPatron
        WHERE   LTRIM(RFC) = LTRIM(@Rfc)

    IF LEN(RTRIM(@observacion)) = 0
        BEGIN
            IF EXISTS ( SELECT  se.porcentaje
                        FROM    dbo.SubContratacionEmpleado AS se
                        WHERE   se.empresa = @empresa
                                AND se.codigo = @codigo
                                AND se.tiponom = @tiponom
                                AND se.periodo = @periodo
                                AND se.ayo_operacion = @ayo_operacion
								AND se.fechaInicial = @fechaInicial
								AND se.fechaFinal = @FechaFinal )
                SET @observacion = '03.-Ya existe el registro'
            ELSE
                SET @observacion = '04.-Registro para importar'


        END

    SELECT  @codigo ,
            @observacion ,
            @nombre ,
            @razonSocial

GO

IF OBJECT_ID('dbo.Fun_F_SubContracionImportar') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_SubContracionImportar
GO

CREATE PROCEDURE dbo.Fun_F_SubContracionImportar
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @Rfc AS CHAR(13) ,
    @porcentaje AS FLOAT ,
    @cUser AS VARCHAR(50),
	@fechaInicial AS DATETIME,
	@fechaFinal AS DATETIME

AS
    SET NOCOUNT ON

    DECLARE @tiponom AS INTEGER
    DECLARE @periodo AS INTEGER
    DECLARE @ayo_operacion AS INTEGER
    DECLARE @funcion AS CHAR(20)
    DECLARE @rfcPatron AS char(13)

    SET @funcion = 'F'



    IF EXISTS ( SELECT  codigo
                FROM    dbo.empleados
                WHERE   empresa = @empresa
                        AND codigo = @codigo
                        AND activo = 'S' )
        BEGIN

            IF EXISTS ( SELECT  RFC
                        FROM    dbo.SubContratacionPatron
                        WHERE   RTRIM(LTRIM(RFC)) = RTRIM(LTRIM(@Rfc)) )
                BEGIN

                    SELECT  @rfcPatron = RFC
                    FROM    dbo.SubContratacionPatron
                    WHERE   RTRIM(LTRIM(RFC)) = RTRIM(LTRIM(@Rfc))

                    SELECT  @tiponom = ll.tiponom ,
                            @periodo = p.periodo ,
                            @ayo_operacion = p.ayo_operacion
                    FROM    dbo.Llaves AS ll
                            INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                                            AND ll.tiponom = p.tiponom
                    WHERE   ll.codigo = @codigo
                            AND ll.empresa = @empresa
                            AND p.estatus = 'A'

                    IF LEN(LTRIM(@Rfc)) < 13
                        SET @Rfc = ' ' + @Rfc

                    EXECUTE dbo.Fun_F_AddSubcontratacionPorcentaje @empresa, -- int
                        @codigo, -- numeric
                        @rfcPatron, -- char(13)
                        @tiponom, -- int
                        @periodo, -- int
                        @ayo_operacion, -- int
                        @porcentaje, -- float
                        @funcion, -- char(20)
                        @cuser, -- varchar(50)
						@fechaInicial,
						@fechaFinal

                END

        END
GO

IF OBJECT_ID('dbo.Fun_F_GetSubcontratacionByTiponom') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_GetSubcontratacionByTiponom
GO

CREATE PROCEDURE dbo.Fun_F_GetSubcontratacionByTiponom
    @empresa AS INTEGER ,
    @tiponom AS INTEGER ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER
AS
    SET NOCOUNT ON

    SELECT  se.codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre) AS 'Nombre' ,
            se.RFC ,
            sp.RazonSocial ,
            se.porcentaje,
			se.fechaInicial,
			se.fechaFinal
    FROM    dbo.SubContratacionEmpleado AS se
            INNER JOIN dbo.SubContratacionPatron AS sp ON se.RFC = sp.RFC
            INNER JOIN dbo.empleados AS e ON se.empresa = e.empresa
                                             AND se.codigo = e.codigo
    WHERE   se.empresa = @empresa
            AND se.tiponom = @tiponom
            AND se.periodo = @periodo
            AND se.ayo_operacion = @ayo_operacion
    ORDER BY se.codigo ,
            se.RFC

GO


IF OBJECT_ID('dbo.Fun_Z_GetSubcontratacionByFechas') IS NOT NULL
    DROP PROCEDURE dbo.Fun_Z_GetSubcontratacionByFechas
GO

CREATE PROCEDURE dbo.Fun_Z_GetSubcontratacionByFechas
    @empresa AS INTEGER ,
	@fechaInicial AS DATETIME,
	@FechaFinal AS DATETIME,
	@RfcFiltro AS VARCHAR(15)
AS
    SET NOCOUNT ON

    SELECT DISTINCT se.codigo,
	       RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre',
           e.rfcalfa + CONVERT(char(6),e.rfcnum) + e.rfchomo AS 'RFCTrabajador',
           se.FechaInicial,
	       se.FechaFinal,
           se.RFC AS 'RFCPatron',
            sp.RazonSocial
    FROM dbo.SubContratacionEmpleado AS se
    INNER JOIN dbo.empleados AS e ON se.codigo = e.codigo AND se.empresa = e.empresa
    INNER JOIN dbo.SubContratacionPatron AS sp ON se.RFC = sp.RFC
    WHERE se.empresa = @empresa
          AND ( se.fechainicial BETWEEN @fechainicial AND @fechaFinal OR se.fechaFinal BETWEEN @fechainicial AND @fechaFinal)
		  AND LTRIM(RTRIM(se.RFC)) = LTRIM(RTRIM(@RfcFiltro))
    ORDER BY se.codigo

GO

IF OBJECT_ID('dbo.SAT_PeriodicidadPago') IS NULL
    CREATE TABLE dbo.SAT_PeriodicidadPago
        (
          c_PeriodicidadPago CHAR(2) NOT NULL ,
          Descripcion VARCHAR(200) NOT NULL ,
          Version FLOAT NOT NULL,
          InicioVigencia DATETIME ,
          FinVigencia DATETIME
          CONSTRAINT SATPeriodicidadPagoPK1 PRIMARY KEY CLUSTERED ( c_PeriodicidadPago,version )

        )
GO

IF NOT EXISTS (SELECT 1 FROM dbo.SAT_PeriodicidadPago WHERE version = 1.0)
BEGIN
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('01','Diario',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('02','Semanal',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('03','Catorcenal',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('04','Quincenal',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('05','Mensual',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('06','Bimestral',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('07','Unidad obra',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('08','Comisin',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('09','Precio alzado',1.0,'20170101',NULL)
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('99','Otra Periodicidad',1.0,'20170101',NULL)

END

GO

IF NOT EXISTS (SELECT 1 FROM dbo.SAT_PeriodicidadPago WHERE version = 1.0 AND c_PeriodicidadPago = '10')
BEGIN
     INSERT INTO dbo.SAT_PeriodicidadPago (c_PeriodicidadPago,Descripcion,Version,InicioVigencia,FinVigencia) VALUES ('10','Decenal',1.0,'20170106',NULL)
END

GO


IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'PeriodicidadPagoSAT'
                        AND sysobjects.name = 'Nominas' )
    ALTER TABLE dbo.Nominas ADD PeriodicidadPagoSAT CHAR(02) NULL
GO

UPDATE  dbo.Nominas
SET     PeriodicidadPagoSAT = CASE WHEN frecuencia = 07 THEN '02'
                                   WHEN frecuencia = 14 THEN '03'
                                   WHEN frecuencia = 15 THEN '04'
                                   WHEN frecuencia = 30 THEN '05'
                                   WHEN frecuencia = 10 THEN '10'
                              END
WHERE   tiponom > 0
        AND PeriodicidadPagoSAT IS NULL


GO


IF EXISTS ( SELECT  syscolumns.name
            FROM    syscolumns
                    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
            WHERE   syscolumns.name = 'actividad'
                    AND sysobjects.name = 'tabulador' )
    ALTER TABLE dbo.tabulador ALTER COLUMN  actividad VARCHAR(100)
GO

IF EXISTS ( SELECT  syscolumns.name
            FROM    syscolumns
                    LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
            WHERE   syscolumns.name = 'descripcion'
                    AND sysobjects.name = 'tabulador' )
    ALTER TABLE dbo.tabulador ALTER COLUMN  descripcion VARCHAR(100)
GO


IF (SELECT 1
    FROM Information_Schema.Columns
    WHERE TABLE_NAME = 'contratos'
          AND TABLE_SCHEMA = 'dbo'
          AND COLUMN_NAME = 'puesto'
          AND CHARACTER_MAXIMUM_LENGTH <> 100) IS NOT NULL
    ALTER TABLE dbo.contratos ALTER COLUMN puesto VARCHAR(100)
GO


/*Nuevos campos para controlar la version del complemento 1.2 */
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'inicio'
                        AND sysobjects.name = 'CatalogoTipoConceptoCFDI' )
    BEGIN

        ALTER TABLE dbo.CatalogoTipoConceptoCFDI ADD inicio DATETIME NULL
        ALTER TABLE dbo.CatalogoTipoConceptoCFDI ADD termino DATETIME NULL
        ALTER TABLE dbo.CatalogoTipoConceptoCFDI ADD versionComplemento FLOAT NULL
        ALTER TABLE dbo.CatalogoTipoConceptoCFDI ADD origen CHAR(4) NULL

    END
GO

/* Actualizar los nuevos campos para identificar la vigencia */
UPDATE  dbo.CatalogoTipoConceptoCFDI
SET     inicio = '20140101' ,
        termino = '29991231' ,
        versionComplemento = 1.1 ,
        origen = 'SAT'
WHERE   inicio IS NULL
        AND termino IS NULL
        AND versionComplemento IS NULL

GO

/* Desactivar para 2017 las claves 16,17,40,41,42 de percepciones*/
UPDATE  dbo.CatalogoTipoConceptoCFDI
SET     termino = '20161231'
WHERE   idClave IN ( 16, 17, 40, 41, 42 )
        AND tipo = 'P'
        AND versionComplemento = 1.1

GO

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 44 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 44 , -- idClave - int
           'Jubilaciones, pensiones o haberes de retiro en parcialidades' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 45 , -- idClave - int
           'Ingresos en acciones o ttulos valor que representan bienes' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 46 , -- idClave - int
           'Ingresos asimilados a salarios' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 47 , -- idClave - int
           'Alimentacin' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 48 , -- idClave - int
           'Habitacin' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 49 , -- idClave - int
           'Premios por asistencia' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 91 , -- idClave - int
           'Devolucion ISR (otros pagos 001)' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'APSI'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 92 , -- idClave - int
           'Subsidio efectivamente pagado (otros pagos 002)' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'APSI'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 93 , -- idClave - int
           'Viaticos (otros pagos 003)' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'APSI'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 94 , -- idClave - int
           'Compensacion ISR ejercicios anteriores (otros pagos 004)' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'APSI'  -- origen - char(4)
         )


 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 22 , -- idClave - int
           'Impuestos Locales' , -- descripcion - varchar(250)
           'D' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 23 , -- idClave - int
           'Aportaciones voluntarias' , -- descripcion - varchar(250)
           'D' , -- tipo - char(1)
           '20170101' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

END


IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 50 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 50 , -- idClave - int
           'Viticos' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170106' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'SAT'  -- origen - char(4)
         )

END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 95 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
 INSERT INTO dbo.CatalogoTipoConceptoCFDI
         ( idClave ,
           descripcion ,
           tipo ,
           inicio ,
           termino ,
           versionComplemento ,
           origen
         )
 VALUES  ( 95 , -- idClave - int
           'Pagos distintos a los listados (otros pagos 999)' , -- descripcion - varchar(250)
           'P' , -- tipo - char(1)
           '20170106' , -- inicio - datetime
           '29991231' , -- termino - datetime
           1.2 , -- versionComplemento - float
           'APSI'  -- origen - char(4)
         )

END


IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 24 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (24,'Ajuste en Gratificacin Anual (Aguinaldo) Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (25,'Ajuste en Gratificacin Anual (Aguinaldo) Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (26,'Ajuste en Participacin de los Trabajadores en las Utilidades PTU Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (27,'Ajuste en Participacin de los Trabajadores en las Utilidades PTU Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (28,'Ajuste en Reembolso de Gastos Mdicos Dentales y Hospitalarios Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (29,'Ajuste en Fondo de ahorro Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (30,'Ajuste en Caja de ahorro Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (31,'Ajuste en Contribuciones a Cargo del Trabajador Pagadas por el Patrn Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (32,'Ajuste en Premios por puntualidad Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (33,'Ajuste en Prima de Seguro de vida Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (34,'Ajuste en Seguro de Gastos Mdicos Mayores Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (35,'Ajuste en Cuotas Sindicales Pagadas por el Patrn Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (36,'Ajuste en Subsidios por incapacidad Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (37,'Ajuste en Becas para trabajadores y/o hijos Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (38,'Ajuste en Horas extra Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (39,'Ajuste en Horas extra Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (40,'Ajuste en Prima dominical Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (41,'Ajuste en Prima dominical Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (42,'Ajuste en Prima vacacional Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (43,'Ajuste en Prima vacacional Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (44,'Ajuste en Prima por antigedad Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (45,'Ajuste en Prima por antigedad Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (46,'Ajuste en Pagos por separacin Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (47,'Ajuste en Pagos por separacin Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (48,'Ajuste en Seguro de retiro Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (49,'Ajuste en Indemnizaciones Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (50,'Ajuste en Indemnizaciones Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (51,'Ajuste en Reembolso por funeral Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (52,'Ajuste en Cuotas de seguridad social pagadas por el patrn Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (53,'Ajuste en Comisiones Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (54,'Ajuste en Vales de despensa Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (55,'Ajuste en Vales de restaurante Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (56,'Ajuste en Vales de gasolina Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (57,'Ajuste en Vales de ropa Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (58,'Ajuste en Ayuda para renta Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (59,'Ajuste en Ayuda para artculos escolares Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (60,'Ajuste en Ayuda para anteojos Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (61,'Ajuste en Ayuda para transporte Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (62,'Ajuste en Ayuda para gastos de funeral Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (63,'Ajuste en Otros ingresos por salarios Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (64,'Ajuste en Otros ingresos por salarios Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (65,'Ajuste en Jubilaciones, pensiones o haberes de retiro Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (66,'Ajuste en Jubilaciones, pensiones o haberes de retiro Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (67,'Ajuste en Pagos por separacin Acumulable','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (68,'Ajuste en Pagos por separacin No acumulable','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (69,'Ajuste en Jubilaciones, pensiones o haberes de retiro Acumulable','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (70,'Ajuste en Jubilaciones, pensiones o haberes de retiro No acumulable','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (71,'Ajuste en Subsidio para el empleo (efectivamente entregado al trabajador)','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (72,'Ajuste en Ingresos en acciones o ttulos valor que representan bienes Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (73,'Ajuste en Ingresos en acciones o ttulos valor que representan bienes Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (74,'Ajuste en Alimentacin Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (75,'Ajuste en Alimentacin Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (76,'Ajuste en Habitacin Exento','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (77,'Ajuste en Habitacin Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (78,'Ajuste en Premios por asistencia','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (79,'Ajuste en Pagos distintos a los listados y que no deben considerarse como ingreso por sueldos, salarios o ingresos asimilados.','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (80,'Ajuste en Viticos gravados','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (81,'Ajuste en Viticos (entregados al trabajador)','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (082,'Ajuste en Fondo de ahorro Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (083,'Ajuste en Caja de ahorro Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (084,'Ajuste en Prima de Seguro de vida Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (085,'Ajuste en Seguro de Gastos Mdicos Mayores Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (086,'Ajuste en Subsidios por incapacidad Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (087,'Ajuste en Becas para trabajadores y/o hijos Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (088,'Ajuste en Seguro de retiro Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (089,'Ajuste en Vales de despensa Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (090,'Ajuste en Vales de restaurante Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (091,'Ajuste en Vales de gasolina Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (092,'Ajuste en Vales de ropa Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (093,'Ajuste en Ayuda para renta Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (094,'Ajuste en Ayuda para artculos escolares Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (095,'Ajuste en Ayuda para anteojos Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (096,'Ajuste en Ayuda para transporte Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (097,'Ajuste en Ayuda para gastos de funeral Gravado','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (098,'Ajuste a ingresos asimilados a salarios gravados','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (099,'Ajuste a ingresos por sueldos y salarios gravados','D','20170101','29991231',1.2,'SAT')
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (100,'Ajuste en Viticos exentos','D','20170101','29991231',1.2,'SAT')

END

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_FonacotInformacionArchivoEmpleados
* Project       : APSI Nomina
* Description   : Mayo 04, 2017
*                 Obtiene la informacion para generar el archivo de empleados para Fonacot
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Mayo 04, 2017
* Parameters    : empresa,MesAyo,MesOperacion,AyoOperacion
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_FonacotInformacionArchivoEmpleados') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_FonacotInformacionArchivoEmpleados
GO


CREATE PROCEDURE dbo.Fun_E_FonacotInformacionArchivoEmpleados
    @empresa AS INTEGER ,
    @mesAyo AS CHAR(5)
AS
    SET NOCOUNT ON

    DECLARE @Importes AS FLOAT

    DECLARE @tba_Sumas AS TABLE
        (
          codigo NUMERIC(8, 0) ,
          SalarioMensualBruto FLOAT ,
          salarioMensualNeto FLOAT
        )

    DECLARE @tba_Sumas2 AS TABLE
        (
          codigo NUMERIC(8, 0) ,
          SalarioMensualBase FLOAT
        )

    SET @Importes = 0

    IF OBJECT_ID('dbo.Fun_E_FonacotRepEmpleados') IS NOT NULL
        DROP TABLE dbo.Fun_E_FonacotRepEmpleados


    SELECT  e.ultmov ,
            e.rfcalfa ,
            e.rfcnum ,
            e.rfchomo ,
            e.afiliacion + e.digvera 'NSS1' ,
            e.curp ,
            e.sexo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre) AS 'NombreCompleto' ,
            e.ap_paterno ,
            e.ap_materno ,
            e.nombre ,
            e.fchantigua ,
            ROUND(e.sueldo * 30, 2) AS 'SalarioMensualBase' ,
            @Importes AS 'SalarioMensualBruto' ,
            e.afiliacion + e.digvera 'NSS2' ,
            ISNULL(ad.fonacot, 0) AS 'Fonacot' ,
            e.codigo ,
            @Importes AS 'SalarioMensualNeto' ,
            e.ultfchmov,
            ll.clase
    INTO    dbo.Fun_E_FonacotRepEmpleados
    FROM    dbo.empleados AS e
            INNER JOIN dbo.EmpleadoAdicional AS ad ON e.empresa = ad.empresa
                                                      AND e.codigo = ad.codigo
            INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa AND e.codigo = ll.codigo
    WHERE   e.empresa = @empresa
            AND e.activo = 'S'
            AND e.pagar_nomina = 'S'
    ORDER BY e.codigo

    INSERT  INTO @tba_Sumas
            SELECT  codigo ,
                    SUM(tot_percep) ,
                    SUM(neto)
            FROM    dbo.nomina1_anual
            WHERE   empresa = @empresa
                    AND mes = @mesAyo
            GROUP BY empresa ,
                    codigo

    /*Agrega la suma del mes de los conceptos que esten confgiruados como salarios para los empleados que tienen sueldo cero a peticion de Calleros 02/06/2017 */
    IF EXISTS ( SELECT  codigo
                FROM    dbo.Fun_E_FonacotRepEmpleados
                WHERE   SalarioMensualBase <= 0 )
        BEGIN
            INSERT  INTO @tba_Sumas2
                    SELECT  ka.codigo ,
                            SUM(ka.importe)
                    FROM    dbo.kardex_anual AS ka
                            LEFT JOIN dbo.conceptos AS c ON ka.empresa = c.empresa
                                                            AND ka.num_conc = c.num_conc
                            LEFT JOIN dbo.Fun_E_FonacotRepEmpleados AS rep ON ka.codigo = rep.codigo
                    WHERE   ka.empresa = @empresa
                            AND ka.mes = @mesAyo
                            AND ka.tpago_desc = 'P'
                            AND c.Cfdi = 1
                            AND rep.SalarioMensualBase <= 0
                    GROUP BY ka.codigo

            UPDATE  rep
            SET     rep.SalarioMensualBase = ISNULL(na.SalarioMensualBase, 0)
            FROM    dbo.Fun_E_FonacotRepEmpleados AS rep
                    LEFT JOIN @tba_Sumas2 AS na ON na.codigo = rep.codigo
            WHERE   rep.SalarioMensualBase <= 0

        END


    UPDATE  rep
    SET     rep.SalarioMensualBruto = ISNULL(na.SalarioMensualBruto, 0) ,
            rep.SalarioMensualNeto = ISNULL(na.SalarioMensualNeto, 0)
    FROM    dbo.Fun_E_FonacotRepEmpleados AS rep
            LEFT JOIN @tba_Sumas AS na ON na.codigo = rep.codigo

    SELECT  *
    FROM    dbo.Fun_E_FonacotRepEmpleados
    ORDER BY Codigo


GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_ObtieneSolicitudes
* Project       : APSI Nomina
* Description   : Mayo 30, 2017
*                 Obtiene la informacion de las solicitudes por prestamos o permisos que se capturan en el portal del empleado
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Mayo 30, 2017
* Parameters    : empresa
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_ObtieneSolicitudes') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_ObtieneSolicitudes
GO


CREATE PROCEDURE dbo.Fun_E_ObtieneSolicitudes @empresa AS INTEGER
AS
    SET NOCOUNT ON

    SELECT  s.Codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre' ,
            ll.centro ,
            ll.tiponom ,
            e.fchantigua ,
            CASE WHEN s.Tipo = 'PER' AND s.marca <> 'FP' THEN 'Permiso'
			     WHEN s.Tipo = 'PER' AND s.marca = 'FP'  THEN 'Permiso sin goce'
                 WHEN s.Tipo = 'PST' THEN 'Prestamo'
				 WHEN s.Tipo = 'FI'  THEN 'Falta injustificada'
				 WHEN s.Tipo = 'PDE' THEN 'Permiso por dia economico'
				 ELSE 'Desconocido'
            END AS 'Tipo' ,
            s.Disfrute ,
            CASE WHEN s.Tipo = 'PER' THEN Dias_Disfrute
			     WHEN s.Tipo = 'FI'  THEN Dias_Disfrute
				 WHEN s.Tipo = 'PDE' THEN Dias_Disfrute
                 ELSE s.Importe
            END AS 'Dias_Monto' ,
            p.periodo ,
            p.ayo_operacion,
            p.inicio ,
            p.cierre ,
            p.pago ,
            p.dias ,
            e.ultmov,
            e.fchalta,
            ll.horario,
			p.dias_anticipados,
			ISNULL(n.codigo,0) AS 'CalculoYaNomina',
			ISNULL(s.Marca,'') AS 'Marca',
			s.idSolicitud,
			ISNULL(s.tipoPlazo,0) AS 'tipoPlazo',
			ISNULL(s.plazo,0) AS 'plazo',
			e.sueldo 
    FROM    dbo.Solicitud_VPA AS s
            INNER JOIN dbo.empleados AS e ON s.Empresa = e.empresa AND s.Codigo = e.codigo
            INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa  AND e.codigo = ll.codigo
            INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa AND ll.tiponom = p.tiponom
            LEFT JOIN dbo.nomina_tot AS n ON s.empresa = n.empresa AND s.codigo = n.codigo
    WHERE   s.Empresa = @empresa
            AND s.Tipo IN ( 'PER', 'PST', 'FI', 'PDE' )
            AND s.Estatus = 'S'
            AND p.estatus = 'A'
            AND s.nomina = 'S'
    ORDER BY s.Codigo

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_ObtieneSolicitudesIncapacidades
* Project       : APSI Nomina
* Description   : Septiembre 09, 2020
*                 Obtiene la informacion de las solicitudes por incapacidades que se capturan en el portal del empleado
* Copyright     : (c) Apsi 2009 - 2020. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Septiembre 09, 2020
* Parameters    : empresa
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_ObtieneSolicitudesIncapacidades') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_ObtieneSolicitudesIncapacidades
GO


CREATE PROCEDURE dbo.Fun_E_ObtieneSolicitudesIncapacidades
@empresa AS INTEGER
AS
    SET NOCOUNT ON

    SELECT  s.Codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre' ,
            ll.centro ,
            ll.tiponom ,
            e.fchantigua ,
            CASE WHEN s.Tipo = 'IG' THEN 'Incapacidad enfermedad general'
                 WHEN s.Tipo = 'IR' THEN 'Incapacidad riesgo de trabajo'
				 WHEN s.Tipo = 'IM' THEN 'Incapacidad maternidad'
				 ELSE 'Desconocido'
            END AS 'Tipo' ,
            s.Inicio AS 'Inicio_Inc' ,
            DATEDIFF(DD,s.inicio,s.termino)+1  AS 'Dias_Monto' ,
            p.periodo ,
            p.ayo_operacion,
            p.inicio ,
            p.cierre ,
            p.pago ,
            p.dias ,
            e.ultmov,
            e.fchalta,
            ll.horario,
			s.termino,
			s.Folio,
			s.riesgo,
			s.secuela,
			s.control,
			p.dias_anticipados,
			ISNULL(n.codigo,0) AS 'CalculoYaNomina',
			s.idIncapacidad,
			0 AS 'tipoPlazo',
			0 AS 'plazo',
			e.sueldo
    FROM    dbo.PE_Incapacidades AS s
            INNER JOIN dbo.empleados AS e ON s.Empresa = e.empresa AND s.Codigo = e.codigo
            INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa AND e.codigo = ll.codigo
            INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa AND ll.tiponom = p.tiponom
            LEFT JOIN dbo.nomina_tot AS n ON s.empresa = n.empresa AND s.codigo = n.codigo
    WHERE   s.Empresa = @empresa
            AND s.Tipo IN ( 'IG', 'IR', 'IM' )
            AND p.estatus = 'A'
            AND s.importado IS NULL
    ORDER BY s.Codigo

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_AutorizarSolicitud
* Project       : APSI Nomina
* Description   : Mayo 30, 2017
*                 Autorizar una solicitud por prestamo o permiso, afectar la tabla Solicitud_VPA
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Mayo 30, 2017
* Parameters    : empresa,codigo,tipo,fecha,motivo
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_AutorizarSolicitud') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_AutorizarSolicitud
GO


CREATE PROCEDURE dbo.Fun_E_AutorizarSolicitud
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @fecha AS DATETIME ,
    @tipo AS VARCHAR(3) ,
    @motivo AS VARCHAR(50) ,
    @cUser AS VARCHAR(50) ,
	@num_conc AS INTEGER,
	@IdSolicitud AS INTEGER
AS
    SET NOCOUNT ON
    BEGIN TRANSACTION
    BEGIN TRY


	 IF @num_conc >= 109 AND @num_conc <= 111
	    UPDATE dbo.PE_Incapacidades
		SET    importado = 1,
			   FechaAprobacion = GETDATE(),
			   usuario = @cUser 
		WHERE  empresa = @empresa
		       AND codigo = @codigo
			   AND tipo = @tipo
			   AND inicio = @Fecha
			   AND idIncapacidad = @idSolicitud
	 ELSE
        UPDATE  dbo.Solicitud_VPA
        SET     Estatus = 'A',
                Motivo =@motivo,
				FechaAprobacion = GETDATE(),
				usuario = @cUser 
        WHERE   empresa = @empresa
                AND codigo = @codigo
                AND Tipo = @tipo
			    AND idSolicitud = @idSolicitud

        -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Verificar solicitudes' ,
                        'Autorizar ' + @tipo + ' ' + CONVERT(CHAR(15), @fecha) ,
                        SUBSTRING(@motivo, 1, 50) ,
                        @cUser ,
                        '' ,
                        LEFT(Empresas.Registro_Patronal, 10) ,
                        'NO'
                FROM    dbo.Empresas
                WHERE   Empresa = @empresa


    END TRY

    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


/****************************************************************************************************************************
* Name          : dbo.Fun_E_RechazarSolicitud
* Project       : APSI Nomina
* Description   : Mayo 30, 2017
*                 Rechazar una solicitud por prestamo o permiso, afectar la tabla Solicitud_VPA
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Mayo 30, 2017
* Parameters    : empresa,codigo,tipo,fecha,motivo
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_RechazarSolicitud') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_RechazarSolicitud
GO


CREATE PROCEDURE dbo.Fun_E_RechazarSolicitud
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @fecha AS DATETIME ,
    @tipo AS VARCHAR(3) ,
    @motivo AS VARCHAR(50) ,
    @cUser AS VARCHAR(50) ,
	@idSolicitud AS INTEGER
AS
    SET NOCOUNT ON
    BEGIN TRANSACTION
    BEGIN TRY

	    IF @tipo IN ('IG','IM','IR')
		   UPDATE dbo.PE_Incapacidades
		   SET    importado = 0,
		          Comentarios = @motivo
		WHERE  empresa = @empresa
		       AND codigo = @codigo
			   AND tipo = @tipo
			   AND idIncapacidad = @idSolicitud

        ELSE
           UPDATE  dbo.Solicitud_VPA
           SET     Estatus = 'R' ,
                   Motivo = @motivo
           WHERE   empresa = @empresa
                   AND codigo = @codigo
                   AND Tipo = @tipo
				   AND idSolicitud = @idSolicitud

        -- Actualizar la bitacora
        INSERT  INTO dbo.Bitacora
                ( Empresa ,
                  Fecha ,
                  Hora ,
                  Funcion ,
                  Codigo ,
                  Opcion ,
                  Opcion2 ,
                  Opcion3 ,
                  Usuario ,
                  Clave ,
                  RegPat ,
                  Sistema

                )
                SELECT  @empresa ,
                        GETDATE() ,
                        SUBSTRING(CONVERT(CHAR(20), GETDATE()), 12, 8) ,
                        'E' ,
                        @codigo ,
                        'Verificar solicitudes' ,
                        'Rechazo ' + @tipo + ' ' + CONVERT(CHAR(15),@fecha),
                        SUBSTRING(@motivo, 1, 50) ,
                        @cUser ,
                        '' ,
                        LEFT(Empresas.Registro_Patronal, 10) ,
                        'NO'
                FROM    dbo.Empresas
                WHERE   Empresa = @empresa


    END TRY

    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage
    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_E_GetAusentismoXFechas
* Project       : APSI Nomina
* Description   : Octubre 02, 2017
*                 Regresa los ausentismos en un periodo dado, para validar las cargas masivas y la interfase con el reloj en linea
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Octubre 02, 2017
* Parameters    : empresa,codigo,inicio, termino
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_GetAusentismoXFechas') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_GetAusentismoXFechas
GO


CREATE PROCEDURE dbo.Fun_E_GetAusentismoXFechas
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0) ,
    @inicio AS DATETIME ,
    @termino AS DATETIME
AS
    SELECT  d.num_conc ,
            d.fchinicio ,
            d.fchtermino ,
            d.dias ,
            d.numeroinc ,
            CASE WHEN @inicio >= d.fchinicio
                      AND @termino <= d.fchtermino
                 THEN DATEDIFF(DD, @inicio, @termino) + 1
                 WHEN @inicio < d.fchinicio
                      AND @termino <= d.fchtermino
                 THEN DATEDIFF(DD, d.fchinicio, @termino) + 1
                 WHEN @inicio >= d.fchinicio
                      AND @termino > d.fchtermino
                 THEN DATEDIFF(DD, @inicio, d.fchtermino) + 1
                 WHEN @inicio < d.fchtermino
                      AND @termino > d.fchtermino THEN d.dias
                 ELSE 0
            END AS 'DiasTraslapados' ,
            d.periodo ,
            d.ayo_operacion ,
            d.tiponom ,
            d.justificar
    FROM    dbo.deducciones AS d
    WHERE   d.empresa = @empresa
            AND ( ( d.FchInicio BETWEEN @Inicio AND @Termino )
                  OR ( d.Fchtermino BETWEEN @Inicio AND @Termino )
                  OR ( @Inicio BETWEEN d.FchInicio AND d.Fchtermino )
                  OR ( @Termino BETWEEN d.FchInicio AND d.fchtermino )
                )
            AND d.codigo = @codigo
            AND d.num_conc >= 108
            AND d.num_conc <= 111
    ORDER BY d.fchinicio DESC

GO

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 101 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (101,'ISR Retenido de ejercicio anterior','D','20171205','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 99 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   UPDATE dbo.CatalogoTipoConceptoCFDI SET descripcion = 'Reintegro de ISR retenido en exceso de ejercicio anterior (siempre que no haya sido enterado al SAT) otros pagos 005.' ,inicio = '20171205'
   WHERE idClave = 95 AND tipo = 'P'

   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (99,'Pagos distintos a los listados (otros pagos 999)','P','20170101','29991231',1.2,'APSI')

   UPDATE dbo.conceptos SET Cfdi = 99 WHERE Cfdi = 95 AND ((num_conc >= 1 AND num_conc <= 100) OR (num_conc >= 501 AND num_conc <= 599) OR (num_conc >= 1100 AND num_conc <= 1199))
END

/* Claves agregadas el 10/12/2019 */
IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 51 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (51,'Pagos por gratificaciones, primas, compensaciones, recompensas u otros a extrabajadores derivados de jubilacin en parcialidades','P','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 52 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (52,'Pagos que se realicen a extrabajadores que obtengan una jubilacin en parcialidades derivados de la ejecucin de resoluciones judicial o de un laudo','P','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 53 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (53,'Pagos que se realicen a extrabajadores que obtengan una jubilacin en una sola exhibicin derivados de la ejecucin de resoluciones judicial o de un laudo','P','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 96 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (96,'Alimentos en bienes (Servicios de comedor y comida) Art 94 ltimo prrafo LISR (otros pagos 006)','P','20200101','29991231',1.2,'APSI')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 97 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (97,'ISR ajustado por subsidio (otros pagos 007)','P','20200101','29991231',1.2,'APSI')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 98 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (98,'Subsidio efectivamente entregado que no corresponda (Aplica slo cuando haya ajuste al cierre de mes en relacin con el Apndice 7 de la gua de llenado de nmina) otros pagos 008','P','20200101','29991231',1.2,'APSI')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 102 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (102,'Ajuste a pagos por gratificaciones, primas, compensaciones, recompensas u otros a extrabajadores derivados de jubilacin en parcialidades, gravados','D','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 103 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (103,'Ajuste a pagos que se realicen a extrabajadores que obtengan una jubilacin en parcialidades derivados de la ejecucin de una resolucin judicial o de un laudo gravados','D','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 104 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (104,'Ajuste a pagos que se realicen a extrabajadores que obtengan una jubilacin en parcialidades derivados de la ejecucin de una resolucin judicial o de un laudo exentos','D','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 105 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (105,'Ajuste a pagos que se realicen a extrabajadores que obtengan una jubilacin en una sola exhibicin derivados de la ejecucin de una resolucin judicial o de un laudo gravados','D','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 106 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (106,'Ajuste a pagos que se realicen a extrabajadores que obtengan una jubilacin en una sola exhibicin derivados de la ejecucin de una resolucin judicial o de un laudo exentos','D','20181015','29991231',1.2,'SAT')
END

IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 107 AND versionComplemento = 1.2 AND tipo = 'D')
BEGIN
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (107,'Ajuste al Subsidio Causado','D','20200101','29991231',1.2,'SAT')
END

GO

/* Cambiar la clave 99 por 999 de otros pagos y agregar la clave 99 que publicada 20/04/2020 */
IF NOT EXISTS (SELECT idClave FROM dbo.CatalogoTipoConceptoCFDI WHERE idClave = 999 AND versionComplemento = 1.2 AND tipo = 'P')
BEGIN

   UPDATE dbo.CatalogoTipoConceptoCFDI SET idClave = 999 WHERE idClave = 99 AND tipo = 'P'
   INSERT INTO dbo.CatalogoTipoConceptoCFDI (idClave,descripcion,tipo,inicio,termino,versionComplemento,origen) VALUES (099,'Reembolso de descuentos efectuados para el crdito de vivienda. (otros pagos 009)','P','20200420','29991231',1.2,'SAT')

END
GO

/****************************************************************************************************************************
* Name          : Proceso almacenados para la interfase con el reloj checador
* Project       : APSI Nomina
* Description   : Enero 11, 2018
*                 Estos procesos tambien se utilizan para la version Web
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Enero 11, 2018
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_RelojApsiValidarIncidencia') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_RelojApsiValidarIncidencia
GO

CREATE PROCEDURE dbo.Fun_F_RelojApsiValidarIncidencia
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER ,
    @tiponom AS INTEGER ,
    @num_conc AS INTEGER ,
    @fecha AS DATETIME ,
    @horas AS FLOAT ,
    @importe AS FLOAT
AS
    SET NOCOUNT ON

    DECLARE @observacion AS VARCHAR(200)
    DECLARE @nombre AS VARCHAR(100)
    DECLARE @inicio AS DATETIME
    DECLARE @cierre AS DATETIME
    DECLARE @sueldo AS FLOAT
    DECLARE @sueldoEmp AS FLOAT
    DECLARE @ultmov AS CHAR(2)
    DECLARE @ultfchmov AS DATETIME
    DECLARE @clase AS CHAR(2)
    DECLARE @centro AS CHAR(14)
	DECLARE @DiasAnticipados AS INTEGER

    SET @observacion = ''
    SET @nombre = ''
    SET @sueldo = 0
    SET @sueldoEmp = 0
    SET @clase = ''
    SET @centro = ''
	SET @DiasAnticipados =  0


    IF NOT EXISTS ( SELECT  codigo
                    FROM    dbo.empleados
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                            AND activo = 'S' )
        SET @observacion = '99.-No existe el empleado o no esta activo'
    ELSE
        BEGIN
            SELECT  @nombre = RTRIM(ap_paterno) + ' ' + RTRIM(ap_materno)
                    + ' ' + nombre ,
                    @sueldoEmp = sueldo ,
                    @ultmov = ultmov ,
                    @ultfchmov = ultfchmov
            FROM    dbo.empleados
            WHERE   empresa = @empresa
                    AND codigo = @codigo
                    AND activo = 'S'

            SELECT  @inicio = p.inicio ,
                    @cierre = p.cierre,
                    @clase = ll.clase,
                    @centro = ll.centro,
					@DiasAnticipados = ISNULL(p.dias_Anticipados,0)
            FROM    dbo.Llaves AS ll
                    INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                                    AND ll.tiponom = p.tiponom
            WHERE   ll.codigo = @codigo
                    AND ll.empresa = @empresa
                    AND p.estatus = 'A'

            SELECT TOP 1
                    @sueldo = ISNULL(av.sueldo, 0)
            FROM    dbo.avisos_imss AS av
            WHERE   av.codigo = @codigo
                    AND av.empresa = @empresa
                    AND @fecha BETWEEN av.fch_mov AND @cierre
            ORDER BY av.fch_mov DESC, av.serial DESC

            IF @sueldo = 0
                SET @sueldo = @sueldoEmp

            IF @ultmov = 'B'
                IF @fecha > @ultfchmov
                    SET @observacion = '03.-Fecha de la incidencia posterior a la baja'

            IF @DiasAnticipados = 0
			   BEGIN
                   IF @fecha > @cierre
                      SET @observacion = '04.-Fecha de la incidencia posterior a fecha de cierre'

                   IF @fecha < @inicio
                      SET @observacion = '05.-Fecha de la incidencia anterior a fecha de inicio'
               END
            ELSE
			   BEGIN
                   IF @fecha > ( @cierre - @DiasAnticipados )
                      SET @observacion = '04.-Fecha de la incidencia posterior a fecha de cierre (DsAnt)'

                   IF @fecha < ( @inicio - @DiasAnticipados )
                      SET @observacion = '05.-Fecha de la incidencia anterior a fecha de inicio (DsAnt)'
               END

        END


    IF LEN(RTRIM(@observacion)) = 0
        BEGIN
            IF EXISTS ( SELECT  p.nomina
                        FROM    dbo.percepciones AS p
                        WHERE   p.empresa = @empresa
                                AND p.codigo = @codigo
                                AND p.tiponom = @tiponom
                                AND p.periodo = @periodo
                                AND p.ayo_operacion = @ayo_operacion
                                AND p.num_conc = @num_conc
                                AND p.fch_pago = @fecha )
                SET @observacion = '02.-Ya existe el registro'
            ELSE
                SET @observacion = '01.-Registro para importar'


        END

    SELECT  @codigo AS 'Codigo' ,
            @observacion AS 'Observacion' ,
            @nombre AS 'Nombre' ,
            @sueldo AS 'Sueldo',
            @clase AS 'Clase',
            @centro AS 'Centro'

GO



IF OBJECT_ID('dbo.Fun_E_RelojApsiValidarIncidencia') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_RelojApsiValidarIncidencia
GO

CREATE PROCEDURE dbo.Fun_E_RelojApsiValidarIncidencia
    @empresa AS INTEGER ,
    @codigo AS NUMERIC(8, 0) ,
    @periodo AS INTEGER ,
    @ayo_operacion AS INTEGER ,
    @tiponom AS INTEGER ,
    @num_conc AS INTEGER ,
    @fecha AS DATETIME ,
    @horas AS FLOAT ,
    @importe AS FLOAT
AS
    SET NOCOUNT ON

    DECLARE @observacion AS VARCHAR(200)
    DECLARE @nombre AS VARCHAR(100)
    DECLARE @inicio AS DATETIME
    DECLARE @cierre AS DATETIME
    DECLARE @sueldo AS FLOAT
    DECLARE @sueldoEmp AS FLOAT
    DECLARE @ultmov AS CHAR(2)
    DECLARE @ultfchmov AS DATETIME
    DECLARE @clase AS CHAR(2)
    DECLARE @centro AS CHAR(14)
	DECLARE @diasAnticipados AS INTEGER
	DECLARE @fchAlta AS DATETIME

    SET @observacion = ''
    SET @nombre = ''
    SET @sueldo = 0
    SET @sueldoEmp = 0
    SET @clase = ''
    SET @centro = ''
	SET @diasAnticipados = 0


    IF NOT EXISTS ( SELECT  codigo
                    FROM    dbo.empleados
                    WHERE   empresa = @empresa
                            AND codigo = @codigo
                            AND activo = 'S' )
        SET @observacion = '99.-No existe el empleado o no esta activo'
    ELSE
        BEGIN
            SELECT  @nombre = RTRIM(ap_paterno) + ' ' + RTRIM(ap_materno)
                    + ' ' + nombre ,
                    @sueldoEmp = sueldo ,
                    @ultmov = ultmov ,
                    @ultfchmov = ultfchmov,
					@fchAlta = fchAlta
            FROM    dbo.empleados
            WHERE   empresa = @empresa
                    AND codigo = @codigo
                    AND activo = 'S'

            SELECT  @inicio = p.inicio ,
                    @cierre = p.cierre,
                    @clase = ll.clase,
                    @centro = ll.centro,
					@diasAnticipados = ISNULL(p.dias_anticipados,0)
            FROM    dbo.Llaves AS ll
                    INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                                    AND ll.tiponom = p.tiponom
            WHERE   ll.codigo = @codigo
                    AND ll.empresa = @empresa
                    AND p.estatus = 'A'

            SELECT TOP 1
                    @sueldo = ISNULL(av.sueldo, 0)
            FROM    dbo.avisos_imss AS av
            WHERE   av.codigo = @codigo
                    AND av.empresa = @empresa
                    AND @fecha BETWEEN av.fch_mov AND @cierre
            ORDER BY av.fch_mov DESC, av.serial DESC

            IF @sueldo = 0
                SET @sueldo = @sueldoEmp

            IF @fecha < @fchAlta
               SET @observacion = '06.-Fecha de la incidencia anterior a la alta'

            IF @ultmov = 'B'
                IF @fecha > @ultfchmov
                    SET @observacion = '03.-Fecha de la incidencia posterior a la baja'

            IF @DiasAnticipados = 0
			   BEGIN
                   IF @fecha > @cierre
                      SET @observacion = '04.-Fecha de la incidencia posterior a fecha de cierre'

                   IF @fecha < @inicio
                      SET @observacion = '05.-Fecha de la incidencia anterior a fecha de inicio'
               END
            ELSE
			   BEGIN
                   IF @fecha > (@cierre - @DiasAnticipados )
                      SET @observacion = '04.-Fecha de la incidencia posterior a fecha de cierre (DsAnt)'

                   IF @fecha < (@inicio - @DiasAnticipados )
                      SET @observacion = '05.-Fecha de la incidencia anterior a fecha de inicio (DsAnt)'
               END



        END


    IF LEN(RTRIM(@observacion)) = 0
        BEGIN
            IF EXISTS ( SELECT  d.descuento
                        FROM    dbo.deducciones AS d
                        WHERE   d.empresa = @empresa
                                AND d.codigo = @codigo
                                AND d.tiponom = @tiponom
                                AND d.periodo = @periodo
                                AND d.ayo_operacion = @ayo_operacion
                                AND d.num_conc = @num_conc
                                AND d.fchinicio = @fecha
								AND d.descuento = @importe )
                SET @observacion = '02.-Ya existe el registro'
            ELSE
                SET @observacion = '01.-Registro para importar'

        END

    SELECT  @codigo AS 'Codigo' ,
            @observacion AS 'Observacion' ,
            @nombre AS 'Nombre' ,
            @sueldo AS 'Sueldo',
            @clase AS 'Clase',
            @centro AS 'Centro'

GO

IF OBJECT_ID('dbo.SeekConcept') IS NOT NULL
    DROP PROCEDURE dbo.SeekConcept
GO

CREATE PROCEDURE dbo.SeekConcept
    (
      @nEmployeeID AS udtLong ,
      @nCompanyID AS udtInteger ,
      @nConcept AS udtInteger ,
      @cClass AS udtName OUTPUT ,
      @cCenter AS CHAR(14) OUTPUT
    )
AS
    DECLARE @existConcept AS udtInteger
    SET @existConcept = 0

    SELECT  @cClass = Conceptos.Clase ,
            @cCenter = Conceptos.Centro ,
            @existConcept = Conceptos.num_conc
    FROM    Conceptos
            INNER JOIN Llaves ON Llaves.Codigo = @nEmployeeID
                                 AND Llaves.Empresa = @nCompanyID
    WHERE   Conceptos.Num_Conc = @nConcept
            AND Conceptos.Clase = Llaves.Clase
            AND Conceptos.Centro = Llaves.Centro
            AND Conceptos.Empresa = @nCompanyID
            AND uso = 'S'

    IF @existConcept = 0 --@cClass = NULL OR @cClass = ''
        BEGIN
            SELECT  @cClass = Conceptos.Clase ,
                    @cCenter = Conceptos.Centro ,
                    @existConcept = Conceptos.num_conc
            FROM    Conceptos
                    INNER JOIN Llaves ON Llaves.Codigo = @nEmployeeID
                                         AND Llaves.Empresa = @nCompanyID
            WHERE   Conceptos.Num_Conc = @nConcept
                    AND Conceptos.Clase = Llaves.Clase
                    AND Conceptos.Centro = ''
                    AND Conceptos.Empresa = @nCompanyID
                    AND uso = 'S'


            IF @existConcept = 0 --@cClass = NULL OR @cClass = ''
                BEGIN
                    SELECT  @cClass = Conceptos.Clase ,
                            @cCenter = Conceptos.Centro
                    FROM    Conceptos
                            INNER JOIN Llaves ON Llaves.Codigo = @nEmployeeID
                                                 AND Llaves.Empresa = @nCompanyID
                    WHERE   Conceptos.Num_Conc = @nConcept
                            AND Conceptos.Clase = ''
                            AND Conceptos.Centro = Llaves.Centro
                            AND Conceptos.Empresa = @nCompanyID
                            AND uso = 'S'


                    IF @existConcept = 0 --@cClass = NULL OR @cClass = ''
                        SELECT  @cClass = Conceptos.Clase ,
                                @cCenter = Conceptos.Centro ,
                                @existConcept = Conceptos.num_conc
                        FROM    Conceptos
                        WHERE   Conceptos.Num_Conc = @nConcept
                                AND Conceptos.Clase = ''
                                AND Conceptos.Centro = ''
                                AND Conceptos.Empresa = @nCompanyID
                                AND uso = 'S'

                END
        END
    IF @existConcept = 0
        BEGIN
            SET @cClass = ''
            SET @cCenter = ''

        END

    SELECT  @cClass AS 'Clase' ,
            @cCenter AS 'Centro' ,
            @existConcept AS 'Num_conc'

GO


IF OBJECT_ID('dbo.GetSummaryAbsenteeisms') IS NOT NULL
    DROP PROCEDURE dbo.GetSummaryAbsenteeisms
GO

CREATE PROCEDURE dbo.GetSummaryAbsenteeisms
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @beginDate AS udtDateTime ,
      @days AS udtFloat ,
      @totalAbsenteeism AS udtFloat OUTPUT ,
      @totalIncapacite AS udtInteger OUTPUT ,
      @endDate AS udtDateTime OUTPUT
    )
    WITH ENCRYPTION
AS
    IF OBJECT_ID('dbo.tmp_detailAbsenteeism') IS NOT NULL
        DROP TABLE dbo.tmp_detailAbsenteeism



    SET @endDate = DATEADD(DAY, @days - 1, @beginDate)
    SET @totalAbsenteeism = 0
    SET @totalIncapacite = 0

--print @endDate

--Deducciones
    SELECT  d.num_conc AS 'conceptId' ,
            CASE WHEN ( d.fchinicio >= @beginDate
                        AND d.fchtermino <= @endDate
                      ) THEN d.dias
                 WHEN ( d.fchinicio < @beginDate
                        AND ( d.fchtermino >= @beginDate
                              AND d.fchtermino <= @endDate
                            )
                      ) THEN DATEDIFF(DAY, @beginDate, d.fchtermino) + 1
                 WHEN ( d.fchinicio < @beginDate
                        AND ( d.fchtermino >= @beginDate
                              AND d.fchtermino >= @endDate
                            )
                      ) THEN @days
                 WHEN ( d.fchinicio >= @beginDate
                        AND d.fchInicio <= @endDate
                      ) THEN DATEDIFF(DAY, d.fchInicio, @endDate) + 1
            END AS 'daysAbsenteeism'
    INTO    dbo.tmp_detailAbsenteeism
    FROM    deducciones AS d
            INNER JOIN conceptos AS c ON ( d.num_conc = c.num_conc
                                           AND d.empresa = c.empresa
                                         )
    WHERE   d.codigo = @employeeId
            AND d.empresa = @companyId
            AND ( d.Num_Conc >= 108
                  AND d.num_conc <= 111
                )
            AND ( ( d.fchinicio >= @beginDate
                    AND d.fchtermino <= @endDate
                  )
                  OR ( d.fchinicio < @beginDate
                       AND ( d.fchtermino >= @beginDate
                             AND d.fchtermino <= @endDate
                           )
                     )
                  OR ( d.fchinicio < @beginDate
                       AND ( d.fchtermino >= @beginDate
                             AND d.fchtermino >= @endDate
                           )
                     )
                  OR ( d.fchinicio >= @beginDate
                       AND d.fchInicio <= @endDate
                     )
                )

    SELECT  @totalAbsenteeism = @totalAbsenteeism
            + CASE WHEN conceptId = 108 THEN daysAbsenteeism
                   ELSE 0
              END ,
            @totalIncapacite = @totalIncapacite
            + CASE WHEN conceptId > 108 THEN daysAbsenteeism
                   ELSE 0
              END
    FROM    dbo.tmp_detailAbsenteeism


GO

IF OBJECT_ID('dbo.CalculateConceptUserDefinedPerception') IS NOT NULL
    DROP PROCEDURE dbo.CalculateConceptUserDefinedPerception
GO

CREATE PROCEDURE dbo.CalculateConceptUserDefinedPerception
    (
      @companyId AS udtInteger ,
      @employeeId AS udtInteger ,
      @conceptId AS udtInteger ,
      @conceptCenter AS udtName ,
      @conceptClass AS udtName ,
      @variable1 AS udtFloat ,
      @variable2 AS udtFloat ,
      @variable3 AS udtFloat ,
      @variable4 AS udtFloat
    )
    WITH ENCRYPTION
AS
    IF OBJECT_ID('dbo.tmp_calculateConcept') IS NOT NULL
        DROP TABLE dbo.tmp_calculateConcept

    DECLARE @resultCalculate AS NUMERIC(10, 2)
    DECLARE @resultCalculateImss AS NUMERIC(10, 2)
    DECLARE @executeCommand AS VARCHAR(1000)
    DECLARE @formula AS VARCHAR(1000)
    DECLARE @salary AS udtFloat
    DECLARE @SBC AS udtFloat
    DECLARE @days AS udtFloat
    DECLARE @incapacity AS udtInteger
    DECLARE @absenteeism AS udtInteger
    DECLARE @salarioMinimo AS udtFloat
    DECLARE @salarioMinimoDF AS udtFloat
    DECLARE @supervisor AS udtInteger
    DECLARE @payrollType AS udtInteger
    DECLARE @schedule AS udtInteger
    DECLARE @geographicZone AS udtName
    DECLARE @monthOperationCompany AS udtInteger
    DECLARE @yearOperationCompany AS udtInteger
    DECLARE @beginDatePayroll AS udtDateTime
    DECLARE @endDatePayroll AS udtDateTime
    DECLARE @returnTotalAbsenteeism AS udtFloat
    DECLARE @returnTotalIncapacite AS udtInteger
    DECLARE @returnEndDate AS udtDateTime
    DECLARE @cClass AS udtName
    DECLARE @cCenter AS udtName
	DECLARE @nFactus AS udtFloat
	DECLARE @UmaDiario AS udtFloat
	DECLARE @FF AS udtDateTime


    SET @resultCalculate = 0
    SET @resultCalculateImss = 0
	SET @nFactus = 1.0
	SET @umaDiario = 0


    BEGIN TRANSACTION
    BEGIN TRY

        --Get Company parameters
        SELECT  @geographicZone = dbo.empresas.zona_geografica ,
                @monthOperationCompany = dbo.empresas.mes_operacion ,
                @yearOperationCompany = dbo.empresas.ayo_operacion
        FROM    dbo.empresas
        WHERE   dbo.empresas.empresa = @companyId

	   SET @Ff = dbo.fin_mes(@monthOperationCompany,@yearOperationCompany)


        SELECT  @salarioMinimoDF = zona_a ,
                @salarioMinimo = CASE WHEN @geographicZone = 'A' THEN zona_a
                                      WHEN @geographicZone = 'B' THEN zona_b
                                      WHEN @geographicZone = 'C' THEN zona_c
                                      ELSE 0
                                 END
        FROM    dbo.GetMinimumWage(@monthOperationCompany,
                                   @yearOperationCompany)

         SELECT TOP 1
                @umaDiario = uma.umaDiario
         FROM dbo.TblUMA AS uma
         WHERE uma.fecha <= @ff
         ORDER BY uma.fecha DESC


        --Get Employee paramaters
        SELECT  @salary = empleados.sueldo ,
                @Sbc = empleados.saldiaint ,
                @supervisor = Llaves.supervisor ,
                @payrollType = Llaves.tiponom ,
                @schedule = Llaves.horario ,
                @days = ISNULL(Periodos.dias, 0)
        FROM    empleados
                INNER JOIN llaves ON ( empleados.empresa = Llaves.empresa
                                       AND empleados.codigo = Llaves.codigo
                                     )
                LEFT JOIN dbo.Periodos ON ( Llaves.empresa = Periodos.empresa
                                            AND Llaves.tiponom = Periodos.tiponom
                                          )
        WHERE   empleados.empresa = @companyId
                AND empleados.codigo = @employeeId
                AND dbo.Periodos.estatus = 'A'



        EXEC [dbo].[getSummaryAbsenteeisms] @companyId, @employeeId,
            @beginDatePayroll, @days,
            @totalAbsenteeism = @returnTotalAbsenteeism OUTPUT,
            @totalIncapacite = @returnTotalIncapacite OUTPUT,
            @endDate = @returnEndDate OUTPUT


        --Get Class, Center from Concept
        EXECUTE SeekConcept @EmployeeID, @CompanyID, @ConceptId,
            @cClass = @conceptClass OUTPUT, @cCenter = @conceptCenter OUTPUT


        --Get Concepts parameters
        SELECT  @conceptId AS 'num_conc' ,
                @conceptCenter AS 'centro' ,
                @conceptClass AS 'clase' ,
                @salary AS 'impor_base' ,
                @sbc AS 'saldiaint' ,
                @days AS 'dias' ,
                @returnTotalIncapacite AS 'inc' ,
                @returnTotalAbsenteeism AS 'aus' ,
                @salarioMinimo AS 'salmin' ,
                @salarioMinimoDF AS 'salDF' ,
                @variable1 AS 'nvar1' ,
                @variable2 AS 'nvar2' ,
                @variable3 AS 'nvar3' ,
                @variable4 AS 'nvar4' ,
                @supervisor AS 'nsupervisor' ,
                @payrollType AS 'ntiponom' ,
                @schedule AS 'nhorario' ,
                dbo.checa_formula(LTRIM(RTRIM(formula)), 'F') AS 'formula' ,
                dbo.checa_formula(LTRIM(RTRIM(imss_ni)), 'IMSS') AS 'formulaImss' ,
                @resultCalculate AS 'importe' ,
                @resultCalculate AS 'importe1' ,
                @resultCalculate AS 'noIntegraImss' ,
                mascara ,
                variable1 ,
                variable2 ,
                variable3 ,
                variable4 ,
				@nFactus AS 'nfactus',
				@umaDiario AS 'UmaDiario'
        INTO    dbo.tmp_calculateConcept
        FROM    conceptos
        WHERE   empresa = @companyId
                AND num_conc = @conceptId
                AND clase = @conceptClass
                AND centro = @conceptCenter




--Evaluate concept
        SELECT  @formula = RTRIM(LTRIM(formula))
        FROM    dbo.tmp_calculateConcept
        SET @executeCommand = 'UPDATE tmp_calculateConcept SET importe = '
            + @formula + ', importe1 = ' + @formula



        IF LEN(@formula) > 0
            EXECUTE ( @executeCommand )


--Evaluate concept no integration IMSS
        SELECT  @formula = RTRIM(LTRIM(formulaImss))
        FROM    dbo.tmp_calculateConcept


        SET @executeCommand = 'UPDATE tmp_calculateConcept SET noIntegraImss = '
            + @formula


        IF LEN(@formula) > 0
            EXECUTE ( @executeCommand )

        UPDATE  dbo.tmp_calculateConcept
        SET     noIntegraImss = importe
        WHERE   noIntegraImss > importe


        SELECT  importe ,
                noIntegraImss ,
                mascara ,
                variable1 ,
                variable2 ,
                variable3 ,
                variable4
        FROM    dbo.tmp_calculateConcept

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO

IF OBJECT_ID('dbo.CalculateConceptForHoursPerception') IS NOT NULL
    DROP PROCEDURE dbo.CalculateConceptForHoursPerception
GO

CREATE PROCEDURE dbo.CalculateConceptForHoursPerception
    @companyId AS udtInteger ,
    @employeeId AS udtLong ,
    @salary AS udtFloat ,
    @hours AS udtFloat ,
    @date AS udtDateTime ,
    @conceptoId AS udtInteger
    WITH ENCRYPTION
AS
    SET DATEFIRST 1

    DECLARE @hoursValue AS udtFloat
    DECLARE @hoursLaborDay AS udtFloat
    DECLARE @dayOfWeek AS udtInteger
    DECLARE @multiplyHour AS udtInteger
    DECLARE @amountReturn AS udtFloat
    DECLARE @companyOperationMonth AS udtInteger
    DECLARE @companyOperationYear AS udtInteger
    DECLARE @beginOperationDate AS udtDateTime
    DECLARE @endOperationDate AS udtDateTime
    DECLARE @salaryEmployee AS udtFloat

--Operation Month and Year From empresas
    SELECT  @companyOperationMonth = mes_operacion ,
            @companyOperationYear = ayo_operacion
    FROM    dbo.empresas
    WHERE   empresa = @companyId

    SET @beginOperationDate = CONVERT(DATETIME, STR(@companyOperationYear)
        + RIGHT(STR(100 + @companyOperationMonth), 2) + '01')

    SET @endOperationDate = dbo.fin_mes(@companyOperationMonth,
                                        @companyOperationYear)

    SET @dayOfWeek = DATEPART(DW, @date)
    SET @hoursLaborDay = 8
    SET @hoursValue = 0
    SET @multiplyHour = 2

--Get Salary employee
    IF @salary = 0
        BEGIN

            EXECUTE dbo.asp_ds @companyId, -- numeric
                @employeeId, -- numeric
                @companyOperationYear, -- int
                @companyOperationMonth, -- int
                @endOperationDate -- datetime

        END

    IF @salary > 0
        SET @salaryEmployee = @salary
    ELSE
        BEGIN
            SELECT  @salaryEmployee = ISNULL(sueldo, 0)
            FROM    dbo.avisos_imss
            WHERE   codigo = @employeeId
                    AND empresa = @companyId
                    AND ( @date >= fch_mov
                          AND @date <= DATEADD(dd, diastr, fch_mov)
                        )
                    AND mov <> 'B'

            IF @salaryEmployee = 0
                SELECT  @salaryEmployee = ISNULL(sueldo, 0)
                FROM    dbo.empleados
                WHERE   codigo = @employeeId
                        AND empresa = @companyId
        END


--Over time triple
    IF @conceptoId = 13
        SET @multiplyHour = 3

    SELECT  @hoursLaborDay = detalle_horarios.sdoxhor
    FROM    dbo.detalle_horarios
            INNER JOIN llaves ON ( llaves.codigo = @employeeId
                                   AND llaves.empresa = @companyId
                                 )
    WHERE   detalle_horarios.horario = llaves.horario
            AND detalle_horarios.dia_semana = @dayOfWeek
            AND detalle_horarios.empresa = @companyId

    IF @hoursLaborDay = 0
        SET @hoursLaborDay = 8

    SET @hoursValue = @salaryEmployee / @hoursLaborDay

    SET @amountReturn = @hoursValue * @hours * @multiplyHour

    SELECT  @amountReturn AS 'result' ,
            @hoursLaborDay AS 'hoursLaborDay' ,
            @dayOfWeek AS 'dayOfWeek' ,
            @hoursValue AS 'hoursValue' ,
            @salaryEmployee AS 'Salary'

GO


IF OBJECT_ID('dbo.GetOverTimeWeekAnalys') IS NOT NULL
    DROP PROCEDURE dbo.GetOverTimeWeekAnalys
GO


CREATE PROCEDURE dbo.GetOverTimeWeekAnalys
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @beginDate AS udtDateTime
    )
    WITH ENCRYPTION
AS
    DECLARE @endDate AS udtDateTime

    SET @endDate = DATEADD(dd, 6, @beginDate)

    SELECT  p1.codigo ,
            ( SELECT    SUM(p.horas_ex)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 9
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'primaDominicalHoras' ,
            ( SELECT    SUM(p.nomina)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 9
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'primaDominicalImporte' ,
            ( SELECT    SUM(p.horas_ex)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 10
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'descansoHoras' ,
            ( SELECT    SUM(p.nomina)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 10
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'descansoImporte' ,
            ( SELECT    SUM(p.horas_ex)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 11
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'dobleNoIntegrableHoras' ,
            ( SELECT    SUM(p.nomina)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 11
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'dobleNoIntegrableImporte' ,
            ( SELECT    SUM(p.horas_ex)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 12
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'dobleIntegrableHoras' ,
            ( SELECT    SUM(p.nomina)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 12
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'dobleIntegrableImporte' ,
            ( SELECT    SUM(p.horas_ex)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 13
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'tripleHoras' ,
            ( SELECT    SUM(p.nomina)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc = 13
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'tripleImporte' ,
            ( SELECT    SUM(p.nomina)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc >= 09
                        AND p.num_conc <= 13
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'totalImporte' ,
            ( SELECT    SUM(p.varia_imss)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc >= 09
                        AND p.num_conc <= 13
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'totalIntegrable' ,
            ( SELECT    SUM(p.nomina) - SUM(p.varia_imss)
              FROM      dbo.percepciones AS p
              WHERE     p.codigo = p1.codigo
                        AND p.num_conc >= 09
                        AND p.num_conc <= 13
                        AND p.empresa = p1.empresa
                        AND p.fch_pago >= @beginDate
                        AND p.fch_pago <= @endDate
            ) AS 'totalNoIntegrable'
    FROM    dbo.percepciones AS p1
    WHERE   p1.empresa = @companyId
            AND p1.codigo = @employeeId
            AND ( p1.fch_pago >= @beginDate
                  AND p1.fch_pago <= @endDate
                )
    GROUP BY p1.codigo ,
            p1.empresa



GO

IF OBJECT_ID('dbo.CalculateWishedPayPerception') IS NOT NULL
    DROP PROCEDURE dbo.CalculateWishedPayPerception
GO

CREATE PROCEDURE dbo.CalculateWishedPayPerception
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @wishedPay AS udtFloat
    )
    WITH ENCRYPTION
AS
    DECLARE @salary AS udtFloat
    DECLARE @days AS udtInteger
    DECLARE @abseenteims AS udtInteger
    DECLARE @incapacites AS udtInteger
    DECLARE @sbc AS udtFloat
    DECLARE @beginDatePayroll AS udtDateTime
    DECLARE @endDatePayroll AS udtDateTime
    DECLARE @payDate AS udtDateTime
    DECLARE @typeSalary AS udtInteger
    DECLARE @dateHiring AS udtDateTime
    DECLARE @schedule AS udtInteger
    DECLARE @payrollType AS udtInteger
    DECLARE @lastDateImss AS udtDateTime
    DECLARE @lastincidenceImss AS udtName
    DECLARE @laborDays AS udtLong

    DECLARE @calculatePay AS udtFloat
    DECLARE @gravable AS udtFloat
    DECLARE @isr AS udtFloat
    DECLARE @subsidio AS udtFloat
    DECLARE @acumulateDays AS udtFloat
    DECLARE @isrTotal AS udtFloat
    DECLARE @isrBase AS CHAR(1)
    DECLARE @isrTypeSalary0 AS udtName
    DECLARE @isrTypeSalary1 AS udtName
    DECLARE @isrTypeSalary2 AS udtName
    DECLARE @isrCalculationBase AS udtName
    DECLARE @loop AS udtInteger
    DECLARE @isrCalculate AS udtFloat
    DECLARE @subsidioCalculate AS udtFloat
    DECLARE @excepcionIsr AS udtName
    DECLARE @isrDaysToProject AS udtFloat
    DECLARE @calculateImss AS udtFloat
    DECLARE @geographicZone AS udtName
    DECLARE @regionalMinimalWage AS udtFloat
    DECLARE @regionalMinimalWageDF AS udtFloat
    DECLARE @month AS udtInteger
    DECLARE @year AS udtInteger
    DECLARE @isPensioner AS udtInteger
    DECLARE @topSalaryBaseImss AS udtFloat
    DECLARE @topImss AS udtInteger
    DECLARE @taxEym25 AS udtFloat
    DECLARE @taxEym106II AS udtFloat
    DECLARE @taxEym107 AS udtFloat
    DECLARE @taxIv147 AS udtFloat
    DECLARE @taxCv168II AS udtFloat
    DECLARE @taxEymAus AS udtFloat
    DECLARE @returnTotalAbsenteeism AS udtFloat
    DECLARE @returnTotalIncapacite AS udtInteger
    DECLARE @returnEndDate AS udtDateTime
    DECLARE @calculateEym25 AS udtFloat
    DECLARE @calculateEym106II AS udtFloat
    DECLARE @calculateEym107 AS udtFloat
    DECLARE @calculateIv147 AS udtFloat
    DECLARE @calculateCv168II AS udtFloat
    DECLARE @calculateEymAus AS udtFloat
    DECLARE @calculateSbc AS udtFloat
    DECLARE @approximatedPay AS udtFloat
    DECLARE @differencePay AS udtFloat
	DECLARE @FactorIntegracionMinimo AS NUMERIC(8,6)


    SET @calculatePay = @wishedPay * 1.20
    SET @isPensioner = 0
    SET @topImss = 25
	SET @FactorIntegracionMinimo = 1.0452

    SELECT  @geographicZone = dbo.empresas.zona_geografica ,
            @month = dbo.empresas.mes_operacion ,
            @year = dbo.empresas.ayo_operacion ,
            @taxEym25 = dbo.empresas.eymtra25 ,
            @taxEym106II = dbo.empresas.eymtra1062 ,
            @taxEym107 = dbo.empresas.eymtra107 ,
            @taxIv147 = dbo.empresas.ivtra147 ,
            @taxCv168II = dbo.empresas.cvtra168ii
    FROM    dbo.empresas
    WHERE   dbo.empresas.empresa = @companyId

	if @year >= 2023
	   SET @FactorIntegracionMinimo = 1.0493


    SELECT  @regionalMinimalWageDF = zona_a ,
            @regionalMinimalWage = CASE WHEN @geographicZone = 'A' THEN zona_a
                                        WHEN @geographicZone = 'B' THEN zona_b
                                        WHEN @geographicZone = 'C' THEN zona_c
                                        ELSE 0
                                   END
    FROM    dbo.GetMinimumWage(@month, @year)

    SELECT  @isPensioner = CASE WHEN dbo.excepciones.excepcion1 = 'IV' THEN 1
                                WHEN dbo.excepciones.excepcion1 = 'CV' THEN 2
                                ELSE 0
                           END
    FROM    dbo.excepciones
    WHERE   codigo = @employeeId
            AND empresa = @companyId
            AND ( excepcion1 = 'IV'
                  OR excepcion1 = 'CV'
                )

    SELECT  @isrBase = base_calc
    FROM    dbo.apsiispt
    WHERE   articulo = ' '
            AND mca_ultimo = 'U'
            AND empresa = @companyId

    IF @isrBase = 'M'
        BEGIN
            SELECT  @gravable = gravable ,
                    @isr = ispt ,
                    @subsidio = creditosal ,
                    @acumulateDays = dias
            FROM    dbo.mensual
            WHERE   codigo = @employeeId
                    AND empresa = @companyId
        END
    ELSE
        SELECT  @gravable = dbo.acum_emps.gravable ,
                @isr = dbo.acum_emps.ispt ,
                @subsidio = dbo.acum_emps.cr_Sal ,
                @acumulateDays = dbo.acum_emps.dias_Labor
        FROM    dbo.acum_emps
                INNER JOIN dbo.empresas ON ( dbo.acum_emps.empresa = dbo.empresas.empresa )
        WHERE   dbo.acum_emps.codigo = @employeeId
                AND dbo.acum_emps.empresa = @companyId
                AND dbo.acum_emps.ejercicio = dbo.empresas.ayo_operacion


    SELECT  @isrTypeSalary0 = dbo.conceptos.variable1 ,
            @isrTypeSalary1 = dbo.conceptos.variable2 ,
            @isrTypeSalary2 = dbo.conceptos.variable3 ,
            @isrDaysToProject = ( CASE WHEN dbo.conceptos.Hrs_Min3 = 30
                                       THEN 30
                                       ELSE 30.4
                                  END )
    FROM    dbo.conceptos
    WHERE   dbo.conceptos.num_conc = 136
            AND dbo.conceptos.empresa = @companyId

    SELECT  @salary = dbo.empleados.sueldo ,
            @sbc = dbo.empleados.saldiaint ,
            @dateHiring = dbo.empleados.fchalta ,
            @typeSalary = dbo.empleados.tiposal ,
            @schedule = dbo.Llaves.horario ,
            @payrollType = dbo.Llaves.tiponom ,
            @beginDatePayroll = dbo.Periodos.inicio ,
            @endDatePayroll = dbo.Periodos.cierre ,
            @payDate = dbo.Periodos.pago ,
            @days = dbo.Periodos.dias ,
            @lastDateImss = dbo.empleados.ultfchmov ,
            @lastincidenceImss = dbo.empleados.ultmov ,
            @excepcionIsr = ISNULL(dbo.Excepciones.Excepcion1, ' ')
    FROM    dbo.empleados
            INNER JOIN dbo.Llaves ON ( dbo.empleados.empresa = dbo.Llaves.empresa
                                       AND dbo.empleados.codigo = dbo.Llaves.codigo
                                     )
            INNER JOIN dbo.Periodos ON ( dbo.Llaves.empresa = dbo.Periodos.empresa
                                         AND dbo.Llaves.tiponom = dbo.Periodos.tiponom
                                       )
            LEFT JOIN dbo.Excepciones ON ( dbo.empleados.Codigo = dbo.Excepciones.Codigo
                                           AND dbo.Excepciones.Excepcion1 = '115'
                                           AND dbo.Excepciones.Empresa = @companyId
                                         )
    WHERE   dbo.empleados.codigo = @employeeId
            AND dbo.empleados.empresa = @companyId
            AND dbo.Periodos.estatus = 'A'

    SET @isrCalculationBase = CASE WHEN @typeSalary = 0 THEN @isrTypeSalary0
                                   WHEN @typeSalary = 1 THEN @isrTypeSalary1
                                   ELSE @isrTypeSalary2
                              END


    SET @days = CASE WHEN @lastincidenceImss = 'B'
                          AND @lastDateImss < @beginDatePayroll THEN 0
                     WHEN @dateHiring > @beginDatePayroll
                     THEN DATEDIFF(dd, @dateHiring, @endDatePayroll) + 1
                     WHEN @lastincidenceImss = 'B'
                          AND @lastDateImss < @endDatePayroll
                     THEN DATEDIFF(dd, @beginDatePayroll, @lastDateImss) + 1
                     ELSE @days
                END

    EXEC [dbo].[getSummaryAbsenteeisms] @companyId, @employeeId,
        @beginDatePayroll, @days,
        @totalAbsenteeism = @returnTotalAbsenteeism OUTPUT,
        @totalIncapacite = @returnTotalIncapacite OUTPUT,
        @endDate = @returnEndDate OUTPUT

    SET @topSalaryBaseImss = @regionalMinimalWageDF * 25
    SET @loop = 1
    SET @laborDays = ( @days - @returnTotalAbsenteeism
                       - @returnTotalIncapacite )
    SET @calculateSbc = CASE WHEN @sbc > @topSalaryBaseImss
                             THEN @topSalaryBaseImss
                             ELSE @sbc
                        END


    WHILE @loop < 50
        BEGIN
            SET @isrTotal = 0
            SET @isrCalculate = 0
            SET @subsidioCalculate = 0
            SET @calculateImss = 0
            SET @calculateEym25 = 0
            SET @calculateEym106II = 0
            SET @calculateEym107 = 0
            SET @calculateIv147 = 0
            SET @calculateCv168II = 0
            SET @calculateEymAus = 0


            IF @isrBase = 'P'  --Calculo de Isr por periodo
                BEGIN

                    SET @isrCalculate = dbo.Fun_R_Isr_Periodico(@calculatePay,
                                                              @laborDays, 0,
                                                              YEAR(@payDate),
                                                              7, @companyId) -- Isr 2008
                    SET @subsidioCalculate = dbo.Fun_R_Isr_Periodico(@calculatePay,
                                                              @laborDays, 0,
                                                              YEAR(@PayDate),
                                                              8, @companyId)  -- Subsidio para el empleo
                END
            IF @isrBase = 'M'
                BEGIN
                    SET @isrCalculate = dbo.Fun_R_Isr_Mensual(@calculatePay,
                                                              @laborDays,
                                                              @gravable,
                                                              @acumulateDays,
                                                              @isr, @subsidio,
                                                              CASE
                                                              WHEN @isrCalculationBase = 'SALDIAINT'
                                                              THEN @sbc
                                                              ELSE @salary
                                                              END, @subsidio,
                                                              0, 0,
                                                              @excepcionIsr,
                                                              @isrDaysToProject,
                                                              @isrCalculationBase,
                                                              'N',
                                                              YEAR(@payDate),
                                                              7, @companyId)
                    SET @subsidioCalculate = dbo.Fun_R_Isr_Mensual(@calculatePay,
                                                              @laborDays,
                                                              @gravable,
                                                              @acumulateDays,
                                                              @isr, @subsidio,
                                                              CASE
                                                              WHEN @isrCalculationBase = 'SALDIAINT'
                                                              THEN @sbc
                                                              ELSE @salary
                                                              END, @subsidio,
                                                              0, 0,
                                                              @excepcionIsr,
                                                              @isrDaysToProject,
                                                              @isrCalculationBase,
                                                              'N',
                                                              YEAR(@payDate),
                                                              8, @companyId)

                END
            SET @isrTotal = @isrCalculate - @subsidioCalculate

            --Calculate IMSS
            --IF @sbc > ( @regionalMinimalWage * 1.0452 ) 
            IF @sbc > ( @regionalMinimalWage * @FactorIntegracionMinimo ) 			
                BEGIN
                    SET @calculateEym25 = ROUND(@laborDays * @calculateSbc
                                                * ( @taxEym25 / 100 ), 2)

                    IF @isPensioner = 2 --Esta pensionado por Vejez
                        SET @calculateEym25 = 0

                    IF @sbc > @regionalMinimalWageDF * 03
                        SET @calculateEym106II = ROUND(@laborDays
                                                       * ( @calculateSbc
                                                           - ( @regionalMinimalWageDF
                                                              * 03 ) )
                                                       * ( @taxEym106II / 100 ),
                                                       02)

                    ELSE
                        SET @calculateEym106II = 0

                    SET @calculateEym107 = ROUND(@laborDays * @calculateSbc
                                                 * ( @taxEym107 / 100 ), 02)

                    --Si esta pensionado o invalido poner el calculo de la prima Iv147 en ceros
                    IF @isPensioner > 0
                        SET @calculateIv147 = 0
                    ELSE
                        SET @calculateIv147 = ROUND(@laborDays * @calculateSbc
                                                    * ( @taxIv147 / 100 ), 02)

                    SET @calculateCv168II = ROUND(@laborDays * @calculateSbc
                                                  * ( @taxCv168II / 100 ), 02)

                    SET @calculateEymAus = ROUND(@returnTotalAbsenteeism
                                                 * @calculateSbc
                                                 * ( ( @taxEym25 + @taxEym107 )
                                                     / 100 ), 02)

                    IF @sbc > @regionalMinimalWageDF * 03
                        SET @calculateEymAus = @calculateEymAus
                            + ROUND(@returnTotalAbsenteeism * ( @calculateSbc
                                                              - ( @regionalMinimalWageDF
                                                              * 03 ) )
                                    * ( @taxEym106II / 100 ), 02)

                    SET @calculateImss = @calculateEym25 + @calculateEym106II
                        + @calculateEym107 + @calculateIv147
                        + @calculateCv168II + @calculateEymAus


                END
            SET @approximatedPay = ROUND(@calculatePay - ( @isrTotal
                                                           + @calculateImss ),
                                         2)
            SET @differencePay = ROUND(@wishedPay - @approximatedPay, 2)
            IF @differencePay = 0
                OR ( @differencePay <= 0.02
                     AND @differencePay >= -0.02
                   )
                BREAK

            SET @calculatePay = @calculatePay + @differencePay


            SET @loop = @loop + 1


        END

/*
    SELECT  @calculateEym25 AS 'eym25' ,
            @calculateEym106II AS 'Eym106II',
            @calculateEym107 AS 'eym107',
            @calculateIv147 AS 'Iv147',
            @calculateCv168II AS 'Cv168II',
            @calculateEymAus AS 'EymAus',
            @calculateSbc AS 'Sbc',
            @regionalMinimalWageDF * 3 AS 'Tope Eym106ii',
            @laborDays AS 'Dias laborados',
            @taxEym25 AS 'eym25' ,
            @taxEym106II AS 'Eym106II',
            @taxEym107 AS 'eym107',
            @taxIv147 AS 'Iv147',
            @taxCv168II AS 'Cv168II'

*/


    SELECT  @calculatePay AS 'Bruto' ,
            @isrTotal AS 'Isr' ,
            @calculateImss AS 'Imss' ,
            @calculatePay - ( @isrTotal + @calculateImss ) AS 'Deseado'


GO


IF OBJECT_ID('dbo.GetFixedBenefits') IS NOT NULL
    DROP FUNCTION dbo.GetFixedBenefits
GO

CREATE FUNCTION dbo.GetFixedBenefits
    (
      @companyId udtInteger ,
      @employeeId udtInteger ,
      @yearOperation udtInteger ,
      @monthOperation udtInteger
    )
RETURNS @FixedBenefitsTable TABLE
    (
      factor udtFloat NOT NULL ,
      ayos udtName NOT NULL ,
      aguinaldo udtFloat NOT NULL ,
      dias_vac udtFloat NOT NULL ,
      prima_vac udtFloat NOT NULL ,
      pmavacdias udtFloat NOT NULL ,
      pmavacimpo udtFloat NOT NULL ,
      despensa udtFloat NOT NULL ,
      despensaim udtFloat NOT NULL ,
      dias_ayo udtFloat NOT NULL ,
      porc_ayo udtFloat NOT NULL ,
      imp_ayo udtFloat NOT NULL ,
      dias_mes udtFloat NOT NULL ,
      porc_mes udtFloat NOT NULL ,
      imp_mes udtFloat NOT NULL ,
      porc_dia udtFloat NOT NULL ,
      imp_dia udtFloat NOT NULL ,
      fdoahopatp udtFloat NOT NULL ,
      fdoahopati udtFloat NOT NULL ,
      fdoahotrap udtFloat NOT NULL ,
      fdoahotrai udtFloat NOT NULL ,
      pmo1ayopor udtFloat NOT NULL ,
      pmo1ayoimp udtFloat NOT NULL ,
      pmo2ayopor udtFloat NOT NULL ,
      pmo2ayoimp udtFloat NOT NULL
    )
    WITH ENCRYPTION
AS
    BEGIN

        DECLARE @yearCompany udtInteger
        DECLARE @monthCompany udtInteger
        DECLARE @yearTable udtInteger
        DECLARE @monthTable udtInteger

        SET @yearTable = @yearOperation
        SET @monthTable = @monthOperation

        SELECT  @yearCompany = ayo_operacion ,
                @monthCompany = mes_operacion
        FROM    empresas
        WHERE   empresa = @companyId


        IF CONVERT(DATETIME, LTRIM(STR(@yearOperation)) + RIGHT(STR(100
                                                              + @monthOperation),
                                                              2) + '01') > CONVERT(DATETIME, LTRIM(STR(@yearCompany))
            + RIGHT(STR(100 + @monthCompany), 2) + '01')
            BEGIN
                SET @yearOperation = @yearCompany
                SET @monthOperation = @monthCompany
            END


        INSERT  INTO @FixedBenefitsTable
                ( factor ,
                  ayos ,
                  aguinaldo ,
                  dias_vac ,
                  prima_vac ,
                  pmavacdias ,
                  pmavacimpo ,
                  despensa ,
                  despensaim ,
                  dias_ayo ,
                  porc_ayo ,
                  imp_ayo ,
                  dias_mes ,
                  porc_mes ,
                  imp_mes ,
                  porc_dia ,
                  imp_dia ,
                  fdoahopatp ,
                  fdoahopati ,
                  fdoahotrap ,
                  fdoahotrai ,
                  pmo1ayopor ,
                  pmo1ayoimp ,
                  pmo2ayopor ,
                  pmo2ayoimp
                )
                SELECT  factor ,
                        ayos ,
                        aguinaldo ,
                        dias_vac ,
                        prima_vac ,
                        pmavacdias ,
                        pmavacimpo ,
                        despensa ,
                        despensaim ,
                        dias_ayo ,
                        porc_ayo ,
                        imp_ayo ,
                        dias_mes ,
                        porc_mes ,
                        imp_mes ,
                        porc_dia ,
                        imp_dia ,
                        fdoahopatp ,
                        fdoahopati ,
                        fdoahotrap ,
                        fdoahotrai ,
                        pmo1ayopor ,
                        pmo1ayoimp ,
                        pmo2ayopor ,
                        pmo2ayoimp
                FROM    empleados AS e
                        INNER JOIN llaves AS ll ON ll.empresa = e.empresa
                                                   AND ll.codigo = e.codigo
                        INNER JOIN tablas_int AS t ON t.empresa = e.empresa
                                                      AND t.clase = ll.clase
                                                      AND t.ayo_operacion = @yearOperation
                                                      AND t.mes_operacion = @monthOperation
                                                      AND t.ayos = DATEDIFF(yy,
                                                              CASE
                                                              WHEN e.fchantigua IS NULL
                                                              THEN CASE
                                                              WHEN e.fchalta IS NULL
                                                              THEN [dbo].[fin_mes](@monthTable,
                                                              @yearTable)
                                                              ELSE e.fchalta
                                                              END
                                                              ELSE e.fchantigua
                                                              END,
                                                              [dbo].[fin_mes](@monthTable,
                                                              @yearTable))
                                                      + CASE WHEN YEAR(CASE
                                                              WHEN e.fchantigua IS NULL
                                                              THEN CASE
                                                              WHEN e.fchalta IS NULL
                                                              THEN dbo.fin_mes(@monthTable,
                                                              @yearTable)
                                                              ELSE e.fchalta
                                                              END
                                                              ELSE e.fchantigua
                                                              END) <= YEAR(dbo.fin_mes(@monthTable,
                                                              @yearTable))
                                                              AND MONTH(CASE
                                                              WHEN e.fchantigua IS NULL
                                                              THEN CASE
                                                              WHEN e.fchalta IS NULL
                                                              THEN dbo.fin_mes(@monthTable,
                                                              @yearTable)
                                                              ELSE e.fchalta
                                                              END
                                                              ELSE e.fchantigua
                                                              END) <= MONTH(dbo.fin_mes(@monthTable,
                                                              @yearTable))
                                                              AND CASE
                                                              WHEN DAY(CASE
                                                              WHEN e.fchantigua IS NULL
                                                              THEN CASE
                                                              WHEN e.fchalta IS NULL
                                                              THEN dbo.fin_mes(@monthTable,
                                                              @yearTable)
                                                              ELSE e.fchalta
                                                              END
                                                              ELSE e.fchantigua
                                                              END) = 31
                                                              AND DAY(dbo.fin_mes(@monthTable,
                                                              @yearTable)) = 30
                                                              THEN 30
                                                              ELSE DAY(CASE
                                                              WHEN e.fchantigua IS NULL
                                                              THEN CASE
                                                              WHEN e.fchalta IS NULL
                                                              THEN dbo.fin_mes(@monthTable,
                                                              @yearTable)
                                                              ELSE e.fchalta
                                                              END
                                                              ELSE e.fchantigua
                                                              END)
                                                              END <= DAY(dbo.fin_mes(@monthTable,
                                                              @yearTable))
                                                             THEN 1
                                                             ELSE 0
                                                        END
                WHERE   e.empresa = @companyId
                        AND e.codigo = @employeeId

        RETURN
    END

GO

IF OBJECT_ID('dbo.WD_Obtener_Percepciones_T') IS NOT NULL
    DROP PROCEDURE dbo.WD_Obtener_Percepciones_T
GO

CREATE PROCEDURE dbo.WD_Obtener_Percepciones_T
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0) ,
    @periodo AS INT ,
    @ayo_operacion AS INT ,
    @tiponom AS INT ,
    @mes_operacion AS INT ,
    @tipoConsulta AS INT
AS

    SET NOCOUNT ON

    IF @tipoConsulta = 0  --Consultar el periodo
        SELECT  CASE WHEN p.varia_imss > 0 THEN 1
                     ELSE 0
                END AS 'EsVariable' ,
                CASE WHEN p.varia_imss > 0
                          AND p.mes_operacion = e.mes_operacion
                          AND p.ayo_operacion = e.ayo_operacion THEN 1
                     ELSE 0
                END AS 'EsVariableMes' ,
                p.folio ,
                p.num_conc ,
                c.concepto AS 'concepto' ,
                p.fch_pago ,
                ISNULL(p.horas_ex,0) AS 'Horas' ,
                p.nomina ,
                p.varia_imss ,
                ISNULL(p.varia1,0) AS 'Varia1' ,
                ISNULL(p.varia2,0) AS 'Varia2' ,
                ISNULL(p.varia3,0) AS 'Varia3' ,
                ISNULL(p.varia4,0) AS 'Varia4' ,
                p.periodo ,
                p.mes_operacion ,
                p.ayo_operacion ,
                p.tiponom
        FROM    dbo.percepciones AS p
                INNER JOIN dbo.empresas AS e ON p.empresa = e.empresa
                LEFT JOIN dbo.conceptos AS c ON p.empresa = c.empresa AND p.num_conc = c.num_conc AND p.clase = c.clase AND p.centro = c.centro
        WHERE   p.empresa = @empresa
                AND p.codigo = @codigo
                AND p.periodo = @periodo
                AND p.ayo_operacion = @ayo_operacion
        ORDER BY p.folio

    IF @tipoConsulta = 1  --Consultar el mes
        SELECT  CASE WHEN p.varia_imss > 0 THEN 1
                     ELSE 0
                END AS 'EsVariable' ,
                CASE WHEN p.varia_imss > 0
                          AND p.mes_operacion = e.mes_operacion
                          AND p.ayo_operacion = e.ayo_operacion THEN 1
                     ELSE 0
                END AS 'EsVariableMes' ,
                p.folio ,
                p.num_conc ,
                c.concepto AS 'concepto' ,
                p.fch_pago ,
                ISNULL(p.horas_ex,0) AS 'Horas' ,
                p.nomina ,
                p.varia_imss ,
                ISNULL(p.varia1,0) AS 'Varia1' ,
                ISNULL(p.varia2,0) AS 'Varia2' ,
                ISNULL(p.varia3,0) AS 'Varia3' ,
                ISNULL(p.varia4,0) AS 'Varia4' ,
                p.periodo ,
                p.mes_operacion ,
                p.ayo_operacion ,
                p.tiponom
        FROM    dbo.percepciones AS p
                INNER JOIN dbo.empresas AS e ON p.empresa = e.empresa
                LEFT JOIN dbo.conceptos AS c ON p.empresa = c.empresa AND p.num_conc = c.num_conc AND p.clase = c.clase AND p.centro = c.centro
        WHERE   p.empresa = @empresa
                AND p.codigo = @codigo
                AND p.mes_operacion = @mes_operacion
                AND p.ayo_operacion = @ayo_operacion
        ORDER BY p.folio


    IF @tipoConsulta = 2  --Consultar el ejercicio
        SELECT  CASE WHEN p.varia_imss > 0 THEN 1
                     ELSE 0
                END AS 'EsVariable' ,
                CASE WHEN p.varia_imss > 0
                          AND p.mes_operacion = e.mes_operacion
                          AND p.ayo_operacion = e.ayo_operacion THEN 1
                     ELSE 0
                END AS 'EsVariableMes' ,
                p.folio ,
                p.num_conc ,
                c.concepto AS 'concepto' ,
                p.fch_pago ,
                ISNULL(p.horas_ex,0) AS 'Horas' ,
                p.nomina ,
                p.varia_imss ,
                ISNULL(p.varia1,0) AS 'Varia1' ,
                ISNULL(p.varia2,0) AS 'Varia2' ,
                ISNULL(p.varia3,0) AS 'Varia3' ,
                ISNULL(p.varia4,0) AS 'Varia4' ,
                p.periodo ,
                p.mes_operacion ,
                p.ayo_operacion ,
                p.tiponom
        FROM    dbo.percepciones AS p
                INNER JOIN dbo.empresas AS e ON p.empresa = e.empresa
                LEFT JOIN dbo.conceptos AS c ON p.empresa = c.empresa AND p.num_conc = c.num_conc AND p.clase = c.clase AND p.centro = c.centro
        WHERE   p.empresa = @empresa
                AND p.codigo = @codigo
                AND p.ayo_operacion = @ayo_operacion
        ORDER BY p.fch_pago DESC
GO



IF OBJECT_ID('dbo.WD_Obtener_ConceptosEmpleado_T') IS NOT NULL
    DROP PROCEDURE dbo.WD_Obtener_ConceptosEmpleado_T
GO

CREATE PROCEDURE dbo.WD_Obtener_ConceptosEmpleado_T
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0),
    @num_conc AS INT
AS

    SET NOCOUNT ON

    DECLARE @Conceptos AS TABLE
        (
          num_conc INT ,
          concepto VARCHAR(50) ,
          clase CHAR(2) ,
          centro CHAR(15) ,
          captura CHAR(1),
          formula VARCHAR(300),
          mascara VARCHAR(300)
        )
    DECLARE @claseEmpleado AS CHAR(2)
    DECLARE @centroEmpleado AS CHAR(15)


    SELECT  @claseEmpleado = clase ,
            @centroEmpleado = centro
    FROM    dbo.llaves
    WHERE   codigo = @codigo
            AND empresa = @empresa

    INSERT  INTO @Conceptos
            SELECT  num_conc ,
                    concepto ,
                    clase ,
                    centro ,
                    captura,
                    formula,
                    mascara
            FROM    dbo.conceptos
            WHERE   uso = 'S'
                    AND captura = 'M'
                    AND num_conc < 200
                    AND empresa = @empresa
            ORDER BY num_conc

    DELETE  @Conceptos
    WHERE   clase <> ''
            AND clase <> @claseEmpleado

    DELETE  @Conceptos
    WHERE   centro <> ''
            AND centro <> @centroEmpleado

    INSERT  INTO @Conceptos
            SELECT  num_conc ,
                    concepto ,
                    clase ,
                    centro ,
                    captura ,
                    formula,
                    mascara
            FROM    dbo.conceptos
            WHERE   uso = 'S'
                    AND clase = @claseEmpleado
                    AND num_conc IN ( 16, 17 )
                    AND empresa = @empresa
            ORDER BY num_conc

    IF @num_conc = 0
       SELECT  num_conc ,
               concepto ,
               clase ,
               centro ,
               captura ,
               formula,
               mascara
       FROM    @Conceptos
       ORDER BY num_conc
    ELSE
       SELECT  num_conc ,
               concepto ,
               clase ,
               centro ,
               captura ,
               formula ,
               mascara
       FROM    @Conceptos
       WHERE num_conc = @num_conc
       ORDER BY num_conc



GO

IF OBJECT_ID('dbo.WD_F_Obtener_HorasLaboradasXSemana') IS NOT NULL
    DROP PROCEDURE dbo.WD_F_Obtener_HorasLaboradasXSemana
GO

CREATE PROCEDURE dbo.WD_F_Obtener_HorasLaboradasXSemana
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0)
AS
    SELECT  dh.dia_Semana ,
            ISNULL(dh.sdoxhor, 0) AS 'HorasXTurno'
    FROM    dbo.Llaves AS ll
            INNER JOIN dbo.detalle_horarios AS dh ON ll.empresa = dh.empresa
                                                     AND ll.horario = dh.horario
    WHERE   ll.empresa = @empresa
            AND ll.codigo = @codigo

GO

IF OBJECT_ID('dbo.WD_F_Obtener_ValorHoraXFecha') IS NOT NULL
    DROP PROCEDURE dbo.WD_F_Obtener_ValorHoraXFecha
GO

CREATE PROCEDURE dbo.WD_F_Obtener_ValorHoraXFecha
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0) ,
    @fecha AS DATETIME
AS
    SET NOCOUNT ON
    SET DATEFIRST 7

    DECLARE @sueldo AS FLOAT
    DECLARE @horasXturno AS FLOAT
    DECLARE @fecha1 AS DATETIME


    SET @fecha1 = dbo.NvaFecha(01, MONTH(@fecha), YEAR(@fecha))

    SELECT TOP 1
            @sueldo = ISNULL(sueldo, 0)
    FROM    dbo.avisos_imss
    WHERE   empresa = @empresa
            AND codigo = @codigo
            AND mov <> 'B'
            AND fch_mov BETWEEN @fecha1 AND @fecha
    ORDER BY fch_mov DESC


    SELECT  @horasXturno = ISNULL(dh.sdoxhor, 0)
    FROM    dbo.Llaves AS ll
            INNER JOIN dbo.detalle_horarios AS dh ON ll.empresa = dh.empresa
                                                     AND ll.horario = dh.horario
    WHERE   ll.empresa = @empresa
            AND ll.codigo = @codigo
            AND dh.dia_Semana = DAY(@fecha)

    SELECT  ISNULL(@sueldo,0) AS 'Sueldo' ,
            @horasXturno AS 'HorasXTurno',
            ISNULL(@sueldo,0) / @horasXturno AS 'ValorHora'

GO


IF OBJECT_ID('dbo.WD_F_Obtener_MotivosTiempoExtra') IS NOT NULL
    DROP PROCEDURE dbo.WD_F_Obtener_MotivosTiempoExtra
GO

CREATE PROCEDURE dbo.WD_F_Obtener_MotivosTiempoExtra
AS
    SET NOCOUNT ON

    SELECT  num_motivo ,
            descripcion
    FROM    dbo.motivo_cambio
    WHERE   dato = 'TEX'
    ORDER BY num_motivo

GO


IF OBJECT_ID('dbo.WD_F_ValidarCapturaContras') IS NOT NULL
    DROP PROCEDURE dbo.WD_F_ValidarCapturaContras
GO

CREATE PROCEDURE dbo.WD_F_ValidarCapturaContras
    @empresa AS INT ,
    @codigo AS NUMERIC(8, 0) ,
    @num_conc AS INT ,
    @importe AS FLOAT
AS
    SET NOCOUNT ON

    DECLARE @ejercicio AS INT
    DECLARE @importeAcumulado AS FLOAT
    DECLARE @importeContra AS FLOAT
    DECLARE @mensajeValidacion AS VARCHAR(2000)

    SET @importeAcumulado = 0
    SET @importeContra = 0
    SET @mensajeValidacion = ''

    SELECT  @ejercicio = p.ayo_operacion
    FROM    dbo.Llaves AS ll
            INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                            AND ll.tiponom = p.tiponom
    WHERE   ll.empresa = @empresa
            AND ll.codigo = @codigo
            AND p.estatus = 'A'

    SELECT  @importeAcumulado = ISNULL(imp_acum, 0)
    FROM    dbo.acum_conc
    WHERE   codigo = @codigo
            AND ejercicio = @ejercicio
            AND empresa = @empresa
            AND num_conc = @num_conc

    SELECT  @importeContra = ISNULL(imp_acum, 0)
    FROM    dbo.acum_conc
    WHERE   codigo = @codigo
            AND ejercicio = @ejercicio
            AND empresa = @empresa
            AND num_conc = @num_conc + 1000

    IF ISNULL(@importeAcumulado, 0) = 0
        SET @mensajeValidacion = 'El empleado no tiene registrado ninguna deduccion con el concepto '
            + CONVERT(CHAR(3), @num_conc)
    ELSE
        BEGIN
            SET @importeContra = @importeAcumulado - ISNULL(@importeContra, 0)
            IF @importeContra < @importe
                SET @mensajeValidacion = 'El concepto '
                    + CONVERT(CHAR(3), @num_conc) + ' solo tiene acumulado $ '
                    + CONVERT(CHAR(12), @importeContra)
                    + ' y usted desea registrar $ '
                    + CONVERT(CHAR(12), @importe)


        END

    SELECT LEN(@mensajeValidacion) AS 'ExisteMensaje',@mensajeValidacion  AS 'Mensaje validacion'
GO


----------------------------------------------------------------------------------------------------------------------------------------
--
--   Percepciones PROCEDURES
--
----------------------------------------------------------------------------------------------------------------------------------------

/**************************************************************************************************
 * Name          : AddPercepcionTableRecord
 * Project       : APSI Nomina
 * Description   : October 14, 2009
 *                 Adds a new record
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 14, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.AddPercepcionTableRecord') IS NOT NULL
    DROP PROCEDURE dbo.AddPercepcionTableRecord
GO

CREATE PROCEDURE dbo.AddPercepcionTableRecord
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @folioId AS udtInteger ,
      @conceptId AS udtInteger ,
      @operationMonth AS udtInteger ,
      @operationYear AS udtInteger ,
      @conceptCenter AS udtName ,
      @conceptClass AS udtName ,
      @payrollPeriod AS udtInteger ,
      @payrollType AS udtInteger ,
      @payrollDate AS udtDateTime ,
      @dateCapture AS udtDateTime ,
      @variable AS udtFloat ,
      @varia_imss AS udtFloat ,
      @hours AS udtFloat ,
      @operation AS udtInteger ,
      @units AS udtFloat ,
      @partevaria AS udtFloat ,
      @payrollPay AS udtFloat ,
      @alwaysPay AS udtName ,
      @varia1 AS udtFloat ,
      @varia2 AS udtFloat ,
      @varia3 AS udtFloat ,
      @varia4 AS udtFloat ,
      @masive AS udtName ,
      @isBaja AS udtName ,
      @destajo AS udtName ,
      @origen AS udtName ,
      @overTimeReason AS udtInteger


    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        INSERT  INTO dbo.percepciones
                ( [empresa] ,
                  [codigo] ,
                  [folio] ,
                  [num_conc] ,
                  [mes_operacion] ,
                  [ayo_operacion] ,
                  [centro] ,
                  [clase] ,
                  [periodo] ,
                  [tiponom] ,
                  [fch_real] ,
                  [fch_pago] ,
                  [variable] ,
                  [varia_imss] ,
                  [horas_ex] ,
                  [operacion] ,
                  [unidades] ,
                  [partevaria] ,
                  [nomina] ,
                  [siempre] ,
                  [varia1] ,
                  [varia2] ,
                  [varia3] ,
                  [varia4] ,
                  [masivo] ,
                  [baja] ,
                  [destajo] ,
                  [origen] ,
                  [motivo]


                )
        VALUES  ( @companyId ,
                  @employeeId ,
                  @folioId ,
                  @conceptId ,
                  @operationMonth ,
                  @operationYear ,
                  SUBSTRING(@conceptCenter,1,14) ,
                  SUBSTRING(@conceptClass,1,2) ,
                  @payrollPeriod ,
                  @payrollType ,
                  @payrollDate ,
                  @dateCapture ,
                  @variable ,
                  @varia_imss ,
                  @hours ,
                  @operation ,
                  @units ,
                  @partevaria ,
                  @payrollPay ,
                  SUBSTRING(@alwaysPay,1,1) ,
                  @varia1 ,
                  @varia2 ,
                  @varia3 ,
                  @varia4 ,
                  SUBSTRING(@masive,1,1) ,
                  SUBSTRING(@isBaja,1,1) ,
                  @destajo ,
                  SUBSTRING(@origen,1,1) ,
                  @overTimeReason

                )

        SET @recordId = @@IDENTITY

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @recordId AS 'recordId'
            RETURN @recordId
        END
GO

/**************************************************************************************************
 * Name          : AddPercepcionForDays
 * Project       : APSI Nomina
 * Description   : October 19, 2009
 *                 Adds a new record
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 19, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_AddPercepcionForDays') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_AddPercepcionForDays
GO

CREATE PROCEDURE dbo.Fun_F_AddPercepcionForDays
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @conceptId AS udtInteger ,
      @conceptCenter AS udtName ,
      @conceptClass AS udtName ,
      @dateCapture AS udtDateTime ,
      @captureDays AS udtFloat ,
      @amountPay AS udtFloat ,
      @origin AS udtName ,
      @option AS udtName ,
      @option2 AS udtName ,
      @option3 AS udtName ,
      @function AS udtName ,
      @user AS udtName ,
      @registroPatronal AS udtName ,
      @system AS udtName

    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    DECLARE @recordId AS udtId
    DECLARE @folioId AS udtInteger
    DECLARE @operationMonth AS udtInteger
    DECLARE @operationYear AS udtInteger
    DECLARE @period AS udtInteger
    DECLARE @payrollType AS udtInteger
    DECLARE @datePayment AS udtDateTime
    DECLARE @variable AS udtFloat
    DECLARE @varia_imss AS udtFloat
    DECLARE @amountHours AS udtFloat
    DECLARE @operation AS udtInteger
    DECLARE @parteVariableImss AS udtFloat
    DECLARE @alwaysPay AS udtName
    DECLARE @variable1 AS udtFloat
    DECLARE @variable2 AS udtFloat
    DECLARE @variable3 AS udtFloat
    DECLARE @variable4 AS udtFloat
    DECLARE @massiveCapture AS udtName
    DECLARE @isBaja AS udtName
    DECLARE @isDestajo AS udtName
    DECLARE @overTimeReason AS udtInteger

    DECLARE @password AS udtName

    DECLARE @laborDays AS udtInteger
    DECLARE @absenteeismDays AS udtInteger
    DECLARE @incapacitieDays AS udtInteger
    DECLARE @lastDayMonth AS udtDateTime


    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY


    --Variables payroll status
        SELECT  @period = periodos.periodo ,
                @datePayment = periodos.pago ,
                @payrollType = periodos.tiponom ,
                @isBaja = empleados.ultmov
        FROM    dbo.periodos
                INNER JOIN llaves ON ( llaves.tiponom = periodos.tiponom
                                       AND llaves.empresa = periodos.empresa
                                     )
                INNER JOIN empleados ON ( llaves.codigo = empleados.codigo
                                          AND llaves.empresa = empleados.empresa
                                        )
        WHERE   periodos.estatus = 'A'
                AND llaves.codigo = @employeeId
                AND llaves.empresa = @companyId

        IF @datePayment IS NOT NULL
            BEGIN
                SET @operationMonth = MONTH(@datePayment)
                SET @operationYear = YEAR(@datePayment)
            END

    --Last folio from percepciones
        SELECT  @folioId = ISNULL(MAX(folio),0)
        FROM    dbo.percepciones
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND periodo = @period
                AND ayo_operacion = @operationYear
                AND tiponom = @payrollType

    --Labor Days, Absenteeism Days & Incapacitie Days from avisos_imss
        SELECT  @lastDayMonth = dbo.fin_mes(@operationMonth, @operationYear)

        EXECUTE asp_ds @companyId, @employeeId, @operationYear,
            @operationMonth, @lastDayMonth
        EXECUTE asp_ds_aus @companyId, @employeeId, @operationYear,
            @operationMonth, 7
        EXECUTE asp_ds_inc @companyId, @employeeId, @operationYear,
            @operationMonth

        SELECT  @laborDays = SUM(diastr) ,
                @absenteeismDays = SUM(ausen) ,
                @incapacitieDays = SUM(incap)
        FROM    dbo.avisos_imss
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND mes_operacion = @operationMonth
                AND ayo_operacion = @operationYear

    --Declare variables
        SET @variable = @amountPay
        SET @varia_imss = @amountPay
        SET @amountHours = 0
        SET @operation = 0
        SET @alwaysPay = 'N'
        SET @variable1 = 0
        SET @variable2 = 0
        SET @variable3 = 0
        SET @variable4 = 0
        SET @isDestajo = 'N'
        SET @overTimeReason = 0
        SET @parteVariableImss = 0
        SET @password = ''
        SET @massiveCapture = 'N'
        SET @folioId = @folioId + 1

    --Calculate @parteVariableImss
        IF @laborDays > 0
            SET @parteVariableImss = @variable / ( @laborDays
                                                   - ( ISNULL(@absenteeismDays,
                                                              0)
                                                       + ISNULL(@incapacitieDays,
                                                              0) ) )


        EXECUTE AddPercepcionTableRecord @companyId, @employeeId, @folioId,
            @conceptId, @operationMonth, @operationYear, @conceptCenter,
            @conceptClass, @period, @payrollType, @datePayment, @dateCapture,
            @variable, @varia_imss, @amountHours, @operation, @captureDays,
            @parteVariableImss, @amountPay, @alwaysPay, @variable1, @variable2,
            @variable3, @variable4, @massiveCapture, @isBaja, @isDestajo,
            @origin, @overTimeReason

        INSERT  INTO dbo.bitacora
        VALUES  ( @companyId, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @employeeId, @option, @option2, @option3, @user,
                  @password, @registroPatronal, @system )

        SET @recordId = @@IDENTITY

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @recordId AS 'recordId'
            RETURN @recordId
        END
GO



/**************************************************************************************************
 * Name          : AddPercepcionForHours
 * Project       : APSI Nomina
 * Description   : October 19, 2009
 *                 Adds a new record
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 19, 2009
 * Relation Store Procedures : AddPercepcionTableRecord
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_AddPercepcionForHours') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_AddPercepcionForHours
GO

CREATE PROCEDURE dbo.Fun_F_AddPercepcionForHours
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @conceptId AS udtInteger ,
      @conceptCenter AS udtName ,
      @conceptClass AS udtName ,
      @dateCapture AS udtDateTime ,
      @captureHours AS udtFloat ,
      @amountPay AS udtFloat ,
      @origin AS udtName ,
      @overTimeReason AS udtInteger ,
      @option AS udtName ,
      @option2 AS udtName ,
      @option3 AS udtName ,
      @function AS udtName ,
      @user AS udtName ,
      @registroPatronal AS udtName ,
      @system AS udtName

    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    DECLARE @recordId AS udtId
    DECLARE @folioId AS udtInteger
    DECLARE @operationMonth AS udtInteger
    DECLARE @operationYear AS udtInteger
    DECLARE @period AS udtInteger
    DECLARE @payrollType AS udtInteger
    DECLARE @datePayment AS udtDateTime
    DECLARE @variable AS udtFloat
    DECLARE @varia_imss AS udtFloat
    DECLARE @units AS udtFloat
    DECLARE @operation AS udtInteger
    DECLARE @parteVariableImss AS udtFloat
    DECLARE @alwaysPay AS udtName
    DECLARE @variable1 AS udtFloat
    DECLARE @variable2 AS udtFloat
    DECLARE @variable3 AS udtFloat
    DECLARE @variable4 AS udtFloat
    DECLARE @massiveCapture AS udtName
    DECLARE @isBaja AS udtName
    DECLARE @isDestajo AS udtName

    DECLARE @password AS udtName

    DECLARE @laborDays AS udtInteger
    DECLARE @absenteeismDays AS udtInteger
    DECLARE @incapacitieDays AS udtInteger
    DECLARE @lastDayMonth AS udtDateTime
    DECLARE @integrationImss AS udtName


    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY


    --Variables payroll status
        SELECT  @period = periodos.periodo ,
                @datePayment = periodos.pago ,
                @payrollType = periodos.tiponom ,
                @isBaja = empleados.ultmov
        FROM    dbo.periodos
                INNER JOIN llaves ON ( llaves.tiponom = periodos.tiponom
                                       AND llaves.empresa = periodos.empresa
                                     )
                INNER JOIN empleados ON ( llaves.codigo = empleados.codigo
                                          AND llaves.empresa = empleados.empresa
                                        )
        WHERE   periodos.estatus = 'A'
                AND llaves.codigo = @employeeId
                AND llaves.empresa = @companyId

        IF @datePayment IS NOT NULL
            BEGIN
                SET @operationMonth = MONTH(@datePayment)
                SET @operationYear = YEAR(@datePayment)
            END

    --Last folio from percepciones
        SELECT  @folioId = ISNULL(MAX(folio),0)
        FROM    dbo.percepciones
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND periodo = @period
                AND ayo_operacion = @operationYear
                AND tiponom = @payrollType

    --Labor Days, Absenteeism Days & Incapacitie Days from avisos_imss
        SELECT  @lastDayMonth = dbo.fin_mes(@operationMonth, @operationYear)

        EXECUTE asp_ds @companyId, @employeeId, @operationYear,
            @operationMonth, @lastDayMonth
        EXECUTE asp_ds_aus @companyId, @employeeId, @operationYear,
            @operationMonth, 7
        EXECUTE asp_ds_inc @companyId, @employeeId, @operationYear,
            @operationMonth

        SELECT  @laborDays = SUM(diastr) ,
                @absenteeismDays = SUM(ausen) ,
                @incapacitieDays = SUM(incap)
        FROM    dbo.avisos_imss
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND mes_operacion = @operationMonth
                AND ayo_operacion = @operationYear

    -- Integration Imss From conceptos
        SELECT  @integrationImss = ISNULL(imss, 'N')
        FROM    dbo.conceptos
        WHERE   empresa = @companyId
                AND num_conc = @conceptId
                AND centro = @conceptCenter
                AND clase = @conceptClass


    --Declare variables
        IF @integrationImss = 'S'
            BEGIN
                SET @variable = @amountPay
                SET @varia_imss = @amountPay
            END
        ELSE
            BEGIN
                SET @variable = 0
                SET @varia_imss = 0
            END

        SET @units = 0
        SET @operation = 0
        SET @alwaysPay = 'N'
        SET @variable1 = 0
        SET @variable2 = 0
        SET @variable3 = 0
        SET @variable4 = 0
        SET @isDestajo = 'N'
        SET @parteVariableImss = 0
        SET @password = ''
        SET @massiveCapture = 'N'
        SET @folioId = @folioId + 1


    --Calculate @parteVariableImss
        IF @laborDays > 0
            AND @variable > 0
			BEGIN
			    DECLARE @diasParaVariables AS INTEGER
			    SET @diasParaVariables = ( @laborDays - ( ISNULL(@absenteeismDays,0) + ISNULL(@incapacitieDays, 0) ) )
			    IF @diasParaVariables <= 0
			       SET @diasParaVariables = 1

                SET @parteVariableImss = @variable / @diasParaVariables
            END


        EXECUTE dbo.AddPercepcionTableRecord @companyId, @employeeId, @folioId,
            @conceptId, @operationMonth, @operationYear, @conceptCenter,
            @conceptClass, @period, @payrollType, @datePayment, @dateCapture,
            @variable, @varia_imss, @captureHours, @operation, @units,
            @parteVariableImss, @amountPay, @alwaysPay, @variable1, @variable2,
            @variable3, @variable4, @massiveCapture, @isBaja, @isDestajo,
            @origin, @overTimeReason

        INSERT  INTO dbo.bitacora
        VALUES  ( @companyId, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @employeeId, @option, @option2, @option3, @user,
                  @password, @registroPatronal, @system )

        SET @recordId = @@IDENTITY

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @recordId AS 'recordId'
            RETURN @recordId
        END
GO


/**************************************************************************************************
 * Name          : AddPercepcionForUserDefined
 * Project       : APSI Nomina
 * Description   : October 19, 2009
 *                 Adds a new record
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 19, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_AddPercepcionForUserDefined') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_AddPercepcionForUserDefined
GO

CREATE PROCEDURE dbo.Fun_F_AddPercepcionForUserDefined
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @conceptId AS udtInteger ,
      @conceptCenter AS udtName ,
      @conceptClass AS udtName ,
      @dateCapture AS udtDateTime ,
      @variable1 AS udtFloat ,
      @variable2 AS udtFloat ,
      @variable3 AS udtFloat ,
      @variable4 AS udtFloat ,
      @amountPay AS udtFloat ,
      @origin AS udtName ,
      @alwaysPay AS udtName ,
      @option AS udtName ,
      @option2 AS udtName ,
      @option3 AS udtName ,
      @function AS udtName ,
      @user AS udtName ,
      @registroPatronal AS udtName ,
      @system AS udtName

    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY

    DECLARE @recordId AS udtId
    DECLARE @folioId AS udtInteger
    DECLARE @operationMonth AS udtInteger
    DECLARE @operationYear AS udtInteger
    DECLARE @period AS udtInteger
    DECLARE @payrollType AS udtInteger
    DECLARE @datePayment AS udtDateTime
    DECLARE @variable AS udtFloat
    DECLARE @varia_imss AS udtFloat
    DECLARE @units AS udtFloat
    DECLARE @amountHours AS udtFloat
    DECLARE @operation AS udtInteger
    DECLARE @parteVariableImss AS udtFloat
    DECLARE @massiveCapture AS udtName
    DECLARE @isBaja AS udtName
    DECLARE @isDestajo AS udtName
    DECLARE @overTimeReason AS udtInteger

    DECLARE @password AS udtName

    DECLARE @laborDays AS udtInteger
    DECLARE @absenteeismDays AS udtInteger
    DECLARE @incapacitieDays AS udtInteger
    DECLARE @lastDayMonth AS udtDateTime
    DECLARE @integrationImss AS udtName
    DECLARE @addIntegrationFactorAguinaldo AS udtName
    DECLARE @integrationFactor AS udtFloat
    DECLARE @companyOperationMonth AS udtInteger
    DECLARE @companyOperationYear AS udtInteger


    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

--Operation Month and Year From empresas
        SELECT  @companyOperationMonth = mes_operacion ,
                @companyOperationYear = ayo_operacion
        FROM    dbo.empresas
        WHERE   empresa = @companyId

    --Variables payroll status
        SELECT  @period = periodos.periodo ,
                @datePayment = periodos.pago ,
                @payrollType = periodos.tiponom ,
                @isBaja = empleados.ultmov
        FROM    dbo.periodos
                INNER JOIN llaves ON ( llaves.tiponom = periodos.tiponom
                                       AND llaves.empresa = periodos.empresa
                                     )
                INNER JOIN empleados ON ( llaves.codigo = empleados.codigo
                                          AND llaves.empresa = empleados.empresa
                                        )
        WHERE   periodos.estatus = 'A'
                AND llaves.codigo = @employeeId
                AND llaves.empresa = @companyId

        IF @datePayment IS NOT NULL
            BEGIN
                SET @operationMonth = MONTH(@datePayment)
                SET @operationYear = YEAR(@datePayment)
            END

    --Last folio from percepciones
        SELECT  @folioId = ISNULL(MAX(folio), 0)
        FROM    dbo.percepciones
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND periodo = @period
                AND ayo_operacion = @operationYear
                AND tiponom = @payrollType

    --Labor Days, Absenteeism Days & Incapacitie Days from avisos_imss
        SELECT  @lastDayMonth = dbo.fin_mes(@operationMonth, @operationYear)

        EXECUTE asp_ds @companyId, @employeeId, @operationYear,
            @operationMonth, @lastDayMonth
        EXECUTE asp_ds_aus @companyId, @employeeId, @operationYear,
            @operationMonth, 7
        EXECUTE asp_ds_inc @companyId, @employeeId, @operationYear,
            @operationMonth

        SELECT  @laborDays = SUM(diastr) ,
                @absenteeismDays = SUM(ausen) ,
                @incapacitieDays = SUM(incap)
        FROM    dbo.avisos_imss
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND mes_operacion = @operationMonth
                AND ayo_operacion = @operationYear

     --Get factor integration
        SELECT  @integrationFactor = ISNULL(factor, 1)
        FROM    [dbo].[GetFixedBenefits](@companyId, @employeeId,
                                         @companyOperationYear,
                                         @companyOperationMonth)

        IF @integrationFactor = 0
            SET @integrationFactor = 1

    -- Integration Imss From conceptos
        SELECT  @integrationImss = ISNULL(imss, 'N') ,
                @addIntegrationFactorAguinaldo = ISNULL(mca_agui, 'N')
        FROM    dbo.conceptos
        WHERE   empresa = @companyId
                AND num_conc = @conceptId
                AND centro = @conceptCenter
                AND clase = @conceptClass


    --Declare variables
        IF @integrationImss = 'S'
            BEGIN
                SET @variable = @amountPay
                SET @varia_imss = @amountPay

                EXECUTE dbo.CalculateConceptUserDefinedPerception @companyId,
                    @employeeId, @conceptId, @conceptCenter, @conceptClass,
                    @variable1, @variable2, @variable3, @variable4

                IF OBJECT_ID('dbo.tmp_calculateConcept') IS NOT NULL
                    BEGIN
					    --Se ajusto la formula, se resta la parte no integrable IMSS, de acuerdo a la formula 04/03/2020 Mario Garcia
                        SELECT  @variable = @variable - noIntegraImss ,
                                @varia_imss = @varia_imss - noIntegraImss
                        FROM    dbo.tmp_calculateConcept
                    END



                --Agrega el factor de integracion de tablas
                IF @addIntegrationFactorAguinaldo = 'S'
                    BEGIN
                        SET @variable = @amountPay * @integrationFactor
                        SET @varia_imss = @amountPay * @integrationFactor
                    END
            END
        ELSE
            BEGIN
                SET @variable = 0
                SET @varia_imss = 0
            END

      IF @variable < 0
         SET @variable = 0

      If @varia_imss < 0
        SET @varia_imss = 0


        SET @units = 0
        SET @operation = 0
        SET @isDestajo = 'N'
        SET @parteVariableImss = 0
        SET @password = ''
        SET @massiveCapture = 'N'
        SET @amountHours = 0
        SET @folioId = @folioId + 1


    --Calculate @parteVariableImss
        IF @laborDays > 0
		    AND (@laborDays - @absenteeismDays - @incapacitieDays) > 0
            AND @variable > 0
            SET @parteVariableImss = @variable / ( @laborDays
                                                   - ( ISNULL(@absenteeismDays,
                                                              0)
                                                       + ISNULL(@incapacitieDays,
                                                              0) ) )
        ELSE
		    IF @variable > 0
			   SET @parteVariableImss = @variable


        EXECUTE AddPercepcionTableRecord @companyId, @employeeId, @folioId,
            @conceptId, @operationMonth, @operationYear, @conceptCenter,
            @conceptClass, @period, @payrollType, @datePayment, @dateCapture,
            @variable, @varia_imss, @amountHours, @operation, @units,
            @parteVariableImss, @amountPay, @alwaysPay, @variable1, @variable2,
            @variable3, @variable4, @massiveCapture, @isBaja, @isDestajo,
            @origin, @overTimeReason

        INSERT  INTO dbo.bitacora
        VALUES  ( @companyId, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @employeeId, @option, @option2, @option3, @user,
                  @password, @registroPatronal, @system )

        SET @recordId = @@IDENTITY

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @recordId AS 'recordId'
            RETURN @recordId
        END

GO

/**************************************************************************************************
 * Name          : DeletePercepcionTableRecords
 * Project       : APSI Nomina
 *                 Data maintenace
 * Description   : Deletes existing records
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 14, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.DeletePercepcionTableRecords') IS NOT NULL
    DROP PROCEDURE dbo.DeletePercepcionTableRecords
GO

CREATE PROCEDURE dbo.DeletePercepcionTableRecords
    (
      @empresa AS udtInteger ,
      @codigo AS udtLong ,
      @folio AS udtInteger ,
      @num_conc AS udtInteger ,
      @mes_operacion AS udtInteger ,
      @ayo_operacion AS udtInteger ,
      @periodo AS udtInteger ,
      @tiponom AS udtInteger ,
      @function AS udtName ,
      @user AS udtName ,
      @registroPatronal AS udtName ,
      @system AS udtName

    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @deletedRecords AS udtInteger
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

    DECLARE @Option1 AS udtName
    DECLARE @Option2 AS udtName
    DECLARE @Option3 AS udtName
    DECLARE @password AS udtName

    SET @Option1 = 'Captura individual WEB'
    SET @Option2 = 'Eliminar concepto : ' + CONVERT(CHAR(4),@num_conc) + ' folio ' + CONVERT(CHAR(10),@folio)
    SET @Option3 = 'Periodo : ' + CONVERT(CHAR(2),@periodo) + ' ejercicio ' + CONVERT(CHAR(04),@ayo_operacion)

    SET @password = ''

        DELETE  FROM dbo.percepciones
        WHERE   [empresa] = @empresa
                AND [codigo] = @codigo
                AND [folio] = @folio
                AND [num_conc] = @num_conc
                AND [mes_operacion] = @mes_operacion
                AND [ayo_operacion] = @ayo_operacion
                AND [periodo] = @periodo
                AND [tiponom] = @tiponom


        SET @deletedRecords = @@ROWCOUNT

        INSERT  INTO dbo.bitacora
        VALUES  ( @empresa, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @codigo, @option1, @option2, @option3, @user,
                  @password, @registroPatronal, @system )


    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @deletedRecords AS 'deletedRecords'
            RETURN @deletedRecords
        END
GO

/**************************************************************************************************
 * Name          : GetPercepcionTableRecords
 * Project       : APSI Nomina
 *                 Data maintenace
 * Description   : Finds existing records
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 14, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.GetPercepcionTableRecords') IS NOT NULL
    DROP PROCEDURE dbo.GetPercepcionTableRecords
GO

CREATE PROCEDURE dbo.GetPercepcionTableRecords
    (
      @empresa AS udtInteger ,
      @codigo AS udtLong ,
      @folio AS udtInteger ,
      @num_conc AS udtInteger ,
      @mes_operacion AS udtInteger ,
      @ayo_operacion AS udtInteger ,
      @centro AS udtName ,
      @clase AS udtName ,
      @periodo AS udtInteger ,
      @tiponom AS udtInteger ,
      @fecha_Real AS udtDateTime ,
      @startPosition AS udtInteger ,
      @elementsToRetrieve AS udtInteger
    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @orderByClause AS udtStringSize512
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        -- Set the debug flag
        SET @debugFlag = 0

        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''

        -- Count all the existing records
        SET @selectClause = 'SELECT COUNT(*) FROM dbo.Percepciones '

        -- Search criteria: empresa
        IF @empresa > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'empresa = '
                    + LTRIM(RTRIM(STR(@empresa)))

            END

        -- Search criteria: codigo
        IF @codigo > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'codigo = '
                    + LTRIM(RTRIM(STR(@codigo)))

            END

        -- Search criteria: folio
        IF @folio > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'folio = '
                    + LTRIM(RTRIM(STR(@folio)))

            END

        -- Search criteria: num_conc
        IF @num_conc > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'num_conc = '
                    + LTRIM(RTRIM(STR(@num_conc)))

            END

        -- Search criteria: mes_Operacion
        IF @mes_operacion > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'mes_operacion = '
                    + LTRIM(RTRIM(STR(@mes_operacion)))

            END

        -- Search criteria: empresa
        IF @ayo_operacion > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'ayo_operacion = '
                    + LTRIM(RTRIM(STR(@ayo_operacion)))

            END


        -- Search criteria: nameId
        IF LEN(@centro) > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'centro = '''
                    + REPLACE(@centro, '''', '''''') + ''''

            END

        IF LEN(@clase) > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'clase = '''
                    + REPLACE(@clase, '''', '''''') + ''''

            END

        -- Search criteria: periodo
        IF @periodo > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'periodo = '
                    + LTRIM(RTRIM(STR(@periodo)))

            END

        -- Search criteria: tiponom
        IF @tiponom > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'tiponom = '
                    + LTRIM(RTRIM(STR(@tiponom)))

            END

        -- Search criteria: fch_real
        IF DATEDIFF(DAYOFYEAR, '2000-01-01', @fecha_Real) > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SELECT  @whereClause = @whereClause + 'WHERE '
                        SELECT  @whereClauseUsed = 1

                    END
                ELSE
                    SELECT  @whereClause = @whereClause + ' AND '

                SELECT  @whereClause = @whereClause
                        + 'CONVERT(VARCHAR, fch_real, 112) >= '''
                        + CONVERT(VARCHAR, @fecha_Real, 112) + ''''

            END



        CREATE TABLE #PercepcionCounter ( TotalRecords INTEGER )

        IF @debugFlag = 1
            SELECT  @selectClause + @whereClause
        ELSE
            INSERT  INTO #PercepcionCounter
                    EXECUTE ( @selectClause + @whereClause
                           )

        -- Set the total records indicador
        SELECT TOP 1
                @totalRecords = TotalRecords
        FROM    #PercepcionCounter
        SET @totalRecords = ISNULL(@totalRecords, 0)
        SET @whereClauseUsed = 0

        DROP TABLE #PercepcionCounter

        -- Check the element per page indicator
        IF @elementsToRetrieve < 1
            SET @elementsToRetrieve = @totalRecords

        -- Check the initial position
        IF @startPosition < 1
            SET @startPosition = 0

        SET @whereClauseUsed = 0

        IF @startPosition > 1
            BEGIN

                SET @startPositionPlusOneElement = @startPosition
                    + @elementsToRetrieve - 1

                IF @startPositionPlusOneElement < 1
                    SET @startPositionPlusOneElement = 1

                IF @startPositionPlusOneElement > @totalRecords
                    BEGIN
                        SET @startPositionPlusOneElement = @totalRecords
                        SET @elementsToRetrieve = @totalRecords
                            - @startPosition + 1
                    END

                IF @startPosition = @totalRecords
                    SET @elementsToRetrieve = 1

                IF @startPosition > @totalRecords
                    SET @startPosition = @totalRecords

                IF @elementsToRetrieve >= @totalRecords
                    AND @startPosition > 1
                    SET @elementsToRetrieve = @totalRecords - @startPosition
                        + 1

                SET @selectClause = 'SELECT empresa, codigo, folio, num_conc, mes_operacion, '
                    + 'ayo_operacion, centro, clase, periodo, tiponom, fch_real, '
                    + 'fch_pago, variable, varia_imss, horas_ex, operacion, unidades, '
                    + 'partevaria, nomina, siempre, varia1, varia2, varia3, varia4, '
                    + 'masivo, baja, destajo, origen, motivo, '
                    + RTRIM(LTRIM(STR(@totalRecords)))
                    + ' AS TotalRecords FROM (SELECT TOP '
                    + LTRIM(RTRIM(STR(@elementsToRetrieve)))
                    + 'empresa, codigo, folio, num_conc, mes_operacion, '
                    + 'ayo_operacion, centro, clase, periodo, tiponom, fch_real, '
                    + 'fch_pago, variable, varia_imss, horas_ex, operacion, unidades, '
                    + 'partevaria, nomina, siempre, varia1, varia2, varia3, varia4, '
                    + 'masivo, baja, destajo, origen, motivo '
                    + 'FROM (SELECT TOP '
                    + LTRIM(RTRIM(STR(@startPositionPlusOneElement)))
                    + 'empresa, codigo, folio, num_conc, mes_operacion, '
                    + 'ayo_operacion, centro, clase, periodo, tiponom, fch_real, '
                    + 'fch_pago, variable, varia_imss, horas_ex, operacion, unidades, '
                    + 'partevaria, nomina, siempre, varia1, varia2, varia3, varia4, '
                    + 'masivo, baja, destajo, origen, motivo '
                    + 'FROM [percepciones] '

                SET @orderByClause = ' ORDER BY codigo,num_conc ASC) AS PercepcionTemporalOne ORDER BY codigo,num_conc DESC) AS PercepcionTemporalTwo ORDER BY codigo,num_conc ASC'

            END
        ELSE
            BEGIN

                IF @startPosition = 0
                    SET @selectClause = 'SELECT TOP 100 PERCENT'

                ELSE
                    SET @selectClause = 'SELECT TOP '
                        + RTRIM(LTRIM(STR(@elementsToRetrieve)))

                SET @selectClause = @selectClause
                    + ' empresa, codigo, folio, num_conc, mes_operacion,'
                    + ' ayo_operacion, centro, clase, periodo, tiponom, fch_real, '
                    + ' fch_pago, variable, varia_imss, horas_ex, operacion, unidades, '
                    + ' partevaria, nomina, siempre, varia1, varia2, varia3, varia4, '
                    + ' masivo, baja, destajo, origen, motivo, '
                    + RTRIM(LTRIM(STR(@totalRecords)))
                    + ' AS TotalRecords FROM [Percepciones] '

                SET @orderByClause = ' ORDER BY codigo,num_conc ASC'
            END

        IF @debugFlag = 1
            SELECT  @selectClause + @whereClause + @orderByClause
        ELSE
            EXECUTE ( @selectClause + @whereClause + @orderByClause
            )

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION
GO

/**************************************************************************************************
 * Name          : GetPercepcions
 * Project       : APSI Nomina
 *                 Data maintenace
 * Description   : Finds existing records
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 14, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.GetPerceptions') IS NOT NULL
    DROP PROCEDURE dbo.GetPerceptions
GO

CREATE PROCEDURE dbo.GetPerceptions
    (
      @empresa AS udtInteger ,
      @codigo AS udtLong ,
      @folio AS udtInteger ,
      @num_conc AS udtInteger ,
      @mes_operacion AS udtInteger ,
      @ayo_operacion AS udtInteger ,
      @centro AS udtName ,
      @clase AS udtName ,
      @periodo AS udtInteger ,
      @tiponom AS udtInteger ,
      @fecha_Real AS udtDateTime ,
      @startPosition AS udtInteger ,
      @elementsToRetrieve AS udtInteger
    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @selectClause AS NVARCHAR(4000)
    DECLARE @whereClause AS udtStringSize1024
    DECLARE @orderByClause AS udtStringSize512
    DECLARE @totalRecords AS udtInteger
    DECLARE @startPositionPlusOneElement AS udtInteger
    DECLARE @whereClauseUsed AS udtBoolean
    DECLARE @debugFlag AS udtBoolean
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        -- Set the debug flag
        SET @debugFlag = 0

        -- Initialize the local variables
        SET @whereClauseUsed = 0
        SET @whereClause = ''
        SET @orderByClause = ''

        -- Count all the existing records
        SET @selectClause = 'SELECT COUNT(*) FROM dbo.Percepciones '

        -- Search criteria: empresa
        IF @empresa > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.empresa = '
                    + LTRIM(RTRIM(STR(@empresa)))

            END

        -- Search criteria: codigo
        IF @codigo > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.codigo = '
                    + LTRIM(RTRIM(STR(@codigo)))

            END

        -- Search criteria: folio
        IF @folio > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.folio = '
                    + LTRIM(RTRIM(STR(@folio)))

            END

        -- Search criteria: num_conc
        IF @num_conc > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.num_conc = '
                    + LTRIM(RTRIM(STR(@num_conc)))

            END

        -- Search criteria: mes_Operacion
        IF @mes_operacion > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause
                    + 'Percepciones.mes_operacion = '
                    + LTRIM(RTRIM(STR(@mes_operacion)))

            END

        -- Search criteria: empresa
        IF @ayo_operacion > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause
                    + 'Percepciones.ayo_operacion = '
                    + LTRIM(RTRIM(STR(@ayo_operacion)))

            END


        -- Search criteria: nameId
        IF LEN(@centro) > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.centro = '''
                    + REPLACE(@centro, '''', '''''') + ''''

            END

        IF LEN(@clase) > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.clase = '''
                    + REPLACE(@clase, '''', '''''') + ''''

            END

        -- Search criteria: periodo
        IF @periodo > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.periodo = '
                    + LTRIM(RTRIM(STR(@periodo)))

            END

        -- Search criteria: tiponom
        IF @tiponom > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SET @whereClause = @whereClause + 'WHERE '
                        SET @whereClauseUsed = 1

                    END
                ELSE
                    SET @whereClause = @whereClause + ' AND '

                SET @whereClause = @whereClause + 'Percepciones.tiponom = '
                    + LTRIM(RTRIM(STR(@tiponom)))

            END

        -- Search criteria: fch_real
        IF DATEDIFF(DAYOFYEAR, '2000-01-01', @fecha_Real) > 0
            BEGIN

                IF @whereClauseUsed = 0
                    BEGIN

                        SELECT  @whereClause = @whereClause + 'WHERE '
                        SELECT  @whereClauseUsed = 1

                    END
                ELSE
                    SELECT  @whereClause = @whereClause + ' AND '

                SELECT  @whereClause = @whereClause
                        + 'CONVERT(VARCHAR, Percepciones.fch_real, 112) >= '''
                        + CONVERT(VARCHAR, @fecha_Real, 112) + ''''

            END



        CREATE TABLE #PercepcionCounter ( TotalRecords INTEGER )

        IF @debugFlag = 1
            SELECT  @selectClause + @whereClause
        ELSE
            INSERT  INTO #PercepcionCounter
                    EXECUTE ( @selectClause + @whereClause
                           )

        -- Set the total records indicador
        SELECT TOP 1
                @totalRecords = TotalRecords
        FROM    #PercepcionCounter
        SET @totalRecords = ISNULL(@totalRecords, 0)
        SET @whereClauseUsed = 0

        DROP TABLE #PercepcionCounter

        -- Check the element per page indicator
        IF @elementsToRetrieve < 1
            SET @elementsToRetrieve = @totalRecords

        -- Check the initial position
        IF @startPosition < 1
            SET @startPosition = 0

        SET @whereClauseUsed = 0

        IF @startPosition > 1
            BEGIN

                SET @startPositionPlusOneElement = @startPosition
                    + @elementsToRetrieve - 1

                IF @startPositionPlusOneElement < 1
                    SET @startPositionPlusOneElement = 1

                IF @startPositionPlusOneElement > @totalRecords
                    BEGIN
                        SET @startPositionPlusOneElement = @totalRecords
                        SET @elementsToRetrieve = @totalRecords
                            - @startPosition + 1
                    END

                IF @startPosition = @totalRecords
                    SET @elementsToRetrieve = 1

                IF @startPosition > @totalRecords
                    SET @startPosition = @totalRecords

                IF @elementsToRetrieve >= @totalRecords
                    AND @startPosition > 1
                    SET @elementsToRetrieve = @totalRecords - @startPosition
                        + 1

                SET @selectClause = 'SELECT '
                    + '[Percepciones].empresa, [Percepciones].codigo, [Percepciones].folio, [Percepciones].num_conc, [Percepciones].mes_operacion, '
                    + '[Percepciones].ayo_operacion,[Percepciones].centro,[Percepciones].clase, [Percepciones].periodo,[Percepciones].tiponom,[Percepciones].fch_real, '
                    + '[Percepciones].fch_pago,[Percepciones].variable,[Percepciones].varia_imss,[Percepciones].horas_ex,[Percepciones].operacion,[Percepciones].unidades, '
                    + '[Percepciones].partevaria,[Percepciones].nomina,[Percepciones].siempre,[Percepciones].varia1,[Percepciones].varia2,[Percepciones].varia3,[Percepciones].varia4, '
                    + '[Percepciones].masivo,[Percepciones].baja,[Percepciones].destajo,[Percepciones].origen,[Percepciones].motivo,[Conceptos].concepto, '
                    + RTRIM(LTRIM(STR(@totalRecords)))
                    + ' AS TotalRecords FROM (SELECT TOP '
                    + LTRIM(RTRIM(STR(@elementsToRetrieve)))
                    + '[Percepciones].empresa, [Percepciones].codigo, [Percepciones].folio, [Percepciones].num_conc, [Percepciones].mes_operacion, '
                    + '[Percepciones].ayo_operacion,[Percepciones].centro,[Percepciones].clase, [Percepciones].periodo,[Percepciones].tiponom,[Percepciones].fch_real, '
                    + '[Percepciones].fch_pago,[Percepciones].variable,[Percepciones].varia_imss,[Percepciones].horas_ex,[Percepciones].operacion,[Percepciones].unidades, '
                    + '[Percepciones].partevaria,[Percepciones].nomina,[Percepciones].siempre,[Percepciones].varia1,[Percepciones].varia2,[Percepciones].varia3,[Percepciones].varia4, '
                    + '[Percepciones].masivo,[Percepciones].baja,[Percepciones].destajo,[Percepciones].origen,[Percepciones].motivo,[Conceptos].concepto '
                    + 'FROM (SELECT TOP '
                    + LTRIM(RTRIM(STR(@startPositionPlusOneElement)))
                    + '[Percepciones].empresa, [Percepciones].codigo, [Percepciones].folio, [Percepciones].num_conc, [Percepciones].mes_operacion, '
                    + '[Percepciones].ayo_operacion,[Percepciones].centro,[Percepciones].clase, [Percepciones].periodo,[Percepciones].tiponom,[Percepciones].fch_real, '
                    + '[Percepciones].fch_pago,[Percepciones].variable,[Percepciones].varia_imss,[Percepciones].horas_ex,[Percepciones].operacion,[Percepciones].unidades, '
                    + '[Percepciones].partevaria,[Percepciones].nomina,[Percepciones].siempre,[Percepciones].varia1,[Percepciones].varia2,[Percepciones].varia3,[Percepciones].varia4, '
                    + '[Percepciones].masivo,[Percepciones].baja,[Percepciones].destajo,[Percepciones].origen,[Percepciones].motivo,[Conceptos].concepto '
                    + 'FROM [Percepciones] '
                    + 'LEFT JOIN [Conceptos] ON ([Percepciones].empresa = [Conceptos].empresa AND [Percepciones].num_conc = [Conceptos].num_conc AND [Percepciones].clase = [Conceptos].clase AND [Percepciones].centro = [Conceptos].centro ) '

                SET @orderByClause = ' ORDER BY [Percepciones].codigo,[Percepciones].num_conc ASC) AS PercepcionTemporalOne ORDER BY [Percepciones].codigo,[Percepciones].num_conc DESC) AS PercepcionTemporalTwo ORDER BY [Percepciones].codigo,[Percepciones].num_conc ASC'

            END
        ELSE
            BEGIN

                IF @startPosition = 0
                    SET @selectClause = 'SELECT TOP 100 PERCENT '

                ELSE
                    SET @selectClause = 'SELECT TOP '
                        + RTRIM(LTRIM(STR(@elementsToRetrieve)))

                SET @selectClause = @selectClause
                    + '[Percepciones].empresa, [Percepciones].codigo, [Percepciones].folio, [Percepciones].num_conc, [Percepciones].mes_operacion, '
                    + '[Percepciones].ayo_operacion,[Percepciones].centro,[Percepciones].clase, [Percepciones].periodo,[Percepciones].tiponom,[Percepciones].fch_real, '
                    + '[Percepciones].fch_pago,[Percepciones].variable,[Percepciones].varia_imss,[Percepciones].horas_ex,[Percepciones].operacion,[Percepciones].unidades, '
                    + '[Percepciones].partevaria,[Percepciones].nomina,[Percepciones].siempre,[Percepciones].varia1,[Percepciones].varia2,[Percepciones].varia3,[Percepciones].varia4, '
                    + '[Percepciones].masivo,[Percepciones].baja,[Percepciones].destajo,[Percepciones].origen,[Percepciones].motivo,[Conceptos].concepto, '
                    + RTRIM(LTRIM(STR(@totalRecords)))
                    + ' AS TotalRecords FROM [Percepciones] '
                    + ' LEFT JOIN [Conceptos] ON ([Percepciones].empresa = [Conceptos].empresa AND [Percepciones].num_conc = [Conceptos].num_conc AND [Percepciones].clase = [Conceptos].clase AND [Percepciones].centro = [Conceptos].centro ) '


                SET @orderByClause = ' ORDER BY [Percepciones].codigo,[Percepciones].num_conc ASC'
            END

        IF @debugFlag = 1
            SELECT  @selectClause + @whereClause + @orderByClause
        ELSE
            EXECUTE ( @selectClause + @whereClause + @orderByClause
            )

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION
GO


/**************************************************************************************************
 * Name          : UpdatePercepcionTableRecord
 * Project       : APSI Nomina
 *                 Data maintenace
 * Description   : Updates an existing record
 * Table name    : Percepciones
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.Apsi.com/)
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : October 12, 2009
 **************************************************************************************************/
IF OBJECT_ID('dbo.UpdatePercepcionTableRecord') IS NOT NULL
    DROP PROCEDURE dbo.UpdatePercepcionTableRecord
GO

CREATE PROCEDURE dbo.UpdatePercepcionTableRecord
    (
      @empresa AS udtInteger ,
      @codigo AS udtLong ,
      @folio AS udtInteger ,
      @num_conc AS udtInteger ,
      @mes_operacion AS udtInteger ,
      @ayo_operacion AS udtInteger ,
      @centro AS udtName ,
      @clase AS udtName ,
      @periodo AS udtInteger ,
      @tiponom AS udtInteger ,
      @fch_Real AS udtDateTime ,
      @fch_Pago AS udtDateTime ,
      @variable AS udtFloat ,
      @varia_imss AS udtFloat ,
      @horas_Ex AS udtFloat ,
      @operacion AS udtInteger ,
      @unidades AS udtFloat ,
      @partevaria AS udtFloat ,
      @nomina AS udtFloat ,
      @siempre AS udtName ,
      @varia1 AS udtFloat ,
      @varia2 AS udtFloat ,
      @varia3 AS udtFloat ,
      @varia4 AS udtFloat ,
      @masivo AS udtName ,
      @baja AS udtName ,
      @destajo AS udtName ,
      @origen AS udtName ,
      @motivo AS udtInteger
    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @updatedRecords AS udtInteger
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

        UPDATE  dbo.percepciones
        SET     fch_real = @fch_Real ,
                fch_pago = @fch_Pago ,
                variable = @variable ,
                varia_imss = @varia_imss ,
                horas_ex = @horas_Ex ,
                operacion = @operacion ,
                unidades = @unidades ,
                partevaria = @partevaria ,
                nomina = @nomina ,
                siempre = @siempre ,
                varia1 = @varia1 ,
                varia2 = @varia2 ,
                varia3 = @varia3 ,
                varia4 = @varia4 ,
                masivo = @masivo ,
                baja = @baja ,
                destajo = @destajo ,
                origen = @origen ,
                motivo = @motivo
        WHERE   [empresa] = @empresa
                AND [codigo] = @codigo
                AND [folio] = @folio
                AND [num_conc] = @num_conc
                AND [mes_operacion] = @mes_operacion
                AND [ayo_operacion] = @ayo_operacion
                AND [centro] = @centro
                AND [clase] = @clase
                AND [periodo] = @periodo
                AND [tiponom] = @tiponom

        SELECT  @updatedRecords = @@ROWCOUNT

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @updatedRecords AS 'updatedRecords'
            RETURN @updatedRecords
        END
GO


IF OBJECT_ID('dbo.CalculateOverTimeWeekPerception') IS NOT NULL
    DROP PROCEDURE dbo.CalculateOverTimeWeekPerception
GO

CREATE PROCEDURE dbo.CalculateOverTimeWeekPerception
    (
      @companyId AS udtInteger ,
      @employeeId AS udtLong ,
      @salary AS udtFloat ,
      @beginDate AS udtDateTime ,
      @hoursDay1 AS udtFloat ,
      @hoursDay2 AS udtFloat ,
      @hoursDay3 AS udtFloat ,
      @hoursDay4 AS udtFloat ,
      @hoursDay5 AS udtFloat ,
      @hoursDay6 AS udtFloat ,
      @hoursDay7 AS udtFloat
    )
    WITH ENCRYPTION
AS
    SET DATEFIRST 1
	SET NOCOUNT ON

    DECLARE @day1 AS udtInteger
    DECLARE @day2 AS udtInteger
    DECLARE @day3 AS udtInteger
    DECLARE @day4 AS udtInteger
    DECLARE @day5 AS udtInteger
    DECLARE @day6 AS udtInteger
    DECLARE @day7 AS udtInteger
    DECLARE @day0 AS udtInteger
    DECLARE @lastDate AS udtDateTime

    DECLARE @totalHours AS udtFloat
    DECLARE @doubleIntegrableHours AS udtFloat
    DECLARE @doubleNotIntegrableHours AS udtFloat
    DECLARE @totalDoubleHours AS udtFloat
    DECLARE @tripleHours AS udtFloat
    DECLARE @sundayBonus AS udtFloat
    DECLARE @sundayHours AS udtFloat
    DECLARE @doubleIntegrableAmount AS udtFloat
    DECLARE @doubleNotIntegrableAmount AS udtFloat
    DECLARE @tripleAmount AS udtFloat
    DECLARE @date AS udtDateTime
    DECLARE @nonWorkableday AS udtName
    DECLARE @schedule AS udtInteger
    DECLARE @hoursValue AS udtFloat
    DECLARE @hoursLaborDay AS udtFloat
    DECLARE @concept09 AS udtInteger
    DECLARE @concept10 AS udtInteger
    DECLARE @concept11 AS udtInteger
    DECLARE @concept12 AS udtInteger
    DECLARE @concept13 AS udtInteger
    DECLARE @hoursDay AS NUMERIC(06, 2)
    DECLARE @dayOfWeek AS udtInteger
    DECLARE @amountPay AS udtFloat
    DECLARE @paySundayBonus AS udtName
    DECLARE @SundayBonusPercentage AS udtFloat
    DECLARE @daysOverTime AS udtInteger
    DECLARE @nineHour AS udtFloat
    DECLARE @hollydayHours AS udtFloat
    DECLARE @hollydayAmount AS udtFloat
    DECLARE @totalAmount AS udtFloat
    DECLARE @totalIntegrableAmount AS udtFloat
    DECLARE @totalNotIntegrableAmount AS udtFloat
    DECLARE @salaryEmployee AS udtFloat
    DECLARE @companyOperationMonth AS udtInteger
    DECLARE @companyOperationYear AS udtInteger
    DECLARE @beginOperationDate AS udtDateTime
    DECLARE @endOperationDate AS udtDateTime
	DECLARE @FestivoDay AS udtName

    DECLARE @overTimeTable TABLE
        (
          dateOverTime udtDateTime NOT NULL ,
          conceptId udtInteger NOT NULL ,
          hoursDay udtFloat NOT NULL ,
          amountPay udtFloat NOT NULL ,
          hoursValue udtFloat NULL ,
          hoursLaborDay udtFloat NULL
        )

    SET @totalHours = 0
    SET @date = @beginDate
    SET @concept09 = 09
    SET @concept10 = 10
    SET @concept11 = 11
    SET @concept12 = 12
    SET @concept13 = 13
    SET @daysOverTime = 0
    SET @doubleIntegrableHours = 0
    SET @doubleNotIntegrableHours = 0
    SET @tripleHours = 0
    SET @totalDoubleHours = 0
    SET @nineHour = 0
    SET @lastDate = @beginDate + 6
    SET @sundayBonus = 0
    SET @sundayHours = 0
    SET @hollydayAmount = 0
    SET @hollydayHours = 0
    SET @doubleIntegrableAmount = 0
    SET @doubleNotIntegrableAmount = 0
    SET @tripleAmount = 0
    SET @totalAmount = 0
    SET @totalIntegrableAmount = 0
    SET @totalNotIntegrableAmount = 0
    SET @salaryEmployee = 0


--Days of week, begin date
    SET @day1 = DATEPART(DW, @date)

    SET @day0 = @day1 + 1
    IF @day0 > 7
        SET @day0 = 1
    SET @day2 = @day0

    SET @day0 = @day0 + 1
    IF @day0 > 7
        SET @day0 = 1
    SET @day3 = @day0

    SET @day0 = @day0 + 1
    IF @day0 > 7
        SET @day0 = 1
    SET @day4 = @day0

    SET @day0 = @day0 + 1
    IF @day0 > 7
        SET @day0 = 1
    SET @day5 = @day0

    SET @day0 = @day0 + 1
    IF @day0 > 7
        SET @day0 = 1
    SET @day6 = @day0

    SET @day0 = @day0 + 1
    IF @day0 > 7
        SET @day0 = 1
    SET @day7 = @day0

--Operation Month and Year From empresas
    SELECT  @companyOperationMonth = mes_operacion ,
            @companyOperationYear = ayo_operacion
    FROM    dbo.empresas
    WHERE   empresa = @companyId

    SET @beginOperationDate = CONVERT(DATETIME, STR(@companyOperationYear)
        + RIGHT(STR(100 + @companyOperationMonth), 2) + '01')

    SET @endOperationDate = dbo.fin_mes(@companyOperationMonth,
                                        @companyOperationYear)
-- schedule from llaves
    SELECT  @schedule = horario
    FROM    dbo.llaves
    WHERE   codigo = @employeeId
            AND empresa = @companyId


--Varibles Sunday Bonus from conceptos
    SELECT  @paySundayBonus = CASE WHEN captura = 'M' THEN 'T'
                                   ELSE 'F'
                              END ,
            @SundayBonusPercentage = ISNULL(porciento1, 25)
    FROM    dbo.conceptos
    WHERE   empresa = @companyId
            AND num_conc = 9

    SET @SundayBonusPercentage = @SundayBonusPercentage / 100
    IF @salary = 0
        BEGIN

            EXECUTE dbo.asp_ds @companyId, -- numeric
                @employeeId, -- numeric
                @companyOperationYear, -- int
                @companyOperationMonth, -- int
                @endOperationDate -- datetime

        END

    WHILE @date <= @lastDate
        BEGIN
            SET @nonWorkableday = ISNULL(( SELECT   descanso
                                           FROM     dbo.Detalle_Horarios
                                           WHERE    Horario = @schedule
                                                    AND dia_semana = DATEPART(DW,
                                                              @date)
                                                    AND empresa = @companyId
                                         ), 'F')
            SET @hoursLaborDay = ISNULL(( SELECT    sdoxhor
                                          FROM      dbo.Detalle_Horarios
                                          WHERE     Horario = @schedule
                                                    AND dia_semana = DATEPART(DW,
                                                              @date)
                                                    AND empresa = @companyId
                                        ), 8)

            SET @FestivoDay = ISNULL(( SELECT   'T'
                                           FROM     dbo.Festivos
                                           WHERE    fecha = @date
                                                    AND empresa = @companyId
                                         ), 'F')

            IF @salary > 0
                SET @salaryEmployee = @salary
            ELSE
                BEGIN
                    SELECT  @salaryEmployee = ISNULL(sueldo, 0)
                    FROM    dbo.avisos_imss
                    WHERE   codigo = @employeeId
                            AND empresa = @companyId
                            AND ( @date >= fch_mov
                                  AND @date <= DATEADD(dd, diastr, fch_mov)
                                )
                            AND mov <> 'B'

                    IF @salaryEmployee = 0
                        SELECT  @salaryEmployee = sueldo
                        FROM    dbo.empleados
                        WHERE   codigo = @employeeId
                                AND empresa = @companyId
                END

            IF @hoursLaborDay = 0
			   SET @hoursLaborDay = 8

            SET @hoursValue = @salaryEmployee / @hoursLaborDay
            SET @dayOfWeek = DATEPART(DW, @date)

            SET @hoursDay = CASE WHEN @dayOfWeek = @day1 THEN @hoursDay1
                                 WHEN @dayOfWeek = @day2 THEN @hoursDay2
                                 WHEN @dayOfWeek = @day3 THEN @hoursDay3
                                 WHEN @dayOfWeek = @day4 THEN @hoursDay4
                                 WHEN @dayOfWeek = @day5 THEN @hoursDay5
                                 WHEN @dayOfWeek = @day6 THEN @hoursDay6
                                 WHEN @dayOfWeek = @day7 THEN @hoursDay7
                                 ELSE 0
                            END
            PRINT @date
            PRINT @hoursDay
            PRINT @dayOfWeek

            IF @hoursDay > 0
                BEGIN
                    IF @dayOfWeek = 7
                        AND @paySundayBonus = 'T'
            --Prima dominical
                        BEGIN
                            SET @amountPay = @salaryEmploYee
                                * @SundayBonusPercentage
                            SET @sundayHours = @hoursDay
                            SET @sundayBonus = @amountPay
                            INSERT  INTO @overTimeTable
                            VALUES  ( @date, @concept09, @hoursDay, @amountPay,
                                      @hoursValue, @hoursLaborDay )
                        END

                    IF @nonWorkableday = 'T' OR @FestivoDay = 'T'
            --Labores en dia de descanso
                        BEGIN
                            SET @amountPay = @hoursDay * @hoursValue * 2
                            SET @hollydayAmount = @amountPay
                            SET @hollydayHours = @hoursDay

                            INSERT  INTO @overTimeTable
                            VALUES  ( @date, @concept10, @hoursDay, @amountPay,
                                      @hoursValue, @hoursLaborDay )
                        END
                    ELSE
                        BEGIN
                            SET @totalHours = @totalHours + @hoursDay
                            IF @totalHours <= 9
                                BEGIN
                                    SET @daysOverTime = @daysOverTime + 1
                    --Si son menos de 3 dias de la semana, analizar si son mas de 3 horas diarias, para
                    --Separar el tiempo extra integrable del no integrable
                                    IF @daysOverTime <= 3
                                        BEGIN
                                            IF @hoursDay > 3
                                                BEGIN
                                                    SET @doubleIntegrableHours = @doubleIntegrableHours
                                                        + ( @hoursDay - 3 )
                                                    SET @doubleNotIntegrableHours = @doubleNotIntegrableHours
                                                        + 3
                              --doble No integrable
                                                    SET @amountPay = 3
                                                        * @hoursValue * 2

                                                    SET @doubleNotIntegrableAmount = @doubleNotIntegrableAmount
                                                        + @amountPay

                                                    INSERT  INTO @overTimeTable
                                                    VALUES  ( @date,
                                                              @concept11, 03,
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )
                              --doble integrable
                                                    SET @amountPay = ( @hoursDay
                                                              - 3 )
                                                        * @hoursValue * 2
                                                    SET @doubleIntegrableAmount = @doubleIntegrableAmount
                                                        + @amountPay

                                                    INSERT  INTO @overTimeTable
                                                    VALUES  ( @date,
                                                              @concept12,
                                                              ( @hoursDay - 3 ),
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )
                                                END
                                            ELSE
                                                BEGIN
                             --doble No integrable
                                                    SET @doubleNotIntegrableHours = @doubleNotIntegrableHours
                                                        + @hoursDay
                                                    SET @amountPay = @hoursDay
                                                        * @hoursValue * 2
                                                    SET @doubleNotIntegrableAmount = @doubleNotIntegrableAmount
                                                        + @amountPay

                                                    INSERT  INTO @overTimeTable
                                                    VALUES  ( @date,
                                                              @concept11,
                                                              @hoursDay,
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )
                                                END
                                        END
                                    ELSE
                                        BEGIN
                          --doble integrable
                                            SET @doubleIntegrableHours = @doubleIntegrableHours
                                                + @hoursDay
                                            SET @amountPay = @hoursDay
                                                * @hoursValue * 2
                                            SET @doubleIntegrableAmount = @doubleIntegrableAmount
                                                + @amountPay

                                            INSERT  INTO @overTimeTable
                                            VALUES  ( @date, @concept12,
                                                      @hoursDay, @amountPay,
                                                      @hoursValue,
                                                      @hoursLaborDay )


                                        END
                                END
                            ELSE
                                BEGIN
                                    SET @totalDoubleHours = @doubleIntegrableHours
                                        + @doubleNotIntegrableHours
                                    IF @totalDoubleHours < 9
                                        BEGIN
                         --Tiempo extra triple
                                            SET @nineHour = 9
                                                - @totalDoubleHours
                                            SET @daysOverTime = @daysOverTime
                                                + 1
                                            SET @tripleHours = @tripleHours
                                                + ( @totalHours - 09 )
                                            SET @amountPay = ( @totalHours
                                                              - 09 )
                                                * @hoursValue * 3
                                            SET @tripleAmount = @tripleAmount
                                                + @amountPay
                                            INSERT  INTO @overTimeTable
                                            VALUES  ( @date, @concept13,
                                                      ( @totalHours - 09 ),
                                                      @amountPay, @hoursValue,
                                                      @hoursLaborDay )
                                            IF @daysOverTime <= 3
                                                BEGIN
                                                    IF @nineHour > 3
                                                        BEGIN
                                                            SET @doubleIntegrableHours = @doubleIntegrableHours
                                                              + ( @nineHour
                                                              - 3 )
                                                            SET @doubleNotIntegrableHours = @doubleNotIntegrableHours
                                                              + 3
                                   --Doble no integrable
                                                            SET @amountPay = 3
                                                              * @hoursValue
                                                              * 2
                                                            SET @doubleNotIntegrableAmount = @doubleNotIntegrableAmount
                                                              + @amountPay

                                                            INSERT
                                                              INTO @overTimeTable
                                                            VALUES
                                                              ( @date,
                                                              @concept11, 03,
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )
                                   --doble integrable
                                                            SET @amountPay = ( @nineHour
                                                              - 3 )
                                                              * @hoursValue
                                                              * 2
                                                            SET @doubleIntegrableAmount = @doubleIntegrableAmount
                                                              + @amountPay

                                                            INSERT
                                                              INTO @overTimeTable
                                                            VALUES
                                                              ( @date,
                                                              @concept12,
                                                              ( @nineHour - 3 ),
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )

                                                        END
                                                    ELSE
                                                        BEGIN
                                                            SET @doubleIntegrableHours = @doubleIntegrableHours
                                                              + @nineHour
                                  --Doble integrable
                                                            SET @amountPay = @nineHour
                                                              * @hoursValue
                                                              * 2
                                                            SET @doubleIntegrableAmount = @doubleIntegrableAmount
                                                              + @amountPay

                                                            INSERT
                                                              INTO @overTimeTable
                                                            VALUES
                                                              ( @date,
                                                              @concept12,
                                                              @nineHour,
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )

                                                        END
                                                END
                                            ELSE
                                                BEGIN
                                                    SET @doubleIntegrableHours = @doubleIntegrableHours
                                                        + @nineHour
                               --Doble integrable
                                                    SET @amountPay = @nineHour
                                                        * @hoursValue * 2
                                                    SET @doubleIntegrableAmount = @doubleIntegrableAmount
                                                        + @amountPay

                                                    INSERT  INTO @overTimeTable
                                                    VALUES  ( @date,
                                                              @concept12,
                                                              @nineHour,
                                                              @amountPay,
                                                              @hoursValue,
                                                              @hoursLaborDay )
                                                END

                                        END
                                    ELSE
                                        BEGIN
                                            SET @tripleHours = @tripleHours
                                                + @hoursDay
                       --Tiempo extra triple
                                            SET @amountPay = @hoursDay
                                                * @hoursValue * 3
                                            SET @tripleAmount = @tripleAmount
                                                + @amountPay

                                            INSERT  INTO @overTimeTable
                                            VALUES  ( @date, @concept13,
                                                      @hoursDay, @amountPay,
                                                      @hoursValue,
                                                      @hoursLaborDay )

                                        END

                                END

                        END

                END


            SET @date = @date + 1
        END

    SET @totalAmount = @sundayBonus + @hollydayAmount
        + @doubleNotIntegrableAmount + @doubleIntegrableAmount + @tripleAmount
    SET @totalIntegrableAmount = @sundayBonus + @hollydayAmount
        + @doubleIntegrableAmount + @tripleAmount
    SET @totalNotIntegrableAmount = @doubleNotIntegrableAmount


    SELECT  dateOverTime ,
            conceptId ,
            hoursDay ,
            amountPay ,
            hoursValue ,
            hoursLaborDay ,
            @sundayHours AS 'sundayHours' ,
            @sundayBonus AS 'sundayAmount' ,
            @hollydayAmount AS 'hollydayAmount' ,
            @hollydayHours AS 'hollydayHours' ,
            @doubleNotIntegrableHours AS 'doubleNotIntegrableHours' ,
            @doubleNotIntegrableAmount AS 'doubleNotIntegrableAmount' ,
            @doubleIntegrableHours AS 'doubleIntegrableHours' ,
            @doubleIntegrableAmount AS 'doubleIntegrableAmount' ,
            @tripleHours AS 'tripleHours' ,
            @tripleAmount AS 'tripleAmount' ,
            @totalAmount AS 'totalAmount' ,
            @totalIntegrableAmount AS 'totalIntegrableAmount' ,
            @totalNotIntegrableAmount AS 'totalNotIntegrableAmount'
    FROM    @overTimeTable
    ORDER BY dateOverTime ,
            conceptId



GO

/**************************************************************************************************
 * Name          : AddEmployeeDeduction
 * Project       : APSI Nomina
 * Description   : New deduction to Employee
 * Table name    : Deducciones,Conceptos
 * Copyright     : (c) Apsi 2009 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx)
 * Creation date : Wednesday, Octuber 16, 2009
 **************************************************************************************************/
IF OBJECT_ID('AddDeduction') IS NOT NULL
    DROP PROCEDURE dbo.AddDeduction
GO

CREATE PROCEDURE dbo.AddDeduction
    (
      @companyId AS udtInteger ,
      @employeeId AS udtInteger ,
      @folio AS udtInteger ,
      @deductionId AS udtInteger ,
      @costCenter AS udtName ,
      @class AS udtName ,
      @monthOperation AS udtInteger ,
      @yearOperation AS udtInteger ,
      @payrollType AS udtInteger ,
      @period AS udtInteger ,
      @sicknessId AS udtName ,
      @days AS DECIMAL(6,2) ,
      @paymentDate AS udtDateTime ,
      @sicknessNumber AS udtName ,
      @creditNumber AS udtInteger ,
      @beginDate AS udtDateTime ,
      @endDate AS udtDateTime ,
      @initialSubs AS udtName ,
      @credit AS DECIMAL(10,2) ,
      @term AS udtInteger ,
      @discount AS DECIMAL(10,2) ,
      @balance AS DECIMAL(10,2) ,
      @justify AS udtName ,
      @always AS udtName ,
      @varia1_25 AS DECIMAL(10,2) ,
      @varia2_26 AS DECIMAL(10,2) ,
      @varia3_27 AS DECIMAL(10,2) ,
      @varia4_28 AS DECIMAL(10,2) ,
      @massive AS udtName ,
      @minutes AS udtInteger ,
      @low AS udtName ,
      @origin AS udtName ,
      @user AS udtName
    )
    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

		--Insert Table Deducciones
        INSERT  INTO [deducciones]
                ( [empresa] , --1
                  [codigo] , --2
                  [folio] ,--3
                  [num_conc] ,--4
                  [centro] ,--5
                  [clase] ,--6
                  [mes_operacion] ,--7
                  [ayo_operacion] ,--8
                  [tiponom] ,--9
                  [periodo] ,--10
                  [tipoinc] ,--11
                  [dias] ,--12
                  [fch_pago] ,--13
                  [numeroinc] ,--14
                  [num_cr] ,--15
                  [fchinicio] ,--16
                  [fchtermino] ,--17
                  [inicsubs] ,--18
                  [credito] ,--19
                  [plazo] ,--20
                  [descuento] ,--21
                  [saldo] ,--22
                  [justificar] ,--23
                  [siempre] ,--24
                  [varia1] ,--25
                  [varia2] ,--26
                  [varia3] ,--27
                  [varia4] ,--28
                  [masivo] ,--29
                  [minutos] ,--30
                  [baja] ,--31
                  [origen]
                )--32
        VALUES  ( @companyId ,
                  @employeeId ,
                  @folio ,
                  @deductionId ,
                  RTRIM(LTRIM(@costCenter)) ,
                  RTRIM(LTRIM(@class)) ,
                  @monthOperation ,
                  @yearOperation ,
                  @payrollType ,
                  @period ,
                  RTRIM(LTRIM(@sicknessId)) ,
                  @days ,
                  @paymentDate ,
                  RTRIM(LTRIM(@sicknessNumber)) ,
                  @creditNumber ,
                  @beginDate ,
                  @endDate ,
                  RTRIM(LTRIM(@initialSubs)) ,
                  @credit ,
                  @term ,
                  @discount ,
                  @balance ,
                  RTRIM(LTRIM(@justify)) ,
                  RTRIM(LTRIM(@always)) ,
                  @varia1_25 ,
                  @varia2_26 ,
                  @varia3_27 ,
                  @varia4_28 ,
                  RTRIM(LTRIM(@massive)) ,
                  @minutes ,
                  RTRIM(LTRIM(@low)) ,
                  RTRIM(LTRIM(@origin))
                )


        SELECT  0 AS ErrorNumber ,
                0 AS ErrorSeverity ,
                0 AS ErrorState ,
                '' AS ErrorProcedure ,
                0 AS ErrorLine ,
                '' AS ErrorMessage

    END TRY
    BEGIN CATCH
        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION
GO


/**************************************************************************************************
 * Name          : AddDeductionsForDays
 * Project       : APSI Nomina
 * Description   : New deduction to Employee
 * Table name    : Deducciones,Conceptos
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx)
 * Creation date : Friday, Frebruary 5, 2010
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_AddDeductionsForDays') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_AddDeductionsForDays
GO


CREATE PROCEDURE dbo.Fun_E_AddDeductionsForDays
    (
      @companyId AS udtInteger ,
      @employeeId AS udtInteger ,
      @periodId AS udtInteger ,
      @year AS udtInteger ,
      @tiponom AS udtId ,
      @deductionId AS udtInteger ,
      @sicknessId AS udtName ,
      @days AS DECIMAL(6,2) ,
      @paymentDate AS udtDateTime ,
      @sicknessNumber AS udtName ,
      @beginDate AS udtDateTime ,
      @endDate AS udtDateTime ,
      @initialSubs AS udtName ,
      @discount AS DECIMAL(10,2) ,
      @justify AS udtName ,
      @varia1 AS udtInteger ,
      @varia2 AS udtInteger ,
      @user AS udtName ,
      @option AS udtName ,
      @option2 AS udtName ,
      @option3 AS udtName ,
      @function AS udtName ,
      @registroPatronal AS udtName ,
      @system AS udtName,
      @origin AS udtName,
      @password AS udtName
    )

    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

		--Saca variables faltantes
        DECLARE @period AS udtInteger
        DECLARE @month AS udtInteger
        DECLARE @folio AS udtInteger
        DECLARE @pyrollType AS udtInteger

        SELECT  @period = p.periodo ,
                @month = MONTH(p.pago) ,
                @pyrollType = p.tiponom
        FROM    dbo.periodos AS p
        WHERE   p.tiponom = @tiponom
                AND p.empresa = @companyId
                AND periodo = @periodId
                AND ayo_operacion = @year

        SELECT  @folio = ISNULL(MAX(folio), 0) + 1
        FROM    dbo.deducciones
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND periodo = @period
                AND ayo_operacion = @year

        DECLARE @error AS TABLE
            (
              ErrorNumber INT ,
              ErrorSeverity INT ,
              ErrorState INT ,
              ErrorProcedure NVARCHAR(MAX) ,
              ErrorLine INT ,
              ErrorMessage NVARCHAR(MAX)
            )
	--Exec Stored Procedure AddDeduction
        INSERT  INTO @error
                ( ErrorNumber ,
                  ErrorSeverity ,
                  ErrorState ,
                  ErrorProcedure ,
                  ErrorLine ,
                  ErrorMessage
                )
                EXECUTE dbo.AddDeduction @companyId, @employeeId, @folio,
                    @deductionId, '', '', @month, @year, @pyrollType, @period,
                    @sicknessId, @days, @paymentDate, @sicknessNumber, 0,
                    @beginDate, @endDate, @initialSubs, 0, 0, @discount, 0,
                    @justify, 'N', @varia1, @varia2, 0, 0, 'F', 0, '', @origin ,
                    @user

        INSERT  INTO dbo.bitacora
        VALUES  ( @companyId, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @employeeId, @option, @option2, @option3, @user,
                  @password, @registroPatronal, @system )

        IF ( SELECT ErrorNumber
             FROM   @error
           ) > 0
            BEGIN
                SELECT  ErrorNumber ,
                        ErrorSeverity ,
                        ErrorState ,
                        ErrorProcedure ,
                        ErrorLine ,
                        ErrorMessage
                FROM    @error
            END

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION
GO


/**************************************************************************************************
 * Name          : AddDeductionsForUserDefinded
 * Project       : APSI Nomina
 * Description   : New deduction to Employee
 * Table name    : Deducciones,Conceptos
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx)
 * Creation date : Friday, Frebruary 12, 2018
 **************************************************************************************************/
IF OBJECT_ID('dbo.Fun_E_AddDeductionsForUserDefinded') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_AddDeductionsForUserDefinded
GO


CREATE PROCEDURE dbo.Fun_E_AddDeductionsForUserDefinded
    (
      @companyId AS udtInteger ,
      @employeeId AS udtInteger ,
      @periodId AS udtInteger ,
      @year AS udtInteger ,
      @tiponom AS udtId ,
      @deductionId AS udtInteger ,
      @paymentDate AS udtDateTime ,
      @beginDate AS udtDateTime ,
      @endDate AS udtDateTime ,
      @discount AS DECIMAL(10,2) ,
      @varia1 AS DECIMAL(10,4) ,
      @varia2 AS DECIMAL(10,4) ,
      @varia3 AS DECIMAL(10,4) ,
      @varia4 AS DECIMAL(10,4) ,
      @alwaysDiscount AS udtName ,
      @user AS udtName ,
      @option AS udtName ,
      @option2 AS udtName ,
      @option3 AS udtName ,
      @function AS udtName ,
      @registroPatronal AS udtName ,
      @system AS udtName,
      @origin AS udtName,
      @password AS udtName,
	  @justify AS udtName
    )

    WITH ENCRYPTION
AS
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY

		--Saca variables faltantes
        DECLARE @period AS udtInteger
        DECLARE @month AS udtInteger
        DECLARE @folio AS udtInteger
        DECLARE @pyrollType AS udtInteger

		--Variables para ausentismos, vacias.
        DECLARE @sicknessId AS udtName
		DECLARE @days AS DECIMAL(6,2)
        DECLARE @sicknessNumber AS udtName
        DECLARE @initialSubs AS udtName
        --DECLARE @justify AS udtName


        SET @sicknessId = ''
		SET @days = 0
		SET @sicknessNumber = ''
		SET @initialSubs = ''
		--SET @justify = ''

        SELECT  @period = p.periodo ,
                @month = MONTH(p.pago) ,
                @pyrollType = p.tiponom
        FROM    dbo.periodos AS p
        WHERE   p.tiponom = @tiponom
                AND p.empresa = @companyId
                AND periodo = @periodId
                AND ayo_operacion = @year

        SELECT  @folio = ISNULL(MAX(folio), 0) + 1
        FROM    dbo.deducciones
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND periodo = @period
                AND ayo_operacion = @year

        DECLARE @error AS TABLE
            (
              ErrorNumber INT ,
              ErrorSeverity INT ,
              ErrorState INT ,
              ErrorProcedure NVARCHAR(MAX) ,
              ErrorLine INT ,
              ErrorMessage NVARCHAR(MAX)
            )
	--Exec Stored Procedure AddDeduction
        INSERT  INTO @error
                ( ErrorNumber ,
                  ErrorSeverity ,
                  ErrorState ,
                  ErrorProcedure ,
                  ErrorLine ,
                  ErrorMessage
                )
                EXECUTE dbo.AddDeduction @companyId, @employeeId, @folio,
                    @deductionId, '', '', @month, @year, @pyrollType, @period,
                    @sicknessId, @days, @paymentDate, @sicknessNumber, 0,
                    @beginDate, @endDate, @initialSubs, 0, 0, @discount, 0,
                    @justify, 'N', @varia1, @varia2, @varia3, @varia4, 'F', 0, '', 'C',
                    @user

        INSERT  INTO dbo.bitacora
        VALUES  ( @companyId, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @employeeId, @option, @option2, @option3, @user,
                  @password, @registroPatronal, @system )

        IF ( SELECT ErrorNumber
             FROM   @error
           ) > 0
            BEGIN
                SELECT  ErrorNumber ,
                        ErrorSeverity ,
                        ErrorState ,
                        ErrorProcedure ,
                        ErrorLine ,
                        ErrorMessage
                FROM    @error
            END

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION
GO

/**************************************************************************************************
 * Name          : dbo.Fun_E_AddDeductionForLoan
 * Project       : APSI Nomina
 * Description   : New deduction to Employee
 * Table name    : Deducciones,Conceptos
 * Copyright     : (c) Apsi 2010 - 2014. All rights reserved
 * Company       : Apsi. (http://www.apsi.com.mx/)
 * Author        : Adn Snchez M. (adan.sanchez@apsi.com.mx), Mario Garcia 
 * Creation date : Thursday, Frebruary 11, 2010, 19/01/2021
 **************************************************************************************************/
IF OBJECT_ID('Fun_E_AddDeductionForLoan') IS NOT NULL
    DROP PROCEDURE dbo.Fun_E_AddDeductionForLoan
GO

CREATE PROCEDURE dbo.Fun_E_AddDeductionForLoan
    (
      @companyId AS udtInteger ,
      @employeeId AS udtInteger ,
      @deductionId AS udtInteger ,
      @paymentDate AS udtDateTime ,
      @reference AS udtName ,
      @creditNumber AS udtInteger ,
      @credit AS udtDecimal10_2 ,
      @discount AS udtDecimal10_2 ,
      @termLoan AS udtInteger ,
      @rangeDiscount AS DECIMAL(6,2) ,
      @user AS udtName
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @recordId AS udtId
    SET XACT_ABORT ON
    BEGIN TRANSACTION
    BEGIN TRY
		
		--Saca variables faltantes
        DECLARE @month AS udtInteger 
        DECLARE @folio AS udtInteger 
		DECLARE @period AS udtInteger 
        DECLARE @year AS udtInteger 
        DECLARE @pyrollType AS udtInteger 
		DECLARE @beginDate AS udtDateTime 
        DECLARE @endDate AS udtDateTime 

		DECLARE @function AS udtName
        DECLARE @Option1 AS udtName
        DECLARE @Option2 AS udtName
        DECLARE @Option3 AS udtName
        DECLARE @password AS udtName
		DECLARE @registroPatronal AS udtName
		DECLARE @System AS udtName 
		
		SET @function = 'E'
		SET @System = 'NO'

		SELECT @registroPatronal = substring(e.registro_patronal,1,10)
		FROM dbo.empresas AS e 
		WHERE e.empresa = @companyId

		SELECT @pyrollType = ll.tiponom
		FROM dbo.llaves AS ll
		WHERE ll.empresa = @companyId AND
		      ll.codigo = @employeeId
		 

        SELECT  @period = p.periodo ,
                @month = MONTH(p.pago) ,
				@year = p.ayo_operacion ,
				@beginDate = p.inicio,
				@endDate = p.cierre
        FROM    dbo.periodos AS p
        WHERE   p.tiponom = @pyrollType AND
                p.empresa = @companyId AND
				p.estatus = 'A'
        
        SELECT  @folio = ISNULL(MAX(folio), 0) + 1
        FROM    dbo.deducciones
        WHERE   codigo = @employeeId
                AND empresa = @companyId
                AND periodo = @period
                AND ayo_operacion = @year
				AND tiponom = @pyrollType

        SET @Option1 = 'Grabar descuento :' + Convert(char(4),@deductionId) + ' periodo :' + Convert(char(2),@period) + '-' + Convert(char(4),@year)
        SET @Option2 = 'No credito :' + Convert(char(10),@creditNumber) + ' credito :' + Convert(char(15),@credit)
        SET @Option3 = 'Descuento :' + convert(char(15),@discount)
        SET @password = ''

	
        EXECUTE dbo.AddDeduction @companyId, 
		                         @employeeId, 
								 @folio,
                                 @deductionId,
							     '',
								 '', 
								 @month, 
								 @year, 
								 @pyrollType, 
								 @period,
                                 'D', 
								 @rangeDiscount, 
								 @paymentDate, 
								 @reference,
                                 @creditNumber, 
								 @beginDate, 
								 @endDate,
							     '', 
								 @credit,
                                 @termLoan, 
								 @discount, 
								 @credit,
								 '',
								 'N',
								 0,
								 0,
								 0,
								 0,
								 'F',
                                 @rangeDiscount,
								 '',
								 'C',
								 @user
	
        INSERT  INTO dbo.bitacora
        VALUES  ( @companyId, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, @employeeId, @option1, @option2, @option3, @user,
                  @password, @registroPatronal, @system )


    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0 
            ROLLBACK TRANSACTION
        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

    END CATCH

    IF @@TRANCOUNT > 0 
        BEGIN
            COMMIT TRANSACTION 
        END 

GO


/****************************************************************************************************************************
* Name          : dbo.Fun_F_ObtieneSolicitudes
* Project       : APSI Nomina
* Description   : Mayo 30, 2017
*                 Obtiene la informacion de las solicitudes por tiempo extra que capturan en el portal del empleado
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Marzo 20, 2018
* Parameters    : empresa
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_ObtieneSolicitudes') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_ObtieneSolicitudes
GO


CREATE PROCEDURE dbo.Fun_F_ObtieneSolicitudes
@empresa AS INTEGER,
@tiponom AS INTEGER,
@periodo AS INTEGER,
@ayo AS INTEGER
AS
    SET NOCOUNT ON

	select	b.codigo,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre' ,
            ll.centro ,
            ll.tiponom ,
            e.fchantigua ,
            'Tiempo extra' AS 'Tipo' ,
			b.fecha,
			b.horas,
            p.periodo ,
            p.ayo_operacion,
            p.inicio ,
            p.cierre ,
            p.pago ,
            p.dias ,
            e.ultmov,
            e.fchalta,
            ll.horario,
			a.idSolicitud,
			a.linea,
			a.motivo,
			e.sueldo
	from dbo.PortalEmpleado_SolicitudTE as a
	inner join dbo.PortalEmpleado_HorasExtraSolicitadas as b on b.idSolicitud=a.idSolicitud
    INNER JOIN dbo.empleados AS e ON a.Empresa = e.empresa
                                  AND b.Codigo = e.codigo
    INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa
                                AND e.codigo = ll.codigo
    INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                 AND ll.tiponom = p.tiponom
								 AND p.periodo = @periodo
								 AND p.ayo_operacion = @ayo
	where	a.empresa = @empresa
			and a.tiponom=@tiponom
			and a.periodo=@periodo
			and a.ayo = @ayo
			and a.aprobada=1
   ORDER BY b.codigo,b.fecha

/*
    SELECT  s.Codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' '
            + RTRIM(e.nombre) AS 'Nombre' ,
            ll.centro ,
            ll.tiponom ,
            e.fchantigua ,
            'Tiempo extra' AS 'Tipo' ,
            s.Disfrute ,
            s.Importe AS 'Horas',
            p.periodo ,
            p.ayo_operacion,
            p.inicio ,
            p.cierre ,
            p.pago ,
            p.dias ,
            e.ultmov,
            e.fchalta,
            ll.horario
    FROM    dbo.Solicitud_VPA AS s
            INNER JOIN dbo.empleados AS e ON s.Empresa = e.empresa
                                             AND s.Codigo = e.codigo
            INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa
                                           AND e.codigo = ll.codigo
            INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                            AND ll.tiponom = p.tiponom
    WHERE   s.Empresa = @empresa
            AND s.Tipo = 'TE'
            AND s.Estatus = 'S'
            AND p.estatus = 'A'
            AND s.nomina = 'S'
    ORDER BY s.Codigo
*/
GO

/****************************************************************************************************************************
* Name          : dbo.Fun_F_ObtieneSolicitudesXCodigo
* Project       : APSI Nomina
* Description   : Mayo 30, 2017
*                 Obtiene la informacion de las solicitudes por tiempo extra que capturan en el portal del empleado
* Copyright     : (c) Apsi 2009 - 2017. All rights reserved
* Company       : Apsi. (http://www.Apsi.com/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Marzo 20, 2018
* Parameters    : empresa
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_F_ObtieneSolicitudesXCodigo') IS NOT NULL
    DROP PROCEDURE dbo.Fun_F_ObtieneSolicitudesXCodigo
GO


CREATE PROCEDURE dbo.Fun_F_ObtieneSolicitudesXCodigo
@empresa AS INTEGER,
@codigo AS NUMERIC(8,0),
@tiponom AS INTEGER,
@periodo AS INTEGER,
@ayo AS INTEGER

AS
    SET NOCOUNT ON

	select	b.codigo,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre' ,
            ll.centro ,
            ll.tiponom ,
            e.fchantigua ,
            'Tiempo extra' AS 'Tipo' ,
			b.fecha,
			b.horas,
            p.periodo ,
            p.ayo_operacion,
            p.inicio ,
            p.cierre ,
            p.pago ,
            p.dias ,
            e.ultmov,
            e.fchalta,
            ll.horario,
			e.sueldo,
			h.hrsturno,
			ll.clase,
			CASE WHEN e.ultmov = 'B' THEN 'S' ELSE 'N' END AS 'EsBaja',
			e.saldiaint,
			e.varia_imss,
			e.tiposal,
			a.idSolicitud,
			a.linea,
			a.motivo
	from dbo.PortalEmpleado_SolicitudTE as a
	inner join dbo.PortalEmpleado_HorasExtraSolicitadas as b on b.idSolicitud=a.idSolicitud
    INNER JOIN dbo.empleados AS e ON a.Empresa = e.empresa
                                  AND b.Codigo = e.codigo
    INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa
                                AND e.codigo = ll.codigo
    INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                 AND ll.tiponom = p.tiponom
    INNER JOIN dbo.horarios_catalogo AS h ON ll.empresa = h.empresa
	                                      AND ll.horario = h.horario

	where	a.empresa = @empresa
			and a.tiponom=@tiponom
			and a.periodo=@periodo
			and a.ayo = @ayo
			and a.aprobada=1
			AND b.codigo = @codigo

/*
    SELECT  s.Codigo ,
            RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre' ,
            ll.centro ,
            ll.tiponom ,
            e.fchantigua ,
            'Tiempo extra' AS 'Tipo' ,
            s.Disfrute ,
            s.Importe AS 'Horas',
            p.periodo ,
            p.ayo_operacion,
            p.inicio ,
            p.cierre ,
            p.pago ,
            p.dias ,
            e.ultmov,
            e.fchalta,
            ll.horario,
			e.sueldo,
			hrsturno,
			ll.clase,
			CASE WHEN e.ultmov = 'B' THEN 'S' ELSE 'N' END AS 'EsBaja',
			e.saldiaint,
			e.varia_imss,
			e.tiposal
    FROM    dbo.Solicitud_VPA AS s
            INNER JOIN dbo.empleados AS e ON s.Empresa = e.empresa
                                             AND s.Codigo = e.codigo
            INNER JOIN dbo.Llaves AS ll ON e.empresa = ll.empresa
                                           AND e.codigo = ll.codigo
            INNER JOIN dbo.Periodos AS p ON ll.empresa = p.empresa
                                            AND ll.tiponom = p.tiponom
            INNER JOIN dbo.horarios_catalogo AS h ON ll.empresa = h.empresa AND ll.horario = h.horario
    WHERE   s.Empresa = @empresa
            AND s.Tipo = 'TE'
            AND s.Estatus = 'S'
            AND p.estatus = 'A'
            AND s.nomina = 'S'
			and s.codigo = @codigo
    ORDER BY s.Disfrute
*/
GO

--Para corregir el tamao original de los campos libres nuevos, se agregaron con tamao de 10 caracteres pero deben ser 100 19/07/2018 Mario.
UPDATE dbo.gr_catalogo SET longitud = 100, tamori = '100'
WHERE (numero >= 149 AND numero <= 155)
AND tamori = '10'

UPDATE dbo.gr_formas SET longitud = 100, tamori = '100'
WHERE (numero >= 149 AND numero <= 155)
AND tamori = '10'

--Para corregir el tamao original del campo Actividad, se amplio la longitud a 100 posiciones. 05/10/2018 Mario
UPDATE dbo.gr_catalogo SET longitud = 100, tamori = '100'
WHERE numero = 21
AND tamori = '30'

UPDATE dbo.gr_formas SET longitud = 100, tamori = '100'
WHERE numero = 21
AND tamori = '30'

--Para que mueste en el mismo orden los campos libres como en la funcion D 02/08/2018 Mario.
UPDATE gr_catalogo SET descrip = '',especial =''
WHERE campo IN ('Campo_01','Campo_06','Campo_09','Campo_12')

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 5',especial ='LIBRE 5'
WHERE campo = 'CAMPO_07'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 6',especial ='LIBRE 6'
WHERE campo = 'CAMPO_08'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 7',especial ='LIBRE 7'
WHERE campo = 'CAMPO_10'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 8',especial ='LIBRE 8'
WHERE campo = 'CAMPO_11'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 9',especial ='LIBRE 9'
WHERE campo = 'CAMPO__09'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 10',especial ='LIBRE 10'
WHERE campo = 'CAMPO__10'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 11',especial ='LIBRE 11'
WHERE campo = 'CAMPO__11'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 12',especial ='LIBRE 12'
WHERE campo = 'CAMPO__12'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 13',especial ='LIBRE 13'
WHERE campo = 'CAMPO__13'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 14',especial ='LIBRE 14'
WHERE campo = 'CAMPO__14'

UPDATE gr_catalogo SET descrip = 'CAMPOS LIBRE 15',especial ='LIBRE 15'
WHERE campo = 'CAMPO__15'

GO


/****************************************************************************************************************************
* Name          : dbo.Fun_K_ObtieneReportesImportar
* Project       : APSI Nomina
* Description   : Agosto 15, 2018
*                 Obtiene los reportes de una empresa dada, para importarlos a otra empresa
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Agosto 15, 2018
* Parameters    : empresaOrigen, empresaNueva
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_K_ObtieneReportesImportar') IS NOT NULL
    DROP PROCEDURE dbo.Fun_K_ObtieneReportesImportar
GO


CREATE PROCEDURE dbo.Fun_K_ObtieneReportesImportar
@empresaOrigen AS INTEGER,
@empresaNueva AS INTEGER

AS

SELECT Nombre ,Mascara,Mascara1
FROM dbo.gr_formas
WHERE empresa = @empresaNueva
AND campo = 'CONTROL'
AND Nombre NOT IN (SELECT nombre
                FROM dbo.gr_formas
				WHERE empresa = @empresaOrigen AND campo = 'CONTROL')

ORDER BY Nombre

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_K_ImportarReporte
* Project       : APSI Nomina
* Description   : Agosto 15, 2018
*                 Importar el reporte de otra empresa
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Agosto 15, 2018
* Parameters    : empresaOrigen, empresaNueva, NombreReporte, Funcion, Usuario, RegistroPatronal, Sistema
*******************************************************************************************************************************/
IF OBJECT_ID('dbo.Fun_K_ImportarReporte') IS NOT NULL
    DROP PROCEDURE dbo.Fun_K_ImportarReporte
GO

CREATE PROCEDURE dbo.Fun_K_ImportarReporte
@empresaOrigen AS INTEGER,
@empresaNueva AS INTEGER,
@nombreReporte AS VARCHAR(50),
@function AS udtName ,
@user AS udtName ,
@registroPatronal AS udtName ,
@system AS udtName

AS

    SET NOCOUNT ON

	BEGIN TRANSACTION
    BEGIN TRY

    DECLARE @Option1 AS udtName
    DECLARE @Option2 AS udtName
    DECLARE @Option3 AS udtName
    DECLARE @password AS udtName
    DECLARE @recordId AS udtId


    SET @Option1 = 'Reporteador importar reporte'
    SET @Option2 = 'Empresa origen del reporte ' + CONVERT(CHAR(04),@empresaNueva)
    SET @Option3 = 'Reporte importado : ' + @nombreReporte
    SET @password = ''


    IF NOT EXISTS (SELECT nombre FROM dbo.gr_formas WHERE empresa = @empresaOrigen AND nombre = @nombreReporte)
       BEGIN
           INSERT INTO dbo.gr_formas
                      (empresa
                       ,nombre
                       ,numero
                       ,campo
                       ,longitud
                       ,imprime
                       ,especial
                       ,mascara
                       ,mascara1
                       ,descrip
                       ,condicion
                       ,tcondicion
                       ,rcondicion
                       ,scondicion
                       ,orden
                       ,torden
                       ,rcorte
                       ,tamori
                       ,tabla)
           SELECT @empresaOrigen
                  ,nombre
                  ,numero
                  ,campo
                  ,longitud
                  ,imprime
                  ,especial
                  ,mascara
                  ,mascara1
                  ,descrip
                  ,condicion
                  ,tcondicion
                  ,rcondicion
                  ,scondicion
                  ,orden
                  ,torden
                  ,rcorte
                  ,tamori
                  ,tabla
           FROM dbo.gr_formas
           WHERE empresa = @empresaNueva
           AND nombre = @nombreReporte

        INSERT  INTO dbo.bitacora
        VALUES  ( @empresaOrigen, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                  @function, 0, @option1, @option2, @option3, @user,
                  @password, @registroPatronal, @system )

        SET @recordId = @@IDENTITY


       END

    END TRY
    BEGIN CATCH

        DECLARE @ErrorSeverity udtInteger
        DECLARE @ErrorState udtInteger
        DECLARE @ErrorMessage udtStringSize2048

        SET @ErrorSeverity = ERROR_SEVERITY()
        SET @ErrorState = ERROR_STATE()
        SET @ErrorMessage = 'State: ' + LTRIM(RTRIM(STR(@ErrorState)))
            + CHAR(13) + CHAR(10) + 'Severity: '
            + LTRIM(RTRIM(STR(@ErrorSeverity))) + CHAR(13) + CHAR(10)
            + 'Error number:  ' + LTRIM(RTRIM(STR(ERROR_NUMBER()))) + CHAR(13)
            + CHAR(10) + 'Message: ' + ERROR_MESSAGE() + CHAR(13) + CHAR(10)
            + 'Procedure: ' + ERROR_PROCEDURE() + CHAR(13) + CHAR(10)
            + 'Line: ' + LTRIM(RTRIM(STR(ERROR_LINE())))

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        RAISERROR ( @ErrorMessage, @ErrorSeverity, @ErrorState )

    END CATCH

    IF @@TRANCOUNT > 0
        BEGIN
            COMMIT TRANSACTION
            SELECT  @recordId AS 'recordId'
            RETURN @recordId
        END


GO

/****************************************************************************************************************************
* Name          : dbo.Fun_K_ObtieneReportes
* Project       : APSI Nomina
* Description   : Agosto 15, 2018
*                 Obtiene los reportes de la funcion K
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Agosto 15, 2018
* Parameters    : empresa
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_K_ObtieneReportes') IS NOT NULL
    DROP PROCEDURE dbo.Fun_K_ObtieneReportes
GO


CREATE PROCEDURE dbo.Fun_K_ObtieneReportes
@empresa AS INTEGER

AS

SELECT Nombre,
       Condicion,
	   RCondicion,
	   SCondicion,
	   Orden,
	   RCorte,
	   torden,
	   tabla,
	   TCondicion,
	   Mascara
FROM dbo.gr_formas
WHERE empresa = @empresa
AND campo = 'CONTROL'
ORDER BY Nombre

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_Y_ObtieneClavesSAT
* Project       : APSI Nomina
* Description   : Septiembre 27, 2018
*                 Obtiene los campos que se utilizan para el timbrado de la nomina digital
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Septiembre 27, 2018
* Parameters    : empresa,tiponom,nomina,periodo,ayo_operacion
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_Y_ObtieneClavesSAT') IS NOT NULL
   DROP PROCEDURE dbo.Fun_Y_ObtieneClavesSAT
GO

CREATE PROCEDURE dbo.Fun_Y_ObtieneClavesSAT
@empresa AS INTEGER,
@tiponom AS INTEGER,
@nomina AS CHARACTER(3),
@periodo AS INTEGER,
@ayo_operacion AS INTEGER

AS
  SET NOCOUNT ON

  DECLARE @tba_codigos AS TABLE (empresa INTEGER,
                                 codigo NUMERIC(8,0),
								 tiponom INTEGER,
								 nomina CHAR(3),
								 periodo INTEGER,
								 ayo_operacion INTEGER)

  INSERT INTO @tba_codigos
  SELECT DISTINCT ka.empresa,
                 ka.codigo,
				 ka.tiponom,
				 ka.nomina,
				 ka.periodo,
				 ka.ayo_operacion
  FROM dbo.kardex_anual AS ka
  WHERE ka.empresa = @empresa AND
        ka.tiponom = @tiponom AND
        ka.nomina = @nomina AND
        ka.periodo = @periodo AND
        ka.ayo_operacion = @ayo_operacion


SELECT DISTINCT ka.codigo
                ,RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre'
                ,ISNULL(na.centro,ll.centro) AS 'Centro'
                ,cc.nomdepto AS 'Departamento'
                ,ISNULL(na.clase,ll.clase) AS 'Clase'
                ,cls.nombre AS 'Nombre clase'
                ,ISNULL(na.horario,ll.horario) AS 'Horario'
                ,h.nombre AS 'Nombre horario'
                ,ISNULL(h.JornadaSAT,0) AS 'Jornada SAT'
                ,ISNULL(na.ocupacion,ll.ocupacion) AS 'Puesto'
                ,tab.actividad AS 'Nombre Puesto'
                ,ISNULL(na.Sindicato,e.sindicato) AS 'Sindicato'
                ,ISNULL(na.claveEstado,ea.ClaveEstado) AS 'Clave Estado'
                ,ISNULL(CveEdoSAT.nombreEstado,'') AS 'Nombre Estado'
                ,ISNULL(na.tipoContrato,ea.tipoContrato) AS 'Tipo contrato'
                ,ISNULL(CveConSAT.descripcion,'') 'Nombre tipo contrato'
                ,ISNULL(na.tipoRegimen,ea.tipoRegimen) AS 'Tipo regimen'
                ,ISNULL(CveRegSAT.descripcion,'') 'Nombre tipo regimen'
                ,CASE WHEN ISNULL(na.claveSat,ea.claveSat) = '040' THEN 'IP'
				      WHEN ISNULL(na.claveSat,ea.claveSat) = '041' THEN 'IF'
				      WHEN ISNULL(na.claveSat,ea.claveSat) = '042' THEN 'IM'
					  ELSE 'NA' END  AS 'Origen recurso'
                ,ISNULL(na.PorcientoSAT,ea.porcientoSat) AS 'Porcentaje origen recurso'
                ,ISNULL(rc.uuid,'') AS 'UUID'
                ,ISNULL(rc.fechaTimbrado,'') AS 'Fecha timbrado'
                ,ISNULL(na.codigo,0) AS 'Existe Nomina1'
FROM @tba_codigos AS ka
INNER JOIN dbo.empleados AS e ON ka.empresa = e.empresa AND ka.codigo = e.codigo
LEFT JOIN dbo.nomina1_anual AS na ON ka.empresa = na.empresa AND ka.codigo = na.codigo AND ka.periodo = na.periodo AND ka.ayo_operacion = na.ayo_operacion AND ka.tiponom = na.tiponom
INNER JOIN dbo.llaves AS ll ON ka.empresa = ll.empresa AND ka.codigo = ll.codigo
LEFT JOIN dbo.ResumenCFDIs AS rc ON ka.empresa = rc.Empresa AND ka.codigo = rc.Codigo AND ka.periodo = rc.periodo AND ka.ayo_operacion = rc.ayo AND ka.tiponom = rc.tiponom AND ka.nomina = rc.nomina
INNER JOIN dbo.centros AS cc ON ka.empresa = cc.empresa AND cc.centro = ISNULL(na.centro,ll.centro)
INNER JOIN dbo.clases AS cls ON ka.empresa = cls.empresa AND cls.clase = ISNULL(na.clase,ll.clase)
LEFT JOIN dbo.supervisores AS sup ON ka.empresa = sup.empresa AND sup.supervisor = ISNULL(na.supervisor,ll.supervisor)
LEFT JOIN dbo.horarios_catalogo AS h ON ka.empresa = h.empresa AND h.horario = ISNULL(na.horario,ll.horario)
LEFT JOIN dbo.tabulador AS tab ON ka.empresa = tab.empresa AND tab.ocupacion = ISNULL(na.ocupacion,ll.ocupacion)
LEFT JOIN dbo.empleadoAdicional AS ea ON ka.empresa = ea.empresa AND ka.codigo = ea.codigo
LEFT JOIN dbo.catalogoEstadosCfdi AS CveEdoSAT ON CveEdoSAT.claveEstado = ISNULL(na.claveEstado,ea.ClaveEstado)
LEFT JOIN dbo.CatalogoTipoContrato AS CveConSAT ON CveConSAT.idClave = ISNULL(na.tipoContrato,ea.tipoContrato)
LEFT JOIN dbo.CatalogoRegimenContratacionTrabajador AS CveRegSAT ON CveRegSAT.idClave = ISNULL(na.tipoRegimen,ea.tipoRegimen)
ORDER BY ka.codigo

GO

/****************************************************************************************************************************
* Name          : dbo.Fun_Y_ObtieneClavesSATXCodigo
* Project       : APSI Nomina
* Description   : Septiembre 27, 2018
*                 Obtiene los campos que se utilizan para el timbrado de la nomina digital de un empleado especifico
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Septiembre 27, 2018
* Parameters    : empresa,tiponom,nomina,periodo,ayo_operacion,Codigo
*******************************************************************************************************************************/

IF OBJECT_ID('dbo.Fun_Y_ObtieneClavesSATXCodigo') IS NOT NULL
   DROP PROCEDURE dbo.Fun_Y_ObtieneClavesSATXCodigo
GO

CREATE PROCEDURE dbo.Fun_Y_ObtieneClavesSATXCodigo
@empresa AS INTEGER,
@tiponom AS INTEGER,
@nomina AS CHARACTER(3),
@periodo AS INTEGER,
@ayo_operacion AS INTEGER,
@codigo AS NUMERIC(8,0)

AS
  SET NOCOUNT ON

SELECT DISTINCT ka.codigo
                ,RTRIM(e.ap_paterno) + ' ' + RTRIM(e.ap_materno) + ' ' + RTRIM(e.nombre) AS 'Nombre'
                ,ISNULL(na.centro,ll.centro) AS 'Centro'
                ,cc.nomdepto AS 'Departamento'
                ,ISNULL(na.clase,ll.clase) AS 'Clase'
                ,cls.nombre AS 'Nombre clase'
                ,ISNULL(na.horario,ll.horario) AS 'Horario'
                ,h.nombre AS 'Nombre horario'
                ,h.JornadaSAT AS 'Jornada SAT'
                ,ISNULL(na.ocupacion,ll.ocupacion) AS 'Puesto'
                ,tab.actividad AS 'Nombre Puesto'
                ,ISNULL(na.Sindicato,e.sindicato) AS 'Sindicato'
                ,ISNULL(na.claveEstado,ea.ClaveEstado) AS 'Clave Estado'
                ,ISNULL(CveEdoSAT.nombreEstado,'') AS 'Nombre Estado'
                ,ISNULL(na.tipoContrato,ea.tipoContrato) AS 'Tipo contrato'
                ,ISNULL(CveConSAT.descripcion,'') 'Nombre tipo contrato'
                ,ISNULL(na.tipoRegimen,ea.tipoRegimen) AS 'Tipo regimen'
                ,ISNULL(CveRegSAT.descripcion,'') 'Nombre tipo regimen'
                ,CASE WHEN ISNULL(na.claveSat,ea.claveSat) = '040' THEN 'IP'
				      WHEN ISNULL(na.claveSat,ea.claveSat) = '041' THEN 'IF'
				      WHEN ISNULL(na.claveSat,ea.claveSat) = '042' THEN 'IM'
					  ELSE 'NA' END  AS 'Origen recurso'
                ,ISNULL(na.PorcientoSAT,ea.porcientoSat) AS 'Porcentaje origen recurso'
                ,ISNULL(rc.uuid,'') AS 'UUID'
                ,ISNULL(rc.fechaTimbrado,'') AS 'Fecha timbrado'
                ,ISNULL(na.codigo,0) AS 'Existe Nomina1'
FROM dbo.kardex_anual AS ka
INNER JOIN dbo.empleados AS e ON ka.empresa = e.empresa AND ka.codigo = e.codigo
LEFT JOIN dbo.nomina1_anual AS na ON ka.empresa = na.empresa AND ka.codigo = na.codigo AND ka.periodo = na.periodo AND ka.ayo_operacion = na.ayo_operacion AND ka.tiponom = na.tiponom
INNER JOIN dbo.llaves AS ll ON ka.empresa = ll.empresa AND ka.codigo = ll.codigo
LEFT JOIN dbo.ResumenCFDIs AS rc ON ka.empresa = rc.Empresa AND ka.codigo = rc.Codigo AND ka.periodo = rc.periodo AND ka.ayo_operacion = rc.ayo AND ka.tiponom = rc.tiponom AND ka.nomina = rc.nomina
INNER JOIN dbo.centros AS cc ON ka.empresa = cc.empresa AND cc.centro = ISNULL(na.centro,ll.centro)
INNER JOIN dbo.clases AS cls ON ka.empresa = cls.empresa AND cls.clase = ISNULL(na.clase,ll.clase)
LEFT JOIN dbo.supervisores AS sup ON ka.empresa = sup.empresa AND sup.supervisor = ISNULL(na.supervisor,ll.supervisor)
LEFT JOIN dbo.horarios_catalogo AS h ON ka.empresa = h.empresa AND h.horario = ISNULL(na.horario,ll.horario)
LEFT JOIN dbo.tabulador AS tab ON ka.empresa = tab.empresa AND tab.ocupacion = ISNULL(na.ocupacion,ll.ocupacion)
LEFT JOIN dbo.empleadoAdicional AS ea ON ka.empresa = ea.empresa AND ka.codigo = ea.codigo
LEFT JOIN dbo.catalogoEstadosCfdi AS CveEdoSAT ON CveEdoSAT.claveEstado = ISNULL(na.claveEstado,ea.ClaveEstado)
LEFT JOIN dbo.CatalogoTipoContrato AS CveConSAT ON CveConSAT.idClave = ISNULL(na.tipoContrato,ea.tipoContrato)
LEFT JOIN dbo.CatalogoRegimenContratacionTrabajador AS CveRegSAT ON CveRegSAT.idClave = ISNULL(na.tipoRegimen,ea.tipoRegimen)
WHERE ka.codigo  = @codigo AND
      ka.empresa = @empresa AND
      ka.tiponom = @tiponom AND
      ka.nomina = @nomina AND
      ka.periodo = @periodo AND
      ka.ayo_operacion = @ayo_operacion


GO


/****************************************************************************************************************************
* Name          : dbo.Fun_Y_ActualizaNomina1_ClavesSAT
* Project       : APSI Nomina
* Description   : Septiembre 27, 2018
*                 Actualiza la tabla nomina1_anual, en los campos que se utilizan en el timbrado de la nomina digital,
*                 solo si el registro no esta timbrado, guarda en bitacora el movimiento.
* Copyright     : (c) Apsi 2009 - 2018. All rights reserved
* Company       : Apsi. (http://www.Apsi.com.mx/)
* Author        : Mario Garcia (mario.garcia@apsi.com.mx)
* Creation date : Septiembre 27, 2018
* Parameters    : empresa,codigo,tiponom,nomina,periodo,ayo_operacion,centro,ocupacion,horario,ClaveEstado,TipoContrato,
*                 tipoRegimen,ClaveSAT,PorcientoSAT,Usuario,Opcion1,Opcion2,Opcion3,Funcion,RegistroPatronal,Sistema,Origen,Clave
*******************************************************************************************************************************/


IF OBJECT_ID('dbo.Fun_Y_ActualizaNomina1_ClavesSAT') IS NOT NULL
   DROP PROCEDURE dbo.Fun_Y_ActualizaNomina1_ClavesSAT
GO

CREATE PROCEDURE dbo.Fun_Y_ActualizaNomina1_ClavesSAT
@empresa AS INTEGER,
@codigo AS NUMERIC(8,0),
@tiponom AS INTEGER,
@nomina AS CHAR(3),
@periodo AS INTEGER,
@ayo_operacion AS INTEGER,
@centro AS CHAR(14),
@ocupacion AS INTEGER,
@horario AS INTEGER,
@claveEstado AS VARCHAR(3),
@tipoContrato AS INTEGER,
@tipoRegimen AS INTEGER,
@claveSAT AS VARCHAR(3),
@porcientoSAT AS NUMERIC(12,4),
@user AS udtName ,
@option AS udtName ,
@option2 AS udtName ,
@option3 AS udtName ,
@function AS udtName ,
@registroPatronal AS udtName ,
@system AS udtName,
@password AS udtName

AS

  SET NOCOUNT ON
  SET DATEFORMAT MDY
  DECLARE @recordId AS udtId
  SET XACT_ABORT ON
  BEGIN TRANSACTION
  BEGIN TRY

  IF EXISTS ( SELECT codigo FROM dbo.nomina1_anual
                            WHERE empresa = @empresa AND
							      codigo = @codigo AND
								  periodo = @periodo AND
								  ayo_operacion = @ayo_operacion AND
								  tiponom = @tiponom)
     IF NOT EXISTS (SELECT UUID FROM dbo.ResumenCFDIs
	                           WHERE Empresa = @empresa AND
							         Codigo = @codigo AND
									 periodo = @periodo AND
									 ayo = @ayo_operacion AND
									 tiponom = @tiponom
									 AND nomina = @nomina)
        BEGIN

		    UPDATE nomina1_anual SET centro = @centro,
			                         ocupacion = @ocupacion,
									 horario = @horario,
									 claveEstado = @claveEstado,
									 tipoContrato = @tipoContrato,
									 tipoRegimen = @tipoRegimen,
									 ClaveSAT = @claveSAT,
									 PorcientoSAT = @porcientoSAT
             WHERE empresa = @empresa AND
		           codigo = @codigo AND
			       periodo = @periodo AND
			       ayo_operacion = @ayo_operacion AND
			       tiponom = @tiponom


            INSERT  INTO dbo.bitacora
            VALUES  ( @empresa, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                      @function, @codigo, @option, @option2, @option3, @user,
                      @password, @registroPatronal, @system )


        END

    END TRY
    BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION

GO

IF OBJECT_ID('dbo.sp_infopernom') IS NOT NULL
   DROP PROCEDURE dbo.sp_infopernom
GO


CREATE PROCEDURE dbo.sp_infopernom
           @empresa Integer       = 0,
           @estatus   char(1)       = 'A',
           @tiponom1  Integer       = 1 ,
           @tiponom2  Integer       = 6
 AS
SELECT Nominas.tiponom,
               Nominas.nomina,
               Periodos.periodo,
               Periodos.ayo_operacion,
               Periodos.inicio,
               Periodos.cierre,
               Periodos.pago,
               Periodos.dias,
               Periodos.empresa,
               Periodos.mes,
               nominas.uso,
			   periodos.dias_anticipados
FROM Nominas
INNER JOIN Periodos ON (Nominas.tiponom = Periodos.tiponom AND Nominas.empresa = Periodos.empresa)
WHERE (Periodos.estatus = @estatus AND nominas.empresa = @empresa AND (nominas.tiponom >= @tiponom1 AND nominas.tiponom <= @tiponom2))
ORDER By Periodos.ayo_operacion,Periodos.periodo

GO

IF OBJECT_ID('dbo.Fun_I_CrearClaseCero') IS NOT NULL
   DROP PROCEDURE dbo.Fun_I_CrearClaseCero
GO


CREATE PROCEDURE dbo.Fun_I_CrearClaseCero
@empresa INTEGER
AS

  SET NOCOUNT ON
  SET DATEFORMAT MDY
  DECLARE @recordId AS udtId
  SET XACT_ABORT ON
  BEGIN TRANSACTION
  BEGIN TRY

      DECLARE @mes_operacion AS INTEGER
      DECLARE @ayo_operacion AS INTEGER
	  DECLARE @ayos AS INTEGER
	  DECLARE @Factor AS DECIMAL(10,6)
	  DECLARE @DiasAguinaldo AS DECIMAL(10,2)
	  DECLARE @DiasVacaciones AS DECIMAL(10,2)
	  DECLARE @PrimaVacacional AS DECIMAL(10,2)
	  DECLARE @cAyos AS CHAR(2)
	  DECLARE @clase AS CHAR(2)
	  DECLARE @Ceros AS DECIMAL(10,2)

      SELECT @mes_operacion = mes_operacion,
             @ayo_operacion = ayo_operacion
      FROM dbo.empresas
      WHERE empresa = @empresa

	  SET @Ceros = 0.00

      IF NOT EXISTS(SELECT factor FROM dbo.tablas_int WHERE empresa = @empresa AND clase = '0')
         BEGIN
		     SET @ayos = 1
			 SET @DiasAguinaldo = 15
			 SET @PrimaVacacional = 25
			 SET @Clase = '0 '

		     WHILE @ayos < 46
			      BEGIN
				      SET @DiasVacaciones = CASE WHEN @ayos = 1 THEN 6
					                             WHEN @ayos = 2 THEN 8
											     WHEN @ayos = 3 THEN 10
											     WHEN @ayos = 4 THEN 12
												 WHEN @ayos >= 5 AND @ayos <= 9 THEN 14
												 WHEN @ayos >= 10 AND @ayos <= 14 THEN 16
												 WHEN @ayos >= 15 AND @ayos <= 19 THEN 18
												 WHEN @ayos >= 20 AND @ayos <= 24 THEN 20
												 WHEN @ayos >= 25 AND @ayos <= 29 THEN 22
												 WHEN @ayos >= 30 AND @ayos <= 34 THEN 24
												 WHEN @ayos >= 35 AND @ayos <= 39 THEN 26
												 WHEN @ayos >= 40 AND @ayos <= 44 THEN 28
  											     WHEN @ayos >= 45 THEN 30
												 END
                      SET @factor = 1 + ROUND( ((@DiasAguinaldo/365) + ((@DiasVacaciones * (@PrimaVacacional/100))/365)),4)
	  			      SET @cAyos = dbo.Padl(@ayos,'',2,'0')

				      INSERT INTO dbo.tablas_int (empresa,
					                              clase,
												  Ayos,
												  mes_operacion,
												  ayo_operacion,
												  Factor,
												  Aguinaldo,
												  Dias_Vac,
												  Prima_Vac,
                                                  pmavacdias,
                                                  pmavacimpo,
                                                  despensa,
                                                  despensaim,
                                                  dias_ayo,
                                                  porc_ayo,
                                                  imp_ayo,
                                                  dias_mes,
                                                  porc_mes,
                                                  imp_mes,
                                                  porc_dia,
                                                  imp_dia,
                                                  fdoahopatp,
                                                  fdoahopati,
                                                  fdoahotrap,
                                                  fdoahotrai,
                                                  pmo1ayopor,
                                                  pmo1ayoimp,
                                                  pmo2ayopor,
                                                  pmo2ayoimp)

					                      VALUES (@empresa,
										          @Clase,
												  @cAyos,
												  @mes_operacion,
												  @ayo_operacion,
												  @factor,
												  @DiasAguinaldo,
												  @DiasVacaciones,
												  @PrimaVacacional,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros)
                      SET @ayos = @ayos + 1
                  END
	     END

  END TRY
  BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

  END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


IF OBJECT_ID('dbo.usuariosNominaCambiaKZ') IS NOT NULL
   DROP PROCEDURE dbo.usuariosNominaCambiaKZ
GO


CREATE PROCEDURE dbo.usuariosNominaCambiaKZ

AS
	BEGIN

	create table #Temporal (idPerfil bigint,
							opcion varchar(3))

	create table #TemporalPerfiles (idPerfil bigint)

	insert into #TemporalPerfiles
	select perfiles.idperfil
	from perfiles
	where perfiles.sistema='NO'

	delete from opciones where sistema='NO' and funcion ='K' and opcion='2'
	delete from opciones where sistema='NO' and funcion ='K' and opcion='13'
	delete from perfil_funcion where funcion='K' and opcion='2' and idperfil in (select idperfil from #TemporalPerfiles)
	delete from perfil_funcion where funcion='K' and opcion='13' and idperfil in (select idperfil from #TemporalPerfiles)

	if not exists (select * from opciones where opcion='7' and sistema='NO' and funcion='Z')
	begin
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('7','NO','Z','Archivos SAT Altas y Validaciones')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('8','NO','Z','Sub-Contratacin')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('9','NO','Z','Forma 37 De Otros Patrones')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('10','NO','Z','Auditor Fiscal')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('11','NO','Z','Reportes Auxiliares')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('12','NO','Z','Ajuste Anual')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('13','NO','Z','Calcular RFC / CURP')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('14','NO','Z','Simuladores de ISR')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('15','NO','Z','Catlogos Nmina Digital')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('16','NO','Z','Visor CFDIs')
		INSERT INTO opciones (opcion,sistema,funcion,descripcion)  VALUES('17','NO','Z','Leyes y reglamentos SAT')

		DECLARE @idPerfil AS bigint

		DECLARE Perfiles CURSOR FOR SELECT idperfil FROM #TemporalPerfiles

		OPEN Perfiles

		FETCH NEXT FROM Perfiles INTO @idPerfil

		WHILE @@fetch_status = 0

		BEGIN

			insert into #Temporal values( @idPerfil,'7')
			insert into #Temporal values( @idPerfil,'8')
			insert into #Temporal values( @idPerfil,'9')
			insert into #Temporal values( @idPerfil,'10')
			insert into #Temporal values( @idPerfil,'11')
			insert into #Temporal values( @idPerfil,'12')
			insert into #Temporal values( @idPerfil,'13')
			insert into #Temporal values( @idPerfil,'14')
			insert into #Temporal values( @idPerfil,'15')
			insert into #Temporal values( @idPerfil,'16')
			insert into #Temporal values( @idPerfil,'17')

			FETCH NEXT FROM Perfiles INTO @idPerfil
		END

		CLOSE Perfiles

		DEALLOCATE Perfiles

		insert into perfil_funcion
		SELECT 'Z',opcion,idPerfil from #Temporal
	END
END

GO

IF OBJECT_ID('dbo.usuariosNominaCambiaKZ') IS NOT NULL
   EXECUTE dbo.usuariosNominaCambiaKZ
GO

IF OBJECT_ID('dbo.sp_viewdeducciones ') IS NOT NULL
  DROP PROCEDURE dbo.sp_viewdeducciones
GO

CREATE  PROCEDURE dbo.sp_viewdeducciones
@empresa integer = 0 ,
@codigo   Numeric(8,0) = 0,
@periodo  integer = 0,
@ejercicio Numeric(4,0) = 0,
@tiponom Integer = 0

AS

SELECT folio,
       num_conc,
       dias,
       descuento,
       credito,
       saldo,
       numeroinc,
       siempre,
       justificar,
       fch_pago,
       tipoinc,
       fchtermino,
       fchinicio,
       periodo,
       varia1,
       varia2,
       varia3,
       varia4,
       num_cr,
       centro,
       clase,
       mes_operacion,
       ayo_operacion,
       tiponom,
	   inicsubs
FROM dbo.deducciones
WHERE codigo = @codigo AND
      empresa = @empresa AND
      Periodo = @periodo AND
	  Ayo_operacion = @ejercicio AND
	  tiponom = @tiponom

Order By Folio

GO

IF OBJECT_ID('dbo.sp_viewdedmes') IS NOT NULL
  DROP PROCEDURE dbo.sp_viewdedmes
GO

CREATE PROCEDURE dbo.sp_viewdedmes
@Empresa   integer = 0 ,
@Codigo    Numeric(8,0)  = 0,
@Mes       integer = 0,
@Ejercicio Numeric(4,0)  = 0
AS
SELECT folio,
       num_conc,
	   dias,
	   descuento,
	   credito,
	   saldo,
       numeroinc,
	   siempre,
	   justificar,
	   fch_pago,
	   tipoinc,
	   fchtermino,
       fchinicio,
	   periodo,
	   varia1,
	   varia2,
	   varia3,
	   varia4,
	   num_cr,
       centro,
	   clase,
	   mes_operacion,
	   ayo_operacion,
	   tiponom,
	   inicsubs
FROM dbo.deducciones
WHERE codigo = @Codigo AND
      empresa = @Empresa AND
	  Mes_operacion = @Mes AND
	  Ayo_operacion = @Ejercicio
Order By Folio

GO

IF OBJECT_ID('dbo.sp_viewdedayo') IS NOT NULL
  DROP PROCEDURE dbo.sp_viewdedayo
GO

CREATE PROCEDURE dbo.sp_viewdedayo
@Empresa integer        = 0 ,
@Codigo   Numeric(8,0)  = 0,
@Ejercicio Numeric(4,0)  = 0
AS
SELECT folio,
        num_conc,
        dias,
        descuento,
        credito,
        saldo,
        numeroinc,
        siempre,
        justificar,
        fch_pago,
        tipoinc,
        fchtermino,
        fchinicio,
        periodo,
        varia1,
        varia2,
        varia3,
        varia4,
        num_cr,
        centro,
        clase,
        mes_operacion,
        ayo_operacion,
        tiponom,
		inicsubs
FROM dbo.deducciones
WHERE codigo = @Codigo AND
      empresa = @Empresa AND
	  Ayo_operacion = @Ejercicio
Order By periodo,folio


GO

/*Se amplio a 3 digitos el campo horario, por un cliente de Ricardo que utiliza mas de 100 horarios */
UPDATE dbo.gr_catalogo SET longitud = 3 
WHERE campo = 'HORARIO' AND longitud < 3

UPDATE dbo.gr_formas SET longitud = 3 
WHERE campo = 'HORARIO' AND longitud < 3

GO


IF OBJECT_ID('dbo.FUN_I_Agregar_MotivosTiempoExtra') IS NOT NULL
    DROP PROCEDURE dbo.FUN_I_Agregar_MotivosTiempoExtra
GO

CREATE PROCEDURE dbo.FUN_I_Agregar_MotivosTiempoExtra
@empresa AS INTEGER,
@IdMotivo AS INTEGER,
@descripcion AS VARCHAR(50),
@origen AS CHAR(6),
@usuario AS VARCHAR(50)

AS

  SET NOCOUNT ON
  SET DATEFORMAT MDY
  DECLARE @recordId AS udtId
  SET XACT_ABORT ON

  BEGIN TRANSACTION
  BEGIN TRY

   DECLARE @IdNuevoMotivo AS INTEGER
   DECLARE @Dato AS CHAR(4)
   DECLARE @funcion AS VARCHAR(20)
   DECLARE @codigo AS DECIMAL(8,0)
   DECLARE @opcion AS VARCHAR(50)
   DECLARE @opcion2 AS VARCHAR(50)
   DECLARE @opcion3 AS VARCHAR(50)
   DECLARE @password AS VARCHAR(20)
   DECLARE @registroPatronal AS VARCHAR(10)
   DECLARE @sistema AS CHAR(2)

   SET @Dato = 'TEX'
   SET @IdNuevoMotivo = 0
   SET @funcion = @origen
   SET @opcion = ''
   SET @opcion2 = @descripcion
   SET @opcion3 = ''
   SET @password = ''
   SET @sistema = 'NO'
   SET @registroPatronal = ''
   SET @codigo = 0


   IF NOT EXISTS (SELECT num_motivo FROM dbo.motivo_cambio WHERE dato = @dato AND num_motivo = @IdMotivo)
      BEGIN
          SELECT @IdNuevoMotivo = ISNULL(MAX(num_motivo),0) 
          FROM dbo.motivo_cambio 
          WHERE dato = @dato

	      SET @IdNuevoMotivo = @IdNuevoMotivo + 1
          SET @opcion = 'Agregar nuevo motivo tiempo extra'
		  SET @opcion3 = 'Numero motivo ' + CONVERT(CHAR(5),@IdNuevoMotivo)


	      INSERT INTO dbo.motivo_cambio
             (empresa
             ,dato
             ,num_motivo
             ,descripcion)
          VALUES
           (0
           ,@dato
           ,@IdNuevoMotivo
           ,@descripcion)
      END
    ELSE
	   BEGIN

          SET @opcion = 'Actualizar motivo tiempo extra'
		  SET @opcion3 = 'Numero motivo ' + CONVERT(CHAR(5),@IdMotivo)

           UPDATE dbo.motivo_cambio SET descripcion = @descripcion
           WHERE  num_motivo = @IdMotivo AND
                  dato = @dato
      END

      INSERT  INTO dbo.bitacora
      VALUES  ( @empresa, GETDATE(), CONVERT(VARCHAR(09), GETDATE(), 114),
                @funcion, @codigo, @opcion, @opcion2, @opcion3, @usuario,
                @password, @registroPatronal, @sistema )



   END TRY
   BEGIN CATCH

          IF ( XACT_STATE() ) = -1
              OR @@TRANCOUNT > 0
              ROLLBACK TRANSACTION

           SELECT  ERROR_NUMBER() AS ErrorNumber ,
                   ERROR_SEVERITY() AS ErrorSeverity ,
                   ERROR_STATE() AS ErrorState ,
                   ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                   ERROR_LINE() AS ErrorLine ,
                   ERROR_MESSAGE() AS ErrorMessage

    END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION



GO

IF OBJECT_ID('dbo.FUN_Y_ParametrosPTUPagosAnteriores') IS NOT NULL
    DROP PROCEDURE dbo.FUN_Y_ParametrosPTUPagosAnteriores
GO

CREATE PROCEDURE dbo.FUN_Y_ParametrosPTUPagosAnteriores
@empresa AS INTEGER,
@ejercicio AS INTEGER,
@Consolida AS CHAR(1)

AS

SET NOCOUNT ON

DECLARE @ejercicio1 AS INTEGER
DECLARE @ejercicio2 AS INTEGER
DECLARE @ejercicio3 AS INTEGER

SET @ejercicio1 = @ejercicio - 0
SET @ejercicio2 = @ejercicio - 1
SET @ejercicio3 = @ejercicio - 2


IF @Consolida = 'N'
   SELECT ae.codigo
	     ,@ejercicio1 AS 'Ejercicio1'
         ,ISNULL(eje1.PtuEjercicio1,0) AS 'PtuEjercicio1'
	     ,@ejercicio2 AS 'Ejercicio2'
         ,ISNULL(eje2.PtuEjercicio2,0) AS 'PtuEjercicio2'
	     ,@ejercicio3 AS 'Ejercicio3'
         ,ISNULL(eje3.PtuEjercicio3,0) AS 'PtuEjercicio3'
	     ,ll.ocupacion
	     ,t.actividad
		 ,ae.empresa
   FROM dbo.acum_emps AS ae
   INNER JOIN dbo.llaves AS ll ON ae.empresa = ll.empresa AND ae.codigo = ll.codigo
   LEFT JOIN dbo.tabulador AS t ON ll.empresa = t.empresa AND ll.ocupacion = t.ocupacion
   OUTER APPLY (SELECT SUM(ISNULL(eje1.imp_acum,0)) AS 'PtuEjercicio1'
                FROM dbo.acum_conc AS eje1
   	            WHERE eje1.empresa = ae.empresa
			      AND eje1.ejercicio = @ejercicio1
			      AND eje1.num_conc IN (15,515) 
			      AND eje1.codigo = ae.codigo ) AS eje1
   OUTER APPLY (SELECT SUM(ISNULL(eje2.imp_acum,0)) AS 'PtuEjercicio2'
                FROM dbo.acum_conc AS eje2
   	            WHERE eje2.empresa = ae.empresa
		   	    AND eje2.ejercicio = @ejercicio2
			    AND eje2.num_conc IN (15,515) 
			    AND eje2.codigo = ae.codigo ) AS eje2
   OUTER APPLY (SELECT SUM(ISNULL(eje3.imp_acum,0)) AS 'PtuEjercicio3'
                FROM dbo.acum_conc AS eje3
   	            WHERE eje3.empresa = ae.empresa
			    AND eje3.ejercicio = @ejercicio3
			    AND eje3.num_conc IN (15,515) 
			    AND eje3.codigo = ae.codigo ) AS eje3
   WHERE ae.empresa = @empresa AND
         ae.ejercicio = @ejercicio
   ORDER BY ae.codigo 
ELSE
   BEGIN

   SELECT ae.codigo
	     ,@ejercicio1 AS 'Ejercicio1'
         ,ISNULL(eje1.PtuEjercicio1,0) AS 'PtuEjercicio1'
	     ,@ejercicio2 AS 'Ejercicio2'
         ,ISNULL(eje2.PtuEjercicio2,0) AS 'PtuEjercicio2'
	     ,@ejercicio3 AS 'Ejercicio3'
         ,ISNULL(eje3.PtuEjercicio3,0) AS 'PtuEjercicio3'
	     ,ll.ocupacion
	     ,t.actividad
		 ,ae.empresa
   FROM dbo.acum_emps AS ae
   INNER JOIN dbo.llaves AS ll ON ae.empresa = ll.empresa AND ae.codigo = ll.codigo
   LEFT JOIN dbo.tabulador AS t ON ll.empresa = t.empresa AND ll.ocupacion = t.ocupacion
   OUTER APPLY (SELECT SUM(ISNULL(eje1.imp_acum,0)) AS 'PtuEjercicio1'
                FROM dbo.acum_conc AS eje1
   	            WHERE eje1.ejercicio = @ejercicio1
				  AND ( EXISTS (SELECT Consolidacion.Empresa FROM dbo.Consolidacion WHERE Consolidacion.Empresas = eje1.Empresa AND Consolidacion.Ejercicio = @Ejercicio AND Consolidacion.Empresa = @Empresa) OR
                  eje1.Empresa = @Empresa)
			      AND eje1.num_conc IN (15,515) 
			      AND eje1.codigo = ae.codigo ) AS eje1
   OUTER APPLY (SELECT SUM(ISNULL(eje2.imp_acum,0)) AS 'PtuEjercicio2'
                FROM dbo.acum_conc AS eje2
   	            WHERE eje2.ejercicio = @ejercicio2
				  AND ( EXISTS (SELECT Consolidacion.Empresa FROM dbo.Consolidacion WHERE Consolidacion.Empresas = eje2.Empresa AND Consolidacion.Ejercicio = @Ejercicio AND Consolidacion.Empresa = @Empresa) OR
                  eje2.Empresa = @Empresa)
			    AND eje2.num_conc IN (15,515) 
			    AND eje2.codigo = ae.codigo ) AS eje2
   OUTER APPLY (SELECT SUM(ISNULL(eje3.imp_acum,0)) AS 'PtuEjercicio3'
                FROM dbo.acum_conc AS eje3
   	            WHERE eje3.ejercicio = @ejercicio3
				  AND ( EXISTS (SELECT Consolidacion.Empresa FROM dbo.Consolidacion WHERE Consolidacion.Empresas = eje3.Empresa AND Consolidacion.Ejercicio = @Ejercicio AND Consolidacion.Empresa = @Empresa) OR
                  eje3.Empresa = @Empresa)
			    AND eje3.num_conc IN (15,515) 
			    AND eje3.codigo = ae.codigo ) AS eje3
   WHERE ae.ejercicio = @ejercicio AND
        ( EXISTS (SELECT Consolidacion.Empresa FROM dbo.Consolidacion WHERE Consolidacion.Empresas = ae.Empresa AND Consolidacion.Ejercicio = @Ejercicio AND Consolidacion.Empresa = @Empresa) OR
                  ae.Empresa = @Empresa)
   ORDER BY ae.codigo 

 END

GO

IF OBJECT_ID('dbo.FUN_Y_ParametrosPTUTabulador') IS NOT NULL
    DROP PROCEDURE dbo.FUN_Y_ParametrosPTUTabulador
GO

CREATE PROCEDURE dbo.FUN_Y_ParametrosPTUTabulador
@empresa AS INTEGER,
@ejercicio AS INTEGER,
@cAcumula AS CHAR(1)

AS

SET NOCOUNT ON

DECLARE @ejercicio1 AS INTEGER
DECLARE @ejercicio2 AS INTEGER
DECLARE @ejercicio3 AS INTEGER


SET @ejercicio1 = @ejercicio - 0
SET @ejercicio2 = @ejercicio - 1
SET @ejercicio3 = @ejercicio - 2

DECLARE @tPromedioPorOcupacion AS TABLE (Ocupacion INT, 
                                         Promedio NUMERIC(10,2), 
										 Ejercicio1 NUMERIC(10,2),
										 Ejercicio2 NUMERIC(10,2),
										 Ejercicio3 NUMERIC(10,2) )

IF @cAcumula = 'S'
    INSERT INTO @tPromedioPorOcupacion(Ocupacion, Promedio, Ejercicio1, Ejercicio2, Ejercicio3 )
    SELECT tPtu.Ocupacion,
           --tPtu.PtuTotal,
           ROUND(tPtu.PtuTotal / 3.00, 2) AS Promedio,
	     tPtu.Ejercicio1,
	     tPtu.Ejercicio2,
	     tPtu.Ejercicio3
    FROM
    (
    SELECT Empleados.RfcAlfa + Empleados.RfcNum + Empleados.Rfchomo AS Rfc,
           Llaves.Ocupacion,
	       SUM(Acum_Conc.Imp_Acum) AS PtuTotal,
	       SUM( IIF(Acum_Conc.Ejercicio = @Ejercicio1, Acum_Conc.Imp_Acum, 0) ) AS Ejercicio1,
	       SUM( IIF(Acum_Conc.Ejercicio = @Ejercicio2, Acum_Conc.Imp_Acum, 0) ) AS Ejercicio2,
	       SUM( IIF(Acum_Conc.Ejercicio = @Ejercicio3, Acum_Conc.Imp_Acum, 0) ) AS Ejercicio3,

           LEAD(Llaves.Ocupacion) OVER (PARTITION BY Llaves.Ocupacion ORDER BY SUM(Acum_Conc.Imp_Acum)) AS EsElMayor

    FROM Acum_Conc
    INNER JOIN Empleados ON Empleados.Codigo = Acum_Conc.Codigo AND Empleados.Empresa = @Empresa
    INNER JOIN Llaves ON Llaves.Codigo = Acum_Conc.Codigo AND Llaves.Empresa = @Empresa
    WHERE Acum_Conc.Num_Conc IN (15,515) AND
          Acum_Conc.Ejercicio IN (@Ejercicio1, @Ejercicio2, @Ejercicio3) AND

          ( EXISTS (SELECT Consolidacion.Empresa FROM dbo.Consolidacion WHERE Consolidacion.Empresas = Acum_Conc.Empresa AND Consolidacion.Ejercicio = @Ejercicio AND Consolidacion.Empresa = @Empresa) OR
            Acum_Conc.Empresa = @Empresa)

    GROUP BY Empleados.RfcAlfa + Empleados.RfcNum + Empleados.Rfchomo, Llaves.Ocupacion
    ) AS tPtu

    WHERE tPtu.EsElMayor IS NULL

    ORDER BY tPtu.Ocupacion

    /*
    SELECT PtuOcupacion.Ocupacion,
           MAX(PtuOcupacion.BaseOcupacion) / 3.00 AS PromedioOcupacion,
		   MAX(PtuOcupacion.Ejercicio1) AS 'Ejercicio1',
		   MAX(PtuOcupacion.Ejercicio2) AS 'Ejercicio2',
		   MAX(PtuOcupacion.Ejercicio3) AS 'Ejercicio3'
    FROM (SELECT Empleados.RfcAlfa + Empleados.RfcNum + Empleados.Rfchomo AS Rfc,
                 Llaves.Ocupacion,
                 SUM(Ka.Imp_acum) AS BaseOcupacion,
				 MAX(eje1.PtuEjercicio1) AS 'Ejercicio1',
				 MAX(eje2.PtuEjercicio2) AS 'Ejercicio2',
				 MAX(eje3.PtuEjercicio3) AS 'Ejercicio3'
          FROM dbo.acum_conc AS Ka
          INNER JOIN dbo.Empleados ON Empleados.Codigo = Ka.Codigo AND Empleados.Empresa = Ka.Empresa
          INNER JOIN dbo.Llaves ON Llaves.Codigo = Ka.Codigo AND Llaves.Empresa = Ka.Empresa
          OUTER APPLY (SELECT SUM(ISNULL(eje1.imp_acum,0)) AS 'PtuEjercicio1'
                       FROM dbo.acum_conc AS eje1
   	                   WHERE eje1.empresa = ka.empresa
			           AND eje1.ejercicio = @ejercicio1
			           AND eje1.num_conc IN (15,515) 
			           AND eje1.codigo = ka.codigo ) AS eje1
           OUTER APPLY (SELECT SUM(ISNULL(eje2.imp_acum,0)) AS 'PtuEjercicio2'
                        FROM dbo.acum_conc AS eje2
   	                    WHERE eje2.empresa = ka.empresa
			            AND eje2.ejercicio = @ejercicio2
			            AND eje2.num_conc IN (15,515) 
			            AND eje2.codigo = ka.codigo ) AS eje2
           OUTER APPLY (SELECT SUM(ISNULL(eje3.imp_acum,0)) AS 'PtuEjercicio3'
                        FROM dbo.acum_conc AS eje3
   	                    WHERE eje3.empresa = ka.empresa
			            AND eje3.ejercicio = @ejercicio3
			            AND eje3.num_conc IN (15,515) 
			            AND eje3.codigo = ka.codigo ) AS eje3
          WHERE Ka.Num_Conc IN (15,515) AND
                Ka.ejercicio BETWEEN @Ejercicio3 AND @Ejercicio1 AND

                ( EXISTS (SELECT Consolidacion.Empresa FROM dbo.Consolidacion WHERE Consolidacion.Empresas = Ka.Empresa AND Consolidacion.Ejercicio = @Ejercicio AND Consolidacion.Empresa = @Empresa) OR
                  Ka.Empresa = @Empresa)

          GROUP BY Empleados.RfcAlfa + Empleados.RfcNum + Empleados.Rfchomo, Llaves.Ocupacion) AS PtuOcupacion

    GROUP BY PtuOcupacion.Ocupacion
    */

ELSE
    INSERT INTO @tPromedioPorOcupacion(Ocupacion, Promedio, Ejercicio1, Ejercicio2, Ejercicio3 )
    SELECT tPtu.Ocupacion,
           --tPtu.PtuTotal,
           ROUND(tPtu.PtuTotal / 3.00, 2) AS Promedio,
	       tPtu.Ejercicio1,
	       tPtu.Ejercicio2,
	       tPtu.Ejercicio3
    FROM
    (
    SELECT Acum_Conc.Codigo,
           Llaves.Ocupacion,
	     SUM(Acum_Conc.Imp_Acum) AS PtuTotal,
	     SUM( IIF(Acum_Conc.Ejercicio = @Ejercicio1, Acum_Conc.Imp_Acum, 0) ) AS Ejercicio1,
	     SUM( IIF(Acum_Conc.Ejercicio = @Ejercicio2, Acum_Conc.Imp_Acum, 0) ) AS Ejercicio2,
	     SUM( IIF(Acum_Conc.Ejercicio = @Ejercicio3, Acum_Conc.Imp_Acum, 0) ) AS Ejercicio3,

           LEAD(Llaves.Ocupacion) OVER (PARTITION BY Llaves.Ocupacion ORDER BY SUM(Acum_Conc.Imp_Acum)) AS EsElMayor

    FROM Acum_Conc
    INNER JOIN Llaves ON Llaves.Codigo = Acum_Conc.Codigo AND Llaves.Empresa = @Empresa
    WHERE Acum_Conc.Num_Conc IN (15,515) AND
          Acum_Conc.Ejercicio IN (@Ejercicio1, @Ejercicio2, @Ejercicio3) AND
	   Acum_Conc.Empresa = @Empresa
    GROUP BY Acum_Conc.Codigo, Llaves.Ocupacion
    ) AS tPtu

    WHERE tPtu.EsElMayor IS NULL

    ORDER BY tPtu.Ocupacion

    /*
    SELECT PtuOcupacion.Ocupacion,
           MAX(PtuOcupacion.BaseOcupacion) / 3.00 AS PromedioOcupacion,
		   MAX(PtuOcupacion.Ejercicio1) AS 'Ejercicio1',
		   MAX(PtuOcupacion.Ejercicio2) AS 'Ejercicio2',
		   MAX(PtuOcupacion.Ejercicio3) AS 'Ejercicio3'
    FROM (SELECT Ka.Codigo,
                 Llaves.Ocupacion,
                 SUM(Ka.imp_acum) AS BaseOcupacion,
				 MAX(eje1.PtuEjercicio1) AS 'Ejercicio1',
				 MAX(eje2.PtuEjercicio2) AS 'Ejercicio2',
				 MAX(eje3.PtuEjercicio3) AS 'Ejercicio3'
          FROM dbo.acum_conc AS Ka
          INNER JOIN dbo.Llaves ON Llaves.Codigo = Ka.Codigo AND Llaves.Empresa = Ka.Empresa
          OUTER APPLY (SELECT SUM(ISNULL(eje1.imp_acum,0)) AS 'PtuEjercicio1'
                       FROM dbo.acum_conc AS eje1
   	                   WHERE eje1.empresa = ka.empresa
			           AND eje1.ejercicio = @ejercicio1
			           AND eje1.num_conc IN (15,515) 
			           AND eje1.codigo = ka.codigo ) AS eje1
           OUTER APPLY (SELECT SUM(ISNULL(eje2.imp_acum,0)) AS 'PtuEjercicio2'
                        FROM dbo.acum_conc AS eje2
   	                    WHERE eje2.empresa = ka.empresa
			            AND eje2.ejercicio = @ejercicio2
			            AND eje2.num_conc IN (15,515) 
			            AND eje2.codigo = ka.codigo ) AS eje2
           OUTER APPLY (SELECT SUM(ISNULL(eje3.imp_acum,0)) AS 'PtuEjercicio3'
                        FROM dbo.acum_conc AS eje3
   	                    WHERE eje3.empresa = ka.empresa
			            AND eje3.ejercicio = @ejercicio3
			            AND eje3.num_conc IN (15,515) 
			            AND eje3.codigo = ka.codigo ) AS eje3
          WHERE Ka.Num_Conc IN ( 15, 515) AND
                Ka.ejercicio BETWEEN @Ejercicio3 AND @Ejercicio1 AND
                Ka.Empresa = @Empresa
          GROUP BY Ka.Codigo, Llaves.Ocupacion) AS PtuOcupacion 

    GROUP BY PtuOcupacion.Ocupacion
    */

SELECT pro.Ocupacion,
       t.actividad,
       pro.Promedio,
	   pro.Ejercicio1,
	   pro.Ejercicio2,
	   pro.Ejercicio3
FROM @tPromedioPorOcupacion AS pro
INNER JOIN dbo.tabulador AS t ON pro.ocupacion = t.ocupacion AND t.empresa = @empresa
ORDER BY pro.ocupacion

GO

IF OBJECT_ID('dbo.Fun_I_CrearClaseCero2023') IS NOT NULL
   DROP PROCEDURE dbo.Fun_I_CrearClaseCero2023
GO


CREATE PROCEDURE dbo.Fun_I_CrearClaseCero2023
@empresa INTEGER
AS

  SET NOCOUNT ON
  SET DATEFORMAT MDY
  DECLARE @recordId AS udtId
  SET XACT_ABORT ON
  BEGIN TRANSACTION
  BEGIN TRY

      DECLARE @mes_operacion AS INTEGER
      DECLARE @ayo_operacion AS INTEGER
	  DECLARE @ayos AS INTEGER
	  DECLARE @Factor AS DECIMAL(10,6)
	  DECLARE @DiasAguinaldo AS DECIMAL(10,2)
	  DECLARE @DiasVacaciones AS DECIMAL(10,2)
	  DECLARE @PrimaVacacional AS DECIMAL(10,2)
	  DECLARE @cAyos AS CHAR(2)
	  DECLARE @clase AS CHAR(2)
	  DECLARE @Ceros AS DECIMAL(10,2)

      SET @mes_operacion = 1
	  SET @ayo_operacion = 2023
	  SET @Ceros = 0.00

      IF NOT EXISTS(SELECT factor FROM dbo.tablas_int WHERE empresa = @empresa AND clase = '0' AND Ayo_Operacion = @ayo_operacion AND Mes_Operacion = @mes_operacion)
         BEGIN
		     SET @ayos = 1
			 SET @DiasAguinaldo = 15
			 SET @PrimaVacacional = 25
			 SET @Clase = '0 '

		     WHILE @ayos < 46
			      BEGIN
				      SET @DiasVacaciones = CASE WHEN @ayos = 1 THEN 12
					                             WHEN @ayos = 2 THEN 14
											     WHEN @ayos = 3 THEN 16
											     WHEN @ayos = 4 THEN 18
												 WHEN @ayos = 5 THEN 20
												 WHEN @ayos >= 6 AND @ayos <= 10 THEN 22
												 WHEN @ayos >= 11 AND @ayos <= 15 THEN 24
												 WHEN @ayos >= 16 AND @ayos <= 20 THEN 26
												 WHEN @ayos >= 21 AND @ayos <= 25 THEN 28
												 WHEN @ayos >= 26 AND @ayos <= 30 THEN 30
												 WHEN @ayos >= 31 AND @ayos <= 45 THEN 32
												 END
                      SET @factor = 1 + ROUND( ((@DiasAguinaldo/365) + ((@DiasVacaciones * (@PrimaVacacional/100))/365)),4)
	  			      SET @cAyos = dbo.Padl(@ayos,'',2,'0')

				      INSERT INTO dbo.tablas_int (empresa,
					                              clase,
												  Ayos,
												  mes_operacion,
												  ayo_operacion,
												  Factor,
												  Aguinaldo,
												  Dias_Vac,
												  Prima_Vac,
                                                  pmavacdias,
                                                  pmavacimpo,
                                                  despensa,
                                                  despensaim,
                                                  dias_ayo,
                                                  porc_ayo,
                                                  imp_ayo,
                                                  dias_mes,
                                                  porc_mes,
                                                  imp_mes,
                                                  porc_dia,
                                                  imp_dia,
                                                  fdoahopatp,
                                                  fdoahopati,
                                                  fdoahotrap,
                                                  fdoahotrai,
                                                  pmo1ayopor,
                                                  pmo1ayoimp,
                                                  pmo2ayopor,
                                                  pmo2ayoimp)

					                      VALUES (@empresa,
										          @Clase,
												  @cAyos,
												  @mes_operacion,
												  @ayo_operacion,
												  @factor,
												  @DiasAguinaldo,
												  @DiasVacaciones,
												  @PrimaVacacional,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros,
												  @Ceros)
                      SET @ayos = @ayos + 1
                  END
	     END

  END TRY
  BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

  END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO


IF OBJECT_ID('dbo.Fun_I_ActualizarDiasVacaciones2023') IS NOT NULL
   DROP PROCEDURE dbo.Fun_I_ActualizarDiasVacaciones2023
GO


CREATE PROCEDURE dbo.Fun_I_ActualizarDiasVacaciones2023
@empresa INTEGER,
@mes_operacion INTEGER,
@ayo_operacion INTEGER

AS

  SET NOCOUNT ON
  SET DATEFORMAT MDY
  DECLARE @recordId AS udtId
  SET XACT_ABORT ON
  BEGIN TRANSACTION
  BEGIN TRY


	  if @ayo_operacion >= 2023
	     BEGIN
		   /* Crea la clase 0, con los nuevos dias de vacaciones, de la clase cero, para tener el registro de las vacaciones de la ley anterior */ 
           IF NOT EXISTS(SELECT factor FROM dbo.tablas_int WHERE empresa = @empresa AND clase = '0' AND Ayo_Operacion = 2023 AND Mes_Operacion = 1)
	          EXECUTE dbo.Fun_I_CrearClaseCero2023 @empresa

           /*Actualiza los dias de vacaciones si son menores a los de la nueva reforma 2023 de todas las clases apartir de 2023 */
		   UPDATE dbo.tablas_int SET dias_vac = CASE WHEN ayos = '01' AND dias_vac < 12 THEN 12
					                                 WHEN ayos = '02' AND dias_vac < 14 THEN 14
											         WHEN ayos = '03' AND dias_vac < 16 THEN 16
											         WHEN ayos = '04' AND dias_vac < 18 THEN 18
												     WHEN ayos = '05' AND dias_vac < 20 THEN 20
												     WHEN ayos >= '06' AND ayos <= '10' AND dias_vac < 22 THEN 22
												     WHEN ayos >= '11' AND ayos <= '15' AND dias_vac < 24 THEN 24
												     WHEN ayos >= '16' AND ayos <= '20' AND dias_vac < 26 THEN 26
												     WHEN ayos >= '21' AND ayos <= '25' AND dias_vac < 28 THEN 28
												     WHEN ayos >= '26' AND ayos <= '30' AND dias_vac < 30 THEN 30
												     WHEN ayos >= '31' AND ayos <= '45' AND dias_vac < 32 THEN 32
													 ELSE dias_vac
												 END
            WHERE empresa = @empresa AND
			      mes_operacion = @mes_operacion AND
				  ayo_operacion = @ayo_operacion
				  

         /*Actualiza el factor de integracion a los nuevos dias de vacaciones*/
		 UPDATE dbo.tablas_int SET factor = ROUND((((1 + (Aguinaldo/365) + ((DIAS_VAC /365)) * PRIMA_VAC/100) + (PmaVacDias/365) + (DIAS_AYO/365) + (PORC_AYO/100) + (PMO1AYOPOR/100) + (PMO2AYOPOR/100)) + (DIAS_MES/30.4) + round((PORC_MES/100),4) + ROUND((PORC_DIA/100),4) ),4)
         WHERE empresa = @empresa AND
  		       mes_operacion = @mes_operacion AND
			   ayo_operacion = @ayo_operacion


         END

  END TRY
  BEGIN CATCH

        IF ( XACT_STATE() ) = -1
            OR @@TRANCOUNT > 0
            ROLLBACK TRANSACTION

        SELECT  ERROR_NUMBER() AS ErrorNumber ,
                ERROR_SEVERITY() AS ErrorSeverity ,
                ERROR_STATE() AS ErrorState ,
                ISNULL(ERROR_PROCEDURE(), '') AS ErrorProcedure ,
                ERROR_LINE() AS ErrorLine ,
                ERROR_MESSAGE() AS ErrorMessage

  END CATCH

    IF @@TRANCOUNT > 0
        COMMIT TRANSACTION


GO

IF OBJECT_ID('dbo.Fun_I_ObtenerClaseCero') IS NOT NULL
   DROP PROCEDURE dbo.Fun_I_ObtenerClaseCero
GO


CREATE PROCEDURE dbo.Fun_I_ObtenerClaseCero
@empresa INTEGER,
@Ayo_operacion INTEGER

AS

IF @Ayo_operacion < 2023

   BEGIN 
      IF NOT EXISTS(SELECT factor FROM dbo.tablas_int WHERE empresa = @empresa AND clase = '0' AND ayo_operacion < 2023)
         EXECUTE dbo.Fun_I_CrearClaseCero @empresa

      SELECT Empresa,Ayos,Factor,Aguinaldo,Dias_Vac,Prima_Vac,mes_operacion,ayo_operacion
      FROM dbo.tablas_int 
      WHERE empresa = @empresa AND
            clase = '0' AND
			ayo_operacion < 2023
      ORDER BY ayos

   END
ELSE
    BEGIN 
       IF NOT EXISTS(SELECT factor FROM dbo.tablas_int WHERE empresa = @empresa AND clase = '0' AND Ayo_Operacion = 2023 AND Mes_Operacion = 1)
          EXECUTE dbo.Fun_I_CrearClaseCero2023 @empresa

       SELECT Empresa,Ayos,Factor,Aguinaldo,Dias_Vac,Prima_Vac,mes_operacion,ayo_operacion
       FROM dbo.tablas_int 
       WHERE empresa = @empresa AND
             clase = '0' AND
			 Ayo_Operacion = 2023
       ORDER BY ayos
    END

GO       


IF OBJECT_ID('dbo.Fun_I_ObtenerTablaCV168II') IS NOT NULL
   DROP PROCEDURE dbo.Fun_I_ObtenerTablaCV168II
GO


CREATE PROCEDURE dbo.Fun_I_ObtenerTablaCV168II
@Ayo_operacion INTEGER

AS

If @Ayo_operacion < 2023
   SET @Ayo_operacion = 2023

IF @Ayo_operacion > 2030
   SET @Ayo_operacion = 2030

SELECT rango,
       limiteInferior,
	   claveInferior,
	   limiteSuperior,
	   claveSuperior,
	   primaCVPatron,
	   ayo
FROM dbo.NOM_TBL_PrimaCVPatron 
WHERE ayo = @Ayo_operacion
ORDER BY rango

GO

PRINT 'GO'

GO




